<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use PDO;
use PDOException;

class AddressController extends Controller
{
    // JSON {"User_No": 24 , "Login_Type": "Buyer" , "Address_ID": "" , "Store_No" : }
    public function address_details(Request $request){
        $data = array();
        $status = true;

        $post = $request->post();
        extract($post);
        try
        {
            if(isset($User_No) && isset($Login_Type) && $User_No >0 )
            {
                if(isset($Address_ID) && $Address_ID >0)
                {
                    $where = "BA.Address_ID = $Address_ID";
                }
                else {
                    $where = "BA.User_No = '$User_No' and BA.Login_Type = '$Login_Type' ";
                }

                $addresstmt = $this->pdo->prepare("Select BA.Address_ID address_id, BA.Address_Type Type , BA.User_No cust_no, COALESCE(BA.Name, '') name , COALESCE(BA.Email_ID , '') email, COALESCE(BA.Address, '') address, COALESCE(BA.Flat_No , '') flat_no , COALESCE(BA.Locality , '') locality_code, COALESCE(BA.Pincode , '') pincode, COALESCE(BA.State_Code , '') state_code, COALESCE(BA.City_Code , '') city_code , COALESCE(BA.Latitude , '') loc_lat , COALESCE(BA.Longitude , '') loc_long, COALESCE(BA.Contact_No , '') contact_no , COALESCE(BA.Contact_No_Type , '') contact_no_type , COALESCE(BA.Default_Flag , '') def_flag , COALESCE(BA.Landmark , '') landmark, COALESCE(CM.City_Name , '') city_name, COALESCE(SM.State_Name , '') state_name , Is_Area_Served($Store_No,BA.Locality) as is_served, COALESCE(AM.Area_Name , '') locality
                from BBC_Addresses BA
                left join City_Master CM on BA.City_Code = CM.City_Code
                left join State_Master SM on BA.State_Code = SM.State_Code
                left join Area_Master AM on BA.Locality = AM.Area_Code where $where and BA.Status = 'A'");
                $addresstmt->execute();
                $data = $addresstmt->fetchAll(PDO::FETCH_ASSOC);

                if (!empty($data)) {

                    // $addresses = $arr;
                    $msg = 'Success';
                } else {
                    $msg = 'Address data not available';
                    $status = false;
                }
            }
            else
            {
                $msg = 'Invalid Data';
                $status = false;
            }

        } catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
            // return get_response(, $status, $addresses);
        }
        return get_response($msg, $status, $data);
    }

    public function delete_address(Request $request){
        $data = array();
        $status = true;

        $post = $request->post();
        extract($post);
        $creation_date = date('Y-m-d H:i:s');
        try {
            if(isset($User_No) && $User_No > 0 && isset($Login_Type) && isset($Address_ID) && $Address_ID > 0){
                $stmt1 = $this->pdo ->prepare("Update BBC_Addresses set Status = 'D' , Default_Flag = 'I' , Changed_Date = '$creation_date' , Changed_By = $User_No where User_No = '$User_No' and Login_Type = '$Login_Type' and Address_ID = '$Address_ID'");
                $arr = $stmt1 -> execute();

                if($arr ){
                    $msg = 'Address Deleted Successfully.';
                }else{
                    $msg = 'Address Delete Fail.';
                    $status = false;
                }
            }else{
                $msg = 'Invalid Data';
                $status = false;
            }
        }catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }

        return get_response($msg, $status, $data);
    }

    // JSON {"User_No": 24 , "Login_Type": "Buyer" , "Address_ID": "34"}
    public function set_address_default(Request $request){
        $data = array();
        $status = true;

        $post = $request->post();
        extract($post);
        $Changed_Date = date('Y-m-d H:i:s');
        try{
            if(isset($User_No) && isset($Login_Type) && $User_No >0 && isset($Address_ID) && $Address_ID > 0)
            {
                $stmt1 = $this->pdo->prepare("Update BBC_Addresses set Default_Flag = 'I' , Changed_Date = '$Changed_Date' , Changed_By = $User_No where User_No = $User_No and Login_Type = '$Login_Type'");
                $arr = $stmt1 -> execute();

                if($arr)
                {
                    $stmt = $this->pdo->prepare("Update BBC_Addresses set Default_Flag = 'A' , Changed_Date = '$Changed_Date' , Changed_By = $User_No where Address_ID = $Address_ID" );
                    $arr2 = $stmt -> execute();

                    if($arr2 )
                    {
                        $msg = 'Default address updated successfully';
                    }
                    else {
                        $msg = 'Default address updation failed';
                        $status = false;
                    }

                }
                else
                {
                    $msg = 'Invalid Data';
                    $status = false;
                }
            }
            else{
                $msg = 'Invalid Data';
                $status = false;
            }
        }
        catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }
        return get_response($msg, $status,$data);
    }

    /*{
        "Cust_No" : 1 ,
        "Name" : "Swanand" ,
        "email_id" : "" ,
        "Flat" : 1 ,
        "Locality" : 8 ,
        "Address" : "Abcd" ,
        "State_Code" : "MH" ,
        "City_Code" : 1 ,
        "Latitude" :  ,
        "Longitude" :  ,
        "Pincode" : 411004 ,
        "Contact_No" : 9579732831 ,
        "Contact_No_Type" : "M" ,
        "Landmark" : "Pune"
        }
    */
    public function add_new_address(Request $request){
        $data = array();
        $status = true;

        $post = $request->post();
        Log::info('Request for add_new_address', ['post' => $post]);
        extract($post);
        $Creation_Date = date('Y-m-d H:i:s');

        try{
            if(isset($Cust_No) && $Cust_No >0)
            {
                Log::debug('In add_new_address in if condition checked isset and not empty cust no', ['Cust_No' => $Cust_No]);
                ## If latitude and longitute are 0 then calculate it from google geocode
                if($Latitude == 0 || $Latitude == 0.00 || $Latitude == null ||
                    $Longitude == 0 || $Longitude == 0.00 || $Longitude == null )
                {
                    Log::debug('In add_new_address in if condition checked If latitude and longitute are 0 then calculate it from google geocode', ['Latitude' => $Latitude,'Longitude'=>$Longitude]);
                    # get Locality name from id : area_master : Locality
                    $area = $this->pdo->prepare("SELECT AM.Area_Name, City_Name, State_Name FROM Area_Master AM
                INNER JOIN City_Master ON City_Master.City_Code = AM.City_Code
                INNER JOIN State_Master ON State_Master.State_Code = City_Master.State_Code
					    WHERE AM.Area_Code = $Locality AND AM.Status = 'A' ");
                    $area->execute();
                    $data = $area->fetch(PDO::FETCH_ASSOC);
                    //$area->debugDumpParams();
                    Log::debug('In add_new_address result for following query to get Locality name from id : area_master : Locality', ['sql' => $area->debugDumpParams(),'result'=>$data]);
                    if(!empty($data)){
                        Log::debug('In add_new_address in if condition checked If not empty result for following query', ['sql' => $area->debugDumpParams(),'result'=>$data]);
                        $areaName = $data['Area_Name'];
                        $cityName = $data['City_Name'];
                        $stateName = $data['State_Name'];
                        $address = $Flat.", ".$Address.", ".$areaName.", ".$cityName.", ".$Pincode.", ".$stateName;
                        ## Calculate lat long from address
                        $latLong = getLatLong($address);
                        Log::debug('In add_new_address calculated lat long from address', ['latLong' => $latLong,'address'=>$address]);
                        $Latitude = $latLong['latitude'] ? $latLong['latitude'] : '0.00';
                        $Longitude = $latLong['longitude'] ? $latLong['longitude'] : '0.00';
                    }
                }

                // new address get inserted
                $stmt = $this->pdo->prepare("INSERT INTO BBC_Addresses (
                User_No , Address_Type , Ref_Address_ID , Login_Type , GSTIN , Email_ID , Address , Name ,
                Flat_No , Locality , Pincode , City_Code , State_Code , Latitude , Longitude , Default_Flag , Contact_No , Contact_No_Type , Status , Creation_Date , Created_By , Changed_Date , Changed_By ,Landmark
            )
            values('$Cust_No' , 'Delivery' , '0' , 'Buyer' , '' , '$email_id' , '$Address' , '$Name' , '$Flat' , '$Locality' , '$Pincode' , '$City_Code' , '$State_Code' , '$Latitude' , '$Longitude' , 'A' , '$Contact_No' , '$Contact_No_Type' , 'A' , '$Creation_Date' , '$Cust_No' , '$Creation_Date' , '$Cust_No' , '$Landmark'  )"


                );
                $stmt->execute();

                // get auto increment id of inserted address
                $address_id = $this->pdo->lastInsertId();
                Log::debug('In add_new_address new address get inserted', ['sql' => $stmt->debugDumpParams(),'inserted_id'=>$this->pdo->lastInsertId()]);
                // all address updated with default flag I except last inserted address
                $updateAddress = $this->pdo->prepare("UPDATE BBC_Addresses SET Default_Flag = 'I' WHERE User_No='$Cust_No' AND Login_Type='Buyer' AND Address_ID!='$address_id'");
                $updateAddress->execute();
                Log::debug('In add_new_address all address updated with default flag I except last inserted address', ['sql' => $updateAddress->debugDumpParams()]);
                if($updateAddress)
                {
                    // get addresses of given customer no
                    $add = $this->pdo->prepare("SELECT BA.`User_No` as cust_no, BA.`Address_ID` as add_id, BA.`Name` as name, BA.`Email_ID` as email, BA.`Flat_No` as flat_no, BA.`Address` as address, AM.`Area_Name` as locality, BA.`Locality` as locality_code, BA.`City_Code` as city_code, BA.`Landmark` as landmark, CM.`City_Name` as city_name, BA.`State_Code` as state_code, SM.`State_Name` as state_name, BA.`Latitude` as loc_lat, BA.`Longitude` as loc_long, BA.`Default_Flag` as def_flag, BA.`Contact_No` as contact_no, BA.`Contact_No_Type` as contact_no_type
                        FROM `BBC_Addresses` AS `BA`LEFT JOIN `City_Master` AS `CM` ON BA.`City_Code` = CM.`City_Code`
				        LEFT JOIN `State_Master` AS `SM` ON BA.`State_Code` = SM.`State_Code`
				        LEFT JOIN `Area_Master` AS `AM` ON AM.`Area_Code` = BA.`Locality`
					    WHERE BA.`User_No` = $Cust_No AND BA.`Status` = 'A' AND BA.`Login_Type` = 'Buyer' ORDER BY Default_Flag ASC");
                    $add ->execute();
                    $data = $add->fetchAll(PDO::FETCH_ASSOC);
                    Log::debug('In add_new_address get addresses of given customer no', ['sql' => $add->debugDumpParams(),'result'=>$data]);
                    if(!empty($data))
                    {
                        $msg = 'Address Added Successfully.';
                    }
                    else
                    {
                        $msg = 'Unable to add new address.';
                        $status = false;
                    }

                }
                else
                {
                    $msg = 'Unable to add new address.';
                    $status = false;
                }

            }
            else
            {
                $msg = 'Invalid Data';
                $status = false;
            }
        }catch (PDOException $e)
        {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
            Log::debug('Response for add_new_address in catch', ['data' => $data,'status'=>false,'msg'=>$msg]);
        }
        Log::info('Response for add_new_address', ['data' => $data,'status'=>false,'msg'=>$msg]);
        return get_response($msg, $status, $data);
    }

    /*{"Address_ID" : "",
    "User_No" : "",
    "Login_Type" : ,
    "Name" : ""
    "Email_ID" "
    "Address": "",
    "Flat_No" : "",
    "Locality": "",
    "Pincode" : "",
    "City_Code": "",
    "State_Code": "";
    "Latitude":"",
    "Longitude":"",
    "Contact_No": "",
    "Landmark":""
    }*/

    public function update_address(Request $request){
        $post = $request->post();
        extract($post);
        $status = false;

        $param_array = array();
        $where = '';
        $setvalues = '';
        $date1 = date('Y-m-d H:i:s');
        $msg = "Success";
        if(isset($Address_ID) && $Address_ID > 0 && isset($User_No) && $User_No > 0)
        {
            if(isset($Login_Type) && $Login_Type = 'Buyer')
            {
                ## If latitude and longitute are 0 then calculate it from google geocode
                if($Latitude == 0 || $Latitude == 0.00 || $Latitude == null ||
                    $Longitude == 0 || $Longitude == 0.00 || $Longitude == null )
                {
                    # get Locality name from id : area_master : Locality
                    $area = $this->pdo->prepare("SELECT AM.Area_Name, City_Name, State_Name FROM Area_Master AM
                INNER JOIN City_Master ON City_Master.City_Code = AM.City_Code
                INNER JOIN State_Master ON State_Master.State_Code = City_Master.State_Code
					    WHERE AM.Area_Code = $Locality AND AM.Status = 'A' ");
                    $area->execute();
                    $data = $area->fetch(PDO::FETCH_ASSOC);
                    //$area->debugDumpParams();
                    if(!empty($data)){
                        $areaName = $data['Area_Name'];
                        $cityName = $data['City_Name'];
                        $stateName = $data['State_Name'];
                        $address = $Flat.", ".$Address.", ".$areaName.", ".$cityName.", ".$Pincode.", ".$stateName;
                        ## Calculate lat long from address
                        $latLong = getLatLong($address);
                        $Latitude = $latLong['latitude'] ? $latLong['latitude'] : '0.00';
                        $Longitude = $latLong['longitude'] ? $latLong['longitude'] : '0.00';
                    }
                }

                $param_array[':address_id'] = $Address_ID;
                $param_array[':userno'] = $User_No;
                $where = 'Address_ID = :address_id and User_No = :userno;' ;

                if(isset($Name))
                {
                    $param_array[':name'] = $Name;
                    $setvalues .= 'Name = :name,';
                }
                if(isset($Email_ID))
                {
                    $param_array[':email_id'] = $Email_ID;
                    $setvalues .= 'Email_ID = :email_id,';
                }

                if(isset($Address))
                {
                    $param_array[':address'] = $Address;
                    $setvalues .= 'Address = :address,';
                }
                if(isset($Flat_No))
                {
                    $param_array[':flat_no'] = $Flat_No;
                    $setvalues .= 'Flat_No = :flat_no,';
                }
                if(isset($Locality))
                {
                    $param_array[':locality'] = $Locality;
                    $setvalues .= 'Locality = :locality,';
                }
                if(isset($Pincode))
                {
                    $param_array[':pincode'] = $Pincode;
                    $setvalues .= 'Pincode = :pincode,';
                }
                if(isset($City_Code))
                {
                    $param_array[':citycode'] = $City_Code;
                    $setvalues .= 'City_Code = :citycode,';
                }
                if(isset($State_Code))
                {
                    $param_array[':statecode'] = $State_Code;
                    $setvalues .= 'State_Code = :statecode,';
                }
                if(isset($Latitide))
                {
                    $param_array[':latitude'] = $Latitide;
                    $setvalues .= 'Latitude = :latitude,';
                }
                if(isset($Longitude))
                {
                    $param_array[':Longitude'] = $Longitude;
                    $setvalues .= 'Longitude = :Longitude,';
                }
                if(isset($Contact_No))
                {
                    $param_array[':contactno'] = $Contact_No;
                    $setvalues .= 'Contact_No = :contactno,';
                }
                if(isset($State_Code))
                {
                    $param_array[':landmark'] = $Landmark;
                    $setvalues .= 'Landmark = :landmark,';
                }

                $param_array[':changeddate'] = $date1;
                $setvalues .= 'Changed_By = '.$User_No.' , Changed_Date = :changeddate';

                $stmt = $this->pdo->prepare("UPDATE BBC_Addresses  SET " . $setvalues . ' WHERE ' . $where);
                try {

                    $updated = $stmt->execute($param_array);
                    // get all address related to user
                    $add = $this->pdo->prepare("SELECT

					BA.`User_No` as cust_no,

					BA.`Address_ID` as add_id,

					BA.`Name` as name,

					BA.`Email_ID` as email,

					BA.`Flat_No` as flat_no,

					BA.`Address` as address,

					AM.`Area_Name` as locality,

					BA.`Locality` as locality_code,

					BA.`City_Code` as city_code,

					BA.`Landmark` as landmark,

					CM.`City_Name` as city_name,

					BA.`State_Code` as state_code,

					SM.`State_Name` as state_name,

					BA.`Latitude` as loc_lat,

					BA.`Longitude` as loc_long,

					BA.`Default_Flag` as def_flag,

					BA.`Contact_No` as contact_no,

					BA.`Contact_No_Type` as contact_no_type

					FROM `BBC_Addresses` AS `BA`

					LEFT JOIN `City_Master` AS `CM` ON BA.`City_Code` = CM.`City_Code`

					LEFT JOIN `State_Master` AS `SM` ON BA.`State_Code` = SM.`State_Code`

					LEFT JOIN `Area_Master` AS `AM` ON AM.`Area_Code` = BA.`Locality`

					WHERE BA.`User_No` = $User_No AND BA.`Status` = 'A' AND BA.`Login_Type` = 'Buyer' ORDER BY Default_Flag ASC");
                    $add ->execute();
                    $arr = $add->fetchAll(PDO::FETCH_ASSOC);
                    if(!empty($arr))
                    {
                        foreach($arr as $row_address)
                        {
                            $record[] = $row_address;
                        }
                        $data['addresses'] = $record;
                    }
                    else
                    {
                        $data['addresses'] = '';
                    }
                    // list of address fetching end
                    if ($updated == 1) {
                        $msg = "Address Updated Successfully.";
                        $status = true;
                        // $data['addresses'];
                    } else {
                        $msg = "Unable To Update Address";
                        $status = false;
                    }

                } catch (PDOException $e) {
                    $status = false;
                    $data = $e->getMessage();
                    return get_response("Something went wrong", $status, $data);
                }
            }
            else{
                // Login_Type incorrect
                $msg = "Something went wrong";
                $data = "LoginType incorrect!!";
                $status = false;
            }
        }
        else{ // if address id not passed
            $msg = "Something went wrong";
            $data = "Incorrect or missing User!!";
            $status = false;
        }
        return get_response($msg, $status, $data);
    }
}
