<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class BankController extends Controller
{
    public function get_all_banks(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        //header_remove("Cache-Control");

        try {
            $stmt = $this->pdo->prepare("select B.Bank_name as name, RPAD(B.Bank_IFSC,11,0) as code
        from   Bank_IFSC_Master B
        order by B.Bank_Name");
            $stmt->execute();
            $data = $stmt->fetchAll(PDO::FETCH_ASSOC);

            if (!empty($data)) {
                $msg = 'Success';
            } else {
                $msg = 'Bank IFSC data not available';
                $status = false;
            }
        } catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
        }

        return get_response( $msg, $status, $data);
    }
}
