<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;

class BeatRoutesController extends Controller
{
    /******** JSON INPUT
    {"Login_Type":"FSO","User_No":"12"}
     ********/
    public function get_beatroutes(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        if ($Cust_No=="" || $Cust_No==null ||$Cust_No==NULL) {
            //new Customer,Show all Store mapped to FSO
            $stmt = $this->pdo->prepare("select DISTINCT G.Store_No,M.Store_Name
        from BBC_Org_User_Groups G,
        BBC_Org_Group_Users U,
        Store_Master M
        where  U.Store_No=G.Store_No
        and M.Store_No=G.Store_No
        and U.Login_Type=?
        and U.User_No =?
        and U.Status='A'
        and G.Status='A'
        group by G.ID
        Order by G.ID");
            $stmt->execute([$Login_Type,$User_No]);
        }
        else{
            //existing Customer,exclude Stores already mapped
            $stmt = $this->pdo->prepare("select DISTINCT G.Store_No,M.Store_Name
        from BBC_Org_User_Groups G,
        BBC_Org_Group_Users U,
        Store_Master M
        where  U.Store_No=G.Store_No
        and M.Store_No=G.Store_No
        and M.Store_No not in (select Store_No from BBC_Org_Group_Users
                               where  User_No=?
                               and    Login_Type='Buyer')
        and U.Login_Type=?
        and U.User_No =?
        and U.Status='A'
        and G.Status='A'
        group by G.ID
        Order by G.ID");
            $stmt->execute([$Cust_No,$Login_Type,$User_No]);
        }
        $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

        if(!empty($arr)) {
            foreach($arr as $key=>$details){
                $data[$key]['Store_No']    = $details['Store_No'];
                $data[$key]['Store_Name']  = $details['Store_Name'];
                //Get Beatroute for the Store
                $stmt1 = $this->pdo->prepare("select G.ID as BeatRootNo,CONCAT(G.User_Group_Name,'(',group_concat(CASE
                WHEN Day_Num=1 THEN 'Mon'
                WHEN Day_Num=2 THEN 'Tue'
                WHEN Day_Num=3 THEN 'Wed'
                WHEN Day_Num=4 THEN 'Thu'
                WHEN Day_Num=5 THEN 'Fri'
                WHEN Day_Num=6 THEN 'Sat'
                WHEN Day_Num=7 THEN 'Sun'
                ELSE 'No Days'
                    END),')') as BeatRootName
                    from BBC_Org_User_Groups G,
                    BBC_Org_Group_Days D,
                    BBC_Org_Group_Users U
                    where
                    G.ID= D.Org_Group_ID
                    and G.ID= U.Org_Group_ID
                    and D.Store_No=G.Store_No
                    and U.Store_No=G.Store_No
                    and D.Store_No=U.Store_No
                    and U.Login_Type= ?
                    and U.User_No   = ?
                    and G.Store_No  = ?
                    and U.Status='A'
                    and G.Status='A'
                    and D.Status='A'
                    and D.Days_For='Order'
                    group by G.ID
                    Order by G.ID,D.Day_Num");
                $stmt1->execute([$Login_Type,$User_No,$details['Store_No']]);
                $arr1 = $stmt1->fetchAll(PDO::FETCH_ASSOC);
                $Beatroute = array();
                $Beatrouteno = array();
                if(!empty($arr1)) {
                    foreach($arr1 as $key1=>$details1){
                        array_push($Beatroute,$details1['BeatRootName']);
                        array_push($Beatrouteno,$details1['BeatRootNo']);
                    }

                }
                else {
                    //array_push($Beatroute,"No Beatroute Assignment exist!");
                    //No Beatroute Found
                }
                $data[$key]['Beat_Routes']  =$Beatroute;
                $data[$key]['beatroute_no']  =$Beatrouteno;



            }

            $msg = 'Success';
            $output['beatroutes'] = $data;
        } else {
            $msg = 'No Suppliers , Beatroutes found';
            $status = false;
        }

        return  get_response($msg, $status, $output);
    }
}
