<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class BuyerController extends Controller
{
    //Json input
    // businessID
    // start_order_date [ format YYYY-MM-DD ]
    // end_order_date [ format YYYY-MM-DD ]
    // UnsentBuyersFlag

    // TODO: Original_Order_No to be added to the data retrieved. will have data only for return orders.

    public function get_buyerdetails(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        // At this point we have input parameters in
        // $business_id, $start_date, $end_date, UnsentBuyersFlag
        // ignore business_id for now.

        // if both start_date and end_date is passed then filter for that date range.
        // if buyer details is to be retrieved for a single date then that date will be passed in start_date parameter.
        // if an 'UnsentOrdersFlag' is set then retrieve only the addresses that do not have the legacy buyer number is not populated.

        // TODO: validate input parameters.

        // build a where clause depending on the input parameters

        $param_array = array();
        $where = '';

        // work out the start date and set the end date to today.
        // the where condition uses >= so the selected buyer details are retrieved.

        //         $date = new DateTime($dt);
        //         $date->sub($interval);
        //         $start_order_date = $date->format('Y-m-d');
        //         // set the order end date to today.
        //         $end_order_date = date("Y-m-d");
        // }

        if (isset($start_date)) {
            $param_array[':start_date'] = $start_date;

            $where .= 'Cust_Master.Creation_Date >= STR_TO_DATE(:start_date, "%Y-%m-%d") AND ';
        }

        if (isset($end_date)) {
            $param_array[':end_date'] = $end_date;
            $where .= 'Cust_Master.Creation_Date <= STR_TO_DATE(:end_date, "%Y-%m-%d") AND ';
        } else {
            if (isset($start_date)) {
                $param_array[':end_date'] = $start_date;
                $where .= 'Order_Hdr.Order_Date <= STR_TO_DATE(:end_date, "%Y-%m-%d") AND ';
            }
        }

        // // this is used to identify orders which have not yet been sent to the 3rd party application
        // if (isset($UnsentOrdersFlag)) {
        //     if ($UnsentOrdersFlag == 'Y') {
        //         // $where .= ' ( Order_Hdr.Legacy_Order_No IS NULL OR Order_Hdr.Legacy_Order_No = "")  AND ';
        //         $where .= ' Order_Hdr.Legacy_Order_No is NULL AND ';
        //     }
        // }

        $where .= '1=1';

        //var_dump( $where );

// select CM.Channel , CM.Cust_No , CM.Cust_Name , CM.Outlet_Name , CM.Mobile_No , CM.Status, BA.Address , BA.Flat_No , BA.Locality , AM.Area_Name,BA.Pincode , BA.City_Code , C.City_Name,BA.State_Code , SM.State_Name
// from Cust_Master CM left join BBC_Addresses BA
// on CM.Cust_No = BA.User_No and BA.Login_Type = 'Buyer'
// left join Area_Master AM on BA.Locality = AM.Area_Code
// left Join City_Master C on BA.City_Code = C.City_Code
// left join State_Master SM on BA.State_Code = SM.State_Code
// where CM.Channel = 'F';
        try{
            $stmt = $this->pdo->prepare("select
        Order_Hdr.Order_No,
        Store_Master.Store_No,
        Store_Master.Store_Name,
        DATE_FORMAT(Order_Hdr.`Order_Date`, '%Y-%m-%d') as Order_Date,
        Order_Hdr.Order_Time as Order_Time,
        Order_Hdr.Order_Amount,
        Order_Hdr.Net_Amount,
        Order_Hdr.Header_Discount,
        Order_Hdr.Order_Status as Order_Status,
        Order_Hdr.Snap_Order_Code,
        Order_Hdr.Delivery_Charges,
        Order_Hdr.`Is_Modified` as Modified,
        Order_Hdr.`Payment_Status`,
        Order_Hdr.`Payment_Type`,
        Order_Hdr.`Cust_No`,
        COALESCE(Cust_Store_Master.`Supplier_Retailer_No`,'') as legacy_buyer_no,
        COALESCE(Store_Master.`Supplier_Store_No`,'') as legacy_supplier_no,
        Order_Hdr.`Cust_Type`,
        Order_Hdr.`FSO_No`,
        DATE_FORMAT(Order_Hdr.`Pref_Del_Date`, '%Y-%m-%d') as Delivery_Date,
        COALESCE(Order_Hdr.`Return_Order_No`,'') as Return_Order_No,
        COALESCE(Order_Hdr.`legacy_order_no`,'') as Source_Order_No,
        COALESCE(Order_Hdr.`Return_Order_No`,'') as Original_Order_No,
        Year(Order_Hdr.Order_Date) order_year
        from Order_Hdr inner join Cust_Master on Order_Hdr.Cust_No=Cust_Master.Cust_No
        inner join Store_Master on Order_Hdr.Store_No=Store_Master.Store_No
        inner join Cust_Store_Master on ( Order_Hdr.Store_No=Cust_Store_Master.Store_No and Order_Hdr.Cust_No=Cust_Store_Master.Cust_No  and Cust_Store_Master.Status='A')
        where " . $where . " Order By Order_Hdr.Order_No Desc ");

            // is this format to be used for order and delivery dates '%d-%b-%y'
            // var_dump($stmt);

            $stmt->execute($param_array);

            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

            if (!empty($arr)) { // we have retrieved a list of orders
                // echo "<pre>";
                // print_r($arr);

                // create the array of unique order status based on retrieved column 'Order_Status'
                // create the array for order year based on the retrieved column 'order_year'

                $order_year = array();
                $order_status = array();
                $order_year_temp = array();
                $order_status_temp = array();


                // create the array of order status and order year based on retrieved column 'Order_Status'
                foreach ($arr as $key => $val) {
                    array_push($order_year_temp, $arr[$key]['order_year']);
                    array_push($order_status_temp, $arr[$key]['Order_Status']);
                }

                // make the created array of order status and order year unique
                //TODO: possibly some more validation needed.
                $order_year = array_values(array_unique($order_year_temp));
                $order_status = array_values(array_unique($order_status_temp));

                // populate the payload to be returned.

                $msg = "Success";
                $status = true;
                $data['buyers'] = $arr;
                $data['stores'] = $order_status;
            } else {
                $msg = ' Couldnt find any orders ' . $orderDate . '.';
                $status = false;
            }
        }
        catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
            // return getResponse("Something went wrong", $status, $data);
        }
        return get_response($msg, $status, $data);
    }

    //Json input
    // businessID
    // StoreNo
    // CustNo
    // start_order_date [ format YYYY-MM-DD ]
    // end_order_date [ format YYYY-MM-DD ]
    // UnsentBuyersFlag
    public function get_buyers(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        // At this point we have input parameters in
        // $businessID, $StoreNo $CustNo, $start_order_date, $end_order_date, $UnsentBuyersFlag
        // ignore business_id for now.

        // if $StoreNo is passed then filter buyers associated for that store.
        // if $CustNo is passed then filter buyers for that CustNo.
        // if both order_start_date and order_end_date is passed then filter buyers for that date range.
        // if buyers are to be retrieved for a single date then that date will be passed in order_start_date parameter.
        // if an 'UnsentBuyersFlag' is set then retrieve only the buyers that do not have the legacy buyer no  populated.

        // TODO: validate input parameters.

        // build a where clause depending on the input parameters

        $param_array = array();
        $where = '';
        $wherechange = '';
        $wherenew = '';
        $msg = "Success";

        if (isset($start_order_date) && !empty($start_order_date)) {
            $param_array[':start_order_date'] = $start_order_date;
            $where .= 'CM.Creation_Date >= STR_TO_DATE(:start_order_date, "%Y-%m-%d") AND ';
        }

        if (isset($end_order_date)&& !empty($end_order_date)) {
            $param_array[':end_order_date'] = $end_order_date;
            $where .= 'CM.Creation_Date <= STR_TO_DATE(:end_order_date, "%Y-%m-%d") AND ';
        } else {
            if (isset($start_order_date) && !empty($start_order_date)) {
                $param_array[':end_order_date'] = $start_order_date;
                $where .= 'CM.Creation_Date <= STR_TO_DATE(:end_order_date, "%Y-%m-%d") AND ';
            }
        }

        if (isset($StoreNo) && $StoreNo > 0) {
            $param_array[':storeno'] = $StoreNo;
            $where .= " CSM.Store_no = :storeno AND ";
        }

        if (isset($CustNo) && $CustNo > 0) {
            $param_array[':custno'] = $CustNo;
            $where .= ' CM.Cust_No = :custno AND ';
        }

        $where .= ' 1=1 ';

        // this is used to identify buyers which have not yet been sent to the 3rd party application
        if (isset($UnsentBuyersFlag)) {
            if ($UnsentBuyersFlag == 'Y') {
                $wherenew = ' AND ( CM.Creation_Date >=  now() - interval 60 DAY )   AND CASE when CSM.Supplier_Retailer_No = "" then 0 else CSM.Supplier_Retailer_No end = 0 ';
                $wherechange = ' (CM.Login_Type <> "SCM") AND ( CM.Change_Date >=  now() - interval 1 DAY )  AND CASE when CSM.Supplier_Retailer_No = "" then 0 else CSM.Supplier_Retailer_No end > 0 ';

            }
        }

        try {

            // CSM.Supplier_Retailer_No Supplier_Retailer_No,

            $stmt = $this->pdo->prepare("SELECT CSM.Store_No seller_id,
COALESCE(SM.`Supplier_Store_No`,'') as legacy_supplier_no,
CM.Cust_No buyer_ID,
CM.Cust_Name buyer_name,
CASE when CSM.Supplier_Retailer_No = '' then 0 else CSM.Supplier_Retailer_No end Source_PartyID,
CM.Outlet_Name store_name,
CM.Mobile_No mobile_no,
CM.Status status,
CM.GSTIN as GSTIN,
CM.License_No as FSSAINo,
CM.License_Expiry_Date as FSSAIexpirydate,
CM.Creation_Date as Creation_Date,
CM.Creation_Time as Creation_Time,
CM.Change_Date as Change_Date,
CM.Change_Time as Change_Time,
BA.Latitude as Latitude,
BA.Longitude as Longitude
from Cust_Master CM
left outer join Cust_Store_Master CSM on CM.Cust_No = CSM.Cust_No and CSM.Status='A'
left outer join Store_Master SM on CSM.Store_No = SM.Store_No
left outer join BBC_Addresses BA on BA.User_No = CM.Cust_No AND BA.Login_Type='Buyer' AND BA.Status='A' AND BA.Default_Flag='A'
where CM.Status = 'A' and CSM.Store_No is not null AND
COALESCE(SM.`Supplier_Store_No`,0) != 0 AND
CASE when CSM.Supplier_Retailer_No = '' then 0 else CSM.Supplier_Retailer_No end = 0 AND "
                . $where . $wherenew . "
  union all
         SELECT CSM.Store_No seller_id,
         COALESCE(SM.`Supplier_Store_No`,'') as legacy_supplier_no,
         CM.Cust_No buyer_ID,
         CM.Cust_Name buyer_name,
         CASE when CSM.Supplier_Retailer_No = '' then 0 else CSM.Supplier_Retailer_No end Source_PartyID,
         CM.Outlet_Name store_name,
         CM.Mobile_No mobile_no,
         CM.Status status,
         CM.GSTIN as GSTIN,
         CM.License_No as FSSAINo,
         CM.License_Expiry_Date as FSSAIexpirydate,
         CM.Creation_Date as Creation_Date,
         CM.Creation_Time as Creation_Time,
         CM.Change_Date as Change_Date,
         CM.Change_Time as Change_Time,
         BA.Latitude as Latitude,
         BA.Longitude as Longitude
         from Cust_Master CM
         left outer join Cust_Store_Master CSM on CM.Cust_No = CSM.Cust_No and CSM.Status='A'
         left outer join Store_Master SM on CSM.Store_No = SM.Store_No
         left outer join BBC_Addresses BA on BA.User_No = CM.Cust_No AND BA.Login_Type='Buyer' AND BA.Status='A' AND BA.Default_Flag='A'
         where CM.Status = 'A' and CSM.Store_No is not null AND
         CASE when CSM.Supplier_Retailer_No = '' then 0 else CSM.Supplier_Retailer_No end > 0 AND
         COALESCE(SM.`Supplier_Store_No`,0) != 0 AND "  . $wherechange . "
          Order By Creation_Date, Creation_Time ");

            $stmt->execute($param_array);
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

            if (!empty($arr)) { // we have retrieved a list of buyers

                // try to get the buyer address details
                // $address_array holds the buyer addresses

                // Prepare the sql statement and then use each buyer to retrieve the buyers addresses.

                $buyer_address_query = $this->pdo->prepare("SELECT
CM.Cust_No buyer_ID
, BA.Address_ID address_id
, BA.Address_Type address_type
, BA.Address addr_lines
, BA.Flat_No Store_No
, BA.Locality locality
, AM.Area_Name area
, BA.Pincode pincode
, BA.City_Code city_code
, C.City_Name city_name
, BA.State_Code state_code
, SM.State_Name state_name
FROM Cust_Master CM left join BBC_Addresses BA
on CM.Cust_No = BA.User_No and BA.Login_Type = 'Buyer'
left join Area_Master AM on BA.Locality = AM.Area_Code
left Join City_Master C on BA.City_Code = C.City_Code
left join State_Master SM on BA.State_Code = SM.State_Code
left join Cust_Store_Master CSM on CM.Cust_No = CSM.Cust_No
WHERE CM.Cust_No = :cust_no; ");

                foreach ($arr as $key => $val) {
                    $param_arr[':cust_no'] = $arr[$key]['buyer_ID'];
                    $buyer_address_query->execute($param_arr);
                    $buyer_address_rows = array();
                    $buyer_address_rows = $buyer_address_query->fetchAll(PDO::FETCH_ASSOC);

                    if (sizeof($buyer_address_rows) == 0) {
                        $arr[$key]['buyer_address_rows'] = '';
                    } else {
                        // buyer has addresses
                        $arr[$key]['buyer_address_rows'] = $buyer_address_rows;
                    }
                }

                // populate the payload to be returned.
                $data['count'] = count($arr);
                $data['buyer'] = $arr;
                $msg = "Success";
                $status = true;
            } else {
                $msg = ' Couldnt find any buyers. ';
                $status = false;
            }
        } catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
        return get_response($msg, $status, $data);
    }

    /*
    {
    "Buyer_ID" : "2",
    "Buyer_Name" : "Priyanka Enterprises",
    "GSTIN": "",
    "PAN" : "",
    "Email_ID" : "",
    "License_No" : "",
    "Licence_Expiry_Date" : ""
    }*/
    public function update_buyer(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        $authtoken = $request->header('HTTP_AUTHORIZATION');
        $Creation_Date = date('Y-m-d H:i:s');

        try
        {
            $msg = "";
            $buyerid_flag = 1;
            $buyername_flag = 1;
            $licenseno_flag = 1;
            $buyerstatus_flag = 1;
            if (!(!empty($post['buyer_id']) && is_int($post['buyer_id']))) {
                $msg = " Invalid buyer id , ";
                $buyerid_flag = 0;

            }
            if (!(!empty($post['buyer_name']) && is_string($post['buyer_name']))) {
                $msg .= " Invalid buyer names , ";
                $buyername_flag = 0;
            }
            if (!empty($post['license_no'])) {
                if (empty($post['licence_expiry_date'])) {
                    $msg .= "license expiry required  , ";
                    $licenseno_flag = 0;
                }
            }

            if (!empty($post['licence_expiry_date'])) {
                if (empty($post['license_no'])) {
                    $msg .= "license number required, ";
                    $licenseno_flag = 0;
                }
            }

            // if (!empty($post['licence_expiry_date'])) {
            //     if (!empty($post['license_no'])) {
            //         $msg .= " Invalid license number and license expiry , ";
            //         $licenseno_flag = 0;
            //     }
            // }

            if (!(!empty($post['status']) && ($post['status'] == 'A' || $post['status'] == 'I' || $post['status'] == 'D'))) {
                $msg .= " Invalid buyer status ";
                $buyerstatus_flag = 0;
            }
            if (!($buyerid_flag == 1 && $buyername_flag == 1 && $licenseno_flag == 1 && $buyerstatus_flag == 1)) {
                $status = false;
                $data = '';
                return get_response($msg, $status, $data);
            }

            if (!empty($post['buyer_id'])) {
                $Cust_No = $post['buyer_id'];
                $stmtA = $this->pdo->prepare("select Cust_No, Supplier_Retailer_No from Cust_Store_Master where Supplier_Retailer_No='$Cust_No' LIMIT 1");
                $stmtA->execute();
                $rowA = $stmtA->fetch(PDO::FETCH_ASSOC);
                if (empty($rowA)) {
                    $msg = $Cust_No . " Buyer not found";
                    $status = false;
                    $data['buyer_id'] = $post['buyer_id'];
                    $data['buyer_name'] = $post['buyer_name'];
                    $data['email_id'] = $post['email_id'];
                    $data['GSTIN'] = $post['GSTIN'];
                    $data['PAN'] = $post['PAN'];
                    $data['license_no'] = $post['license_no'];
                    $data['licence_expiry_date'] = $post['licence_expiry_date'];
                    $data['status'] = $post['status'];
                    $data['seller_mapping'] = $post['seller_mapping'];;
                    return get_response($msg, $status, $data);

                }

                // Sending the request json in response body
                $data['buyer_id'] = $post['buyer_id'];
                $data['buyer_name'] = $post['buyer_name'];
                $data['email_id'] = $post['email_id'];
                $data['GSTIN'] = $post['GSTIN'];
                $data['PAN'] = $post['PAN'];
                $data['buyer_name'] = $post['email_id'];
                $data['license_no'] = $post['license_no'];
                $data['licence_expiry_date'] = $post['licence_expiry_date'];
                $data['status'] = $post['status'];

                $Source = 'SCM';
                $inputData = [];
                $inputData['User_No'] = $rowA['Cust_No'];
                $inputData['Login_Type'] = "Self";
                $inputData['Cust_Name'] = $post['buyer_name'];
                $inputData['Outlet_Name'] = $post['buyer_name'];
                $inputData['GSTIN'] = $post['GSTIN'];
                $inputData['PAN'] = $post['PAN'];
                $inputData['Email_ID'] = $post['email_id'];
                $inputData['Status'] = $post['status'];
                // $inputData['Mobile_No'] = $post['Contact_No'];
                $inputData['License_No'] = $post['license_no'];
                $inputData['License_Expiry_Date'] = $post['licence_expiry_date'];
                $inputData['Changed_By'] = $rowA['Cust_No'];
                $inputData['Changed_By_Login'] = "SCM";
                $inputData['Buyer_Speciality'] = "";
                $customer_no = $rowA['Cust_No'];
                $customer_status = $post['status'];

                $url = API_UPDATE_BUYER;
                $inputStr = json_encode($inputData);
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $inputStr);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', 'Content-Length: ' . strlen($inputStr), 'AuthType: staticauth', 'Authorization:' . getEnv('API_STATIC_AUTHTOKEN')));
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                $outputData = curl_exec($ch);
                curl_close($ch);
                // It remove the special character or BOM. Decode is not woking when this not used
                $removeBom = str_replace("\xEF\xBB\xBF", '', $outputData);
                $datanew = json_decode($removeBom, true);

                // if ($datanew['status'] == 'true') {
                //     $logArr['message'] = "Buyer Updated";
                //     return get_response($logArr['message'], true);
                // } else if ($datanew['status'] == "false") {
                //     $logArr['message'] = $data['message'];
                //     $status = $data['status'];
                //     return get_response($logArr['message'], false);
                // }

                // Code for checking the seller mapping
                $seller_list = $post['seller_mapping'];
                if (!empty($seller_list)) {
                    foreach ($seller_list as $key => $details) {
                        $data1[$key]['processed'] = 'false';
                        // $data1[$key]['reason'] = 'Not Processed: ';
                        $data1[$key]['seller'] = $details['seller'];
                        $data1[$key]['Status'] = $details['status'];
                        $data1[$key]['credit_limit'] = $details['credit_limit'];
                        $data1[$key]['credit_days'] = $details['credit_days'];
                        $data1[$key]['cust_class'] = $details['cust_class'];
                        $sellerid = $details['seller'];
                        $credit_limit = $details['credit_limit'];
                        $credit_days = $details['credit_days'];
                        $cust_class = $details['cust_class'];
                        $sellerstatus = $details['status'];
                        $seller_flag = 1;
                        $status_flag = 1;
                        $custclass_flag = 1;

                        // validation check for buyer mapping
                        if (!(!empty($details['seller']) && is_int($details['seller']))) {
                            //$data1[$key]['processed'] = 'false';
                            $data1[$key]['reason'] .= 'seller id not valid , ';
                            $seller_flag = 0;
                            //break;
                        }
                        if (!(!empty($details['status']) && ($details['status'] == 'A' || $details['status'] == 'I' || $details['status'] == 'D'))) {
                            //$data1[$key]['processed'] = 'false';
                            $data1[$key]['reason'] .= 'status is not valid , ';
                            $status_flag = 0;
                            //break;
                        }
                        if (!empty($details['cust_class'])) {
                            if (!($details['cust_class'] == 'A' || $details['cust_class'] == 'B' || $details['cust_class'] == 'C')) {
                                //$data1[$key]['processed'] = 'false';
                                $data1[$key]['reason'] .= 'Cust class is not valid , ';
                                $custclass_flag = 0;
                                //break;
                            }
                        }

                        // if (!(!empty($details['cust_class']) && ($details['cust_class'] == 'A' || $details['cust_class'] == 'B' || $details['cust_class'] == 'C'))) {
                        //     //$data1[$key]['processed'] = 'false';
                        //     $data1[$key]['reason'] .= 'Cust class is not valid , ';
                        //     $custclass_flag = 0;
                        //     //break;
                        // }

                        if ($seller_flag == 1 && $status_flag == 1 && $custclass_flag == 1) {
                            $stmtA = $this->pdo->prepare("select Store_No from Store_Master where Supplier_Store_No='$sellerid'");

                            $stmtA->execute();
                            //$stmtA->debugDumpParams();
                            $rowA = $stmtA->fetch(PDO::FETCH_ASSOC);
                            if (empty($rowA)) {
                                $data1[$key]['processed'] = 'false';
                                $data1[$key]['reason'] = 'Seller not found';
                                $sellerfoundstatus = 0;
                                //return get_response($msg, $status, $data);
                            } else {
                                $sellerfoundstatus = 1;
                                $StoreNo = $rowA['Store_No'];
                                $stmtB = $this->pdo->prepare("select Cust_No, Supplier_Retailer_no from Cust_Store_Master where Cust_No='$customer_no' and Store_No='$StoreNo'");
                                $stmtB->execute();
                                $rowB = $stmtB->fetch(PDO::FETCH_ASSOC);

                                if (empty($rowB)) {
                                    // code for inserting
                                    $stmt = $this->pdo->prepare("INSERT INTO Cust_Store_Master(
                            Cust_No,
                            Store_No,
                            Supplier_Retailer_No,
                            Credit_Limit,
                            Credit_Days,
                            Status,
                            Creation_Date,
                            Created_By,
                            Changed_Date,
                            Changed_By
                          ) values (' $customer_no' , ' $StoreNo' , '$Cust_No' , '$credit_limit' , '$credit_days' ,
                    '$sellerstatus' , '$Creation_Date' , '$Cust_No' , '$Creation_Date' , '$customer_no')");

                                    $data1[$key]['processed'] = 'true';
                                    $data1[$key]['reason'] = 'inserted';

                                } else {
                                    // code for updating
                                    $stmt = $this->pdo->prepare("UPDATE Cust_Store_Master SET
                        Status = '$sellerstatus',
                        credit_limit = '$credit_limit',
                        credit_days = '$credit_days',
                        cust_class = '$cust_class',
                        Changed_Date = '$Creation_Date',
                        Changed_By = '$customer_no' where Cust_No='$customer_no' and Store_No='$StoreNo'");
                                    $data1[$key]['processed'] = 'true';
                                    $data1[$key]['reason'] = 'updated ';
                                }
                                $stmt->execute();
                            }
                        } else {
                            break;
                        }
                    }
                    $seller_mapping_status = array_search('false', array_column($data1, 'processed'));
                    // var_dump(empty($seller_mapping_status));
                    // print_r($sellerfoundstatus);
                    if ($datanew['status'] == 'true') {
                        if (empty($seller_mapping_status) && $sellerfoundstatus) {
                            $msg = 'Buyer updated succesfully and sellers mapped';
                            $status = true;
                        } else {
                            $msg = 'Buyer updated succesfully and failure in seller mapping';
                            $status = false;
                        }
                    } else {
                        $msg = 'Buyer not updated';
                        $status = false;
                    }
                    $data['seller_mapping'] = $data1;
                    return get_response($msg, $status, $data);
                } else {
                    if ($datanew['status'] == 'true') {
                        $msg = 'Buyer updated succesfully and No Sellers found';
                    } else {
                        $msg = 'Buyer not updated and No Sellers found';
                    }
                    $status = false;
                    $data['buyer_id'] = $post['buyer_id'];
                    $data['buyer_name'] = $post['buyer_name'];
                    $data['email_id'] = $post['email_id'];
                    $data['GSTIN'] = $post['GSTIN'];
                    $data['PAN'] = $post['PAN'];
                    $data['license_no'] = $post['license_no'];
                    $data['licence_expiry_date'] = $post['licence_expiry_date'];
                    $data['status'] = $post['status'];
                    $data['seller_mapping'] = [];
                    return get_response($msg, $status, $data);
                }

            } else {
                return get_response("Buyer id can not be null", false);
            }

        } catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
    }
}
