<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class CheckOutController extends Controller
{
    public function checkout_page(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        try
        {
            $records_final=array();
            $query = $this->pdo->prepare("SELECT
		BA.`User_No` as `Cust_No`,
		COALESCE(BA.`Address_ID`,'') AS Address_ID,
		COALESCE(BA.`Name`,'') AS Name,
		COALESCE(BA.`Email_ID`,'') AS Email_ID,
		COALESCE(BA.`Flat_No`,'') AS Flat_No,
		COALESCE(BA.`Address`,'') AS Address,
		COALESCE(AM.`Area_Code`,'') as Area_Code,
		COALESCE(AM.`Area_Name`,'') as Locality,
		COALESCE(BA.`Pincode`,'') as pincode,
		COALESCE(BA.`City_Code`,'') AS City_Code,
		COALESCE(CM.`City_Name`,'') AS City_Name,
		COALESCE(BA.`State_Code`,'') AS State_Code,
		COALESCE(SM.`State_Name`,'') AS State_Name,
		COALESCE(BA.`Latitude`,'') AS Latitude,
		COALESCE(BA.`Longitude`,'') AS Longitude,
		COALESCE(BA.`Default_Flag`,'') AS Default_Flag,
		COALESCE(BA.`Contact_No`,'') as cont_no,
		COALESCE(BA.`Contact_No_Type`,'') as cont_no_type,
		COALESCE(BA.`Landmark`,'') as landmark
		FROM `BBC_Addresses` AS `BA`
		LEFT JOIN `City_Master` AS `CM` ON BA.`City_Code` = CM.`City_Code`
		LEFT JOIN `State_Master` AS `SM` ON BA.`State_Code` = SM.`State_Code`
		LEFT JOIN `Area_Master` AS `AM` ON AM.`Area_Code` = BA.`Locality`
		WHERE BA.`User_No` = '$Cust_No' AND BA.`Status` = 'A' AND BA.`Login_Type`='Buyer' Order By BA.`Default_Flag` ASC");

            $query->execute();
            $address = $query->fetchAll(PDO::FETCH_ASSOC);
            $data['address'] = $address;


            $address_id = $address[0]['Address_ID'];


            $data['store_delivery_details'] = getSoreDeliveryDetailsNew($this->pdo, $Store_No, $Cust_No, $address_id);
            $data['payments']  = getStorePaymentTypesNew($this->pdo,$Store_No);

            // for return estimated delivery date
            $data['est_del_date'] = calculatePrefDeliveryDate1($this->pdo,$Store_No,$Cust_No,$address_id);

            // flag true for return estimated delivery days
            $est_del_days = array_unique(calculatePrefDeliveryDate1($this->pdo,$Store_No,$Cust_No,$address_id,true));
            $all_days = [];
            foreach ($est_del_days as $del_days)
            {
                $all_days[$del_days]['daynum'] = $del_days;
                $all_days[$del_days]['dayname'] = date('l', strtotime("Sunday + $del_days Days"));
            }

            // used array_values function for remove numeric index from all_days array
            $data['est_del_days'] = array_values($all_days);

            $msg = "Success";
        }
        catch (PDOException $e)
        {
            $data = $e->getMessage();
            $status = false;
            $msg = "Something went wrong";
            // return getResponse($response, $msg, $status, $data);
        }

        return get_response($msg, $status, $data);
    }
}
