<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class CustomerController extends Controller
{
    public function update_customer_profile(Request $request){
        $post = $request->post();
        extract($post);
        $status = false;

        if(!isset($Login_Type)){
            $msg = "Login Type Missing";
        }else{

            if(strtolower($Login_Type) == 'self'){
                $table = 'Cust_Master';
                $userName = 'Cust_Name';
            } else {
                $table = 'FSO_Master';
                $userName = 'FSO_Name';
            }

            $stmt = $this->pdo->prepare("SELECT * FROM $table WHERE `Mobile_No` LIKE ? ");
            $stmt->execute([$mobile]);
            //$stmt->debugDumpParams();
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

            if(!empty($arr)){
                $Change_Date=date('Y-m-d');
                $Change_Time=date('H:i:s',strtotime('+5 hours 30 minutes'));

                $stmtU = $this->pdo->prepare("UPDATE $table SET $userName=?, Mobile_No=?, Email_ID=? WHERE Mobile_No=?");
                $updated = $stmtU->execute([$name, $mobile, $email, $mobile]);
                //$stmtU->debugDumpParams();

                if($updated == 1){
                    $msg = "User Profile Updated";
                    $status = true;
                }else{
                    $msg = "Profile Not Updated";
                }

            }else{
                $msg = "Invalid credentials";
            }

        }
        return get_response($msg, $status);
    }

    public function customer_change_password(Request $request){
        $post = $request->post();
        extract($post);
        $status = false;

        if(!isset($Login_Type)){
            $msg = "Login Type Missing";
        }else {

            if (strtolower($Login_Type) == 'self') {
                $table = 'Cust_Master';
                $stmt = $this->pdo->prepare("SELECT * FROM $table WHERE `Mobile_No` LIKE ? AND `Password` LIKE ? ");
                $stmt->execute([$mobile, $Old_Password]);
            } else {
                $table = 'FSO_Master';
                $stmt = $this->pdo->prepare("SELECT * FROM $table WHERE `Mobile_No` LIKE ? AND `Password` LIKE ? AND Login_Type = ?");
                $stmt->execute([$mobile, $Old_Password, $Login_Type]);
            }

            //$stmt = $this->pdo->prepare("SELECT * FROM $table WHERE `Mobile_No` LIKE ? AND `Password` LIKE ? ");
            //$stmt->execute([$mobile, $Old_Password]);
            //$stmt->debugDumpParams();
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);


            if (!empty($arr)) {
                $Change_Date = date('Y-m-d');
                $Change_Time = date('H:i:s', strtotime('+5 hours 30 minutes'));
                if (strtolower($Login_Type) == 'self') {
                    $stmtU = $this->pdo->prepare(" UPDATE $table set Password=?, Change_Date=?, Change_Time=? , Changed_By=? WHERE Mobile_No=? ");
                    $updated = $stmtU->execute(array($Password, $Change_Date, $Change_Time, $Changed_By, $mobile));
                } else {
                    $stmtU = $this->pdo->prepare(" UPDATE $table set Password=?, Change_Date=?, Change_Time=? , Changed_By=? WHERE Mobile_No=? AND Login_Type=?");
                    $updated = $stmtU->execute(array($Password, $Change_Date, $Change_Time, $Changed_By, $mobile, $Login_Type));
                }
                //$stmtU = $this->pdo->prepare(" UPDATE $table set Password=?, Change_Date=?, Change_Time=? , Changed_By=? WHERE Mobile_No=? ");
                //$updated = $stmtU->execute(array($Password, $Change_Date, $Change_Time, $Changed_By, $mobile));
                //$stmtU->debugDumpParams();

                if ($updated == 1) {
                    $msg = "User Password Updated";
                    $status = true;
                } else {
                    $msg = "Password Not Updated";
                }
            } else {
                $msg = "Invalid credentials";
            }
        }
        return get_response($msg, $status);
    }

    /*{
        "stock_data": {
        "cust_no": "3109",
        "Login_Type": "FSO",   --Can be FSO , Self , STADM
        "FSO_No": "",
        "stores": [
        {
        "store_no": "4",
        "items": [
        {
        "no": "813",
        "quantity": "4"
        },
        {
        "no": "872",
        "quantity": "2"
        }

        ]
        }
        ]
        }
        }
    */
    public function customer_store_inventory(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        $json_input_decode = array();

        $json_input_decode[':stock_data'] = $stock_data;

        $cust_no = $stock_data['cust_no'];
        $Login_Type = $stock_data['Login_Type'];
        $FSO_No = $stock_data['FSO_No'];
        try{
            if(isset($stock_data['stores']) && !empty($stock_data['stores'])){

                // echo"here";die();
                $final_array=array();
                for($i=0;$i<sizeof($stock_data['stores']);$i++){

                    $StoreNo=$stock_data['stores'][$i]['store_no'];

                    for($j=0;$j<sizeof($stock_data['stores'][$i]['items']);$j++)
                    {
                        $ArticleNo=$stock_data['stores'][$i]['items'][$j]['no'];
                        $quantity= $stock_data['stores'][$i]['items'][$j]['quantity'];

                        $row[0]['Article_No']=$ArticleNo;
                        $row[0]['Store_No']=$StoreNo;
                        $row[0]['quantity']=$quantity;
                        array_push($final_array, $row);

                    }
                    updateInventoryData($this->pdo,$cust_no, $StoreNo, $final_array, $Login_Type, $FSO_No);
                }

                $msg = "Inventory data updated successfully";
            }
            else
            {
                $msg = "Inventory data not updated successfully";
            }
        }
        catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }
        return get_response($msg, $status, $data);
    }

    public function customer_order_deliver(Request $request){
        $post = $request->post();
        extract($post);
        $status = true;
        $query="SELECT
				Order_Hdr.Store_No,
				Cust_Master.Cust_No,
				Cust_Master.Mobile_No,
				Cust_Master.Cust_Name,
				Order_Hdr.Payment_Status
			from Order_Hdr
			inner join Cust_Master on Order_Hdr.Cust_No=Cust_Master.Cust_No
			where Order_Hdr.Order_No=".$Order_No." ";
        $data = $this->pdo->query($query)->fetchAll(PDO::FETCH_ASSOC)[0];
        // print_r($data);die;
        if (count($data) > 0) {
            # code...
            $Cust_No=$data['Cust_No'];
            $phone_no=$data['Mobile_No'];
            $cust_name=$data['Cust_Name'];
            $store_no=$data['Store_No'];
            $Change_Date    = date('Y-m-d');
            //$Change_Time    = date('H:i:s',strtotime('+5 hours 30 minutes'));
            $Change_Time    = date('H:i:s');
            //$updatequery="UPDATE `Order_Hdr` SET `Order_Status`= 'Delivered' where `Order_No` = ".$Order_No." AND `Cust_No` = ".$Cust_No."";
            //Added by Meenal Barve to update Actual delivery date and Actual delivery time
            $updatequery="UPDATE `Order_Hdr` SET `Order_Status`= 'Delivered',`Actual_Del_Date` = '$Change_Date',`Actual_Del_Time`='$Change_Time' where `Order_No` = ".$Order_No." AND `Cust_No` = ".$Cust_No."";
            // echo $updatequery;die;
            $this->pdo->query($updatequery);

            $OrderID		= $Order_No;
            $Memo			= 'Order Delivered';
            $History_Date	= date('Y-m-d');
            //$History_Time	= date('H:i:s',strtotime('+5 hours 30 minutes'));
            $History_Time	= date('H:i:s');
            $Status 		= 'A';
            $Creation_Date  = date('Y-m-d');
            //$Creation_Time  = date('H:i:s',strtotime('+5 hours 30 minutes'));
            $Creation_Time  = date('H:i:s');
            $Created_By     = $Cust_No;
            $Changed_By     = $Cust_No;
            $Login_Type     = $Login_Type; //Added by Meenal B. to capture Login Type
            $User_No        = $User_No;    //Added by Meenal B. to capture User No

            /* $Insertquery = "INSERT INTO `Order_History`(`Order_ID`, `Memo`, `History_Date`, `History_Time`, `Status`, `Creation_Date`,`Creation_Time`, `Created_By`, `Change_Date`, `Change_Time`, `Changed_By`)
             VALUES (".$Order_No.", '".$Memo."', '".$History_Date."', '".$History_Time."', ".$Status.", '".$Creation_Date."', '".$Creation_Time."',".$Created_By.",'".$Change_Date."', ".$Change_Time.", ".$Changed_By.")";*/
            $Insertquery = "INSERT INTO `Order_History`(`Order_ID`, `Memo`, `History_Date`, `History_Time`, `Status`, `Creation_Date`,	`Creation_Time`, `Created_By`, `Change_Date`, `Change_Time`, `Changed_By` ,`Login_Type`)VALUES ('$Order_No', '$Memo', '$History_Date', '$History_Time', '$Status', '$Creation_Date', '$Creation_Time','$User_No', '$Change_Date', '$Change_Time', '$User_No' ,'$Login_Type')";
            // echo $Insertquery;die;
            $this->pdo->query($Insertquery);
            $lastInsertedHistoryID = $this->pdo->lastInsertId();

            $queryINSERT="SELECT Store_Name, Mobile_No_1, Mobile_No_2 from Store_Master where Store_No=".$store_no."";
            $rowresult = $this->pdo->query($queryINSERT)->fetchAll(PDO::FETCH_ASSOC)[0];
            //print_r($rowresult);die;
            $store_name=$rowresult['Store_Name'];
            $store_mobile_no_1=$rowresult["Mobile_No_1"];
            $store_mobile_no_2=$rowresult["Mobile_No_2"];

            $store_owner_mobile;
            if($store_mobile_no_1 != '' && $store_mobile_no_2 != '')
            {
                $store_owner_mobile = $store_mobile_no_1.",".$store_mobile_no_2;
            }else if($store_mobile_no_1 == '')
            {
                $store_owner_mobile = $store_mobile_no_2;
            }else if($store_mobile_no_2 == '')
            {
                $store_owner_mobile = $store_mobile_no_1;
            }

            if(isset($_REQUEST['store_id'])){

                /*$message_sms = generate_sms(DELIVERED_ANDROID, array($Order_No,$store_name));
                Submit(SMS_HOST,SMS_PORT,SMS_USERNAME,SMS_PASSWORD,SMS_SENDER,$message_sms,$phone_no,SMS_MSG_TYPE,SMS_DLR);	*/

                SubmitSMS($phone_no, 'DELIVERED_ANDROID', array($Order_No,$store_name));

            } else {

                /*$message_sms = generate_sms(DELIVERED_ANDROID, array($Order_No,$store_name));
                Submit(SMS_HOST,SMS_PORT,SMS_USERNAME,SMS_PASSWORD,SMS_SENDER,$message_sms,$phone_no,SMS_MSG_TYPE,SMS_DLR);*/

                SubmitSMS($phone_no, 'DELIVERED_ANDROID', array($Order_No,$store_name));

            }

            $message = "Order Delivered successfully";
            send_api_notification($this->pdo,'customer_order_deliver', $Cust_No, 'Self');

            $fData = [];
            $fData['History_ID'] = $lastInsertedHistoryID;
            return get_response($message, $status, $fData);

        }
        else{

            $message="Order Not Found";
            //send_api_notification($this->pdo,'customer_order_deliver', $Cust_No, 'Self');
            return get_response($message, $status);
        }
    }
}
