<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;

class FSOController extends Controller
{
    /*
    {
    "Buyer_ID" : "2",
    "Buyer_Name" : "Priyanka Enterprises",
    "GSTIN": "",
    "PAN" : "",
    "Email_ID" : "",
    "License_No" : "",
    "Licence_Expiry_Date" : ""
    }*/
    public function fso_offline_signup(Request $request){
        $post = $request->post();
        $url = FSO_RETAILER_SIGNUP_URL;

        $inputStr = json_encode($post);
        $headers = apache_request_headers();

        $headers_data = array('Content-Type: application/json',
            "Authorization: $headers[Authorization]",
            'AuthType: '.$headers['AuthType'],
            'Content-Length: ' . strlen($inputStr));


        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $inputStr);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers_data);
        $headers = apache_request_headers();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
        curl_setopt($ch, CURLOPT_VERBOSE, true);
        $outputData = curl_exec($ch);

        $outputData = str_replace("\xEF\xBB\xBF",'',$outputData);
        return $outputData;

        /* $info = curl_getinfo($ch);
        curl_close($ch);

        // It remove the special character or BOM. Decode is not woking when this not used
        $removeBom = str_replace("\xEF\xBB\xBF",'',$outputData);
        $data = json_decode($removeBom);
        return getResponse($data['message']."daya", $data['status']); */
    }

    /****
    fso_retailer_signup
    1. insert retailer in Cust_Master in active status
    2. add mapping entry in cust_store_master,bbc_org_group_users
     ****/

    /******** JSON INPUT
    {"name":"shivshakti", "mobile":"9898989898","password":"daya","gstin":"54lrgd57trelre","pan":"fldsfjl","channel":"M","cust_type": "I" or "B","fsono","10",
    "mapping":[{"supplier":"2","beatroute":"134"},
    {"supplier":"11","beatroute":"54"},
    {"supplier":"17","beatroute":"99"},
    {"supplier":"12","beatroute":"111"}
    ]
    }
     ********/
    public function fso_retailer_signup(Request $request){
        $outputData = [];
        $post = $request->post();

        // extract($post);
        $custData = $post['cust_details'];
        // print_r($custData);die;
        $User_No = $custData['custno'];
        $created_by = $custData['fsono'];


        $name = $custData['name'];

        $outlet_name = $custData['outlet_name'];



        $str_name = "/[0-9]{10}/i";

        $name = trim($name);
        $name = str_replace('  ', ' ', $name);

        $outlet_name = trim($outlet_name);
        $outlet_name = str_replace('  ', ' ', $outlet_name);


        $validate_name = preg_match($str_name, $name, $validate_name, PREG_OFFSET_CAPTURE); //return 1 if digits > 9 else return 0
        $validate_outlet_name = preg_match($str_name, $outlet_name, $validate_outlet_name, PREG_OFFSET_CAPTURE); //return 1 if digits > 9 else return 0


        $status = true;
        //$data = [];

        try {
            $this->pdo->beginTransaction();

            if ($validate_name == 0 && $validate_outlet_name == 0) {
                $name = $name;
                $outlet_name = $outlet_name;


                // Sheetal Chive
                //  Added Condition : if name and outlet name is empty then data should not be save into db
                //  07-04-2022

                if($name == '' && $outlet_name == '')
                {
                    $msg = "The name and outlet name is empty please filled valid name and outlet name ";
                    $status = false;
                    return get_response($msg, $status);
                }
                $status = true;
                if ($custData['login_type'] == 'Self') {


                    $outputData = [];
                    $post=$custData;
                    ####Check retailer is exists
                    $isExists = $this->checkRetailerExists1($this->pdo, $post);

                    if($isExists == false){

                        ##### Add retailer into db with inactive status
                        $custNo = $this->insertRetailer1($this->pdo, $post);
                        if($custNo > 0) {
                            ##### dev-17 create default address of Customer with input city
                            if ($post['city'] !='' ) {
                                $ans = $this->retailerCreateDefaultAddress($this->pdo,$custNo,$post['mobile'],$post['gstin'],$name,$post['city'],$post['locality']);
                                if ($ans == false) {
                                    //$status= true;
                                    $msg = "Prospective Customer Added,Customer Address could not be created";
                                } else {
                                    $msg = "Prospective Customer Added,Customer Address created";
                                    $outputData['address_Id'] = $ans;
                                }
                            }else
                                $msg = "Prospective Customer Added";
                        } else {
                            $msg = "Something Went Wrong";
                            $status = false;
                        }
                    } else {
                        $msg = $isExists;
                        $status = false;
                    }


                    $custNo = $User_No;
                }else {


                    ##### Add retailer into db with active status
                    $custNo = $this->fsoinsertRetailer($this->pdo, $custData);
                    // print_r($custNo);die;
                    $outputData['custNo'] = $custNo;
                    ##### dev-17 create default address of Customer with input city

                    if ($custData['city'] != '') {
                        $ans = $this->retailerCreateDefaultAddress($this->pdo, $custNo, $custData['mobile'], $custData['gstin'], $custData['name'], $custData['city'], $custData['locality']);
                        if ($ans == false) {

                            $msg = "Retailer Added/Mapped Successfully,Customer Address could not be created";
                        } else {
                            $msg = "Retailer Added/Mapped Successfully,Customer Address created";
                            $outputData['address_Id'] = $ans;
                        }
                    }
                    $msg="Retailer Added/Mapped Successfully.";
                }


                $this->pdo->commit();

                //send notification for offline syncing
                //***************************************************************************
                //send_api_notification($this->pdo,'fso_retailer_signup', $custNo, 'Self');
                //***************************************************************************

                //return getResponse($msg, $status, $outputData);

                $this->returnDataSignup($this->pdo, $msg, $status, $outputData, $custNo, 'Self');
            } else {
                $msg = "Please enter valid Name or outlet name which has digits less than 10";
                $status = false;
                $outputData = [];
                $custNo = '';
                $this->returnDataSignup($this->pdo, $msg, $status, $outputData, $custNo, 'Self');
                // die;
                // $this->returnDataSignup($this->pdo, $msg, $status, $outputData);
            }



        }
        catch (PDOException $e) {

            $this->pdo->rollback();
            $data = $e->getMessage();
            //return  getResponse("Something went wrong", false, $outputData);
            $this->returnDataSignup($this->pdo, "Something went wrong", false, $data, $User_No, 'Self');
        }
    }

     /****
     * insertRetailer
     * insert reatailer, insert mapping, send sms
     * @param: $pdo : is pdo object
     * @param: $post : is post input data array
     * return cust_no or false
     ****/
    private function fsoinsertRetailer($pdo, $custData){


        //$password=md5(trim($password));
        $password=trim($custData['password']); //Removed MD5 as Android app is already converting password into MD5
        $otp = str_pad(mt_rand(1000, 9999), 4, '0', STR_PAD_LEFT);
        $otp_count = 0; //no otp is sent so set count as zero
        $excluded = 'N';
        $status   = 'A';  //FSO creates retailer in active mode as no OTP is sent to activate the account
        $channel  = 'F'; //F means FSO has created this retailer
        $creation_date  = date('Y-m-d');
        $creation_time  = date('H:i:s');
        $created_by     = $custData['fsono'];
        $custNo         = $custData['custno'];
        $change_date    = $creation_date;
        $change_time    = $creation_time;
        $changed_by     = $created_by;
        $cust_type      = $custData['cust_type']; //Added by Meenal B. 27th Sep 2018 cust_type (I/B)
        $ref_code       = $custData['ref_code']; //Added by Meenal B. 15th Jan 2019 ref_code
        $mapping        = $custData['mapping'];
        $name           = $custData['name'];
        //$outlet_name    = $custData['name'];
        $outlet_name    = $custData['outlet_name'];
        $mobile         = $custData['mobile'];
        $gstin          = $custData['gstin'];
        $pan            = $custData['pan'];
        $license_no     = $custData['licenseno'];
        $sno            = $custData['store_no'];//in case mapping object is not passed
        $license_expiry_date = $custData['license_expiry_date'];
        $city                = $custData['city']; //dev-17
        $Speciality = 0; //added by swanand for buyer catalog
        $Business_ID = $custData['Business_ID'];
        $store_no = $custData['store_no'];
        $locality = $custData['locality'];

        // Sheetal Chive
        // 06 - 04 - 2022
        // handeled the condition that the date is in any form like y-m-d or d-m-y .
        // it should be save in db in the form of YYYY - MM - DD

        $license_expiry_date  = date('Y-m-d',strtotime($license_expiry_date));

        $name = trim($name);
        $name = str_replace('  ', ' ', $name);

        $outlet_name = trim($outlet_name);
        $outlet_name = str_replace('  ', ' ', $outlet_name);

        // print_r($license_expiry_date);die;
        //$latitude       = $custData['latitude'];  //Customer signup coordinates
        //$longitude      = $custData['longitude']; //Customer signup coordinates
        /*if ($cust_type =='I')
        $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status) values('$name','$name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code' , '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status')";
        else
        $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status) values('$name','$outlet_name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code' , '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status')";*/
        //echo $password.$channel.$created_by.$cust_type.$name.$mobile;
        if ($custNo >0) { //if customer present
            // foreach ($mapping as $key => $mapData) {
            // $this->retailerBeatrouteMapping($pdo, $custNo, $mapData['supplier'],$mapData['beatroute'],$custData['fsono']/*,$latitude,$longitude*/);
            //  }
            if(empty($mapping))
            {
                if($Business_ID==3)
                {
                    $getBeatRoute = "SELECT User_Group_Name , ID from BBC_Org_User_Groups where Store_No = '$store_no' and User_Group_Name = 'Call Center Route'";
                    $getBeatRouteResult =$pdo->query($getBeatRoute)->fetch(PDO::FETCH_ASSOC);
                    // print_r($getBeatRouteResult['ID']);
                    // die();
                    $beatroute = $getBeatRouteResult['ID'];
                    if($getBeatRouteResult)
                    {
                        $this->retailerBeatrouteMappingNew($pdo, $custNo, $store_no,$beatroute,$Business_ID,$created_by);
                    }
                }
            }
            else
            {
                $countMapping = count($mapping);
                $count = 0;
                foreach ($mapping as $key => $mapData) {
                    if($Business_ID == 3)
                    {
                        $store_number = $mapData['supplier'];
                        $beatrouteId = $mapData['beatroute'];
                        $getBeatRouteCenter = "SELECT User_Group_Name from BBC_Org_User_Groups where Store_No = '$store_number' and User_Group_Name = 'Call Center Route' and ID = '$beatrouteId'" ;
                        $getBeatRouteCenterResult = $pdo->query($getBeatRouteCenter)->fetch(PDO::FETCH_ASSOC);

                        if(empty($getBeatRouteCenterResult))
                        {
                            $count++;
                            $this->retailerBeatrouteMapping($pdo, $custNo, $mapData['supplier'],$mapData['beatroute'],$Business_ID,$created_by/*,$latitude,$longitude*/);
                        }
                        else
                        {
                            $getBeatRoute = "SELECT User_Group_Name , ID from BBC_Org_User_Groups where Store_No = '$store_no' and User_Group_Name = 'Call Center Route'";
                            $getBeatRouteResult =$pdo->query($getBeatRoute)->fetch(PDO::FETCH_ASSOC);
                            // print_r($getBeatRouteResult['ID']);
                            // die();
                            $beatroute = $getBeatRouteResult['ID'];
                            if($getBeatRouteResult)
                            {
                                $this->retailerBeatrouteMappingNew($pdo, $custNo, $mapData['supplier'],$mapData['beatroute'],$Business_ID,$created_by);
                            }
                        }
                    }
                    else
                    {
                        $this->retailerBeatrouteMapping($pdo, $custNo, $mapData['supplier'],$mapData['beatroute'],$Business_ID,$created_by/*,$latitude,$longitude*/);
                    }
                }

                if($countMapping == $count)
                {
                    // echo"count";
                    $getBeatRoute = "SELECT User_Group_Name , ID from BBC_Org_User_Groups where Store_No = '$store_no' and User_Group_Name = 'Call Center Route'";
                    $getBeatRouteResult =$pdo->query($getBeatRoute)->fetch(PDO::FETCH_ASSOC);
                    $beatroute = $getBeatRouteResult['ID'];
                    if($getBeatRouteResult)
                    {
                        $this->retailerBeatrouteMappingNew($pdo, $custNo, $store_no,$beatroute,$Business_ID,$created_by);
                    }
                }

                // print_r($countMapping);
                // echo"<br>";
                // print_r($count);
                // die();
            }

        }
        else { //if customer not present
            // print_r("here");
            // die();
            if ($cust_type =='I'){
                // print_r("expression");
                // die();
                ### Insert as indivisual
                $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status,License_No,License_Expiry_Date , Speciality_Id) values('$name','$outlet_name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code', '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status','$license_no','$license_expiry_date','$Speciality')";
            } else {
                ### Insert as a Outlet
                // print_r($license_expiry_date);die;

                $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status,License_No,License_Expiry_Date , Speciality_Id) values('$name','$outlet_name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code' , '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status','$license_no','$license_expiry_date','$Speciality')";

                ### Update otp to all outlet with the same mobile number ###
                #updateOutletsOtp($pdo, $otp, $mobile); commented by Meenal B. for FSO retailer signup
            }
            // print_r($query);
            // die();

            if($pdo->query($query)){
                // echo"id";
                // die();
                $custNo=$pdo->lastInsertId();
                // print_r($custNo);
                // die();
                ##### Add retailer store mapping #####
                ##### Add retailer store mapping #####
                //if(empty($mapping) && $sno !='') {  //sph-b2c-bugfix
                if(empty($mapping) && ($sno !='' || $sno>0)) {  //sph-b2c-buffix , insert only of store no >0
                    $query = "INSERT INTO Cust_Store_Master
            (Cust_No , Store_No , Supplier_Retailer_No , Credit_Limit , Credit_Days ,
            Creation_Date , Created_By , Changed_Date , Changed_By , Status)VALUES ('$custNo',
                    '$sno',
                     (select Get_Cust_Legacyno('$custNo','$sno','$Business_ID') ),
                    '200000.00',
                    '0',
                    '$creation_date',
                    '$created_by',
                    '$creation_date',
                    '$created_by',
                    'A')";
                    $pdo->query($query);

                    if($Business_ID==3)
                    {
                        $getBeatRoute = "SELECT User_Group_Name , ID from BBC_Org_User_Groups where Store_No = '$store_no' and User_Group_Name = 'Call Center Route'";
                        $getBeatRouteResult =$pdo->query($getBeatRoute)->fetch(PDO::FETCH_ASSOC);
                        // print_r($getBeatRouteResult['ID']);
                        // die();
                        $beatroute = $getBeatRouteResult['ID'];
                        if($getBeatRouteResult)
                        {
                            $this->retailerBeatrouteMappingNew($pdo, $custNo, $store_no,$beatroute,$Business_ID,$created_by);
                        }
                    }
                }
                else {
                    $countMapping = count($mapping);
                    $count = 0;
                    foreach ($mapping as $key => $mapData) {
                        if($Business_ID == 3)
                        {
                            // echo"here";
                            // die();
                            $store_number = $mapData['supplier'];
                            $beatrouteId = $mapData['beatroute'];
                            $getBeatRouteCenter = "SELECT User_Group_Name from BBC_Org_User_Groups where Store_No = '$store_number' and User_Group_Name = 'Call Center Route' and ID = '$beatrouteId' " ;
                            $getBeatRouteCenterResult = $pdo->query($getBeatRouteCenter)->fetch(PDO::FETCH_ASSOC);

                            if(empty($getBeatRouteCenterResult))
                            {
                                $count++;
                                $this->retailerBeatrouteMapping($pdo, $custNo, $mapData['supplier'],$mapData['beatroute'],$Business_ID,$created_by/*,$latitude,$longitude*/);
                            }
                            else
                            {
                                $getBeatRoute = "SELECT User_Group_Name , ID from BBC_Org_User_Groups where Store_No = '$store_no' and User_Group_Name = 'Call Center Route'";
                                $getBeatRouteResult =$pdo->query($getBeatRoute)->fetch(PDO::FETCH_ASSOC);
                                // print_r($getBeatRouteResult['ID']);
                                // die();
                                $beatroute = $getBeatRouteResult['ID'];
                                if($getBeatRouteResult)
                                {
                                    $this->retailerBeatrouteMappingNew($pdo, $custNo, $mapData['supplier'],$mapData['beatroute'],$Business_ID,$created_by);
                                }
                            }
                        }
                        else
                        {
                            $this->retailerBeatrouteMapping($pdo, $custNo, $mapData['supplier'],$mapData['beatroute'],$Business_ID,$created_by/*,$latitude,$longitude*/);
                        }

                    }
                    if($countMapping == $count)
                    {
                        // echo"count";
                        $getBeatRoute = "SELECT User_Group_Name , ID from BBC_Org_User_Groups where Store_No = '$store_no' and User_Group_Name = 'Call Center Route'";
                        $getBeatRouteResult =$pdo->query($getBeatRoute)->fetch(PDO::FETCH_ASSOC);
                        $beatroute = $getBeatRouteResult['ID'];
                        if($getBeatRouteResult)
                        {
                            $this->retailerBeatrouteMappingNew($pdo, $custNo, $store_no,$beatroute,$Business_ID,$created_by);
                        }
                    }
                }
                return $custNo;
            } else {
                return false;
            }
        }
    }

     /****
     * retailerStoreFSOMapping
     * insert retailer store fso mapping with dummy fso no : 1
     * @param: $pdo : is pdo object
     * @param: $custNo : cust_no/ retailer no
     * @param: $store_no : store no
     ****/
    private function retailerBeatrouteMapping($pdo, $custNo, $store_no,$beatroute,$bno,$created_by/*,$latitude,$longitude*/){
        $creation_date  = date('Y-m-d H:i:s',strtotime('+5 hours 30 minutes'));
        // print_r($created_by);die;

        // $created_by     = $fsono;
        /*$query = "INSERT INTO `Cust_FSO_Lookup` (`Cust_No`, `Store_No`, `FSO_No`, `Status`, `Creation_Date`, `Created_By`, `Changed_Date`, `Changed_By`) VALUES ('$custNo', '$store_no', '1', 'A', '$creation_date', '$created_by', '$creation_date', '$created_by')";*/
        //Added by Meenal Barve 15th April 2019 added 0 to new column Supplier_Legacy_No
        //Check if record already present in Cust_Store_MAster
        $query ="SELECT 1 from Cust_Store_Master
             WHERE  Cust_No ='$custNo' AND Store_No='$store_no' AND Status='A'";

        $data =$pdo->query($query)->fetchAll(PDO::FETCH_ASSOC);
        $result = true;
        if (count($data)==0) {
            $query = "INSERT INTO Cust_Store_Master
     (Cust_No , Store_No , Supplier_Retailer_No , Credit_Limit , Credit_Days ,
            Creation_Date , Created_By , Changed_Date , Changed_By , Status) VALUES ('$custNo',
            '$store_no',
             (select Get_Cust_Legacyno('$custNo','$store_no','$bno')),
             '200000.00',
             '0',
             '$creation_date',
             '$created_by',
             '$creation_date',
             '$created_by',
             'A'
             )";
            $result = $pdo->query($query);

        }
        if($result) {
            //Insert into BBC_Org_Group_Users
            $query = "INSERT INTO BBC_Org_Group_Users (Org_Group_ID,
        Store_No,
        User_No,
        Login_Type,
        Status,
        Creation_Date,
        Created_By,
        Changed_Date,
        Changed_By)
        VALUES ('$beatroute',
            '$store_no',
             '$custNo',
             'Buyer',
             'A',
             '$creation_date',
             '$created_by',
             '$creation_date',
             '$created_by')";
            $pdo->query($query);

        }
    }

    /****
     * checkRetailerExists
     * @param: $pdo : is pdo object
     * @param: $post : is post input data array
     * return error msg or false
     ****/
    private function checkRetailerExists1($pdo, $post){
        extract($post);
        $msg = '';
        //Added by Meenal B. 28th September 2018
        if ($cust_type=='I') {
            $append_name = 'customer';
            $query="select * from Cust_Master where Mobile_No='$mobile'";
        }
        else {
            $append_name = 'outlet';
            $query="select * from Cust_Master where Mobile_No='$mobile' and Outlet_Name='$outlet_name'";
        }

        $data =$pdo->query($query)->fetchAll(PDO::FETCH_ASSOC);
        if(count($data) > 0){
            $data = $data['0'];
            if($data['Status'] == 'I' && $data['Excluded'] == 'Y'){
                $msg = 'You are a registered '.$append_name.' but your account has not been activated yet. Please contact Customer care to activate your account.';
            } else if($data['Status'] == 'I' && $data['OTP_Count'] < 5){
                $msg = 'You are a registered '.$append_name.' but your account has not been activated yet. Please activate your account.';
            } else if($data['Status'] == 'I' && $data['OTP_Count'] >= 5){
                $msg = 'You are a registered '.$append_name.' but your account has not been activated yet. Please contact Customer care to activate your account.';
            } else {
                $msg = 'Your number is already registered and activated with us. Please login to continue';
            }
            return $msg;
        } else {
            return false;
        }

    }

    /****
     * insertRetailer
     * insert reatailer, insert mapping, send sms
     * @param: $pdo : is pdo object
     * @param: $post : is post input data array
     * return cust_no or false
     ****/
    private function insertRetailer1($pdo, $post){
        //extract($post);

        //$password=md5(trim($password));
        /*$password=trim($password); //Removed MD5 as Android app is already converting password into MD5
        $otp = str_pad(mt_rand(1000, 9999), 4, '0', STR_PAD_LEFT);
        $otp_count = 1;
        $excluded = 'N';
        $status         = 'I';
        if($channel == '') $channel = 'M';
        $creation_date  = date('Y-m-d');
        $creation_time  = date('H:i:s',strtotime('+5 hours 30 minutes'));
        $created_by     = '0';
        $change_date    = $creation_date;
        $change_time    = $creation_time;
        $changed_by     = $created_by;
        $cust_type      = $cust_type; //Added by Meenal B. 27th Sep 2018 cust_type (I/B)
        $ref_code       = $ref_code; //Added by Meenal B. 15th Jan 2019 ref_code
        */

        $password=trim($post['password']); //Removed MD5 as Android app is already converting password into MD5
        $otp = str_pad(mt_rand(1000, 9999), 4, '0', STR_PAD_LEFT);
        $otp_count = 1;
        $excluded = 'N';
        $status   = 'I';
        $channel  = $post['channel'];
        if($channel == '') $channel = 'M';
        $creation_date  = date('Y-m-d');
        $creation_time  = date('H:i:s');
        $created_by     = '0';
        $custNo         = $post['custno'];
        $change_date    = $creation_date;
        $change_time    = $creation_time;
        $changed_by     = $created_by;
        $cust_type      = $post['cust_type']; //Added by Meenal B. 27th Sep 2018 cust_type (I/B)
        $ref_code       = $post['ref_code']; //Added by Meenal B. 15th Jan 2019 ref_code
        $mapping        = $post['mapping'];
        $name           = $post['name'];
        $outlet_name    = $post['outlet_name'];
        $mobile         = $post['mobile'];
        $gstin          = $post['gstin'];
        $pan            = $post['pan'];
        $store_no       = $post['store_no'];
        $license_no     = $post['licenseno'];
        $license_expiry_date = $post['license_expiry_date'];
        $Speciality = 0;
        $Business_ID = $post['Business_ID'];


        // Sheetal Chive
        // 06 - 04 - 2022
        // handeled the condition that the date is in any form like y-m-d or d-m-y .
        // it should be save in db in the form of YYYY - MM - DD

        $license_expiry_date  = date('Y-m-d',strtotime($license_expiry_date));


        /*if ($cust_type =='I')
        $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status) values('$name','$name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code' , '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status')";
        else
        $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status) values('$name','$outlet_name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code' , '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status')";*/

        if ($cust_type =='I'){
            ### Insert as indivisual
            $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status,License_No,License_Expiry_Date , Speciality_Id) values('$name','$outlet_name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code', '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status','$license_no','$license_expiry_date' , '$Speciality')";
        } else {
            ### Insert as a Outlet
            $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status,License_No,License_Expiry_Date , Speciality_Id) values('$name','$outlet_name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code' , '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status','$license_no','$license_expiry_date', '$Speciality')";

        }
        ### Update otp to all outlet with the same mobile number ###
        $this->updateOutletsOtp($pdo, $otp, $mobile);

        if($pdo->query($query)){
            $custNo=$pdo->lastInsertId();

            //Only perform the follwing if Store_no >0 i.e store no available at the time of signup
            //sph-b2c-bugfix
            if ($store_no >0) {   //sph-b2cbugfix
                ##### Add retailer store mapping #####
                $this->retailerStoreFSOMapping1($pdo, $custNo, $store_no,$Business_ID);

                if($Business_ID==3)
                {
                    $getBeatRoute = "SELECT User_Group_Name , ID from BBC_Org_User_Groups where Store_No = '$store_no' and User_Group_Name = 'Call Center Route'";
                    $getBeatRouteResult =$pdo->query($getBeatRoute)->fetch(PDO::FETCH_ASSOC);
                    // print_r($getBeatRouteResult['ID']);
                    // die();
                    $beatroute = $getBeatRouteResult['ID'];
                    if($getBeatRouteResult)
                    {
                        $this->retailerBeatrouteMappingNew($pdo, $custNo, $store_no,$beatroute,$Business_ID,$created_by);
                    }
                }
            } //sph-b2cbugfix

            ##### Send SMS #####
            /*$smsMsg = generate_sms(OTP, array($otp));
            Submit(SMS_HOST,SMS_PORT,SMS_USERNAME,SMS_PASSWORD,SMS_SENDER, $smsMsg, $mobile,SMS_MSG_TYPE,SMS_DLR);*/
            $Login_Display_Name='Buyer'; //This is hard coded for now as signup is for Buyer's only
            SubmitSMS($mobile, 'OTP', array($otp,$Login_Display_Name));

            return $custNo;
        } else {
            return false;
        }

    }

    //created for business id 3
    private function retailerBeatrouteMappingNew($pdo, $custNo, $store_no,$beatroute,$bno,$created_by/*,$latitude,$longitude*/){
        $creation_date  = date('Y-m-d H:i:s',strtotime('+5 hours 30 minutes'));
        // $created_by     = $fsono;

        // print_r($pdo);die;

        /*$query = "INSERT INTO `Cust_FSO_Lookup` (`Cust_No`, `Store_No`, `FSO_No`, `Status`, `Creation_Date`, `Created_By`, `Changed_Date`, `Changed_By`) VALUES ('$custNo', '$store_no', '1', 'A', '$creation_date', '$created_by', '$creation_date', '$created_by')";*/
        //Added by Meenal Barve 15th April 2019 added 0 to new column Supplier_Legacy_No
        //Check if record already present in Cust_Store_MAster
        $query ="SELECT 1 from Cust_Store_Master
             WHERE  Cust_No ='$custNo' AND Store_No='$store_no' AND Status='A'";

        $data =$pdo->query($query)->fetchAll(PDO::FETCH_ASSOC);
        $result = true;
        if (count($data)==0) {
            $query = "INSERT INTO Cust_Store_Master
     (Cust_No , Store_No , Supplier_Retailer_No , Credit_Limit , Credit_Days ,
            Creation_Date , Created_By , Changed_Date , Changed_By , Status) VALUES ('$custNo',
            '$store_no',
             (select Get_Cust_Legacyno('$custNo','$store_no','$bno')),
             '200000.00',
             '0',
             '$creation_date',
             '$created_by',
             '$creation_date',
             '$created_by',
             'A'
             )";
            $result = $pdo->query($query);

        }
        if($result) {
            //Insert into BBC_Org_Group_Users
            $query = "INSERT INTO BBC_Org_Group_Users (Org_Group_ID,
        Store_No,
        User_No,
        Login_Type,
        Status,
        Creation_Date,
        Created_By,
        Changed_Date,
        Changed_By)
        VALUES ('$beatroute',
            '$store_no',
             '$custNo',
             'Buyer',
             'A',
             '$creation_date',
             '$created_by',
             '$creation_date',
             '$created_by')";
            $pdo->query($query);

        }
    }

     //dev-17 create default Address for Customer
        /****
         * retailerStoreFSOMapping
         * insert retailer store fso mapping with dummy fso no : 1
         * @param: $pdo : is pdo object
         * @param: $custNo : cust_no/ retailer no
         * @param: $store_no : store no
         ****/
    private function retailerCreateDefaultAddress($pdo,$custNo,$mobile,$gstin,$name,$city,$locality){
        // print_r($locality);die;

        $query = "insert INTO BBC_Addresses(Address_Type,
    User_No,
    Login_Type,
    GSTIN,
    Name,
    City_Code,
    State_Code,
    Latitude,
    Longitude,
    Contact_No,
    Contact_No_Type,
    Status,
    Default_Flag,
    Creation_Date,
    Created_By,
    Changed_Date,
    Changed_By,
    Locality
    )
    values
    ('Delivery',
    '$custNo',
    'Buyer',
    '$gstin',
    '$name',
    '$city',
    (select State_Code from City_Master where City_Code='$city' and Status='Y'),
    0,
    0,
    '$mobile',
    'M',
    'A',
    'A',
    now(),
    '$custNo',
    now(),
    '$custNo',
    '$locality'
    )";
//    echo $query;
        if($pdo->query($query)){
            return $pdo->lastInsertId();
        } else {
            return false;
        }

    }

    /****
     * retailerStoreFSOMapping
     * insert retailer store fso mapping with dummy fso no : 1
     * @param: $pdo : is pdo object
     * @param: $custNo : cust_no/ retailer no
     * @param: $store_no : store no
     ****/
    private function retailerStoreFSOMapping1($pdo, $custNo, $store_no,$bno){
        $creation_date  = date('Y-m-d H:i:s',strtotime('+5 hours 30 minutes'));
        $created_by     = '1';

        /*$query = "INSERT INTO `Cust_FSO_Lookup` (`Cust_No`, `Store_No`, `FSO_No`, `Status`, `Creation_Date`, `Created_By`, `Changed_Date`, `Changed_By`) VALUES ('$custNo', '$store_no', '1', 'A', '$creation_date', '$created_by', '$creation_date', '$created_by')";*/
        //Added by Meenal Barve 15th April 2019 added 0 to new column Supplier_Legacy_No
        $query = "INSERT INTO Cust_Store_Master
     (Cust_No , Store_No , Supplier_Retailer_No , Credit_Limit , Credit_Days ,
            Creation_Date , Created_By , Changed_Date , Changed_By , Status) VALUES ('$custNo',
            '$store_no',
             (select Get_Cust_Legacyno('$custNo','$store_no','$bno')),
             '200000.00',
             '0',
             '$creation_date',
             '$created_by',
             '$creation_date',
             '$created_by',
             'A'
             )";
        $pdo->query($query);
    }



    /****
     * updateOutletsOtp
     * Update otp to all outlets with the same mobile number
     * @param: $pdo : is pdo object
     * @param: $mobile : mobile no
     ****/
    private function updateOutletsOtp($pdo, $otp, $mobile){

        $changedDate = date('Y-m-d');
        $changedTime = date('H:i:s',strtotime('+5 hours 30 minutes'));
        $changedBy = '0';

        $stmt = $pdo->prepare("update Cust_Master set OTP=?, OTP_Count=?, Change_Date=?, Change_Time=?, Changed_By=?  where Mobile_No=?");
        $stmt->execute(array($otp, 1, $changedDate, $changedTime, $changedBy, $mobile));
        //$stmt->debugDumpParams();
    }

    private function returnDataSignup($db,$msg, $status, $data,$User_No=0,$Login_Type='Self') {
        if ($User_No!=0) {
            send_api_notification($db,'fso_retailer_signup', $User_No, $Login_Type);
        }
        return get_response($msg, $status, $data);
    }
}
