<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use PDO;
use PDOException;

class GetDataController extends Controller
{
    /*
    {
        "meta" : {
        "cellno": "9876543210",
        "package_name":"com.snapkirana.mfm", // OR com.snapkirana.chitale @notnull
        "cust_id":"xxxx", // @notnull
        "fso_id":"xxxx", // OR null @nullable
        "entity":"Store_Master", //@notnull
        "last_pulled_datetime":"2020-01-15 23:08:05 123456", // OR null @nullable,
        "response_code":NULL, @nullable,
        }
    }
    */
    public function api_get_data(Request $request){
        $data = array();
        $status = true;

        $post = $request->post();
        Log::info('Request for api_get_data', ['post' => $post]);
        logging_v2('api_get_data_v2', "\r\nRequest==============> ".json_encode($post));
        $respArr = $post;

        //$metaLastRowID =$post['meta']['last_rowid_sent'];
        extract($post);


        try
        {
            $startAPItime = getMicrotime();
            $param_array = array();
            $data = [];
            $cust_data = [];
            $fso_data = [];
            $primaryKey = '';
            $type = '';

            $excptStatus = false;
            $orderbydefault = '';
            $whereChangedDate = '';
            $limit="limit ".(OFFLINE_PAGE_LENGTH+1);
            $metaLastRowID = $meta['last_rowid_sent'];
            $oldTable = false;
            $where = ' WHERE 1 = 1 ';
            $orderby = 'order by ';
            $last_record_pull_date = '';
            $table_name = $meta['entity'] ?? '';
            $businessID = $meta['business_id'] ?? 0;

            $logtxt = '';

            $fName = OFFLINE_LOG_URL.'/api_get_data_v2_'.date("j.n.Y").'.log';
            if (!file_exists($fName)) {
                $logHeader = "Mobile@START API@END API@TIME TAKEN@COUNT@LAST DATE@LAST ID@Entity Name@Entity Details sql Start@End@GetDefaultDate Start@end@CheckTableNewOrOld@end@getCellWhereClause@end@getPackageWhereClause@end@getBusinessWhereClause@end @getCustNoWhereClause@end@getFSONoWhereClause@end@whereChangedDate@end@FINAL SQL In@Finall sql executed";
                logging_v2('api_get_data_v2', $logHeader."\r\n");
            }
            $logtxt = "$table_name";

            ##Check entity is valid
            $logtxt .= '@'.getMicrotime();
            $entityDetails = getEntityPK($this->db, $table_name);
            $logtxt .= '@'.getMicrotime();
            $selectColumns = '';
            $archiveDate = null;
            if(!empty($entityDetails)){
                $pks = explode(',',$entityDetails['Primary_Key']);
                if(!empty($pks)){
                    $primaryKey = $pks['0'];
                }
                $type = $entityDetails['Type'];
                $selectColumns = $entityDetails['Select_Cols'];
                $archivePeriod = trim($entityDetails['Archive_Period']);
                #Get archive date
                if($archivePeriod > 0){
                    $archiveDate = date("Y-m-d",strtotime("-".$archivePeriod." DAY"));
                }
            }

            if($archiveDate == null){
                $logtxt .= '@'.getMicrotime();
                $dateDetails = getDefaultDate($this->db, $businessID);
                $logtxt .= '@'.getMicrotime();
                $initialDate = '0000-00-00 00:00:00';//default date
                if( !empty($dateDetails) && $type != 'ALL'){
                    $initialDate = $dateDetails['Config_Value'];
                }
            } else {
                $initialDate = $archiveDate;
            }

            $last_record_pull_date = $meta['last_record_datetime'] ?? $initialDate;

            ##Get table new or old, last record pull date, and order by cluase of date and time
            if($primaryKey != ''){
                $logtxt .= '@'.getMicrotime();
                $listData = checkTableNewOrOld($this->db, $table_name);
                $logtxt .= '@'.getMicrotime();
                if(!empty($listData)){
                    $orderbydefault = $listData['orderbydefault'];
                    //$oldTable = $listData['oldtable'];
                }
            } else {

                $respArr['meta']['is_last_pg'] = true;
                $respArr['payload']=[];
                $msg = 'Invalid Data. Entity Or Primary key is missing in '.$table_name.'!!';
                $status = false;
                $logtxt .= '@Error '.$msg;
                logging_v2('api_get_data_v2', $logtxt);
                return get_response($msg, $status, $respArr);
            }

            $cellNo = $meta['cellno'];
            $logtxt .= '@'.getMicrotime();
            $whereCellNo = getCellWhereClause($table_name, $cellNo);
            $logtxt .= '@'.getMicrotime();
            //$respArr['whereCellNo'] = $whereCellNo;

            $package = $meta['package_name'] ?? '';
            $logtxt .= '@'.getMicrotime();
            $wherePackage = getPackageWhereClause($table_name, $package);
            $logtxt .= '@ '.getMicrotime();
            //$respArr['wherePackage'] = $wherePackage;

            $logtxt .= '@'.getMicrotime();
            $whereBusiness = getBusinessWhereClause($table_name, $businessID);
            $logtxt .= '@'.getMicrotime();
            //$respArr['whereBusiness'] = $whereBusiness;

            # cust_present = check mobile number in cust_master
            # FSO_present = check mobile number in fso_master
            $invalidMobile = false;
            if($cellNo != ''){
                $mobileCustExists = getCustomerDetails($this->pdo, 'Mobile_No', $cellNo);
                $mobileFSOExists = getFSODetails($this->pdo, 'Mobile_No', $cellNo);
                if(empty($mobileCustExists) && empty($mobileFSOExists)){
                    $invalidMobile = true;
                }
            } else {
                $invalidMobile = true;
            }

            if($invalidMobile == true){
                $respArr['meta']['is_last_pg'] = true;
                $respArr['payload']=[];
                $msg = 'Insert Valid Login';
                $status = false;
                $logtxt .= '@Error '.$msg;
                logging_v2('api_get_data_v2', $logtxt);
                return get_response($msg, $status, $respArr);
            }

            ## if cust_ids are empty, get mobile no FROM cust master
            /*$custIds = $meta['cust_ids'] ?? [];

            if($cellNo != '' && empty($custIds) {
                $custIds = getCustData();
            }*/

            $invalidCustNo = false;
            if( isset($meta['cust_ids']) && !empty($meta['cust_ids']) && count($meta['cust_ids']) > 0 ){
                for($i=0;$i<count($meta['cust_ids']);$i++)
                {
                    if(isset($meta['cust_ids'][$i]['Cust_No']) && $meta['cust_ids'][$i]['Cust_No'] > 0){
                        #Check cust no exists in Cust_Master
                        $cust_no = $meta['cust_ids'][$i]['Cust_No'];
                        $cust_details = getCustomerDetails($this->db, 'Cust_No', $cust_no);
                        if(!empty($cust_details)){
                            $cust_data[] = $cust_no;
                        }
                    }
                }
            } else {
                $invalidCustNo = true;
                //$respArr['meta']['cust_ids_error'] = "Invalid Customer No";
            }
            //exit;

            if($invalidCustNo == true && $type != 'ALL' && empty($cust_data) && ($table_name != 'BBC_Org_Users' && $table_name != 'BBC_Org_User_Privs' && $table_name != 'BBC_Org_User_Filters' && $table_name != 'Cust_Master' && $table_name != 'FSO_Master' && $table_name != 'Pull_Master')){
                $respArr['meta']['is_last_pg'] = true;
                $respArr['payload']=[];
                $msg = 'Invalid Customer Number/s';
                $status = false;
                $logtxt .= '@Error '.$msg;
                logging_v2('api_get_data_v2', $logtxt);
                return get_response($msg, $status, $respArr);
            }

            $logtxt .= '@'.getMicrotime();
            $whereCustNo = $this->getCustNoWhereClause($table_name, $cust_data, $businessID);
            $logtxt .= '@'.getMicrotime();
            //$respArr['whereCustNo'] = $whereCustNo;

            $invalidFSONo = false;
            if(isset($meta['fso_ids']) && !empty($meta['fso_ids']) && (count($meta['fso_ids']) > 0)){
                for($i=0;$i<count($meta['fso_ids']);$i++)
                {
                    if(isset($meta['fso_ids'][$i]['FSO_No']) && $meta['fso_ids'][$i]['FSO_No'] > 0){
                        #Check fso no exists in FSO_Master
                        $fso_no = $meta['fso_ids'][$i]['FSO_No'];
                        $fso_data[] = $fso_no;
                    }
                }
            } else {
                ##FSO mandatory tables for FSO and optional for an individual
                if($table_name == 'BBC_Org_Users' || $table_name == 'BBC_Org_User_Privs' || $table_name == 'BBC_Org_User_Filters'){
                    ## Mobile exists and Not FSO login
                    if(empty($mobileFSOExists)){
                        $respArr['meta']['is_last_pg'] = true;
                        $respArr['payload']=[];
                        $msg = 'No record for individual customers';
                        $status = true;
                        return get_response($msg, $status, $respArr);
                    } else {
                        ## Mobile exists and FSO login
                        $invalidFSONo = true;
                        //$respArr['meta']['fso_ids_error'] = "Invalid FS0 No";
                    }
                }
            }

            if($invalidFSONo == true && $type != 'ALL' && empty($fso_data)){
                $respArr['meta']['is_last_pg'] = true;
                $respArr['payload']=[];
                $msg = 'Invalid FSO Number';
                $status = false;
                $logtxt .= '@Error '.$msg;
                logging_v2('api_get_data_v2', $logtxt);
                return get_response($msg, $status, $respArr);
            }

            $logtxt .= '@'.getMicrotime();
            $whereFSONo = $this->getFSONoWhereClause($table_name, $fso_data, $cust_data,$businessID);
            $logtxt .= '@'.getMicrotime();
            $whereFSONo = preg_replace("/\r\n|\r|\n|\s+/", ' ', $whereFSONo);
            $whereFSONo = str_replace('  ', ' ', $whereFSONo);
            //$respArr['whereFSONo'] = $whereFSONo;

            $orderby .= $orderbydefault.", ".$primaryKey;

            $logtxt .= '@'.getMicrotime();
            if ($metaLastRowID ==null || $metaLastRowID==""){
                $whereChangedDate .= (" AND Changed_Date > '$last_record_pull_date'  AND Changed_Date  <= DATE_ADD(CURDATE(), INTERVAL 1 DAY) ");
            }
            else {
                $whereChangedDate .= (" AND ((Changed_Date = '$last_record_pull_date' AND $primaryKey > $metaLastRowID) OR Changed_Date > '$last_record_pull_date')");
            }
            $logtxt .= '@'.getMicrotime();

            $finalConcat = '';
            $dp = '';

            if($whereCellNo == '' && $whereCustNo != '' && $table_name != 'Order_Hdr'
                && $table_name != 'BBC_Org_User_Groups' && $table_name != 'BBC_Org_Group_Users'
                && $table_name != 'BBC_Org_Group_Areas'
                && $table_name != 'Store_Catalog_Listing'  && $table_name != 'Store_Catalog_Filters'
                && $table_name != 'Store_Monthly_Off_Date' && $table_name != 'Store_Monthly_Off_Details'
                && $table_name != 'Store_Weekly_Off_Details' && $table_name != 'Scheme_Filters'
                && $table_name != 'Scheme_Article_Rules' && $table_name != 'Cust_Store_Master'
                && $table_name != 'Store_Master' && $table_name != 'BBC_Org_Group_Days'
                && $table_name != 'Cust_Store_Inventory' && $table_name != 'Promo_Order_Level'
                && $table_name != 'Scheme_Master' && $table_name != 'Store_Listing'
                && $table_name != 'BBC_Org_Serving_Areas' && $table_name != 'BBC_Addresses') {
                # Other table
                $finalConcat = ($whereFSONo == '') ? " AND $whereCustNo " : " AND ($whereCustNo UNION ALL $whereFSONo) " ;
                $dp = '11111';
            } else if($table_name == 'Store_Listing') {
                //$finalConcat = ($whereFSONo == '') ? " AND $whereCustNo )" : " AND ($whereCustNo UNION ALL $whereFSONo) " ;
                $finalConcat = " AND $whereCustNo )";
            } else if($table_name == 'Scheme_Master') {
                //$finalConcat = ($whereFSONo == '') ? " AND $whereCustNo )" : " AND ($whereCustNo UNION ALL $whereFSONo) " ;
                $finalConcat = " AND $whereCustNo )";
            } else if($table_name == 'Promo_Order_Level') {
                //$finalConcat = ($whereFSONo == '') ? " AND $whereCustNo )" : " AND ($whereCustNo UNION ALL $whereFSONo) " ;
                $finalConcat = " AND $whereCustNo )";
            } else if($table_name == 'Store_Master') {
                $finalConcat = ($whereFSONo == '') ? " AND $whereCustNo ) " : " AND ($whereCustNo UNION ALL $whereFSONo) " ;
                $dp = '---11111';
            } else if($table_name == 'Cust_Store_Inventory') {
                //$finalConcat = ($whereFSONo == '') ? " AND $whereCustNo ) " : " AND ($whereCustNo UNION ALL $whereFSONo) )" ;
                $finalConcat = " AND $whereCustNo ) ";
                $dp = '---22222';
            } /* else if($table_name == 'BBC_Org_Serving_Areas') {
            $finalConcat = " AND $whereCustNo ) ";
            $dp = '---21212122';
        } */ else if($table_name == 'Store_Monthly_Off_Date' || $table_name == 'Store_Monthly_Off_Details'
                || $table_name == 'Store_Weekly_Off_Details') {
                //$finalConcat = ($whereFSONo == '') ? " AND $whereCustNo )" : " AND $whereCustNo UNION ALL $whereFSONo) " ;
                $finalConcat = " AND $whereCustNo )";
                $dp = '131415511';
            } else if($table_name == 'Scheme_Filters') {
                //$finalConcat = ($whereFSONo == '') ? " AND $whereCustNo ) )" : " AND $whereCustNo UNION ALL $whereFSONo) ) " ;
                $finalConcat = " AND $whereCustNo ) )";
                $dp = '131415511';
            }  else if($table_name == 'Scheme_Article_Rules') {
                //$finalConcat = ($whereFSONo == '') ? " AND $whereCustNo )" : " AND $whereCustNo UNION ALL $whereFSONo)  " ;
                $finalConcat = " AND $whereCustNo )";
                $dp = '131415511';
            } else if($table_name == 'Cust_Master') {
                $dp = '2222';
                #Cust Master
                if($whereCellNo != ''){
                    $finalConcat = ($whereFSONo == '') ? " AND $whereCellNo " : " AND $whereCellNo OR ($whereFSONo) " ;
                } else {
                    $finalConcat = null;
                }
            } else if($table_name == 'FSO_Master') {
                $dp = '33333';
                #FSO master
                if($whereCellNo != '' && $whereCustNo == '' && $whereFSONo == ''){
                    $finalConcat = " AND $whereCellNo ";
                } else {
                    $finalConcat = null;
                }
            } else if($table_name == 'BBC_Org_Users') {
                $dp = '44444';
                #BBC_Org_Users
                $finalConcat = ($whereFSONo != '') ? " AND $whereFSONo " : "" ;

                //$excptStatus = ($whereFSONo == '') ? true : false; //if no fso assigned

            }  else if($table_name == 'BBC_Org_User_Filters' ) {
                $dp = '433334444';
                #BBC_Org_User_Filters
                $finalConcat = ($whereFSONo != '') ? " AND $whereFSONo " : "" ;
                //$excptStatus = ($whereFSONo == '') ? true : false; //if no fso assigned

            }  else if($table_name == 'BBC_Org_Group_Days') {
                $bkt = '';
                $dp = '55555';
                $cn = [];
                $concatAnd = '';
                if($whereCustNo != '') {
                    if($whereFSONo == ''){
                        $bkt = ' ) ';
                    }
                    $cn[] = $whereCustNo.$bkt;

                }
                if(!empty($cn)) $concatAnd = " AND ";

                $cn[] = ($whereFSONo != '') ? ' UNION ALL '.$whereFSONo.' )' : '';
                $finalConcat = $concatAnd.implode(' ', $cn);
            } else if($table_name == 'BBC_Org_User_Groups') {
                $bkt = '';
                $dp = '55555';
                $cn = [];
                $concatAnd = '';
                if($whereCustNo != '') {
                    if($whereFSONo == ''){
                        $bkt = ' ) ';
                    }
                    $cn[] = $whereCustNo.$bkt;
                }
                if(!empty($cn))$concatAnd = " AND ";

                $cn[] = ($whereFSONo != '') ? ' UNION ALL '.$whereFSONo.' )' : '';

                $finalConcat = $concatAnd.implode(' ', $cn);

            }else if($table_name == 'BBC_Org_Group_Areas') {
                $bkt = '';
                $dp = '55555';
                $cn = [];
                $concatAnd = '';
                if($whereCustNo != '') {
                    if($whereFSONo == ''){
                        $bkt = ' ) ';
                    }
                    $cn[] = $whereCustNo.$bkt;
                }

                if(!empty($cn)) $concatAnd = " AND ";

                $cn[] = ($whereFSONo != '') ? ' UNION ALL '.$whereFSONo.' )' : '';

                $finalConcat = $concatAnd.implode(' ', $cn);
            }
            else if($table_name == 'BBC_Org_Group_Users') {
                $bkt = '';
                $dp = "121212";
                $cn = [];
                $concatAnd = ' AND ';
                if($whereCustNo != '') { $cn[] = $whereCustNo; }
                if(!empty($cn)) $concatAnd = " AND (";
                $cn[] = ($whereFSONo != '') ? " OR ".$whereFSONo : '';
                $finalConcat = $concatAnd.implode('', $cn)." ) ";
            } else if($table_name == 'BBC_Addresses') {

                $finalConcat = ($whereFSONo == '') ? " AND $whereCustNo " : " AND ($whereCustNo UNION ALL $whereFSONo) " ;
                $dp = 'BBC_Addresses';
            } else if($table_name == 'Order_Addresses' || $table_name == 'BBC_Notification_History' || $table_name == 'Order_Hdr' || $table_name == 'Order_Itm' || $table_name == 'Store_Transaction' || $table_name == 'Store_Transaction_Detail' || $table_name == 'Order_Consignment' || $table_name == 'Store_Promo_Messages' || $table_name == 'Store_City_Article' || $table_name == 'Customer_Feedback' || $table_name == 'Order_Con_Book_Form' || $table_name == 'Store_Cust_Article_Price' || $table_name == 'Invoice_Hdr') {
                $dp = '66666';
                $finalConcat = $whereCustNo;
                if($whereCellNo != '' && $whereCustNo == '' && $whereFSONo == '')
                {
                    $finalConcat = null;
                }
            } else if($table_name == 'Pull_Master'){
                $dp = '77777';
                #Pull master
                if($whereCellNo == '' && $whereCustNo == '' && $whereFSONo == '' ){
                    $finalConcat = ' AND Entity_Type = "DB" ';
                } else {
                    $finalConcat = null;
                }
            } else if( $wherePackage != '' || $whereBusiness != '' || ($table_name == 'Article_Margins' && $whereBusiness == '')){
                $dp = '88888';
                $finalConcat = "";
            } else if($whereCustNo == '' && ($table_name == 'Cust_Store_Master' || $table_name == 'User_Cart' || $table_name == 'User_Love' || $table_name == 'Order_Itm_Batch' || $table_name == 'Store_Payment_Types' || $table_name == 'Order_History' || $table_name == 'Store_Delivery_Time' ) ){
                $dp = '999999';
                $finalConcat = null;
            } else if($table_name == 'Store_Vendor_Master'){
                $dp = '000000000';
                $finalConcat = " AND Vendor_For = 'STORE' ";
            } else if($table_name == 'Cust_Store_Master') {
                $finalConcat = " AND Cust_No IN ($whereCustNo) ";
                $dp = 'dddddddddd';
            } else {
                $dp = '-----------';
                $finalConcat = "";
            }
            //print $dp."<pre>".$finalConcat; exit;

            if($table_name =='Article_Offers'){
                $finalConcat = "";
            }

            if($selectColumns != ''){
                $select = $selectColumns;
            } else {
                $select = " * ";
            }



            $logtxt .= '@'.getMicrotime();

            $getEntityRows = "SELECT $select FROM $table_name $where $finalConcat
                          $whereChangedDate $wherePackage $whereBusiness $orderby $limit;";


            // $logtxt .= "@".$getEntityRows;

            if(isset($finalConcat)){

                $stmt = $this->pdo->prepare($getEntityRows);

                $stmt->execute();
                $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
                $logtxt .= '@'.getMicrotime();

                //$stmt->debugDumpParams(); exit;
                $msg = (empty($arr)) ? 'No records found' : 'Success';
                $status = true;
                $respArr['meta']['is_last_pg'] = true;
                ##Check count > limit
                if(count($arr) > OFFLINE_PAGE_LENGTH){
                    ## then unset last record 1001 and mark last as true
                    $respArr['meta']['is_last_pg'] = false;
                    unset($arr[count($arr)-1]);
                }

                if(!empty($arr)){
                    $lastIndex = count($arr)-1;
                    if ($oldTable) {
                        $respArr['meta']['last_record_datetime'] = $arr[$lastIndex]['Change_Date']." ".$arr[$lastIndex]['Change_Time'];
                    }
                    else {
                        $respArr['meta']['last_record_datetime'] = $arr[$lastIndex]['Changed_Date'];
                        $lastDateTime = $respArr['meta']['last_record_datetime'];
                    }

                    $respArr['meta']['last_rowid_sent'] = $arr[$lastIndex][$primaryKey];
                    $lastRowId = $respArr['meta']['last_rowid_sent'];
                }

            } else {
                $arr = [];
                $msg = 'Invalid Inputs';
                $logtxt .= '@Invalid Inputs '.getMicrotime();
                # $excptStatus: if user has no assigned fso then not passing fso is not invalid data, so make status true
                if( $excptStatus == true){
                    $status = $excptStatus;
                    $msg = 'Success';
                } else {
                    $status = false;
                }
                $respArr['meta']['is_last_pg'] = true;
            }

            # cust ids and fso ids dont send in response
            unset($respArr['meta']['cust_ids']);
            unset($respArr['meta']['fso_ids']);

            ## Remove extra spaces and \r \n \s
            $getEntityRows = preg_replace("/\r\n|\r|\n|\s+/", ' ', $getEntityRows);
            $getEntityRows = str_replace('  ', ' ', $getEntityRows);

            $query = isset($finalConcat) ? $getEntityRows : '';
            $respArr['query'] = $query;
            logging_v2('api_get_data_v2', "\r\nSQL========".$query);
            $respArr['total_records'] = count($arr);
            $respArr['payload']=$arr;

            $data = $respArr;

        } //try
        catch (PDOException $e)
        {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
        //$logtxt .= '@END '.getMicrotime()."\r\n";
        $endlog = getMicrotime();

        if(isset($respArr['total_records'])){
            $count = $respArr['total_records'] ?? 0;
        }

        $lastDateTime = $lastDateTime ?? 'null';
        $lastRowId = $lastRowId ?? 'null';

        $finallogTxt = $cellNo."@".$startAPItime."@".$endlog."@". ($endlog - $startAPItime). "@".$count. "@".$lastDateTime."@".$lastRowId;
        logging_v2('api_get_data_v2', $finallogTxt."@".$logtxt."\r\n");

        logging_v2('api_get_data_v2', "response==> ".json_encode($data));
        logging_v2('api_get_data_v2', "\r\n");
        Log::info('Response for api_get_data', ['data' => $data,'status'=>false,'msg'=>$msg]);
        return get_response($msg, $status, $data);
    }

    public function api_get_data_all_queries(Request $request){
        $outputData = [];
        $post = $request->post();
        // $entity = $post['entity'];
        $query ='';
        // extract($post);
        $custData = 1981;
        $fsoData = 47;
        $last_record_datetime = "2020-09-09 17:22:41";
        $last_rowid_sent = 4;
        $custIdsArray = ["Cust_No"=>1981,"Cust_No"=>2933];
        $fsoIdsArray = ["FSO_No" => 47];

        $custEmpty            = ["cust_ids"=>[],"fso_ids"=>[$fsoIdsArray], "last_record_datetime"=> $last_record_datetime ,"last_rowid_sent"=>$last_rowid_sent];//cust_id empty
        $fsoEmpty             = ["cust_ids"=>[$custIdsArray],"fso_ids"=>[],"last_record_datetime"=> $last_record_datetime, "last_rowid_sent"=>$last_rowid_sent]; //fso_id empty
        $cust_fso_empty       = ["cust_ids"=>[],"fso_ids"=>[],"last_record_datetime"=>$last_record_datetime, "last_rowid_sent"=>$last_rowid_sent]; // cust_fso empty
        $date_row_id_present  = ["fso_ids"=>[$fsoIdsArray], "cust_ids"=>[$custIdsArray] ,"last_record_datetime"=> $last_record_datetime,"last_rowid_sent"=>$last_rowid_sent]; // all present
        $id_Empty             = ["fso_ids"=>[$fsoIdsArray], "cust_ids"=>[$custIdsArray],"last_record_datetime"=>$last_record_datetime ,"last_rowid_sent"=>null]; // last_row_id empty
        $lastRecordArrayEmpty = ["fso_ids"=>[$fsoIdsArray], "cust_ids"=>[$custIdsArray],"last_record_datetime"=>null ,"last_rowid_sent" =>$last_rowid_sent]; // last_record_datetime empty
        $lastRecordArray_last_row_id_Empty = ["fso_ids"=>[$fsoIdsArray], "cust_ids"=>[$custIdsArray],"last_record_datetime"=>null ,"last_rowid_sent" =>null ]; // lastRecordArray_last_row_id_Empty empty

        $json_array = [$custEmpty,$fsoEmpty,$cust_fso_empty,$date_row_id_present,$id_Empty,$lastRecordArrayEmpty,$lastRecordArray_last_row_id_Empty];


        $All_Entities = ['Pull_Master','Business_Master','Business_Config_Master','Store_Master','Cust_Master','Cust_Store_Master',
            'BBC_Org_Users','BBC_Org_User_Groups','BBC_Org_Serving_Areas','BBC_Org_Group_Users','Country_Master','Zone_Master','State_Master','Region_Master',
            'District_Master','City_Master','Area_Master','BBC_Addresses','CRNote_Hdr','Brand_Master','Article_Master','Article_More_Images','Nested_Category',
            'BBC_Org_User_Filters','Article_Category','Store_Lisiting','Scheme_Master','Scheme_Filters','Scheme_Article_Rules','User_Cart',
            'User_Love','Order_Hdr','Order_Itm','Order_Itm_Batch','Store_Transaction','Store_Transaction_Detail','BBC_Notification_History','Payment_Types',
            'Store_Payment_Types','FSO_Master', 'App_Project_Licenses', 'Order_Consignment','Config_Master','Bank_IFSC_Master', 'Store_Promo_Messages','Store_City_Article',
            'Store_Cust_Article_Price',  'Invoice_Hdr', 'Order_History','Cust_Store_Inventory','Store_Vendor_Master','Vendor_Master','Store_Delivery_Time','Store_Monthly_Off_Date',
            'Store_Monthly_Off_Details', 'Store_Weekly_Off_Details', 'Article_Where_Use', 'Customer_Feedback',  'Promo_Order_Level',   'Order_Addresses',
            'Order_Con_Book_Form','Article_Offers','Payment', 'BBC_Org_Group_Areas'
        ];
        //  $All_Entities = ['BBC_Org_User_Groups'];



        $count = count($All_Entities);
        $json_array_count = count($json_array);
        $i = 0;
        $j = 0;

        for($i = 0; $i < $count;$i++)
        {

            try{
                for($j=0;$j< $json_array_count;$j++)
                {
                    $inputStr = "";
                    $filename = __DIR__.'/all_queries.txt';

                    $myfile = fopen($filename, "w");
                    $reqtxt = json_encode($json_array);
                    $json_array_item = $json_array[$j];
                    fwrite($myfile, PHP_EOL);

                    $url = "https://chitaledev.saralideas.com/b2bservices/sf_services/public/index.php/api_get_data";
                    // $url = "http://chitale.loc/b2bservices/sf_services/public/index.php/api_get_data";

                    // print_r($url);die;

                    $post['meta']['business_id'] = 2;
                    $post['meta']['entity'] = $All_Entities[$i];
                    $post['meta']['is_last_pg'] = false;
                    $post['meta']['last_pulled_datetime']=null;
                    $post['meta']['last_record_datetime']=$json_array_item['last_record_datetime'];
                    $post['meta']['last_rowid_sent']=$json_array_item['last_rowid_sent'];
                    $post['meta']['package_name'] = "com.saralideas.chitale";
                    $post['meta']['cellno']= "9011114112";
                    $post['meta']['fso_ids']= $json_array_item['fso_ids'];
                    $post['meta']['cust_ids'] = $json_array_item['cust_ids'];
                    $inputStr = json_encode($post);


                    $ch = curl_init();
                    curl_setopt($ch,CURLOPT_URL,$url);
                    curl_setopt($ch, CURLOPT_POST, true);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $inputStr);
                    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','Content-Length: ' . strlen($inputStr)));
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
                    curl_setopt($ch, CURLOPT_VERBOSE, true);
                    $outputData = curl_exec($ch);
                    $outputData = str_replace("\xEF\xBB\xBF",'',$outputData);

                    $outputData_decoded = json_decode($outputData);

                    print_r("Req:".$inputStr."#Resp".$outputData_decoded->data->query);
                    $outputstr = "";
                    try{
                        $outputstr = $outputData_decoded->data->query;
                    } catch(Exception $e){}
                    // fwrite($myfile, "Response Data : ");
                    fwrite($myfile, "Req:".$inputStr."# Res:".$outputstr);


                }
            }
            catch(Exception $e)
            {
                echo "error";
            }


        }
    }

    private function getCustNoWhereClause($table_name, $cust_data, $businessID){

        if(count($cust_data) > 0) {
            if(!empty($cust_data) && ($table_name == 'BBC_Notification_History' || $table_name == 'Store_Cust_Article_Price')){
                $cust_data[] = '0';
            }
            $cust_id_array = "(".implode(',',$cust_data).")";

            $fName = $table_name."_OFL";//create function name
            if(function_exists($fName)){ //check if function exists then call
                if($table_name == 'Article_Margins'){
                    $where = $fName('custno', $cust_id_array, $businessID);
                } else {
                    $where = $fName('custno', $cust_id_array);
                }
            } else {
                $where = '';
            }
            return $where;
        }
    }

    private function getFSONoWhereClause($table_name, $fso_data, $cust_data, $businessID){
        $where = '';
        $fso_id_array = "(".implode(',', $fso_data).")";
        $fso_array = implode(',', $fso_data);
        $getAllRouteForFSO  = "SELECT Store_No from BBC_Org_Users where FSO_No IN (".$fso_array.")";

        if((Count( $fso_data)>0) && (($table_name != 'FSO_Master') OR ($table_name != 'Cust_Master')))
        {
            $wherecustno = '';
            $wherestoreno = '';
            $wherecustaddr = '';
            $wherestoreaddr = '';
            $wheregroupusers = '';
            $wherefiltercustnos = '';

            $whereop = !empty($cust_data) ? ' OR ' : ' AND ';

            $wherecustno = getFSONoSubWhereClause($fso_id_array, $whereop, 'custno');
            $wherecustnoIn = getFSONoSubWhereClause($fso_id_array, $whereop, 'custnoIn');
            $wherestoreno = getFSONoSubWhereClause($fso_id_array, $whereop, 'storeno');
            $wheresupplierno = getFSONoSubWhereClause($fso_id_array, $whereop, 'supplierno');
            $wherestoreid = getFSONoSubWhereClause($fso_id_array, $whereop, 'storeid');
            $whereuseraddr = getFSONoSubWhereClause($fso_id_array, $whereop, 'useraddr');
            $wherestoreaddr = getFSONoSubWhereClause($fso_id_array, $whereop, 'storeaddr');
            $wheregroupusers = getFSONoSubWhereClause($fso_id_array, $whereop, 'groupusers');
            if ($table_name == 'Cust_Master' )
            {
                $where .= $wherecustnoIn;
            } else if ($table_name =='Cust_Store_Inventory' ){
                $where .= $wherecustno;
            } else if ($table_name =='Cust_Store_Master'){
                $where .= $wherecustno;
            } else if (($table_name == 'Store_Master')
                // || ($table_name =='BBC_Org_Group_Areas')
                //|| ($table_name =='BBC_Org_Serving_Areas')
                || ($table_name =='BBC_Org_Serving_Stores')
                || ($table_name =='Store_Listing')
                || ($table_name =='Store_Catalog_Master')
                || ($table_name =='Store_Catalog_Filters')
                || ($table_name =='Store_Catalog_Listing')
                || ($table_name =='Scheme_Master' )
                || ($table_name =='Store_Vendor_Master')
                || ($table_name =='Promo_Order_Level')
            ) {
                $where .= $wherestoreno. ")";
            }
            /*
                Chenged by : Sheetal Chive
                Reason     : changed below if statements to get fso details from BBC_Org_Users table.BBC_Org_Users has fso-store mapping.
                Date       : 16-05-2022
            */

            //  else if ($table_name =='BBC_Org_Group_Days') {
            //     $where .= " select fso.Org_Group_ID
            //      from BBC_Org_Group_Users fso
            //      INNER JOIN FSO_Master ON FSO_Master.FSO_No =fso.User_No AND FSO_Master.Login_Type = fso.Login_Type and fso.User_No IN $fso_id_array ) ";
            // }
            else if ($table_name =='BBC_Org_Group_Days') {
                $where .= "$getAllRouteForFSO";
            }
            //  else if($table_name =='BBC_Org_User_Groups') {
            //     $where .= " select fso.Org_Group_ID
            //      from BBC_Org_Group_Users fso
            //      INNER JOIN FSO_Master ON FSO_Master.FSO_No =fso.User_No AND FSO_Master.Login_Type = fso.Login_Type and fso.User_No IN $fso_id_array "; //removed extra brackets
            // }
            else if($table_name =='BBC_Org_User_Groups') {
                $where .= " $getAllRouteForFSO"; //removed extra brackets
            }

            // else if($table_name =='BBC_Org_Group_Areas') {
            //     $where .= " select fso.Org_Group_ID
            //      from BBC_Org_Group_Users fso
            //      INNER JOIN FSO_Master ON FSO_Master.FSO_No =fso.User_No AND FSO_Master.Login_Type = fso.Login_Type and fso.User_No IN $fso_id_array "; //removed extra brackets
            // }
            else if($table_name =='BBC_Org_Group_Areas') {
                $where .= "$getAllRouteForFSO"; //removed extra brackets
            }
            else if ($table_name =='Store_Monthly_Off_Date' || $table_name =='Store_Monthly_Off_Details' || $table_name =='Store_Weekly_Off_Details'){//$table_name =='Store_Delivery_Time' ||
                $where .= $wherestoreid;
            } /*else if ($table_name =='Article_Offers'){
             $where .= $wheresupplierno;
        }*/ else if ($table_name =='Scheme_Article_Rules') {
                //$where .= " SELECT ID FROM Scheme_Master WHERE ".$wherestoreno." ) ";
                $where .= $wherestoreno;
            } else if ($table_name =='Scheme_Filters') {
                $where .= $wherestoreno;
            } else if ($table_name == 'BBC_Org_Users') {
                $where .= " FSO_No IN $fso_id_array";
            } else if ($table_name == 'BBC_Org_User_Privs') {
                $where .= "";
            } else if ($table_name == 'BBC_Org_Group_Users') {
                //print "===".$where .= $wheregroupusers;
                $where .= " ( User_No in $fso_id_array AND Login_Type = 'FSO' )";
            } else if ($table_name == 'BBC_Org_User_Filters') {
                $where .= " FSO_No IN $fso_id_array ";
                //$where .= $wherestoreno;
            } else if ($table_name == 'Article_Margins') {

                if ( $businessID > 0 && CENTRALIZE_PRICING)
                {
                    $where = getBusinessWhereClause($table_name, $businessID);
                } else {
                    $where = $where . $wherestoreno ;
                    $where .= " AND Filter_Type ='Store' ";
                }
            } /*else if ($table_name == 'Store_Transaction_Detail') {
             $where = $where . " Transaction_ID IN (SELECT Transaction_ID FROM Store_Transaction WHERE " . $wherecustno .")";
        } else if ( $table_name == 'Order_Itm_Batch')  {
             $where = $where . " ( Order_No IN (SELECT Order_No FROM Order_Hdr WHERE " . $wherecustno .") )";
        } else if ($table_name == 'Order_Con_Book_Form') {
             $where = $where . " ( Order_No IN (SELECT Order_No FROM Order_Hdr WHERE " . $wherecustno .") )" ;
             $where .= " AND Vendor_No IN $fso_id_array AND Vendor_Type ='DO' ";
        } elseif ($table_name == 'Order_Consignment') {

            $where =  " ( Book_Form_ID IN (SELECT ID FROM Order_Con_Book_Form WHERE ".$wherestoreno." ) )" ;

        } else if ($table_name == 'Order_History') {
             $where = $where . " ( Order_ID IN (SELECT Order_No FROM Order_Hdr WHERE " . $wherecustno .") )" ;
        } else if (($table_name == 'BBC_Addresses' )
            || ($table_name == 'Order_Addresses')) {
             $whereuseraddr = ($whereuseraddr != '') ? ' AND '. $whereuseraddr : '';
             $wherestoreaddr = ($wherestoreaddr != '') ? ' AND '. $wherestoreaddr : '';
             $where = $where." (Login_Type ='Buyer' " .$whereuseraddr ." ) OR (Login_Type='Seller' " .$wherestoreaddr." )";
        } else if ($table_name == 'Store_Cust_Article_Price' ) {
            $where = $where . " ( " .$wherestoreno." AND Cust_No = 0 OR ( ".$wherestoreno.") AND Cust_No > 0 AND ".$wherecustno ." ) " ;
        }*/

        }
        return $where;
    }
}
