<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

class InternalHeartBeatController extends Controller
{
    /*
        {
        "business_id":2
        }
    */
    public function internal_heartbeat(Request $request){
        $startAPItime = getMicrotime();
        $data = [];
        $msg = '';
        $status = '';
        $post = $request->post();

        //$metaLastRowID =$post['meta']['last_rowid_sent'];
        extract($post);
        try
        {
            $stmtArea = $this->pdo->prepare("select Area_Code code , Area_Name name , Pincode , COALESCE(Latitude,0) as Latitude , COALESCE(Longitude,0) as Longitude  from   Area_Master where Status = 'A' order by Area_Name");
            $stmtArea->execute();
            $areas = $stmtArea->fetchAll(PDO::FETCH_ASSOC);
            if (!empty($areas)) {
                $msg = 'Success';
                $status = true;
                $data['StartTime'] = $startAPItime;
            } else {
                $msg = 'Area Data is not available';
                $status = false;
            }

        }  catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
            // return getResponse($response, "Something went wrong", $status, $data);
        }
        $data['EndTime'] = getMicrotime();
        $timeTaken =  $data['EndTime'] - $startAPItime;
        $data['TimeTaken'] = $timeTaken;
        ##default time is 10 seconds = 10000 miliseconds
        # if it is grated then his sms
        $emailResponse = $this->emailHeartReport($data);
        if($timeTaken >= 10000){
            $phone_no = '9146374745';
            SubmitSMS($phone_no, 'INTERNAL_HEARTBEAT');
        }
        $msg .= ", ".$emailResponse;

        return get_response($msg, $status, $data);
    }

    private function emailHeartReport($data){
        // Replace recipient@example.com with a "To" address. If your account
        // is still in the sandbox, this address must be verified.
        $recepientInfo = ['daya4608@gmail.com'];

        // The plain-text body of the email
        $bodyText =  "Alert";

        $subject =  "Alert!!! ".MY_WEBSITE." HeartBeats";

        // The HTML-formatted body of the email
        $bodyHtml = '
        <pre>Dear Saralideas Team

        We have received '.MY_WEBSITE.' heart report

        Date & Time: '.date('Y-m-d H:i:s').'
        Start Time : '.$data['StartTime'].'
        End Time : '.$data['EndTime'].'
        Time Taken : '.$data['TimeTaken'].'
        ';

        $mail = new PHPMailer(true);

        try {
            // Specify the SMTP settings.
            $mail->isSMTP();
            $mail->setFrom("snapkirna.co.in@gmail.com", 'SARALIDEAS');
            $mail->Username   = 'snapkirna.co.in@gmail.com';
            $mail->Password   = '2021@saral';

            $mail->Host       = 'ssl://smtp.googlemail.com';
            $mail->Port       = 465;
            $mail->SMTPAuth   = true;
            $mail->SMTPSecure = 'tls';
            //$mail->addCustomHeader('X-SES-CONFIGURATION-SET', $configurationSet);

            // Specify the message recipients.
            if(!empty($recepientInfo)){
                foreach ($recepientInfo as $recepient) {
                    $mail->addAddress($recepient);
                }
            }

            // You can also add CC, BCC, and additional To recipients here.
            //$mail->addCC("ccaddress@ccdomain.com", "Some CC Name");
            //$mail->addBCC("bccaddress@ccdomain.com", "Some BCC Name");


            // Specify the content of the message.
            $mail->isHTML(true);
            $mail->Subject    = $subject;
            $mail->Body       = $bodyHtml;
            $mail->AltBody    = $bodyText;
            //$mail->SMTPDebug = 2;//debug email
            $re = $mail->Send();
            $res = "Email sent!";
        } catch (Exception $e) {
            //If not working On in Google and then Manage your Google Account->Security->Under "Signing in to Google," tap 2-Step Verification: Access for less secure apps
            $res = "Email not sent. {$mail->ErrorInfo}"; //Catch errors from Amazon SES.
        }
        return $res;
    }
}
