<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use PDO;
use PDOException;

class InvoiceController extends Controller
{
    /******** JSON INPUT
    {
    "businessID": "2",
    "order_no": "1100001100004",
    "invoice_number" : "abcd12345",
    "invoice_date": "2019-07-23 10:28:08"
    }
     ********/
    public function delete_api_invoices(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        if(!empty($order_no) && !empty($invoice_number))
        {
            $orderans = get_order_details($this->pdo, $order_no);
            if (empty($orderans)) {
                $msg = "Failed to retrieve order details for order " . $order_no;
                $status = false;
                $data = '';

                $this->createLog([$msg]);
                return get_response($msg, $status, $data);
            }

            if ($orderans['Ext_Invoice_No'] == '') {
                $msg = "Invoice Number (" . $orderans['Ext_Invoice_No'] . ") not received for order " . $order_no;
                $status = false;
                $data = '';
                $this->createLog([$msg]);
                return get_response($msg, $status, $data);
            }

            $stmtA = $this->pdo->prepare("select Order_No, Invoice_No from Invoice_Hdr where Order_No='$order_no' and Invoice_No='$invoice_number'");
            $stmtA->execute();
            $rowA = $stmtA->fetch(PDO::FETCH_ASSOC);
            if(empty($rowA)){
                $msg = "Invoice not created for order " . $order_no;
                $status = false;
                $data = '';
                $this->createLog([$msg]);
                return get_response($msg, $status, $data);
            }

            $dborderitems = get_order_item_details($this->pdo, $order_no);

            if (empty($dborderitems)) {
                $msg = "Failed to retrieve order items for order number " . $order_no;
                $status = false;
                $data = '';
                $this->createLog([$msg]);
                return get_response($msg, $status, $data);
            }

            $store_balance = get_amount_store_transaction($this->pdo, $order_no, $invoice_number);
            if (empty($store_balance)) {
                $msg = "Failed to retrieve store balance for order number " . $order_no;
                $status = false;
                $data = '';
                $this->createLog([$msg]);
                return get_response($msg, $status, $data);
            }

            $storeno = $store_balance['Store_No'];
            $custno = $store_balance['Cust_No'];

            $store_balances1 = get_store_balance($this->pdo, $storeno, $custno);
            if (!empty($store_balances1)) {
                $status = true;
            } else {
                $status = false;
            }

            $invoice_hdr_update = get_invoice_hdr($this->pdo, $order_no, $invoice_number);
            if (!empty($invoice_hdr_update)) {
                $msg = "Received invoice header for invoice " . $invoice_number . " and order " . $order_no;
                $status = true;
            } else {
                $msg = "Failed to get invoice header for invoice " . $invoice_number . " and order " . $order_no;
                $status = false;
                $data = '';
                // createLog([$msg]);
                return get_response($msg, $status, $data);
            }

            $invoice_tax_hdr_update = get_invoice_tax_hdr($this->pdo, $order_no, $invoice_number);
            if (!empty($invoice_tax_hdr_update)) {
                $msg = "Received invoice tax header for invoice " . $invoice_number . " and order " . $order_no;
                $status = true;
            } else {
                $msg = "Failed to get invoice tax header for invoice " . $invoice_number . " and order " . $order_no;
                $status = false;
                $data = '';
                // createLog([$msg]);
                return get_response($msg, $status, $data);
            }

            foreach ($invoice_tax_hdr_update as $key => $value) {
                $invoice_tax_hdr_order[$key]['Order_No'] = "D".$value['Invoice_Tax_Hdr_Id'];
                $invoice_tax_hdr_order[$key]['Invoice_Tax_Hdr_Id'] = $value['Invoice_Tax_Hdr_Id'];
            }

            $invoice_tax_itm_update = get_invoice_tax_itm($this->pdo, $order_no, $invoice_number);
            if (!empty($invoice_tax_itm_update)) {
                $msg = "Received invoice tax item for invoice " . $invoice_number . " and order " . $order_no;
                $status = true;
            } else {
                $msg = "Failed to get invoice tax item for invoice " . $invoice_number . " and order " . $order_no;
                $status = false;
                $data = '';
                // createLog([$msg]);
                return get_response($msg, $status, $data);
            }

            foreach ($invoice_tax_itm_update as $key => $value) {
                $invoice_tax_itm_order[$key]['Order_No'] = "D".$value['Invoice_Tax_Itm_Id'];
                $invoice_tax_itm_order[$key]['Invoice_Tax_Itm_Id'] = $value['Invoice_Tax_Itm_Id'];
            }

            $InvoiceHdrOrderNo = "D".$invoice_hdr_update[0]['Invoice_Hdr_Id'];

            try
            {
                $this->pdo->beginTransaction();

                $order_amount_item = 0;

                $saving_amount_hdr = 0;

                for($k = 0; $k<count($dborderitems); $k++)
                {
                    $Article_No = $dborderitems[$k]['Article_No'];
                    $Order_Quantity = $dborderitems[$k]['Order_Quantity'];
                    $Amount = $dborderitems[$k]['Order_Quantity'] * $dborderitems[$k]['Order_Offer_Price'];
                    $Saving = $dborderitems[$k]['Order_Quantity'] * $dborderitems[$k]['Order_Mrp'];
                    $order_amount_item += $dborderitems[$k]['Order_Amount'];
                    $Change_Date = date('Y-m-d');
                    $Change_Time = date('H:i:s', strtotime('+5 hours 30 minutes'));
                    $Change_By = '10000';

                    $Saving_Amount = $Saving - $Amount;
                    $pick_quantity = '0';
                    $pick_amount = '0';

                    $saving_amount_hdr += $Saving_Amount;

                    $update_order_itm = $this->pdo->prepare("update Order_Itm set Saving_Amount=?,Pick_Quantity=? ,Pick_Amount=?, Change_Date=?, Change_Time=?, Changed_By=? where Order_No=? and Article_No=?");
                    $update_order_itm->execute([$Saving_Amount, $pick_quantity, $pick_amount, $Change_Date, $Change_Time, $Change_By, $order_no, $Article_No]);
                }

                $Order_Status = 'Accepted';
                $Delivery_Charges = $orderans['Delivery_Charges'];
                $order_amount = $order_amount_item + $Delivery_Charges;
                $Net_Amount = $order_amount + $orderans['Header_Discount'];
                $Ext_Invoice_No = NULL;
                // $Ext_Order_No = NULL;
                $order_hdr_invoice_no = NULL;
                $Sk_Invoice_No = NULL;

                $update_order_hdr = $this->pdo->prepare("update Order_Hdr set Invoice_No=?, Sk_Invoice_No=?, Ext_Invoice_No=?, Order_Status=?, Order_Amount=?, Net_Amount=?, Saving_Amount=? where Order_No=? and Ext_Invoice_No=?");
                $update_order_hdr->execute([$order_hdr_invoice_no, $Sk_Invoice_No, $Ext_Invoice_No, $Order_Status, $order_amount, $Net_Amount, $saving_amount_hdr, $order_no, $invoice_number]);

                // $update_invoice_hdr = $this->pdo->prepare("update Invoice_Hdr set Order_No=? where Order_No=? and Invoice_No=?");
                // $update_invoice_hdr->execute([$Ext_Order_No, $order_no, $invoice_number]);

                // $update_invoice_tax_hdr = $this->pdo->prepare("update Invoice_Tax_Hdr set Order_No=? where Order_No=? and Invoice_No=?");
                // $update_invoice_tax_hdr->execute([$Ext_Order_No, $order_no, $invoice_number]);

                // $update_invoice_tax_itm = $this->pdo->prepare("update Invoice_Tax_Itm set Order_No=? where Order_No=? and Invoice_No=?");
                // $update_invoice_tax_itm->execute([$Ext_Order_No, $order_no, $invoice_number]);
                $changedatetime = date('Y-m-d H:i:s');
                $changeby = 10000;
                $update_invoice_hdr = $this->pdo->prepare("update Invoice_Hdr set Order_No=?, Changed_By=?, Changed_Date=? where Order_No=? and Invoice_No=?");
                $update_invoice_hdr->execute([$InvoiceHdrOrderNo, $changeby, $changedatetime, $order_no, $invoice_number]);

                $update_invoice_tax_hdr = update_invoice_tax_header($this->pdo, $invoice_tax_hdr_order, $order_no);
                if ($update_invoice_tax_hdr) {
                    $msg = "Update invoice tax header" . $order_no;
                    $status = true;
                } else {
                    $msg = "Failed to update invoice tax header for order " . $invoice_tax_hdr['order_no'];
                    $status = false;
                    $data = '';
                    // createLog([$msg]);
                    return get_response($msg, $status, $data);
                }

                $update_invoice_tax_itm = update_invoice_tax_item($this->pdo, $invoice_tax_itm_order,$order_no);
                if ($update_invoice_tax_itm) {
                    $msg = "Update invoice item header" . $order_no;
                    $status = true;
                } else {
                    $msg = "Failed to update invoice item header for order " . $invoice_tax_hdr['order_no'];
                    $status = false;
                    $data = '';
                    // createLog([$msg]);
                    return get_response($msg, $status, $data);
                }

                $get_store_transaction_details = $this->pdo->prepare("Select Transaction_Type from Store_Transaction where Order_No=? ");
                $get_store_transaction_details->execute([$order_no]);
                $rows = $get_store_transaction_details->fetchAll(PDO::FETCH_ASSOC);
                $flag = false;
                foreach ($rows as $key => $value) {
                    if($value['Transaction_Type'] == '5')
                    {
                        $flag = true;
                    }
                }

                if($flag)
                {
                    $store_transaction[0]['order_no'] = $order_no;
                    $store_transaction[0]['invoice_number'] = 0;
                    $store_transaction[0]['invoice_date'] = 0;
                    $store_transaction[0]['transaction_type'] = 5;
                    $store_transaction[0]['store_no'] = $orderans['Store_No'];
                    $store_transaction[0]['cust_no'] = $orderans['Cust_No'];
                    $store_transaction[0]['fso_no'] = $orderans['FSO_No'];
                    $store_transaction[0]['deposit_amount'] = $orderans['Net_Amount'];
                    $store_transaction[0]['withdraw_amount'] = 0;
                    $store_transaction[0]['outstanding_amt'] = 0;
                    $store_transaction[0]['balance_amt'] = $store_balances1['Balance_Amt'] + $orderans['Net_Amount'];
                    $store_transaction[0]['outstanding_balance_amt'] = $store_balances1['Outstanding_Balance_Amt'];
                    $store_transaction[0]['remark'] = "Reverse ordered amount";

                    // $store_balance_amt = $store_balances1['Balance_Amt'] + $orderans['Net_Amount'];

                    $store_transaction[1]['order_no'] = $order_no;
                    $store_transaction[1]['invoice_number'] = 0;
                    $store_transaction[1]['invoice_date'] = 0;
                    $store_transaction[1]['transaction_type'] = 5;
                    $store_transaction[1]['store_no'] = $orderans['Store_No'];
                    $store_transaction[1]['cust_no'] = $orderans['Cust_No'];
                    $store_transaction[1]['fso_no'] = $orderans['FSO_No'];
                    $store_transaction[1]['deposit_amount'] = 0;
                    $store_transaction[1]['withdraw_amount'] = $order_hdr['order_amount'];
                    $store_transaction[1]['outstanding_amt'] = 0;
                    $store_transaction[1]['balance_amt'] = $store_transaction[0]['balance_amt'] - $order_amount;
                    $store_transaction[1]['outstanding_balance_amt'] = $store_balances1['Outstanding_Balance_Amt'];
                    $store_transaction[1]['remark'] = "Picked order amount";
                }

                // print_r($store_transaction[0]['balance_amt']);
                // echo"<br>";
                // print_r($orderans['Order_Amount']);
                // die();

                $store_transaction['order_no'] = $order_no;
                $store_transaction['invoice_number'] = $invoice_number;
                $store_transaction['invoice_date'] = $invoice_date;
                $store_transaction['transaction_type'] = 8;
                $store_transaction['store_no'] = $store_balance['Store_No'];
                $store_transaction['cust_no'] = $store_balance['Cust_No'];
                $store_transaction['fso_no'] = $store_balance['FSO_No'];
                $store_transaction['deposit_amount'] = $store_balance['Outstanding_Amt'];
                $store_transaction['withdraw_amount'] = 0;
                $store_transaction['outstanding_amt'] = 0;
                if (isset($store_transaction[1]['balance_amt'])) {
                    $store_transaction['balance_amt'] = $store_transaction[1]['balance_amt'];
                } else {
                    $store_transaction['balance_amt'] = $store_balances1['Balance_Amt'];
                }
                // $store_transaction['balance_amt'] = $store_transaction[1]['balance_amt'];
                $store_transaction['outstanding_balance_amt'] = $store_balance['Outstanding_Amt']+$store_balances1['Outstanding_Balance_Amt'];
                $store_transaction['remark'] = "Reverse bill";

                if($flag)
                {
                    // echo"here";
                    // die();
                    $ans_store_transaction1 = create_store_transaction($this->pdo, $store_transaction[0]);
                    if ($ans_store_transaction1) {
                        $status = true;
                    } else {
                        $status = false;
                    }

                    $ans_store_transaction2 = create_store_transaction_from_order($this->pdo, $store_transaction[1]);
                    if ($ans_store_transaction2) {
                        $status = true;
                    } else {
                        $status = false;
                    }
                }
                // die();

                $ans = create_store_transaction($this->pdo, $store_transaction);
                if ($ans) {
                    // $msg = "Created store transaction detail for order " . $invoice_hdr['order_no'];
                    $status = true;
                } else {
                    // $msg = "Failed to create store transaction detail for order" . $invoice_hdr['order_no'];
                    $status = false;
                    // $data = '';
                    // return get_response(null, $status, $data);
                }

                // die();

                $store_transaction_detail['order_no'] = $order_no;
                $store_transaction_detail['store_no'] = $store_balance['Store_No'];
                $store_transaction_detail['cust_no'] = $store_balance['Cust_No'];

                $ans = create_store_transaction_detail($this->pdo, $store_transaction_detail);
                if ($ans) {
                    $status = true;
                } else {
                    $status = false;
                }

                $memo = 'Reverse Bill for invoice number-'.$invoice_number;

                $Order_History = insert_invoice_order_history($this->pdo, $order_no, $memo);
                if ($Order_History) {
                    $status = true;
                } else {
                    $status = false;
                }

                $memo1 = 'Accepted';

                $Order_History = insert_invoice_order_history($this->pdo, $order_no, $memo1);
                if ($Order_History) {
                    $status = true;
                } else {
                    $status = false;
                }

                $this->pdo->commit();
                // $isTrans--;
                $msg = $invoice_number ." invoice deleted";
                $status = true;
            } catch (PDOException $e) {
                $this->pdo->rollback();
                $status = false;
                $data = $e->getMessage();
                return get_response("Something went wrong", $status, $data);
            }
        }
        else
        {
            $msg = "Missing input data";
            $status = false;
        }
        return get_response($msg, $status, $data);
    }

    public function api_invoices_update(Request $request){
        $post = $request->post();

        extract($post);

        $param_array = array();
        $where = '';

        $is_valid = true;
        $logging = 1;

        if ($is_valid) {
            $param_array[':order_no'] = $order_no;

            $logArr['run_datetime'] = date('Y-m-d H:i:s', strtotime('+5 hours 30 minutes'));
            $logArr['order_no'] = $order_no;
            $logArr['invoice_number'] = $invoice_number;


            if ($businessID == 2) {
                $needs_reverse_entry = false;
                $update_reverse_entry = false;

                $invoice_hdr['order_no'] = $order_no;
                $invoice_hdr['invoice_number'] = $invoice_number;
                $invoice_hdr['total_invoice_amount'] = 0;
                $invoice_hdr['total_invoice_qty'] = 0;
                $invoice_hdr['total_base_amount'] = 0;
                $invoice_hdr['total_cgst_amount'] = 0;
                $invoice_hdr['total_sgst_amount'] = 0;
                $invoice_hdr['total_igst_amount'] = 0;
                $invoice_hdr['total_gst_amount'] = 0;
                $invoice_hdr['total_cess_amount'] = 0;

                $invoice_hdr['invoice_date'] = $invoice_date;
                $invoice_hdr['invoice_type'] = 'ETAXINV';
                $invoice_hdr['tax_type'] = 'GST';


                if (count($invoice_items) > 0) {

                    $order = array();
                    $dborderitems = array();

                    $orderans = get_order_details($this->pdo, $invoice_hdr['order_no']);
                    if (empty($orderans)) {
                        $msg = "Failed to retrieve order details for order " . $invoice_hdr['order_no'];
                        $status = false;
                        $data = '';

                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);
                    }

                    $storeno = $orderans['Store_No'];
                    $custno = $orderans['Cust_No'];

                    if ($orderans['Ext_Invoice_No'] != '') {
                        if($orderans['Ext_Invoice_No'] == $invoice_number)
                            $update_reverse_entry = true;
                        // $msg = "Invoice Number (" . $orderans['Ext_Invoice_No'] . ") already received for order " . $invoice_hdr['order_no'];
                        // $status = false;
                        // $data = '';
                        // // createLog([$msg]);
                        // return get_response($msg, $status, $data);

                    }

                    $stmtA = $this->pdo->prepare("select Order_No, Invoice_No from Invoice_Hdr where Order_No=? and Invoice_No=?");
                    $stmtA->execute([$invoice_hdr['order_no'], $invoice_hdr['invoice_number']]);
                    $rowA = $stmtA->fetch(PDO::FETCH_ASSOC);
                    if(!empty($rowA)){
                        $update_reverse_entry = true;
                        // $msg = "Invoice not created for order " . $invoice_hdr['order_no'];
                        // $status = false;
                        // $data = '';
                        // // createLog([$msg]);
                        // return get_response($msg, $status, $data);
                    }

                    $dborderitems = get_order_item_details($this->pdo, $invoice_hdr['order_no']);

                    if (empty($dborderitems)) {
                        $msg = "Failed to retrieve order items for order number " . $invoice_hdr['order_no'];
                        $status = false;
                        $data = '';
                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);
                    }

                    if($update_reverse_entry)
                    {
                        $store_balance1 = get_amount_store_transaction($this->pdo, $order_no, $invoice_number);
                        if (empty($store_balance1)) {
                            $msg = "Failed to retrieve store balance for order number " . $order_no;
                            $status = false;
                            $data = '';
                            // createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }
                    }

                    $order_article_list = array_column($dborderitems, 'Article_No');
                    $invoice_item_list = array_column($invoice_items, 'sk_article_no');

                    $additional_items = array_diff($invoice_item_list, $order_article_list);

                    $missing_articles = array_diff($order_article_list, $invoice_item_list);

                    $missing_items = array_values($missing_articles);

                    if (count($missing_items) > 0) {
                        if (!$needs_reverse_entry) {
                            $needs_reverse_entry = true;
                        }
                    }

                    if (count($additional_items) > 0) {

                        $msg = "Additional articles " . implode(",", $additional_items) . " on invoice for order " . $invoice_hdr['order_no'];
                        $status = false;
                        $data = '';
                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);

                    }

                    foreach ($invoice_items as $key => $val) {
                        if (in_array($invoice_items[$key]['sk_article_no'], $order_article_list)) {
                            $orderitemkey = array_search($invoice_items[$key]['sk_article_no'], array_column($dborderitems, 'Article_No'));

                            if ($invoice_items[$key]['article_invoice_quantity'] > $dborderitems[$orderitemkey]['Order_Quantity']) {
                                $msg = " Article " . $invoice_items[$key]['sk_article_no'] . " has quantity (" . $invoice_items[$key]['article_invoice_quantity'] . ") that is greater than ordered quantity (" . $dborderitems[$orderitemkey][Order_Quantity] . ")for order number " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            if ($invoice_items[$key]['article_invoice_quantity'] < $dborderitems[$orderitemkey]['Order_Quantity']) {
                                if (!$needs_reverse_entry) {
                                    $needs_reverse_entry = true;
                                }

                            }

                            $invoice_items[$key]['article_cess_amount'] = 0;
                            $invoice_items[$key]['invoice_number'] = $invoice_hdr['invoice_number'];
                            $invoice_items[$key]['order_no'] = $invoice_hdr['order_no'];

                            $invoice_hdr['total_invoice_qty'] += $invoice_items[$key]['article_invoice_quantity'];
                            $invoice_hdr['total_base_amount'] += $invoice_items[$key]['article_base_amount'];
                            $invoice_hdr['total_cgst_amount'] += $invoice_items[$key]['article_cgst_amount'];
                            $invoice_hdr['total_sgst_amount'] += $invoice_items[$key]['article_sgst_amount'];
                            $invoice_hdr['total_igst_amount'] += $invoice_items[$key]['article_igst_amount'];
                            $invoice_hdr['total_gst_amount'] += $invoice_items[$key]['article_gst_amount'];
                            $invoice_hdr['total_cess_amount'] += $invoice_items[$key]['article_cess_amount'];

                            $invoice_items[$key]['article_invoice_amount'] += $invoice_items[$key]['article_base_amount']
                                + $invoice_items[$key]['article_gst_amount']
                                + $invoice_items[$key]['article_cess_amount'];

                            $invoice_hdr['total_invoice_amount'] += $invoice_items[$key]['article_invoice_amount'];

                            $gst_id = $invoice_items[$key]['gst_tax_id'];


                            $invoice_tax_hdr_temp[$gst_id]['total_invoice_qty'] += $invoice_items[$key]['article_invoice_quantity'];
                            $invoice_tax_hdr_temp[$gst_id]['total_base_amount'] += $invoice_items[$key]['article_base_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_cgst_amount'] += $invoice_items[$key]['article_cgst_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_sgst_amount'] += $invoice_items[$key]['article_sgst_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_igst_amount'] += $invoice_items[$key]['article_igst_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_gst_amount'] += $invoice_items[$key]['article_gst_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_cess_amount'] += $invoice_items[$key]['article_cess_amount'];

                            $invoice_tax_hdr_temp[$gst_id]['total_invoice_amount'] = $invoice_hdr['total_invoice_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['order_no'] = $invoice_hdr['order_no'];
                            $invoice_tax_hdr_temp[$gst_id]['invoice_number'] = $invoice_hdr['invoice_number'];
                            $invoice_tax_hdr_temp[$gst_id]['invoice_date'] = $invoice_hdr['invoice_date'];
                            $invoice_tax_hdr_temp[$gst_id]['invoice_type'] = 'ETAXINV';
                            $invoice_tax_hdr_temp[$gst_id]['tax_type'] = 'GST';


                            $order_items[$key]['order_no'] = $invoice_hdr['order_no'];
                            $order_items[$key]['article_number'] = $invoice_items[$key]['sk_article_no'];
                            $order_items[$key]['pick_quantity'] = $invoice_items[$key]['article_invoice_quantity'];

                        }
                    }

                    foreach ($missing_items as $missingkey => $missingval) {
                        $curr_num = count($order_items);
                        $order_items[$curr_num]['order_no'] = $invoice_hdr['order_no'];
                        $order_items[$curr_num]['article_number'] = $missing_items[$missingkey];
                        $order_items[$curr_num]['pick_quantity'] = 0;
                    }

                    $missing_invoice_items['article_number'] = $missing_articles;
                    $missing_invoice_items['order_no'] = $order_no;
                    $missing_invoice_items['invoice_no'] = $invoice_number;

                    $invoice_tax_hdr = $invoice_tax_hdr_temp;

                    $order_hdr['order_status'] = 'Ready To Deliver';
                    $order_hdr['order_number'] = $invoice_hdr['order_no'];
                    $order_hdr['ext_invoice_no'] = $invoice_hdr['invoice_number'];
                    $store_balances = get_store_balance($this->pdo, $storeno, $custno);
                    if (!empty($store_balances)) {
                        $msg = "Received Store balance for store " . $storeno . " and buyer " . $custno;
                        $status = true;
                    } else {
                        $msg = "Failed to get Store balance for store " . $storeno . " and buyer " . $custno;
                        $status = false;
                        $data = '';
                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);
                    }

                    if($update_reverse_entry)
                    {
                        $invoice_hdr_update = get_invoice_hdr($this->pdo, $order_no, $invoice_number);
                        if (!empty($invoice_hdr_update)) {
                            $msg = "Received invoice header for invoice " . $invoice_number . " and order " . $order_no;
                            $status = true;
                        } else {
                            $msg = "Failed to get invoice header for invoice " . $invoice_number . " and order " . $order_no;
                            $status = false;
                            $data = '';
                            // createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        $invoice_tax_hdr_update = get_invoice_tax_hdr($this->pdo, $order_no, $invoice_number);
                        if (!empty($invoice_tax_hdr_update)) {
                            $msg = "Received invoice tax header for invoice " . $invoice_number . " and order " . $order_no;
                            $status = true;
                        } else {
                            $msg = "Failed to get invoice tax header for invoice " . $invoice_number . " and order " . $order_no;
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        foreach ($invoice_tax_hdr_update as $key => $value) {
                            $invoice_tax_hdr_order[$key]['Order_No'] = "D".$value['Invoice_Tax_Hdr_Id'];
                            $invoice_tax_hdr_order[$key]['Invoice_Tax_Hdr_Id'] = $value['Invoice_Tax_Hdr_Id'];
                        }

                        $invoice_tax_itm_update = get_invoice_tax_itm($this->pdo, $order_no, $invoice_number);
                        if (!empty($invoice_tax_itm_update)) {
                            $msg = "Received invoice tax item for invoice " . $invoice_number . " and order " . $order_no;
                            $status = true;
                        } else {
                            $msg = "Failed to get invoice tax item for invoice " . $invoice_number . " and order " . $order_no;
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        foreach ($invoice_tax_itm_update as $key => $value) {
                            $invoice_tax_itm_order[$key]['Order_No'] = "D".$value['Invoice_Tax_Itm_Id'];
                            $invoice_tax_itm_order[$key]['Invoice_Tax_Itm_Id'] = $value['Invoice_Tax_Itm_Id'];
                        }
                    }

                    if($update_reverse_entry)
                    {
                        $store_transaction[0]['order_no'] = $invoice_hdr['order_no'];
                        $store_transaction[0]['invoice_number'] = 0;
                        $store_transaction[0]['invoice_date'] = 0;
                        $store_transaction[0]['transaction_type'] = 5;
                        $store_transaction[0]['store_no'] = $orderans['Store_No'];
                        $store_transaction[0]['cust_no'] = $orderans['Cust_No'];
                        $store_transaction[0]['fso_no'] = $orderans['FSO_No'];
                        $store_transaction[0]['deposit_amount'] = $orderans['Net_Amount'];
                        $store_transaction[0]['withdraw_amount'] = 0;
                        $store_transaction[0]['outstanding_amt'] = 0;
                        $store_transaction[0]['balance_amt'] = $store_balances['Balance_Amt'] + $orderans['Net_Amount'];
                        $store_transaction[0]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'];
                        $store_transaction[0]['remark'] = "Reverse ordered amount";
                    }

                    // $store_transaction[1]['order_no'] = $invoice_hdr['order_no'];
                    // $store_transaction[1]['invoice_number'] = 0;
                    // $store_transaction[1]['invoice_date'] = 0;
                    // $store_transaction[1]['transaction_type'] = 5;
                    // $store_transaction[1]['store_no'] = $orderans['Store_No'];
                    // $store_transaction[1]['cust_no'] = $orderans['Cust_No'];
                    // $store_transaction[1]['fso_no'] = $orderans['FSO_No'];
                    // $store_transaction[1]['deposit_amount'] = 0;
                    // $store_transaction[1]['withdraw_amount'] = $order_hdr['order_amount'];
                    // $store_transaction[1]['outstanding_amt'] = 0;
                    // $store_transaction[1]['balance_amt'] = $store_transaction[0]['balance_amt'] - $order_amount;
                    // $store_transaction[1]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'];
                    // $store_transaction[1]['remark'] = "Picked order amount";

                    // $store_transaction[2]['order_no'] = $invoice_hdr['order_no'];
                    // $store_transaction[2]['invoice_number'] = $invoice_hdr['invoice_number'];
                    // $store_transaction[2]['invoice_date'] = $invoice_hdr['invoice_date'];
                    // $store_transaction[2]['transaction_type'] = 9;
                    // $store_transaction[2]['store_no'] = $orderans['Store_No'];
                    // $store_transaction[2]['cust_no'] = $orderans['Cust_No'];
                    // $store_transaction[2]['fso_no'] = $orderans['FSO_No'];
                    // $store_transaction[2]['deposit_amount'] = $store_balance1['Outstanding_Amt'];
                    // $store_transaction[2]['withdraw_amount'] = 0;
                    // $store_transaction[2]['outstanding_amt'] = 0;
                    // $store_transaction[2]['balance_amt'] = $store_transaction[1]['balance_amt'];
                    // $store_transaction[2]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'] + $store_balance1['Outstanding_Amt'];
                    // $store_transaction[2]['remark'] = "Reverse invoice amount update";

                    // $store_transaction[3]['order_no'] = $invoice_hdr['order_no'];
                    // $store_transaction[3]['invoice_number'] = $invoice_hdr['invoice_number'];
                    // $store_transaction[3]['invoice_date'] = $invoice_hdr['invoice_date'];
                    // $store_transaction[3]['transaction_type'] = 3;
                    // $store_transaction[3]['store_no'] = $orderans['Store_No'];
                    // $store_transaction[3]['cust_no'] = $orderans['Cust_No'];
                    // $store_transaction[3]['fso_no'] = $orderans['FSO_No'];
                    // $store_transaction[3]['deposit_amount'] = 0;
                    // $store_transaction[3]['withdraw_amount'] = 0;
                    // if (isset($store_transaction[2]['balance_amt'])) {
                    //     $store_transaction[3]['balance_amt'] = $store_transaction[2]['balance_amt'];
                    // } else {
                    //     $store_transaction[3]['balance_amt'] = $store_balances['Balance_Amt'];
                    // }
                    // $store_transaction[3]['outstanding_amt'] = $invoice_hdr['total_invoice_amount'];
                    // $store_transaction[3]['outstanding_balance_amt'] = $store_transaction[2]['outstanding_balance_amt'] - $invoice_hdr['total_invoice_amount'];
                    // $store_transaction[3]['remark'] = "Revised Bill Entry";

                    $store_transaction_detail['store_no'] = $orderans['Store_No'];
                    $store_transaction_detail['cust_no'] = $orderans['Cust_No'];

                    $Ext_Order_No = NULL;

                    $InvoiceHdrOrderNo = "D".$invoice_hdr_update[0]['Invoice_Hdr_Id'];

                    if($update_reverse_entry)
                    {
                        $needs_reverse_entry = false;
                    }

                    try {
                        $this->pdo->beginTransaction();
                        if($update_reverse_entry)
                        {
                            $update_invoice_hdr = $this->pdo->prepare("update Invoice_Hdr set Order_No=? where Order_No=? and Invoice_No=?");
                            $update_invoice_hdr->execute([$InvoiceHdrOrderNo, $order_no, $invoice_number]);

                            $update_invoice_tax_hdr = update_invoice_tax_header($this->pdo, $invoice_tax_hdr_order, $order_no);
                            if ($update_invoice_tax_hdr) {
                                $msg = "Update invoice tax header" . $order_no;
                                $status = true;
                            } else {
                                $msg = "Failed to update invoice tax header for order " . $invoice_tax_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $update_invoice_tax_itm = update_invoice_tax_item($this->pdo, $invoice_tax_itm_order,$order_no);
                            if ($update_invoice_tax_itm) {
                                $msg = "Update invoice item header" . $order_no;
                                $status = true;
                            } else {
                                $msg = "Failed to update invoice item header for order " . $invoice_tax_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }
                        }

                        $ans = create_invoice_header($this->pdo, $invoice_hdr);
                        if ($ans) {
                            $msg = "Created invoice header" . $invoice_hdr['order_no'];
                            $status = true;
                        } else {
                            $msg = "Failed to create invoice header for order " . $invoice_hdr['order_no'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }
                        // create invoice tax header entry

                        $ans = create_invoice_tax_header($this->pdo, $invoice_tax_hdr);
                        if ($ans) {
                            $msg = "Created invoice tax header" . $invoice_tax_hdr['order_no'];
                            $status = true;
                        } else {
                            $msg = "Failed to create invoice tax header for order " . $invoice_tax_hdr['order_no'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        // // create invoice tax item entry

                        $ans = create_invoice_tax_items($this->pdo, $invoice_items);
                        if ($ans) {
                            $msg = "Created invoice items for order " . $invoice_items['order_no'];
                            $status = true;
                        } else {
                            $msg = "Failed to create invoice items for order " . $invoice_items['order_no'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        // update order
                        $ans = update_order_items($this->pdo, $order_items);
                        if ($ans) {
                            $msg = "Updated order items for " . $order_hdr['order_number'];
                            $status = true;
                        } else {
                            $msg = "Failed to update order items for order " . $order_hdr['order_number'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        if(!($update_reverse_entry))
                        {
                            $ans = update_order_hdr($this->pdo, $order_hdr);
                            if ($ans) {
                                $msg = "Updated order header" . $order_hdr['order_number'];
                                $status = true;
                            } else {
                                $msg = "Failed to update  order status for order " . $order_hdr['order_number'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }
                        }

                        if($update_reverse_entry)
                        {
                            // update order header
                            $ans = update_invoice_order_hdr($this->pdo, $order_hdr);
                            if ($ans) {
                                $msg = "Updated order header" . $order_hdr['order_number'];
                                $status = true;
                            } else {
                                $msg = "Failed to update  order status for order " . $order_hdr['order_number'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            // insert into order_history

                            $memo = "Reverse Invoice On Update";
                            $ans = insert_invoice_order_history($this->pdo, $order_no, $memo);
                            if ($ans) {
                                $msg = "Create order history entry for " . $order_hdr['order_number'];
                                $status = true;
                            } else {
                                $msg = "Error creating order history entry for order " . $order_hdr['order_number'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }
                        }

                        if(!($update_reverse_entry))
                        {
                            $ans = insert_order_history($this->pdo, $order_hdr);
                            if ($ans) {
                                $msg = "Create order history entry for " . $order_hdr['order_number'];
                                $status = true;
                            } else {
                                $msg = "Error creating order history entry for order " . $order_hdr['order_number'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }
                        }
                        /// for upddate
                        if($update_reverse_entry)
                        {
                            $ans = create_store_transaction($this->pdo, $store_transaction[0]);
                            if ($ans) {
                                $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $store_balances2 = get_store_balance($this->pdo, $storeno, $custno);
                            if (!empty($store_balances2)) {
                                $msg = "Received Store balance for store " . $storeno . " and buyer " . $custno;
                                $status = true;
                            } else {
                                $msg = "Failed to get Store balance for store " . $storeno . " and buyer " . $custno;
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $get_order_amount_from_hdr = get_order_details($this->pdo, $invoice_hdr['order_no']);
                            if (empty($get_order_amount_from_hdr)) {
                                $msg = "Failed to retrieve order details for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';

                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $store_transaction[1]['order_no'] = $invoice_hdr['order_no'];
                            $store_transaction[1]['invoice_number'] = 0;
                            $store_transaction[1]['invoice_date'] = 0;
                            $store_transaction[1]['transaction_type'] = 5;
                            $store_transaction[1]['store_no'] = $orderans['Store_No'];
                            $store_transaction[1]['cust_no'] = $orderans['Cust_No'];
                            $store_transaction[1]['fso_no'] = $orderans['FSO_No'];
                            $store_transaction[1]['deposit_amount'] = 0;
                            $store_transaction[1]['withdraw_amount'] = $order_hdr['order_amount'];
                            $store_transaction[1]['outstanding_amt'] = 0;
                            $store_transaction[1]['balance_amt'] = $store_balances2['Balance_Amt'] -  $get_order_amount_from_hdr['Order_Amount'];
                            $store_transaction[1]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'];
                            $store_transaction[1]['remark'] = "Picked order amount";

                            $ans1 = create_store_transaction_from_order($this->pdo, $store_transaction[1]);
                            if ($ans1) {
                                $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $store_transaction[2]['order_no'] = $invoice_hdr['order_no'];
                            $store_transaction[2]['invoice_number'] = $invoice_hdr['invoice_number'];
                            $store_transaction[2]['invoice_date'] = $invoice_hdr['invoice_date'];
                            $store_transaction[2]['transaction_type'] = 9;
                            $store_transaction[2]['store_no'] = $orderans['Store_No'];
                            $store_transaction[2]['cust_no'] = $orderans['Cust_No'];
                            $store_transaction[2]['fso_no'] = $orderans['FSO_No'];
                            $store_transaction[2]['deposit_amount'] = $store_balance1['Outstanding_Amt'];
                            $store_transaction[2]['withdraw_amount'] = 0;
                            $store_transaction[2]['outstanding_amt'] = 0;
                            if (isset($store_transaction[1]['balance_amt'])) {
                                $store_transaction[2]['balance_amt'] = $store_transaction[1]['balance_amt'];
                            } else {
                                $store_transaction[2]['balance_amt'] = $store_balances['Balance_Amt'];
                            }
                            // $store_transaction[2]['balance_amt'] = $store_transaction[1]['balance_amt'];
                            $store_transaction[2]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'] + $store_balance1['Outstanding_Amt'];
                            $store_transaction[2]['remark'] = "Reverse invoice amount update";

                            $ans2 = create_store_transaction($this->pdo, $store_transaction[2]);
                            if ($ans2) {
                                $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $store_transaction[3]['order_no'] = $invoice_hdr['order_no'];
                            $store_transaction[3]['invoice_number'] = $invoice_hdr['invoice_number'];
                            $store_transaction[3]['invoice_date'] = $invoice_hdr['invoice_date'];
                            $store_transaction[3]['transaction_type'] = 3;
                            $store_transaction[3]['store_no'] = $orderans['Store_No'];
                            $store_transaction[3]['cust_no'] = $orderans['Cust_No'];
                            $store_transaction[3]['fso_no'] = $orderans['FSO_No'];
                            $store_transaction[3]['deposit_amount'] = 0;
                            $store_transaction[3]['withdraw_amount'] = 0;
                            if (isset($store_transaction[2]['balance_amt'])) {
                                $store_transaction[3]['balance_amt'] = $store_transaction[2]['balance_amt'];
                            } else {
                                $store_transaction[3]['balance_amt'] = $store_balances['Balance_Amt'];
                            }
                            $store_transaction[3]['outstanding_amt'] = $invoice_hdr['total_invoice_amount'];
                            $store_transaction[3]['outstanding_balance_amt'] = $store_transaction[2]['outstanding_balance_amt'] - $invoice_hdr['total_invoice_amount'];
                            $store_transaction[3]['remark'] = "Revised Bill Entry";

                            $ans3 = create_store_transaction($this->pdo, $store_transaction[3]);
                            if ($ans3) {
                                $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            // update ledger ie store_transaction_detail
                            $ans = create_store_transaction_detail($this->pdo, $store_transaction_detail);
                            if ($ans) {
                                $msg = "Created store transaction detail for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction detail for order" . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }
                        }

                        if ($needs_reverse_entry) {
                            // An extra entry is made in the store transaction to reverse the order amount.
                            $store_transaction[0]['order_no'] = $invoice_hdr['order_no'];
                            $store_transaction[0]['invoice_number'] = 0;
                            $store_transaction[0]['invoice_date'] = 0;
                            $store_transaction[0]['transaction_type'] = 5;
                            $store_transaction[0]['store_no'] = $orderans['Store_No'];
                            $store_transaction[0]['cust_no'] = $orderans['Cust_No'];
                            $store_transaction[0]['fso_no'] = $orderans['FSO_No'];
                            $store_transaction[0]['deposit_amount'] = $orderans['Net_Amount'];
                            $store_transaction[0]['withdraw_amount'] = 0;
                            $store_transaction[0]['outstanding_amt'] = 0;
                            $store_transaction[0]['balance_amt'] = $store_balances['Balance_Amt'] + $orderans['Net_Amount'];
                            $store_transaction[0]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'];
                            $store_transaction[0]['remark'] = "Reverse ordered amount";

                            $ans = create_store_transaction($this->pdo, $store_transaction[0]);
                            if ($ans) {
                                $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            // update ledger ie store_transaction_detail
                            $ans = create_store_transaction_detail($this->pdo, $store_transaction_detail);
                            if ($ans) {
                                $msg = "Created store transaction detail for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction detail for order" . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $store_balances3 = get_store_balance($this->pdo, $storeno, $custno);
                            if (!empty($store_balances3)) {
                                $msg = "Received Store balance for store " . $storeno . " and buyer " . $custno;
                                $status = true;
                            } else {
                                $msg = "Failed to get Store balance for store " . $storeno . " and buyer " . $custno;
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $get_order_amount_from_hdr = get_order_details($this->pdo, $invoice_hdr['order_no']);
                            if (empty($get_order_amount_from_hdr)) {
                                $msg = "Failed to retrieve order details for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';

                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $store_transaction[1]['order_no'] = $invoice_hdr['order_no'];
                            $store_transaction[1]['invoice_number'] = 0;
                            $store_transaction[1]['invoice_date'] = 0;
                            $store_transaction[1]['transaction_type'] = 5;
                            $store_transaction[1]['store_no'] = $orderans['Store_No'];
                            $store_transaction[1]['cust_no'] = $orderans['Cust_No'];
                            $store_transaction[1]['fso_no'] = $orderans['FSO_No'];
                            $store_transaction[1]['deposit_amount'] = 0;
                            $store_transaction[1]['withdraw_amount'] = $order_hdr['order_amount']; // This gets over written by latest value of the order header order amount.
                            $store_transaction[1]['outstanding_amt'] = 0;
                            $store_transaction[1]['balance_amt'] = $store_balances3['Balance_Amt'] -  $get_order_amount_from_hdr['Order_Amount']; // This gets over written by latest value of the order header order amount get substract from cust_no and store value of  balance amount.
                            $store_transaction[1]['outstanding_balance_amt'] = $store_transaction[0]['outstanding_balance_amt'];
                            $store_transaction[1]['remark'] = "Picked order amount";

                            $ans = create_store_transaction_from_order($this->pdo, $store_transaction[1]);
                            if ($ans) {
                                $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            // update ledger ie store_transaction_detail
                            $ans = create_store_transaction_detail($this->pdo, $store_transaction_detail);
                            if ($ans) {
                                $msg = "Created store transaction detail for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction detail for order" . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }
                        }
                        if(!($update_reverse_entry))
                        {
                            $store_transaction[2]['order_no'] = $invoice_hdr['order_no'];
                            $store_transaction[2]['invoice_number'] = $invoice_hdr['invoice_number'];
                            $store_transaction[2]['invoice_date'] = $invoice_hdr['invoice_date'];
                            $store_transaction[2]['transaction_type'] = 3;
                            $store_transaction[2]['store_no'] = $orderans['Store_No'];
                            $store_transaction[2]['cust_no'] = $orderans['Cust_No'];
                            $store_transaction[2]['fso_no'] = $orderans['FSO_No'];
                            $store_transaction[2]['deposit_amount'] = 0;
                            $store_transaction[2]['withdraw_amount'] = 0;
                            // This gets over written by latest value of cust_no and store value of  balance amount
                            if (isset($store_transaction[1]['balance_amt'])) {
                                $store_transaction[2]['balance_amt'] = $store_transaction[1]['balance_amt'];
                            } else {
                                $store_transaction[2]['balance_amt'] = $store_balances['Balance_Amt'];
                            }
                            $store_transaction[2]['outstanding_amt'] = $invoice_hdr['total_invoice_amount'];
                            $store_transaction[2]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'] - $invoice_hdr['total_invoice_amount'];
                            $store_transaction[2]['remark'] = "Order Ready Ext Bill Entry";

                            //
                            $ans = create_store_transaction($this->pdo, $store_transaction[2]);
                            if ($ans) {
                                $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            // update ledger ie store_transaction_detail
                            $ans = create_store_transaction_detail($this->pdo, $store_transaction_detail);
                            if ($ans) {
                                $msg = "Created store transaction detail for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction detail for order" . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }
                        }
                        $this->pdo->commit();
                        $isTrans--;
                        if($update_reverse_entry)
                            $msg = "Invoice updated successfully";
                        else
                            $msg = "Success";
                        $status = true;
                    } catch (PDOException $e) {

                       $this->pdo->rollback();
                        $msg = "Error preparing update order header for order " . $order_hdr['order_number'];
                        echo " $msg " . $e->getMessage();
                        $retval = false;
                    }
                } else {
                    $msg = "Missing input data";
                    $status = false;
                }
            }

        } else { // Input data is not valid
            $msg = "Incorrect or missing input!!";
            // $data = "Incorrect or missing input!!";
            $status = false;

        }
        // createLog([$msg]);
        return get_response($msg, $status, $data);
    }

    // {
    //     "businessID": "2",
    //     "order_no": "1100001100004",
    //      "invoice_number" : "abcd12345",
    //     "invoice_date": "2019-07-23 10:28:08",
    //     "invoice_items": [
    //         {
    //             "gst_tax_id": "5",
    //             "gst_tax_detail_id": "5",
    //             "sk_article_no": "11",
    //             "article_invoice_quantity": "1",
    //             "article_base_amount": "92.58",
    //             "article_cgst_amount": "8.33",
    //             "article_sgst_amount": "8.33",
    //             "article_igst_amount": "0.00",
    //             "article_gst_amount": "16.67"
    //         },
    //         {
    //             "gst_tax_id": "5",
    //             "gst_tax_detail_id": "5",
    //             "sk_article_no": "246",
    //             "article_invoice_quantity": "3",
    //             "article_base_amount": "221.19",
    //             "article_cgst_amount": "19.91",
    //             "article_sgst_amount": "19.91",
    //             "article_igst_amount": "0.00",
    //             "article_gst_amount": "39.81"
    //         },
    //         {
    //             "gst_tax_id": "6",
    //             "gst_tax_detail_id": "6",
    //             "sk_article_no": "317",
    //             "article_invoice_quantity": "2",
    //             "article_base_amount": "62.34",
    //             "article_cgst_amount": "8.73",
    //             "article_sgst_amount": "8.73",
    //             "article_igst_amount": "0.00",
    //             "article_gst_amount": "17.46"
    //         }
    //     ]
    // }
    public function api_invoices(Request $request){
        $post = $request->post();

        extract($post);

        $param_array = array();
        $where = '';

        $is_valid = true; // validate_data ($post) ;
        $logging = 1;

        if ($is_valid) {
            $param_array[':order_no'] = $order_no;

            ### LOG
            $logArr['run_datetime'] = date('Y-m-d H:i:s', strtotime('+5 hours 30 minutes'));
            $logArr['order_no'] = $order_no;
            $logArr['invoice_number'] = $invoice_number;
            $this->createLog($logArr);


            // chitale
            if ($businessID == 2) {

                // $needs_reverse_entry is set to true ( further down ) if invoice article quantity does not match the order article quantity
                // if needs reverse entry is true then an extra entry is made in the store transaction to reverse the order amount.
                $needs_reverse_entry = false;

                // get invoice header data

                $invoice_hdr['order_no'] = $order_no;
                $invoice_hdr['invoice_number'] = $invoice_number;
                $invoice_hdr['total_invoice_amount'] = 0;
                $invoice_hdr['total_invoice_qty'] = 0;
                $invoice_hdr['total_base_amount'] = 0;
                $invoice_hdr['total_cgst_amount'] = 0;
                $invoice_hdr['total_sgst_amount'] = 0;
                $invoice_hdr['total_igst_amount'] = 0;
                $invoice_hdr['total_gst_amount'] = 0;
                $invoice_hdr['total_cess_amount'] = 0;

                $invoice_hdr['invoice_date'] = $invoice_date;
                $invoice_hdr['invoice_type'] = 'ETAXINV';
                $invoice_hdr['tax_type'] = 'GST';

                // get invoice item data

                if (count($invoice_items) > 0) {

                    $order = array();
                    $dborderitems = array();

                    // get order and order items ( including order quantity )
                    $orderans = get_order_details($this->pdo, $invoice_hdr['order_no']);
                    if (empty($orderans)) {
                        $msg = "Failed to retrieve order details for order " . $invoice_hdr['order_no'];
                        $status = false;
                        $data = '';

                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);
                    }

                    $storeno = $orderans['Store_No'];
                    $custno = $orderans['Cust_No'];

                    $exists_invoice_number = $this->pdo->prepare("select Order_No from Order_Hdr where Ext_Invoice_No=?");
                    $exists_invoice_number->execute([$invoice_hdr['invoice_number']]);
                    $exists_invoice_number_row = $exists_invoice_number->fetch(PDO::FETCH_ASSOC);
                    if(!empty($exists_invoice_number_row)){
                        $msg = "Invoice already created for order " . $exists_invoice_number_row['Order_No'];
                        $status = false;
                        $data = '';
                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);
                    }

                    // Error if Invoice already received

                    // if an invoice is already recd then do not process a new invoice for that order.
                    //  && $orderans['Ext_Invoice_No'] == $invoice_hdr['invoice_number']) {
                    if ($orderans['Ext_Invoice_No'] != '') {
                        $msg = "Invoice Number (" . $orderans['Ext_Invoice_No'] . ") already received for order " . $invoice_hdr['order_no'];
                        $status = false;
                        $data = '';
                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);
                    }

                    ### Check invoice_hdr already has order_no, invoice_no entry
                    $stmtA = $this->pdo->prepare("select Order_No, Invoice_No from Invoice_Hdr where Order_No=? and Invoice_No=?");
                    $stmtA->execute([$invoice_hdr['order_no'], $invoice_hdr['invoice_number']]);
                    $rowA = $stmtA->fetch(PDO::FETCH_ASSOC);
                    //$stmt->debugDumpParams();
                    if(!empty($rowA)){
                        $msg = "Invoice already created for order " . $invoice_hdr['order_no'];
                        $status = false;
                        $data = '';
                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);
                    }

                    // Error if Invoice already received

                    $dborderitems = get_order_item_details($this->pdo, $invoice_hdr['order_no']);

                    if (empty($dborderitems)) {
                        $msg = "Failed to retrieve order items for order number " . $invoice_hdr['order_no'];
                        $status = false;
                        $data = '';
                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);
                    }

                    // at this point we have the order items to compare against the input data.

                    // Order_No, Article_No, Order_Quantity
                    $order_article_list = array_column($dborderitems, 'Article_No');
                    $invoice_item_list = array_column($invoice_items, 'sk_article_no');

                    $additional_items = array_diff($invoice_item_list, $order_article_list);

                    $missing_articles = array_diff($order_article_list, $invoice_item_list);

                    $missing_items = array_values($missing_articles);

                    // Set the needs reverse entry flag if articles are missing from the external invoice. ie pick quantity is to be set to zero
                    if (count($missing_items) > 0) {
                        if (!$needs_reverse_entry) {
                            $needs_reverse_entry = true;
                        }
                    }

                    if (count($additional_items) > 0) {

                        $msg = "Additional articles " . implode(",", $additional_items) . " on invoice for order " . $invoice_hdr['order_no'];
                        $status = false;
                        $data = '';
                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);

                    }

                    foreach ($invoice_items as $key => $val) {

                        // derive the invoice header and invoice tax item values

                        if (in_array($invoice_items[$key]['sk_article_no'], $order_article_list)) {

                            // check that the invoice qty is not greater than the order qty

                            $orderitemkey = array_search($invoice_items[$key]['sk_article_no'], array_column($dborderitems, 'Article_No'));

                            if ($invoice_items[$key]['article_invoice_quantity'] > $dborderitems[$orderitemkey]['Order_Quantity']) {
                                $msg = " Article " . $invoice_items[$key]['sk_article_no'] . " has quantity (" . $invoice_items[$key]['article_invoice_quantity'] . ") that is greater than ordered quantity (" . $dborderitems[$orderitemkey][Order_Quantity] . ")for order number " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            if ($invoice_items[$key]['article_invoice_quantity'] < $dborderitems[$orderitemkey]['Order_Quantity']) {
                                if (!$needs_reverse_entry) {
                                    $needs_reverse_entry = true;
                                }

                            }

                            $invoice_items[$key]['article_cess_amount'] = 0;
                            $invoice_items[$key]['invoice_number'] = $invoice_hdr['invoice_number'];
                            $invoice_items[$key]['order_no'] = $invoice_hdr['order_no'];

                            $invoice_hdr['total_invoice_qty'] += $invoice_items[$key]['article_invoice_quantity'];
                            $invoice_hdr['total_base_amount'] += $invoice_items[$key]['article_base_amount'];
                            $invoice_hdr['total_cgst_amount'] += $invoice_items[$key]['article_cgst_amount'];
                            $invoice_hdr['total_sgst_amount'] += $invoice_items[$key]['article_sgst_amount'];
                            $invoice_hdr['total_igst_amount'] += $invoice_items[$key]['article_igst_amount'];
                            $invoice_hdr['total_gst_amount'] += $invoice_items[$key]['article_gst_amount'];
                            $invoice_hdr['total_cess_amount'] += $invoice_items[$key]['article_cess_amount'];

                            $invoice_items[$key]['article_invoice_amount'] += $invoice_items[$key]['article_base_amount']
                                + $invoice_items[$key]['article_gst_amount']
                                + $invoice_items[$key]['article_cess_amount'];

                            $invoice_hdr['total_invoice_amount'] += $invoice_items[$key]['article_invoice_amount'];

                            // invoice tax header
                            // $invoice_tax_hdr_temp
                            // $invoice_tax_items

                            // the gst id is set as the key of the invoice tax header.
                            $gst_id = $invoice_items[$key]['gst_tax_id'];

                            // $invoice_tax_hdr_temp[$gst_id]['gst_tax_id'] = $gst_id ;
                            // $invoice_tax_hdr_temp[$gst_id]['gst_tax_detail_id'] = $invoice_items[$key]['gst_tax_detail_id'];

                            $invoice_tax_hdr_temp[$gst_id]['total_invoice_qty'] += $invoice_items[$key]['article_invoice_quantity'];
                            $invoice_tax_hdr_temp[$gst_id]['total_base_amount'] += $invoice_items[$key]['article_base_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_cgst_amount'] += $invoice_items[$key]['article_cgst_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_sgst_amount'] += $invoice_items[$key]['article_sgst_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_igst_amount'] += $invoice_items[$key]['article_igst_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_gst_amount'] += $invoice_items[$key]['article_gst_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['total_cess_amount'] += $invoice_items[$key]['article_cess_amount'];

                            $invoice_tax_hdr_temp[$gst_id]['total_invoice_amount'] = $invoice_hdr['total_invoice_amount'];
                            $invoice_tax_hdr_temp[$gst_id]['order_no'] = $invoice_hdr['order_no'];
                            $invoice_tax_hdr_temp[$gst_id]['invoice_number'] = $invoice_hdr['invoice_number'];
                            $invoice_tax_hdr_temp[$gst_id]['invoice_date'] = $invoice_hdr['invoice_date'];
                            $invoice_tax_hdr_temp[$gst_id]['invoice_type'] = 'ETAXINV';
                            $invoice_tax_hdr_temp[$gst_id]['tax_type'] = 'GST';

                            // pick quantity on order items

                            $order_items[$key]['order_no'] = $invoice_hdr['order_no'];
                            $order_items[$key]['article_number'] = $invoice_items[$key]['sk_article_no'];
                            $order_items[$key]['pick_quantity'] = $invoice_items[$key]['article_invoice_quantity'];

                        }
                    }

                    // Add the missing items to the invoice_items
                    foreach ($missing_items as $missingkey => $missingval) {
                        $curr_num = count($order_items);
                        $order_items[$curr_num]['order_no'] = $invoice_hdr['order_no'];
                        $order_items[$curr_num]['article_number'] = $missing_items[$missingkey];
                        $order_items[$curr_num]['pick_quantity'] = 0;
                    }

                    $invoice_tax_hdr = $invoice_tax_hdr_temp;

                    // order status to 'Ready to Deliver'
                    // calculate order header pick amount data from order items in the update function.
                    $order_hdr['order_status'] = 'Ready To Deliver';
                    $order_hdr['order_number'] = $invoice_hdr['order_no'];
                    $order_hdr['ext_invoice_no'] = $invoice_hdr['invoice_number'];
                    // calculate order header pick amount data from order items in the update function.

                    // echo "Order article list ";
                    // print_r($order_article_list);

                    // echo "Invoice article list";
                    // print_r($invoice_item_list);

                    // echo "Extra articles ";
                    // print_r($additional_items);

                    // echo "Missing articles";
                    // print_r($missing_items);

                    // echo "Invoice hdr ";
                    // print_r($invoice_hdr);

                    // echo "Invoice tax hdr ";
                    // print_r($invoice_tax_hdr);

                    // echo "Input invoice detail ";
                    // print_r($invoice_items);

                    // echo "Order Header";
                    // print_r($order_hdr);

                    // echo "Order Items";
                    // print_r($order_items);

                    // get store existing and outstanding balance
                    $store_balances = get_store_balance($this->pdo, $storeno, $custno);
                    if (!empty($store_balances)) {
                        $msg = "Received Store balance for store " . $storeno . " and buyer " . $custno;
                        $status = true;
                    } else {
                        $msg = "Failed to get Store balance for store " . $storeno . " and buyer " . $custno;
                        $status = false;
                        $data = '';
                        $this->createLog([$msg]);
                        return get_response($msg, $status, $data);
                    }

                    // populate data for store_transaction
                    if ($needs_reverse_entry) {
                        // populate the data for if needs reverse entry is true then an extra entry is made in the store transaction to reverse the order amount.
                        // Add deposit entry with ordered amount with transaction type = 5

                        $store_transaction[0]['order_no'] = $invoice_hdr['order_no'];
                        $store_transaction[0]['invoice_number'] = 0;
                        $store_transaction[0]['invoice_date'] = 0;
                        $store_transaction[0]['transaction_type'] = 5;
                        $store_transaction[0]['store_no'] = $orderans['Store_No'];
                        $store_transaction[0]['cust_no'] = $orderans['Cust_No'];
                        $store_transaction[0]['fso_no'] = $orderans['FSO_No'];
                        $store_transaction[0]['deposit_amount'] = $orderans['Net_Amount'];
                        $store_transaction[0]['withdraw_amount'] = 0;
                        $store_transaction[0]['outstanding_amt'] = 0;
                        $store_transaction[0]['balance_amt'] = $store_balances['Balance_Amt'] + $orderans['Net_Amount'];
                        $store_transaction[0]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'];
                        $store_transaction[0]['remark'] = "Reverse ordered amount";

                        // if order entry is reversed then we need to add an entry with the new order amount.

                        // $store_transaction[1]['order_no'] = $invoice_hdr['order_no'];
                        // $store_transaction[1]['invoice_number'] = 0;
                        // $store_transaction[1]['invoice_date'] = 0;
                        // $store_transaction[1]['transaction_type'] = 5;
                        // $store_transaction[1]['store_no'] = $orderans['Store_No'];
                        // $store_transaction[1]['cust_no'] = $orderans['Cust_No'];
                        // $store_transaction[1]['fso_no'] = $orderans['FSO_No'];
                        // $store_transaction[1]['deposit_amount'] = 0;
                        // $store_transaction[1]['withdraw_amount'] = $order_hdr['order_amount']; // This gets over written by latest value of the order header order amount.
                        // $store_transaction[1]['outstanding_amt'] = 0;
                        // $store_transaction[1]['balance_amt'] = $store_transaction[0]['balance_amt']; // This gets over written by latest value of the order header order amount get substract from cust_no and store value of  balance amount.
                        // $store_transaction[1]['outstanding_balance_amt'] = $store_transaction[0]['outstanding_balance_amt'];
                        // $store_transaction[1]['remark'] = "Picked order amount";

                    }

                    // $store_transaction[2]['order_no'] = $invoice_hdr['order_no'];
                    // $store_transaction[2]['invoice_number'] = $invoice_hdr['invoice_number'];
                    // $store_transaction[2]['invoice_date'] = $invoice_hdr['invoice_date'];
                    // $store_transaction[2]['transaction_type'] = 3;
                    // $store_transaction[2]['store_no'] = $orderans['Store_No'];
                    // $store_transaction[2]['cust_no'] = $orderans['Cust_No'];
                    // $store_transaction[2]['fso_no'] = $orderans['FSO_No'];
                    // $store_transaction[2]['deposit_amount'] = 0;
                    // $store_transaction[2]['withdraw_amount'] = 0;
                    // // This gets over written by latest value of cust_no and store value of  balance amount
                    // if (isset($store_transaction[1]['balance_amt'])) {
                    //     $store_transaction[2]['balance_amt'] = $store_transaction[1]['balance_amt'];
                    // } else {
                    //     $store_transaction[2]['balance_amt'] = $store_balances['Balance_Amt'];
                    // }
                    // $store_transaction[2]['outstanding_amt'] = $invoice_hdr['total_invoice_amount'];
                    // $store_transaction[2]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'] - $invoice_hdr['total_invoice_amount'];
                    // $store_transaction[2]['remark'] = "Order Ready Ext Bill Entry";

                    $store_transaction_detail['store_no'] = $orderans['Store_No'];
                    $store_transaction_detail['cust_no'] = $orderans['Cust_No'];

                    // print_r($store_transaction);

                    // begin transaction
                    try {
                        $this->pdo->beginTransaction();

                        // create invoice header entry
                        $ans = create_invoice_header($this->pdo, $invoice_hdr);
                        if ($ans) {
                            $msg = "Created invoice header" . $invoice_hdr['order_no'];
                            $status = true;
                        } else {
                            $msg = "Failed to create invoice header for order " . $invoice_hdr['order_no'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }
                        // create invoice tax header entry

                        $ans = create_invoice_tax_header($this->pdo, $invoice_tax_hdr);
                        if ($ans) {
                            $msg = "Created invoice tax header" . $invoice_tax_hdr['order_no'];
                            $status = true;
                        } else {
                            $msg = "Failed to create invoice tax header for order " . $invoice_tax_hdr['order_no'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        // // create invoice tax item entry

                        $ans = create_invoice_tax_items($this->pdo, $invoice_items);
                        if ($ans) {
                            $msg = "Created invoice items for order " . $invoice_items['order_no'];
                            $status = true;
                        } else {
                            $msg = "Failed to create invoice items for order " . $invoice_items['order_no'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        // update order
                        $ans = update_order_items($this->pdo, $order_items);
                        if ($ans) {
                            $msg = "Updated order items for " . $order_hdr['order_number'];
                            $status = true;
                        } else {
                            $msg = "Failed to update order items for order " . $order_hdr['order_number'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        // update order header

                        $ans = update_order_hdr($this->pdo, $order_hdr);
                        if ($ans) {
                            $msg = "Updated order header" . $order_hdr['order_number'];
                            $status = true;
                        } else {
                            $msg = "Failed to update  order status for order " . $order_hdr['order_number'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        // insert into order_history

                        $ans = insert_order_history($this->pdo, $order_hdr);
                        if ($ans) {
                            $msg = "Create order history entry for " . $order_hdr['order_number'];
                            $status = true;
                        } else {
                            $msg = "Error creating order history entry for order " . $order_hdr['order_number'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        // update ledger ie store_transaction
                        if ($needs_reverse_entry) {
                            // An extra entry is made in the store transaction to reverse the order amount.

                            $ans = create_store_transaction($this->pdo, $store_transaction[0]);
                            if ($ans) {
                                $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            // update ledger ie store_transaction_detail
                            $ans = create_store_transaction_detail($this->pdo, $store_transaction_detail);
                            if ($ans) {
                                $msg = "Created store transaction detail for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction detail for order" . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $store_balances1 = get_store_balance($this->pdo, $storeno, $custno);
                            if (!empty($store_balances1)) {
                                $msg = "Received Store balance for store " . $storeno . " and buyer " . $custno;
                                $status = true;
                            } else {
                                $msg = "Failed to get Store balance for store " . $storeno . " and buyer " . $custno;
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $get_order_amount_from_hdr = get_order_details($this->pdo, $invoice_hdr['order_no']);
                            if (empty($get_order_amount_from_hdr)) {
                                $msg = "Failed to retrieve order details for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';

                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $store_transaction[1]['order_no'] = $invoice_hdr['order_no'];
                            $store_transaction[1]['invoice_number'] = 0;
                            $store_transaction[1]['invoice_date'] = 0;
                            $store_transaction[1]['transaction_type'] = 5;
                            $store_transaction[1]['store_no'] = $orderans['Store_No'];
                            $store_transaction[1]['cust_no'] = $orderans['Cust_No'];
                            $store_transaction[1]['fso_no'] = $orderans['FSO_No'];
                            $store_transaction[1]['deposit_amount'] = 0;
                            $store_transaction[1]['withdraw_amount'] = $order_hdr['order_amount']; // This gets over written by latest value of the order header order amount.
                            $store_transaction[1]['outstanding_amt'] = 0;
                            $store_transaction[1]['balance_amt'] = $store_balances1['Balance_Amt'] -  $get_order_amount_from_hdr['Order_Amount']; // This gets over written by latest value of the order header order amount get substract from cust_no and store value of  balance amount.
                            $store_transaction[1]['outstanding_balance_amt'] = $store_transaction[0]['outstanding_balance_amt'];
                            $store_transaction[1]['remark'] = "Picked order amount";

                            $ans = create_store_transaction_from_order($this->pdo, $store_transaction[1]);
                            if ($ans) {
                                $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            // update ledger ie store_transaction_detail
                            $ans = create_store_transaction_detail($this->pdo, $store_transaction_detail);
                            if ($ans) {
                                $msg = "Created store transaction detail for order " . $invoice_hdr['order_no'];
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction detail for order" . $invoice_hdr['order_no'];
                                $status = false;
                                $data = '';
                                $this->createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }
                        }

                        $store_transaction[2]['order_no'] = $invoice_hdr['order_no'];
                        $store_transaction[2]['invoice_number'] = $invoice_hdr['invoice_number'];
                        $store_transaction[2]['invoice_date'] = $invoice_hdr['invoice_date'];
                        $store_transaction[2]['transaction_type'] = 3;
                        $store_transaction[2]['store_no'] = $orderans['Store_No'];
                        $store_transaction[2]['cust_no'] = $orderans['Cust_No'];
                        $store_transaction[2]['fso_no'] = $orderans['FSO_No'];
                        $store_transaction[2]['deposit_amount'] = 0;
                        $store_transaction[2]['withdraw_amount'] = 0;
                        // This gets over written by latest value of cust_no and store value of  balance amount
                        if (isset($store_transaction[1]['balance_amt'])) {
                            $store_transaction[2]['balance_amt'] = $store_transaction[1]['balance_amt'];
                        } else {
                            $store_transaction[2]['balance_amt'] = $store_balances['Balance_Amt'];
                        }
                        $store_transaction[2]['outstanding_amt'] = $invoice_hdr['total_invoice_amount'];
                        $store_transaction[2]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'] - $invoice_hdr['total_invoice_amount'];
                        $store_transaction[2]['remark'] = "Order Ready Ext Bill Entry";

                        //
                        $ans = create_store_transaction($this->pdo, $store_transaction[2]);
                        if ($ans) {
                            $msg = "Created store transaction for order " . $invoice_hdr['order_no'];
                            $status = true;
                        } else {
                            $msg = "Failed to create store transaction entry for order " . $invoice_hdr['order_no'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        // update ledger ie store_transaction_detail
                        $ans = create_store_transaction_detail($this->pdo, $store_transaction_detail);
                        if ($ans) {
                            $msg = "Created store transaction detail for order " . $invoice_hdr['order_no'];
                            $status = true;
                        } else {
                            $msg = "Failed to create store transaction detail for order" . $invoice_hdr['order_no'];
                            $status = false;
                            $data = '';
                            $this->createLog([$msg]);
                            return get_response($msg, $status, $data);
                        }

                        // end transaction

                        $this->pdo->commit();
                        $isTrans--;
                        $msg = "Success";
                        $status = true;
                    } catch (PDOException $e) {

                        $this->pdo->rollback();
                        $msg = "Error preparing update order header for order " . $order_hdr['order_number'];
                        echo " $msg " . $e->getMessage();
                        $retval = false;

                    }

                } else {
                    $msg = "Missing input data";
                    $status = false;
                }
            }

        } else { // Input data is not valid
            $msg = "Incorrect or missing input!!";
            // $data = "Incorrect or missing input!!";
            $status = false;

        }
        $this->createLog([$msg]);
        return get_response($msg, $status, $data);
    }

    private function createLog($data)
    {
        //$log = __DIR__ . '/../logs/api_order_log.txt';
        //file_put_contents($log, print_r($data, true), FILE_APPEND | LOCK_EX);
        Storage::disk('local')->put('api_invoices_log.txt',print_r($data, true));
    }
}
