<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Firebase\JWT\JWT;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class LoginController extends Controller
{
    //sample input request

    /*{
    "mobile":"8007776385",
    "refreshtoken":"451119cac473e5aea94c3731377b277d",
    "packageid":"com.saralideas.s244_myfamilymart",
    "deviceid":"482c11d4c9062342",
    "versionno":68,
    "password":"81dc9bdb52d04dc20036dbd8313ed055",
    "mToken":"dezOqo33Tgmr7Ld7dS_kBq:APA91bFWsAzc9h0FkW2-wMIoffulSPuydZA6AtbVYqMxMas13eGiYkUuddmuz1PAB6pUdBMpANOtGd3G5-bIQ2rbeRy1_hmFYRkGYPSCwTJsUsybF47txEZgeSAbtQJ1fHAEj8MsxSY1"
    }*/
    public function login(Request $request){

        $data = array();
        $status = true;
        $loggedIn = false;
        $post = $request->post();
        extract($post);
        //header_remove("Cache-Control");
        ####Status <>'D' condition added by Meenal Barve as User's with Status D should not be selected
        //query change by swanand to return customerid and customertype for point based url call
        $stmt = $this->pdo->prepare("select ifnull(Store_Master.Store_No , '') as Store_No, Store_Master.Supplier_Store_No as CustomerId ,
    case when Store_Master.Seller_Type = 'Distributor' then 'Distributors'
   when Store_Master.Seller_Type = 'Superstockiest' then 'SuperStockiest' else Store_Master.Seller_Type end as CustomerType , FSO_Master.FSO_No as UserNo, FSO_Master.FSO_Name as UserName, '' as OutletName,FSO_Master.Login_Type as LoginType, FSO_Master.Mobile_No, FSO_Master.OTP, FSO_Master.OTP_Count,FSO_Master.Excluded, FSO_Master.Status, '' City_Code  , '' License_No , '0000-00-00' License_Expiry_Date , '' Speciality_Id from FSO_Master
    left join BBC_Org_Users on BBC_Org_Users.FSO_No = FSO_Master.FSO_No and FSO_Master.Login_Type = 'STADM'
    left join Store_Master on Store_Master.Store_No = BBC_Org_Users.Store_No
    WHERE FSO_Master.Status <>'D' AND Mobile_No= ? AND FSO_Master.password= ?
           UNION ALL
           SELECT  '' as Store_No ,'' as CustomerId , '' as CustomerType ,Cust_Master.Cust_No as UserNo, Cust_Master.Cust_Name as UserName, Cust_Master.Outlet_Name as OutletName,'Self' as LoginType, Cust_Master.Mobile_No, Cust_Master.OTP, Cust_Master.OTP_Count, Cust_Master.Excluded, Cust_Master.Status,Get_Default_City_For_Cust(Cust_No) as City_Code , Cust_Master.License_No , COALESCE(Date(License_Expiry_Date) , '0000-00-00') , COALESCE(Speciality_Id , '') from Cust_Master  WHERE Cust_Master.Status <> 'D' AND Cust_Master.Mobile_No= ? AND Cust_Master.password= ? order by Status");
        /*
        $stmt = $this->pdo->prepare("SELECT FSO_No as UserNo, FSO_Name as UserName, '' as OutletName,Login_Type as LoginType, Mobile_No, OTP, OTP_Count,Excluded, Status, '' City_Code  , '' License_No , '0000-00-00' License_Expiry_Date , '' Speciality_Id from FSO_Master WHERE Status <>'D' AND Mobile_No=? AND password=?
        UNION ALL
        SELECT Cust_No as UserNo, Cust_Name as UserName, Outlet_Name as OutletName,'Self' as LoginType, Mobile_No, OTP, OTP_Count, Excluded, Status,Get_Default_City_For_Cust(Cust_No) as City_Code , License_No , COALESCE(Date(License_Expiry_Date) , '0000-00-00') , COALESCE(Speciality_Id , '') from Cust_Master  WHERE Status <> 'D' AND Mobile_No=? AND password=? order by Status ");
         *//*$stmt = $this->pdo->prepare("SELECT FSO_No as UserNo, FSO_Name as UserName, '' as OutletName,Login_Type as LoginType, Mobile_No, OTP, OTP_Count,Excluded, Status ,'' as City_Code ,'' as City_Name  from FSO_Master WHERE Status <>'D' AND Mobile_No=? AND password=?
    UNION ALL
    SELECT Cust_No as UserNo, Cust_Name as UserName, Outlet_Name as OutletName,'Self' as LoginType, Mobile_No, OTP, OTP_Count, Excluded, CM.Status , CC.City_Code as City_Code , CC.City_Name as City_Name from Cust_Master as CM join BBC_Addresses as BA on BA . User_No = CM . Cust_No join City_Master as CC on CC . City_Code = BA . City_Code WHERE CM.Status <> 'D' AND BA.Default_Flag='A' AND Mobile_No=? AND password=? order by Status ");    */
        //Display City Code,City Name if Login_type is self . Modified On-27-1-2020 Dev-17
        $stmt->execute([$mobile, $password, $mobile, $password]);

        $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
        logging('****STATIC AUTH LOGIN **** : ', 'array=', 1, json_encode($arr));
        //$stmt->debugDumpParams();
        if (!empty($arr)) {
            if ($arr['0']['Status'] == 'I' || $arr['0']['Excluded'] == 'Y') {
                $msg = 'You are a registered user but your account has not been activated yet.';
                $status = false;
            } else if ($arr['0']['OTP_Count'] > 5) {
                $msg = 'You have exceeded otp limit. Please contact Customer care to activate your account';
                $status = false;
            } else {

                $userDetails = array();
                $outlets = array();
                //dev-15
                $sellers = array();
                foreach ($arr as $key => $details) {
                    if ($details['Status'] == 'A') //Added by Meenal B. 2nd Oct 2018 to add only Active Outlet names
                    {
                        $outlets[] = $details['OutletName'];
                        $sellers[] = $details['UserName']; //dev-15
                        $login_roles[] = $details['LoginType'];
                    }
                }

                #### Get active users only
                $activeusers = array();
                foreach ($arr as $key => $details) {
                    if ($details['Status'] == 'A') //Added by Meenal B. 2nd Oct 2018 to add only Active Outlet names
                    {
                        $activeusers[] = $details;
                    }
                }

                $data['LoginType'] = $arr['0']['LoginType'];
                //Added for single mobile multiple profiles branch dev-12
                $data['Roles'] = array_values(array_unique($login_roles)); //dev-15 added array_values
                $data['outlets'] = $outlets;
                $data['sellers'] = $sellers; //dev-15
                //$data['user'] = $arr; //Commented by Meenal B. 2nd Oct 2018
                $data['user'] = $activeusers;
                $msg = 'Login Successful';

                /*if($data['LoginType'] == 'FSO' || $data['LoginType'] == 'DO')
                {
                $table = 'FSO_Master';
                } else {
                $table = 'Cust_Master';
                }*/
                //dev-15
                if ($data['LoginType'] == 'Self') {
                    $table = 'Cust_Master';
                } else {

                    $table = 'FSO_Master';
                }

                $stmt1 = $this->pdo->prepare("update " . $table . " set OTP_Count = ? where Mobile_No = ? ");
                $updated = $stmt1->execute(array('0', $mobile));
                //$stmt->debugDumpParams();
                $stmt = null;
                $loggedIn = true;

                // Adding this for sending the jwt token after login response
                $secret_key = "123456789helo_secret"; // this can be the secret key stored in the settings file
                $issuer_claim = DM_URL; // this can be the servername
                $audience_claim = "login"; // after user login the token is generated
                $issuedat_claim = time(); // issued at for jwt
                $notbefore_claim = $issuedat_claim + 0; //use not before in seconds
                $expire_claim = $issuedat_claim + JWT_TOKEN_EXPIRE; //86400 1 day : expire time in seconds
                $issuedat_claim1 = date('Y-m-d H:i:s'); // issued at for db
                #$expire_claim and $expire_claim1 shoud be same , below expire will go in db
                $expire_claim1 = date('Y-m-d H:i:s', date(strtotime("+".JWT_TOKEN_EXPIRE." seconds", strtotime($issuedat_claim1)))); // expire time in seconds
                $isuetimeconversion = gmdate('H:i:s', $issuedat_claim);

                $token = array(
                    "iss" => $issuer_claim,
                    "aud" => $audience_claim,
                    "iat" => $issuedat_claim,
                    "nbf" => $notbefore_claim,
                    "exp" => $expire_claim,
                    "data" => array(
                        "mobile" => $mobile,
                        "password" => $password,
                    ));

                http_response_code(200);

                $jwt = JWT::encode($token, $secret_key);
                $data['auth_token'] = $jwt;

            }

        } else {
            $msg = 'Please insert valid credentials';
            $status = false;
        }

        $stmt = null;

        #### Insert into Login_History
        $loginStatus = ($loggedIn == true) ? 'Success' : 'Failure';
        $date = date('Y-m-d H:i:s');
        $mToken = $refreshtoken;//TO DO: remove this line by 31 Dec2021 if-> (also in client replace refreshtoken with mtoken)

        $refreshtokenNew = $mobile . $mToken . date('Y-m-d H:i:s:u');
        logging('****STATIC AUTH LOGIN **** : ', 'array=', 1, json_encode($arr));

        $md5Refreshtoken = md5($refreshtokenNew);
        $atoken = $jwt;
        $createdby = '0';
        $changedby = '0';
        $authstatus = 'A';
        $stmt2 = $this->pdo->prepare("INSERT INTO `Login_History` (`Mobile_No`, `Package_ID`, `Verson_No`, `Device_ID`, `Mtoken`, `Atoken`, `Login_status`, `Login_Attempt_Date`) VALUES (? , ? , ? , ? , ? , ? , ? , ?)");
        $inserted = $stmt2->execute([$mobile, $packageid, $versionno, $deviceid, $mToken, $atoken, $loginStatus, $date]);
        $stmt3 = $this->pdo->prepare("INSERT INTO `Authentication_History`( `Mobile_No`, `Mtoken`, `Auth_Token`, `Refresh_Token`, `Expiration_Time`, `Status`, `Creation_Date`, `Created_By`, `Changed_Date`, `Changed_By`) VALUES (? ,? ,? ,? ,? ,? ,? ,? ,? ,? )");
        $inserted1 = $stmt3->execute([$mobile, $mToken, $atoken, $md5Refreshtoken, $expire_claim1, $authstatus, $date, $createdby, $date, $changedby]);
        if (!empty($arr)) {
            $data['refresh_token'] = $md5Refreshtoken;
            $data['expiry_time'] = $expire_claim1;
        }

        return get_response($msg, $status, $data);
    }

    // JSON :{"User_No": "" , "Login_Type": "" , "Address_ID":"" }
    public function api_get_authtoken(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        //$GLOBALS['containers']->log->addInfo('Request for api_get_authtoken', ['post' => $post]);
        extract($post);
        //header_remove("Cache-Control");
        try {
            $stmt = $this->pdo->prepare("SELECT * from Authentication_History WHERE Refresh_Token=? AND Mtoken=? AND Mobile_No=?");
            /* {"mbile_no":"1234567890",
                "mToken":"yyyyyy ",
                "refresh_token":"xxxxxxxxxxxxxxxxx"
            }
            "xxxxxxxxxxxxxxxxx"  --> refresh token assigned back in "b2bservices/sf_services/public/index.php/login" call for that login */
            if (isset($refresh_token)) {
                //$GLOBALS['containers']->log->addDebug('In api_get_authtoken in if condition checked isset refresh_token', ['refresh_token' => $refresh_token]);

                $stmt->execute([$refresh_token, $mToken, $mobile_no]);
                $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
                //$GLOBALS['containers']->log->addDebug('In api_get_authtoken get data from Authentication_History table', ['sql' => $stmt,'result'=>$arr]);
                if (!empty($arr)) {
                    //$GLOBALS['containers']->log->addDebug('In api_get_authtoken in if condition checked not empty result of following query', ['sql' => $stmt,'result'=>$arr]);
                    if (isset($arr[0]['Mobile_No'], $arr[0]['Mtoken'])) {
                        //$GLOBALS['containers']->log->addDebug('In api_get_authtoken in if condition checked isset Mobile_No and Mtoken', ['arr'=>$arr]);
                        $mobile = $arr[0]['Mobile_No'];
                        $mtoken = $arr[0]['Mtoken'];
                    }

                    $authstatus = 'A';
                    $date = date('Y-m-d H:i:s');
                    $createdby = 'userid';
                    $changedby = 'userid';

                    // Adding this for sending the jwt token after refresh token is verified with the authenticated server
                    //$now = new DateTime();
                    $secret_key = "123456789helo_secret"; // this can be the secret key stored in the settings file
                    $issuer_claim = DM_URL; // this can be the servername
                    $audience_claim = "login";
                    $issuedat_claim = time(); // issued at
                    $notbefore_claim = $issuedat_claim + 0; //use not before in seconds
                    $expire_claim = $issuedat_claim + JWT_TOKEN_EXPIRE; // 1 day : expire time in seconds
                    $issuedat_claim1 = date('Y-m-d H:i:s'); // issued at
                    $expire_claim1 = date('Y-m-d H:i:s', date(strtotime("+".JWT_TOKEN_EXPIRE." seconds", strtotime($issuedat_claim1)))); // expire time in seconds
                    $isuetimeconversion = gmdate('H:i:s', $issuedat_claim);
                    $token = array(
                        "iss" => $issuer_claim,
                        "aud" => $audience_claim,
                        "iat" => $issuedat_claim,
                        "nbf" => $notbefore_claim,
                        "exp" => $expire_claim,
                    );
                    // http_response_code(200);

                    $jwt = JWT::encode($token, $secret_key);
                    if ($refresh_token) {
                        //$GLOBALS['containers']->log->addDebug('In api_get_authtoken in if condition checked refresh_token', ['refresh_token' => $refresh_token]);
                        $data['auth_token'] = $jwt;
                        $data['expiry_time'] = $expire_claim1;
                        $msg = 'Success';
                        $atoken = $jwt;
                        // for insering generated auth taken in Authentication_History table
                        $stmt3 = $this->pdo->prepare("INSERT INTO `Authentication_History`( `Mobile_No`, `Mtoken`, `Auth_Token`, `Refresh_Token`, `Expiration_Time`, `Status`, `Creation_Date`, `Created_By`, `Changed_Date`, `Changed_By`) VALUES (? ,? ,? ,? ,? ,? ,? ,? ,? ,? )");
                        $inserted1 = $stmt3->execute([$mobile, $mtoken, $atoken, $refresh_token, $expire_claim1, $authstatus, $date, $createdby, $date, $changedby]);
                        //$GLOBALS['containers']->log->addDebug('In api_get_authtoken inserted generated auth taken in Authentication_History table', ['sql' => $stmt3->debugDumpParams(),'result'=>$inserted1]);
                    }
                } else {
                    //$GLOBALS['containers']->log->addDebug('In api_get_authtoken in else because Refresh token not Found', ['refresh_token' => $refresh_token]);
                    $msg = 'Refresh token not Found';
                    $status = false;
                }
            } else {
                //$GLOBALS['containers']->log->addDebug('In api_get_authtoken in else checked isset refresh_token', ['refresh_token' => $refresh_token,'msg'=>'Invalid Refresh token']);
                $msg = 'Invalid Refresh token';
                $status = false;
            }
            $stmt = null;
        } catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            //$GLOBALS['containers']->log->addDebug('Response for api_get_authtoken in catch', ['data' => $data,'status'=>false,'msg'=>$msg]);
            return get_response( "Something went wrong", $status, $data);
        }
        //$GLOBALS['containers']->log->addInfo('Response for api_get_authtoken', ['response'=>$response,'data' => $data,'status'=>false,'msg'=>$msg]);
        return get_response($msg, $status, $data);

    }

    public function forgot_password(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        if (!isset($mobile) && !isset($Login_Type)) {
            $msg = "Login Type & Mobile No Missing";
            $status = false;
            return get_response($msg, $status);
        }

        if(!isset($Login_Type)){
            $msg = "Login Type Missing";
            $status = true;
            $stmt = $this->pdo->prepare("SELECT FSO_No as UserNo, FSO_Name as UserName, '' as OutletName,Login_Type as LoginType, Mobile_No, OTP, OTP_Count,Excluded, Status from FSO_Master WHERE Status <>'D' AND Mobile_No=?
         UNION ALL
         SELECT Cust_No as UserNo, Cust_Name as UserName, Outlet_Name as OutletName,'Self' as LoginType, Mobile_No, OTP, OTP_Count, Excluded, Status from Cust_Master WHERE Status <> 'D' AND Mobile_No=? order by Status ");
            $stmt->execute([$mobile,$mobile]);
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
            if(!empty($arr)) {
                foreach($arr as $key=>$details){
                    if ($details['Status']== 'A')  //Added by Meenal B. 2nd Oct 2018 to add only Active Outlet names
                    {
                        $login_roles[] = $details['LoginType'];
                    }
                }
                //$data['Roles'] = array_unique($login_roles);
                $data['Roles'] = array_values(array_unique($login_roles)); //dev-17 added array values
            }
            else {
                $msg = 'Please insert valid credentials ,Mobile No not registered';
                $status = false;
            }
            return get_response($msg, $status,$data);
        }else{
            if(strtolower($Login_Type) == 'self'){
                $table = 'Cust_Master';
                $stmt = $this->pdo->prepare("SELECT * FROM $table WHERE `Mobile_No` LIKE ?");
                $stmt->execute([$mobile]);
            } else {
                $table = 'FSO_Master';
                $stmt = $this->pdo->prepare("SELECT * FROM $table WHERE `Mobile_No` LIKE ? AND Login_Type = ?");
                $stmt->execute([$mobile, $Login_Type]);
            }

            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
            if(!empty($arr)) {
                if($arr['0']['Status'] == 'I' || $arr['0']['Excluded'] == 'Y'){
                    $msg = 'You are a registered customer but your account has not been activated yet. Please contact Customer care to activate your account';
                    $status = false;
                } else if($arr['0']['OTP_Count'] > 5){
                    $msg = 'You have exceeded reset password limit. Please contact Customer care to activate your account';
                    $status = false;
                } else {

                    $otp = str_pad(mt_rand(1000, 9999), 4, '0', STR_PAD_LEFT);


                    $password=md5($otp);

                    $otpCount=intval($arr['0']['OTP_Count']);
                    $otpCount += 1;
                    $userNo=$arr['0']['UserNo'];

                    $data['new_otp'] = $otp;
                    $data['new_otp_count'] = $otpCount;
                    $data['user'] = $arr;

                    if(/*$arr['0']['LoginType']*/strtolower($Login_Type) == 'self')
                    {
                        $table = 'Cust_Master';
                        $userNoColumn = 'Cust_No';
                        $stmt = $this->pdo->prepare("update ".$table." set OTP_Count = ?, OTP = ?, Password = ? where Mobile_No = ? ");
                        $updated = $stmt->execute(array($otpCount, $otp, $password, $mobile));
                        //$stmt->debugDumpParams();
                        $stmt = null;
                    } else {
                        $table = 'FSO_Master';
                        $userNoColumn = 'FSO_No';
                        $stmt = $this->pdo->prepare("update ".$table." set OTP_Count = ?, OTP = ?, Password = ? where Mobile_No = ? and Login_Type= ?");
                        $updated = $stmt->execute(array($otpCount, $otp, $password, $mobile ,$Login_Type));
                        //$stmt->debugDumpParams();
                        $stmt = null;
                    }

                    ### Send sms with new password
                    if($updated == 1){

                        /*$smsMsg = generate_sms(FORGOT_USER_PASSWORD, array($otp));
                        $res = Submit(SMS_HOST,SMS_PORT,SMS_USERNAME,SMS_PASSWORD,SMS_SENDER,$smsMsg, $mobile,SMS_MSG_TYPE,SMS_DLR);*/
                        if ($Login_Type =="Self")
                            $Login_Display_Name = "Buyer";
                        else if ($Login_Type=="DO")
                            $Login_Display_Name = "Delivery";
                        //dev-14
                        else if ($Login_Type=="STADM")
                            $Login_Display_Name = "Seller";
                        else if ($Login_Type=="ADMIN")
                            $Login_Display_Name = "ASM";
                        //dev-14
                        else $Login_Display_Name="Sales";
                        SubmitSMS($mobile, 'FORGOT_USER_PASSWORD', array($otp,$Login_Display_Name));

                    }
                    $msg = 'New password sent on your registered mobile number';
                }

            } else {
                $msg = 'Please insert valid credentials';
                $status = false;
            }

            $stmt = null;

            return get_response($msg, $status, $data);

        }
    }

}
