<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class OTPController extends Controller
{
    /****
    check_otp
    1. insert retailer in inactive status
    2. add dummy fso entry with store no, inserted retailer no in Cust_FSO_Lookup
    3. send sms on retailers mobile
     ****/

    /******** JSON INPUT
    {"Mobile_No":"9898989898","otp":"1245", "Login_Type":"Self"} Self or FSO or DO.
     ********/
    public function check_otp(Request $request){
        $data = '';
        $post = $request->post();
        extract($post);

        if (isset($Mobile_No) && $Mobile_No > 0) {
            if (isset($Login_Type)) {
                // setup the query data based on input
                $param_array[':mobile_no'] = $Mobile_No;
                //$param_array[':login_type'] = $Login_Type;
                switch ($Login_Type) {
                    case "Self":
                        $where = ' CM.Mobile_No = :mobile_no';
                        $stmt = $this->pdo->prepare("SELECT CM.Cust_No as no, CM.Cust_Name as name, Email_ID as email, Mobile_No as mobile, 'Self' Login_Type , COALESCE(Excluded,'') Excluded, COALESCE(Status, '') Status, OTP, OTP_Count FROM Cust_Master CM WHERE " . $where . " LIMIT 1;");
                        $updstmt = $this->pdo->prepare("UPDATE Cust_Master CM SET OTP_Count= 0, Status = 'A' where " . $where);

                        break;
                    case "DO":
                    case "FSO":
                        //dev-14
                    case "STADM":
                    case "ADMIN":
                        //
                        $where = ' FM.Mobile_No = :mobile_no and FM.Login_Type = :login_type;';
                        $stmt = $this->pdo->prepare("SELECT FM.FSO_No as no, FM.FSO_Name as name, Email_ID as email, Mobile_No as mobile, Login_Type Login_Type, COALESCE(Excluded,'') Excluded, COALESCE(Status, '') Status, OTP, OTP_Count FROM FSO_Master FM WHERE " . $where);
                        $updstmt = $this->pdo->prepare("UPDATE FSO_Master FM SET OTP_Count = 0, Status = 'A' where " . $where);

                        break;
                    default:
                        $msg = "Something went wrong";
                        $data = "LoginType incorrect!!";
                        $status = false;
                        //return get_response( $msg, $status, $data);
                        $this->returnData($this->pdo, $msg, $status, $data);
                }

                try {

                    if (($Login_Type) == "Self") {
                        $stmt->execute($param_array);
                    }
                    else {  //For FSO , DO ,STADM ,ADMIN
                        $param_array[':login_type'] = $Login_Type;
                        $stmt->execute($param_array);
                    }

                    $arr = $stmt->fetch(PDO::FETCH_ASSOC);

                    // at this point queried data is in arr....

                    if (!empty($arr)) {

                        if ($arr['Status'] == 'I' && $arr['Excluded'] == 'Y') {
                            $msg = 'You are a registered customer but your account has not been activated yet. Please contact Customer care to activate your account';
                            $status = false;
                        } else if ($arr['Status'] == 'I' && $arr['OTP_Count'] >= 5) {
                            $msg = 'You are a registered customer but your account has not been activated yet. Please contact Customer care to activate your account';
                            $status = false;
                        } else {
                            ### Check OTP
                            if ($arr['OTP_Count'] > 5) {
                                $msg = 'You are a registered customer but your account has not been activated yet. Please contact Customer care to activate your account';
                                $status = false;
                            } else if ($arr['OTP_Count'] <= 5 && $arr['OTP'] == $otp) {

                                ### Activate customer
                                // $stmt = $this->pdo->prepare("update Cust_Master set Status=?, OTP_Count=? where Mobile_No=?");

                                try {
                                    //$updstmt->execute($param_array);
                                    $upd_param_array[':mobile_no'] = $Mobile_No;

                                    if ($Login_Type == "Self") {
                                        $updstmt->execute($upd_param_array);
                                    }
                                    else {  //FSO ,DO
                                        $upd_param_array[':login_type'] = $Login_Type;
                                        $updstmt->execute($upd_param_array);
                                    }

                                    //$stmt->debugDumpParams();

                                    $customerArr['no'] = /*$arr['User_No']*/$arr['no'];
                                    $customerArr['name'] = $arr['name'];
                                    $customerArr['email'] = $arr['email'];
                                    $customerArr['mobile'] = $arr['mobile'];
                                    $data['customer'] = $customerArr;

                                    /*$smsMsg = generate_sms(CHECK_OTP, array($data['Mobile_No'], ''));
                                    Submit(SMS_HOST,SMS_PORT,SMS_USERNAME,SMS_PASSWORD,SMS_SENDER,$smsMsg, $mobile,SMS_MSG_TYPE,SMS_DLR);*/
                                    SubmitSMS($mobile, 'CHECK_OTP', array($data['Mobile_No'], ''));
                                    $msg = "Verification successful";
                                    $status = true;

                                } catch (PDOException $e) {
                                    $status = false;
                                    $data = $e->getMessage();
                                    //return get_response( "Something went wrong", $status, $data);
                                    $this->returnData($this->pdo, "Something went wrong", $status, $data,
                                        $arr['no'],$Login_Type);
                                }
                            } else {
                                $msg = "Invalid OTP";
                                $status = false;
                            }
                        }
                    } else {
                        $status = false;
                        $msg = "This mobile number does not exist.";
                    }
                } catch (PDOException $e) {
                    $status = false;
                    $data = $e->getMessage();
                    //return get_response( "Something went wrong", $status, $data);
                    $this->returnData($this->pdo, "Something went wrong", $status, $data,
                        $arr['no'],$Login_Type);
                }
            } else {
                // Login_Type not passed
                $msg = "Something went wrong";
                $data = "Login_Type incorrect!!";
                $status = false;
            }
        } else { // Mobile_No not passed

            $msg = "Something went wrong";
            $data = "Incorrect or missing Mobile number!!";
            $status = false;
        }

        //return get_response( $msg, $status, $data);
        $this->returnData($this->pdo, $msg, $status, $data,$arr['no'],$Login_Type);
    }

    private function returnData($db, $msg, $status, $data,$User_No=0,$Login_Type='Self') {
        if ($User_No!=0 && $status == true) {
            send_api_notification($db,'check_otp', $User_No, $Login_Type);
        }
        return get_response($msg, $status, $data);
    }

    /****
        Input
        Mobile_No
        Login_Type
     ****/
    public function resend_otp(Request $request){
        $data = array();
        $status = true;
        $date1 = date('Y-m-d');
        $time1 = date('H:i:s');
        $loggedIn = false;
        $post = $request->post();
        extract($post);

        // input mobile_no and Login_Type is available at this point.

        // Cust_No, Excluded, Status, OTP_Count

        if (isset($Mobile_No) && $Mobile_No > 0) {
            if (isset($Login_Type)) {
                // setup the query data based on input

                /*switch ($Login_Type) {
                    case "Self":
                        $where = ' CM.Mobile_No = :mobile_no';
                        $stmt = $this->pdo->prepare("SELECT CM.Cust_No User_No, 'Self' Login_Type , COALESCE(Excluded,'') Excluded, COALESCE(Status, '') Status, OTP_Count FROM Cust_Master CM WHERE " . $where . " LIMIT 1;");
                        $updstmt = $this->pdo->prepare("UPDATE Cust_Master CM set OTP_Count= :otp_count , OTP = :otp where " . $where );

                        break;
                    case "DO":
                    case "FSO":
                        //$where = ' FM.Mobile_No = :mobile_no;';
                        $where = ' FM.Mobile_No = :mobile_no and FM.Login_Type = :login_type;';
                        $stmt = $this->pdo->prepare("SELECT FM.FSO_No User_No, Login_Type Login_Type, COALESCE(Excluded,'') Excluded, COALESCE(Status, '') Status, OTP_Count FROM FSO_Master FM WHERE " . $where);
                        $updstmt = $this->pdo->prepare("UPDATE FSO_Master FM set OTP_Count= :otp_count , OTP = :otp where " . $where);

                        break;
                    default:
                        $msg = "Something went wrong";
                        $data = "LoginType incorrect!!";
                        $status = false;
                        return get_response( $msg, $status, $data);
                }*/

                if ($Login_Type =="Self") {
                    $where = ' CM.Mobile_No = :mobile_no';
                    $stmt = $this->pdo->prepare("SELECT CM.Cust_No User_No, 'Self' Login_Type , COALESCE(Excluded,'') Excluded, COALESCE(Status, '') Status, OTP_Count FROM Cust_Master CM WHERE " . $where . " LIMIT 1;");
                    $updstmt = $this->pdo->prepare("UPDATE Cust_Master CM set OTP_Count= :otp_count , OTP = :otp  where " . $where );
                }
                else {
                    $where = ' FM.Mobile_No = :mobile_no and FM.Login_Type = :login_type;';
                    $stmt = $this->pdo->prepare("SELECT FM.FSO_No User_No, Login_Type Login_Type, COALESCE(Excluded,'') Excluded, COALESCE(Status, '') Status, OTP_Count FROM FSO_Master FM WHERE " . $where);
                    $updstmt = $this->pdo->prepare("UPDATE FSO_Master FM set OTP_Count= :otp_count , OTP = :otp  where " . $where);
                }
                try {
                    $param_array[':mobile_no'] = $Mobile_No;

                    if (($Login_Type) == "Self") {
                        $stmt->execute($param_array);
                    }
                    else {  //For FSO , DO
                        $param_array[':login_type'] = $Login_Type;
                        $stmt->execute($param_array);
                    }

                    $arr = $stmt->fetch(PDO::FETCH_ASSOC);

                    // at this point queried data is in arr....

                    if (!empty($arr)) {
                        // validate the data before sending OTP.

                        if ($arr['Excluded'] == 'Y') {
                            $msg="You are a registered customer but your account has not been activated yet. Please contact Customer care to activate your account";
                            $status = false;

                        } /*elseif ($arr['Status'] == 'I') {

                        $msg="Oops! There was a problem. Please contact our Customer care for further help";
                        $status = false;

                    } */elseif ($arr['OTP_Count'] >= 5) {
                            // TODO: change this message
                            $msg="Please contact our Customer care for further help as you have exceeded OTP attempts.";
                            $status = false;

                        } else {

                            $User_No = $arr['User_No'];

                            $OTP_Count = $arr['OTP_Count'];
                            $OTP_Count = $OTP_Count + 1;
                            $OTP = str_pad(mt_rand(1000, 9999), 4, '0', STR_PAD_LEFT);

                            try {
                                $upd_param_array[':otp_count'] = $OTP_Count;
                                $upd_param_array[':otp'] = $OTP;
                                $upd_param_array[':mobile_no'] = $Mobile_No;

                                if ($Login_Type == "Self") {
                                    $isvalid = $updstmt->execute($upd_param_array);
                                }
                                else {  //FSO ,DO
                                    $upd_param_array[':login_type'] = $Login_Type;
                                    $isvalid = $updstmt->execute($upd_param_array);
                                }


                                if ($isvalid == true) {
                                    // send OTP
                                    if ($Login_Type =="Self")
                                        $Login_Display_Name = "Buyer";
                                    else if ($Login_Type=="DO")
                                        $Login_Display_Name = "Delivery";
                                    else $Login_Display_Name="Sales";

                                    SubmitSMS($Mobile_No, 'OTP', array($OTP,$Login_Display_Name));
                                    $msg = "OTP sent";
                                    $status = true;
                                } else {
                                    $msg = "Oops! Something went wrong. Pls try again..";
                                    $status = false;
                                }

                            } catch (PDOException $e) {
                                $status = false;
                                $data = $e->getMessage();
                                return get_response( "Something went wrong", $status, $data);
                            }
                        }
                    } else {
                        // "Mobile number not found in our records. Please check and try again.";
                        $msg = "Your number is not registered with us. Please provide the following details to proceed with registration";
                        $status = false;
                        $data['flag'] = 1;
                    }
                } catch (PDOException $e) {
                    $status = false;
                    $data = $e->getMessage();
                    return get_response( "Something went wrong", $status, $data);
                }
            } else {
                // Login_Type not passed
                $msg = "Something went wrong";
                $data = "Login_Type incorrect!!";
                $status = false;
            }
        } else { // Mobile_No not passed

            $msg = "Something went wrong";
            $data = "Incorrect or missing Mobile number!!";
            $status = false;
        }
        return get_response($msg, $status, $data);
    }
}
