<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use PDO;
use PDOException;

class OrderController extends Controller
{
    //Json input
    // businessID
    // CustNo
    public function get_orderfilters(Request $request){
        $data = array();
        $post = $request->post();
        extract($post);
        // At this point we have input parameters in
        // $business_id,$custno
        // ignore business_id for now.
        // build a where clause depending on the input parameters

        $param_array = array();
        $where = '';
        try{
            if (isset($CustNo) && $CustNo > 0) {
                $param_array[':custno'] = $CustNo;
                $where .= 'Order_Hdr.Cust_No = :custno AND ';
            }
            $where .= '1=1';
            //Get distinct Order statuses
            $stmt = $this->pdo->prepare("select distinct Order_Status as Order_Status
    	from Order_Hdr where ". $where ." Order By Order_Hdr.Order_Status ");

            $stmt->execute($param_array);

            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
            //Get distinct Order Year
            $stmt1 = $this->pdo->prepare("select distinct Year(Order_Date) as order_year
    	from Order_Hdr where ". $where ." Order By Year(Order_Date) Desc");
            $stmt1->execute($param_array);
            $arr1 = $stmt1->fetchAll(PDO::FETCH_ASSOC);

            if (!empty($arr) && !empty($arr1)) { // we have retrieved a list of orders statuse & Years
                // populate the payload to be returned.
                $order_status=array();
                $order_status[0]='All';
                foreach ($arr as $key => $val) {
                    array_push($order_status,$arr[$key]['Order_Status']);
                }

                $order_year=array();
                $order_year[0]='Last 30 Days';
                $order_year[1]='Last 6 Months';

                foreach ($arr1 as $key => $val) {
                    array_push($order_year,$arr1[$key]['order_year']);
                }

                $data['order_status'] = array_values($order_status);
                $data['order_year']   = array_values($order_year);

                $msg = "Success";
                $status = true;
            } else {
                $msg = ' Couldnt find any orders ' . $start_order_date . '.';
                $status = false;
            }
        }catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
        }
        return get_response($msg, $status, $data);
    }

    public function recreate_order(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);
        // $order_no=$_REQUEST['order_no'];
        $flag = true;
        if(!empty($store_no))
            $flag = false; // for normal recreate

        try{
            $final_array=array();
            $query=$this->pdo->prepare("SELECT
			OH.Store_No,
			OH.Cust_No,
			OI.Article_No,
			OI.Order_Quantity

			FROM `Order_Hdr` As `OH`
			INNER JOIN `Order_Itm` AS `OI` ON OI.`Order_No` = OH.`Order_No`
			INNER JOIN `Article_Master` AS `AM` ON AM.`Article_No` = OI.`Article_No`
			INNER JOIN `Store_Listing` AS `SL` ON SL.`Article_No` = AM.`Article_No` AND SL.`Store_No` = OH.`Store_No`
			INNER JOIN `Store_Master` AS `SM` ON SM.`Store_No` = SL.`Store_No`
			WHERE OH.`Order_No` = '$order_no' AND AM.Status = 'A' AND SL.Status = 'A' AND SL.Out_Of_Stock = 0 AND SM.Status = 'A'");

            $query->execute();
            $arr = $query->fetchAll(PDO::FETCH_ASSOC);
            if(!empty($arr)){
                foreach($arr as $array1)
                {
                    if($flag == true)
                        $store_no			=	$array1['Store_No'];
                    if(empty($cust_no))
                        $cust_no			=	$array1['Cust_No'];

                    $row[0]['Article_No']	=	$array1['Article_No'];
                    $row[0]['Store_No']		=	$store_no;
                    $row[0]['quantity']		=	$array1['Order_Quantity'];

                    array_push($final_array, $row);
                }

                $updateStatus = updateCartData($this->pdo,$cust_no, $store_no, $final_array,$flag);

                if($updateStatus){
                    $msg="cart updated successfully";
                }else{
                    $msg="cart updated failed";
                }

            }else{
                $msg='Service Unavailable';
                $status=false;
            }
        }
        catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }
        send_api_notification($this->pdo,'recreate_order', $cust_no, 'Self');
        return get_response($msg, $status, $data);
    }

    public function get_orderlistitems(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        // At this point we have input in $orderno
        // build a where clause depending on the input parameters
        $where = "";
        $param_array=array();

        // pdo handling of 'in' is not elegant nor simple so ignore array of ordernos for now.
        if (isset($orderno) && $orderno > 0 ) {
            $where .= 'Order_Itm.Order_No = :orderno AND ';
            $param_array[':orderno'] = $orderno;
        }

        $where .= ' 1=1 ';

        // echo "param array is <pre>";
        // print_r($param_array[':orderno']);

        $stmt = $this->pdo->prepare("SELECT
    Order_Hdr.Order_No as Order_No,
    Article_Master.Article_No as Article_No,
    Article_Master.Article_Desc as Article_Desc,
    if ( Order_Itm.Pick_Quantity > 0, Order_Itm.Pick_Quantity, Order_Itm.Order_Quantity) Order_Quantity,
    if ( Order_Itm.Pick_Quantity > 0, Order_Itm.Pick_Amount, Order_Itm.Order_Amount)Order_Amount,
    Order_Itm.Order_Offer_Price,Order_Itm.Order_Mrp,Order_Itm.Pick_Quantity,Order_Itm.Pick_Amount,
    Order_Itm.Return_reason_Type as Return_Type,
    Order_Itm.Return_Reason_Desc as Return_Desc,
    Order_Itm_Batch.Batch_No as Batch_No,
    Order_Itm_Batch.Batch_Quantity as Batch_Quantity,
    DATE_FORMAT(Order_Itm_Batch.Batch_Date, '%Y-%m-%d') as Batch_Date,
    Order_Itm_Batch.Image_Url1 as Image_Url1,
    Order_Itm_Batch.Image_Url2 as Image_Url2,
    Order_Itm_Batch.Return_Reason_Type as Batch_Return_Type,
    Order_Itm_Batch.Return_Reason_Desc as Batch_Return_Desc,
Article_Master.Article_Desc, Article_Master.Image_Url, Article_Master.`Large_Image_Url` as large_img, Case_Size, GST, Valume, Unit ,
Article_Master.V_Mfg as make,
Article_Master.V_Mfg_Month_Year as year,
Article_Master.V_Model as model,
Article_Master.OEM_Part_No as oemno,
COALESCE(Article_Supplier_Product_Lookup.Supplier_Article_No, '') as supplier_article_no,
Get_Brand_Name(Article_Master.Brand_ID) as brandname,
'' as split_store_no
from Order_Itm left outer join Article_Master on Order_Itm.Article_No=Article_Master.Article_no
left outer join Order_Hdr on Order_Hdr.Order_No=Order_Itm.Order_No
left outer join Order_Itm_Batch on Order_Itm_Batch.Order_No = Order_Itm.Order_No and Order_Itm_Batch.Article_No = Order_Itm.Article_No
left outer join Store_Listing on ( Order_Itm.Article_No=Store_Listing.Article_No and Order_Hdr.Store_No=Store_Listing.Store_No )
left outer join Article_Supplier_Product_Lookup on ( Order_Hdr.Store_No = Article_Supplier_Product_Lookup.Supplier_No and
   Order_Itm.Article_No = Article_Supplier_Product_Lookup.Article_No )
where ".$where." Order By Order_Itm.Order_No, Order_Itm.Item_No Desc ");

        $stmt->execute($param_array);
        $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

        // echo "<pre>";
        // print_r($arr);

        if (!empty($arr)) {
            $msg = "Success";
            $status = true;
            $data = $arr;
        } else {
            $msg = ' Couldnt find order' . $orderno . '.';
            $status = false;
        }
        return get_response($msg, $status, $data);
    }

    public function get_order_summary(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        $stmt = $this->pdo->prepare("select Order_Total,Order_Count,Order_Date
    from
    (
      select Order_Date,sum(Order_Amount) as Order_Total,Count(Order_No) as Order_Count
      from Order_Hdr
      where Order_Date BETWEEN date_add(curdate(), interval -6 day)
      and curdate()
      and FSO_No=?
      and Order_Status in ('Open','Accepted','Ready To Deliver','Delivered')
      group by Order_Date
      union all
      select curdate(), 0.00,0
      union all
      select date_add(curdate(), interval -1 day), 0.00,0
      union all
      select date_add(curdate(), interval -2 day), 0.00,0
      union all
      select date_add(curdate(), interval -3 day), 0.00,0
      union all
      select date_add(curdate(), interval -4 day), 0.00,0
      union all
      select date_add(curdate(), interval -5 day), 0.00,0
      union all
      select date_add(curdate(), interval -6 day), 0.00,0
    ) x
    group by Order_Date
    order by Order_Date desc");
        $stmt->execute([$fsono]);
        $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);


        // $stmt->debugDumpParams();
        //$orderSummary = [];
        if(!empty($arr)) {
            foreach($arr as $key=>$details){

                $date = $details['Order_Date'];
                $buyer_data = [];
                $Order_Date = str_replace('-', '/',$details['Order_Date']);
                $Order_Date = date('d/m', strtotime($Order_Date));
                $data[$key]['Order_Date'] = $Order_Date;
                $data[$key]['Order_Total'] = $details['Order_Total'];
                $data[$key]['Order_Count'] = $details['Order_Count'];

                $query = $this->pdo->prepare("SELECT Order_Date ,Cust_Name AS Buyer_Name, Sum(Order_Amount) AS Order_Total,
                                    Count(Order_No) AS Order_Count FROM Order_Hdr
                                    INNER JOIN Cust_Master ON Cust_Master.Cust_No = Order_Hdr.Cust_No
                                    WHERE Order_Date = ? AND FSO_No=?
                                    AND Order_Status IN ('Open','Accepted','Ready To Deliver','Delivered')
                                    GROUP BY Buyer_Name" ) ;
                $query->execute([$date,$fsono]);

                $buyer_data = $query->fetchAll(PDO::FETCH_ASSOC);
                // $query->debugDumpParams();


                $data[$key]['Buyer_Data']= $buyer_data;
            }
            //$data[] = $orderSummary;
            //array_push($data,$orderSummary);
            $msg = 'Success';
        } else {
            $msg = 'No Orders found';
            $status = false;
        }
        return  get_response($msg, $status, $data);
    }

    public function api_orders(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        $authtoken = $request->header('HTTP_AUTHORIZATION');

        header_remove("Cache-Control");
        try
        {
            if (!empty($post['source_order_no'])) {
                $Cust_No = $post['BuyerID'];
                $stmtA = $this->pdo->prepare("select Cust_No, Supplier_Retailer_no from Cust_Store_Master where Supplier_Retailer_no='$Cust_No'");
                $stmtA->execute();
                $rowA = $stmtA->fetch(PDO::FETCH_ASSOC);
                if (empty($rowA)) {
                    $msg = $Cust_No . " Buyer not found";
                    $status = false;
                    $data = '';
                    $this->createLogData([$msg]);
                    return get_response($msg, $status, $data);
                } else {
                    $user_no = $rowA['Cust_No'];
                    $queryCustDeliveryAddress = $this->pdo->prepare("Select Get_Delivery_Address($user_no) as Address_ID");
                    $queryCustDeliveryAddress->execute();
                    $resultCustDeliveryAddress = $queryCustDeliveryAddress->fetchAll(PDO::FETCH_ASSOC);
                    $queryCustDeliveryAddress->closeCursor();
                    $Delivery_Address_ID = $resultCustDeliveryAddress[0]['Address_ID'];
                }

                $Store_No = $post['SellerID'];
                $stmtB = $this->pdo->prepare("select Store_No, Supplier_Store_No from Store_Master where Supplier_Store_No='$Store_No'");
                $stmtB->execute();
                $rowB = $stmtB->fetch(PDO::FETCH_ASSOC);
                if (empty($rowB)) {
                    $msg = $Store_No . " Store not found";
                    $status = false;
                    $data = '';
                    $this->createLogData([$msg]);
                    return get_response($msg, $status, $data);
                }

                $Source_Order_No = $post['source_order_no'];
                $stmtC = $this->pdo->prepare("select Order_No from Order_Hdr where Legacy_Order_No='$Source_Order_No'");
                $stmtC->execute();
                $rowC = $stmtC->fetch(PDO::FETCH_ASSOC);
                if (!empty($rowC)) {
                    $msg = "Order placed already. And order number is " . $rowC['Order_No'];
                    $status = false;
                    $data = '';
                    $this->createLogData([$msg]);
                    return get_response($msg, $status, $data);
                }

                $Source = 'SCM';
                $inputData = [];
                $inputData['Order_Details']['Business_ID'] = $post['businessID'];
                $inputData['Order_Details']['cust_no'] = $rowA['Cust_No'];
                $inputData['Order_Details']['store_no'] = $rowB['Store_No'];
                $inputData['Order_Details']['address'] = $Delivery_Address_ID;
                $inputData['Order_Details']['billaddress'] = $Delivery_Address_ID;
                $inputData['Order_Details']['default_store'] = $rowB['Store_No'];
                $inputData['Order_Details']['payment_type'] = 'cash_on_delivery';
                $inputData['Order_Details']['set_product_favourite'] = 0;
                $inputData['Order_Details']['delivery_type'] = 'home_delivery';
                $inputData['Order_Details']['stores']['delivery_charge'] = 0;

                for ($i = 0; $i < count($post['order_items']); $i++) {
                    $sk_article_no = $post['order_items'][$i]['Article_No'];
                    $UOM = $post['order_items'][$i]['UOM'];
                    $Cust_No = $post['BuyerID'];
                    $Article_No = $this->pdo->prepare("select Article_No from Article_Master where OEM_Part_No = '$sk_article_no' and Case_Size = '$UOM'");
                    $Article_No->execute();
                    $Article = $Article_No->fetch(PDO::FETCH_ASSOC);
                    if (empty($Article)) {
                        $msg = $sk_article_no . " article number not found";
                        $status = false;
                        $data = '';
                        $this->createLogData([$msg]);
                        return get_response($msg, $status, $data);
                    } else {
                        $inputData['Order_Details']['stores']['items'][$i]['offer_price'] = $post['order_items'][$i]['offer_price'];
                        $inputData['Order_Details']['stores']['items'][$i]['articleId'] = $Article['Article_No'];
                        $inputData['Order_Details']['stores']['items'][$i]['quantity'] = $post['order_items'][$i]['quantity'];
                        $inputData['Order_Details']['stores']['items'][$i]['unit_price'] = $post['order_items'][$i]['MRP'];
                        $inputData['Order_Details']['stores']['items'][$i]['brand_name'] = $post['order_items'][$i]['brand_name'];
                        $inputData['Order_Details']['stores']['items'][$i]['scheme_id'] = $post['order_items'][$i]['scheme_id'];
                    }
                }

                $inputData['Order_Details']['stores']['promo_code'] = "";
                $inputData['Order_Details']['stores']['discount_amount'] = $post['discAmt'];
                $inputData['Order_Details']['stores']['time_slot'] = "10:45AM-11:45AM";
                $inputData['Order_Details']['stores']['pref_date'] = $post['deliveryDate'];
                $inputData['Order_Details']['stores']['store_no'] = $rowB['Store_No'];
                $inputData['Order_Details']['stores']['custType'] = "Self";

                $inputData['Order_Details']['stores'] = [$inputData['Order_Details']['stores']];
                $inputData['Order_Details'] = [$inputData['Order_Details']];
                $url = API_ORDER_URL;
                $inputStr = json_encode($inputData);
                // print_r($inputStr);
                // die();
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', 'Content-Length: ' . strlen($inputStr), 'AuthType: staticauth', 'Authorization:' . getEnv('API_STATIC_AUTHTOKEN')));
                curl_setopt($ch, CURLOPT_POSTFIELDS, $inputStr);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                $outputData = curl_exec($ch);
                // print_r($outputData);
                curl_close($ch);
                // removeBomUtf8 function is for decode the output data. It remove the special character. Decode is not woking when this function is not used
                $json = removeBomUtf8($outputData);
                $data = json_decode($json, true);
                if ($data['status'] == "true") {
                    $Order_Date = $post['Order_Date'];
                    $logArr['message'] = $data['message'];
                    $logArr['Order_no'] = $data['data']['Order_No'];
                    $this->createLogData($logArr);
                    $status = $data['status'];
                    $outputDataFinal['Order_No'] = $data['data']['Order_No'];
                    $Order_No = explode(",", $data['data']['Order_No']);
                    foreach ($Order_No as $resultOrderNo) {
                        $updateOrderNo = $this->pdo->prepare("Update Order_Hdr set Legacy_Order_No = '$Source_Order_No', Source = '$Source', Order_Date = '$Order_Date' where Order_No='$resultOrderNo'");
                        $updateOrderNo->execute();
                    }
                    $outputDataFinal['Order_Tot_Amt'] = $data['data']['Order_Tot_Amt'];
                    $outputDataFinal['Order_Net_Tot_Amt'] = $data['data']['Order_Net_Tot_Amt'];
                    return get_response($logArr['message'], true, $outputDataFinal);
                } else if ($data['status'] == "false") {
                    $logArr['message'] = $data['data'];
                    $this->createLogData($logArr);
                    $status = $data['status'];
                    return get_response($logArr['message'], false);
                }
            } else {
                return get_response("Source order number can not be null", false);
            }

        } catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
    }

    private function createLogData($data)
    {
        //$log = __DIR__ . '/../logs/api_order_log.txt';
        //file_put_contents($log, print_r($data, true), FILE_APPEND | LOCK_EX);
        Storage::disk('local')->put('api_order_log.txt',print_r($data, true));
    }

    // JSON :{"User_No": "" , "Login_Type": "" , "Order_No":"" }
    public function cancel_order(Request $request){
        $data = array();
        $status = true;

        $post = $request->post();
        extract($post);
        try{

            if(isset($Order_No) && $Order_No >0)
            {
                $stmt = $this->pdo ->prepare("select
            Order_Hdr.Store_No,
            Cust_Master.Mobile_No,
            Cust_Master.Cust_Name,
            Cust_Master.Cust_No,
            Order_Hdr.Payment_Status,
            Order_Hdr.Net_Amount
            from Order_Hdr
            inner join Cust_Master on Order_Hdr.Cust_No=Cust_Master.Cust_No
            where Order_Hdr.Order_No='$Order_No'");
                $stmt -> execute();
                $arr = $stmt ->fetch(PDO::FETCH_ASSOC);

                if(!empty($arr))
                {
                    $phone_no = $arr['Mobile_No'];
                    $cust_name = $arr['Cust_Name'];
                    $cust_no = $arr['Cust_No'];
                    $store_no = $arr['Store_No'];
                    $refund_amount = $arr['Net_Amount'];
                    $Payment_Status = $arr['Payment_Status'];
                    $Change_Date   = date('Y-m-d');
                    $Change_Time   = date('H:i:s');
                    $Changed_By    = $User_No;
                    // $Sk_Invoice_No = $arr['Sk_Invoice_No'];
                    // $Ext_Invoice_No = $arr['Ext_Invoice_No'];

                    if($arr['Payment_Status'] == 'Paid' || $arr['Payment_Status']=='Partial Paid')
                    {
                        $stmt1 = $this->pdo->prepare ("Update Order_Hdr set Payment_Status = 'Refund Pending' , Order_Status = 'Cancelled', Refund_Amount = '$refund_amount', Change_Date = '$Change_Date', Change_Time = '$Change_Time', Changed_By = '$Changed_By' where Order_No = $Order_No");
                    }
                    else
                    {
                        $stmt1 = $this->pdo->prepare ("Update Order_Hdr set Payment_Status = NULL , Order_Status = 'Cancelled', Change_Date = '$Change_Date', Change_Time = '$Change_Time', Changed_By = '$Changed_By' where Order_No = $Order_No");
                    }
                    $updated = $stmt1 -> execute();
                    if($updated == 1)
                    {
                        // data prepare for Order_History entry
                        $OrderID       = $Order_No;
                        $Memo          = 'Order Cancelled';
                        $History_Date  = date('Y-m-d');
                        $History_Time  = date('H:i:s');

                        $Status        = 'A';
                        $Creation_Date = date('Y-m-d');
                        $Creation_Time = date('H:i:s');
                        $Created_By    = $User_No; //$Cust_No;
                        $Change_Date   = date('Y-m-d');
                        $Change_Time   = date('H:i:s');
                        $Changed_By    = $User_No;//$Cust_No;
                        //insert entry in Order_History table
                        $stmt2 = $this->pdo->prepare("insert into Order_History (Order_ID, Memo, History_Date, History_Time, Status, Creation_Date,
                    Creation_Time, Created_By, Change_Date, Change_Time, Changed_By , Login_Type) Values ('$OrderID' , '$Memo' , '$History_Date','$History_Time','$Status','$Creation_Date', '$Creation_Time' , '$Created_By', '$Change_Date' , '$Change_Time' , '$Changed_By' , '$Login_Type' )");
                        $stmt2 -> execute();
                        if ($arr['Payment_Status'] == 'Paid') {
                            $Memo = 'Order Refund Pending';
                            $stmt3 = $this->pdo->prepare("insert into Order_History (Order_ID, Memo, History_Date, History_Time, Status, Creation_Date,
                    Creation_Time, Created_By, Change_Date, Change_Time, Changed_By , Login_Type) Values ('$OrderID' , '$Memo' , '$History_Date','$History_Time','$Status','$Creation_Date', '$Creation_Time' , '$Created_By', '$Change_Date' , '$Change_Time' , '$Changed_By' , '$Login_Type' )");
                            $stmt3->execute();
                        }

                        // $GetInvoiceNumber = $this->pdo->prepare("Select Invoice_No from Stor")

                        $orderans = get_order_details($this->pdo, $Order_No);

                        $store_balances = get_store_balance($this->pdo, $store_no, $cust_no);

                        $store_transaction[0]['order_no'] = $Order_No;
                        $store_transaction[0]['invoice_number'] = 0;
                        $store_transaction[0]['invoice_date'] = 0;
                        $store_transaction[0]['transaction_type'] = 5;
                        $store_transaction[0]['store_no'] = $store_no;
                        $store_transaction[0]['cust_no'] = $cust_no;
                        $store_transaction[0]['fso_no'] = $orderans['FSO_No'];
                        $store_transaction[0]['deposit_amount'] = $orderans['Net_Amount'];
                        $store_transaction[0]['withdraw_amount'] = 0;
                        $store_transaction[0]['outstanding_amt'] = 0;
                        $store_transaction[0]['balance_amt'] = $store_balances['Balance_Amt'] + $orderans['Net_Amount'];
                        $store_transaction[0]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'];
                        $store_transaction[0]['remark'] = "Reverse ordered amount on cancel";

                        $ans = create_store_transaction($this->pdo, $store_transaction[0]);
                        if ($ans) {
                            // $msg = "Created store transaction for order " . $Order_No;
                            $status = true;
                        } else {
                            $msg = "Failed to create store transaction entry for order " . $Order_No;
                            $status = false;
                            $data = '';
                            return get_response($msg, $status, $data);
                        }

                        if(isset($Sk_Invoice_No) || isset($Ext_Invoice_No))
                        {
                            if(isset($Sk_Invoice_No))
                                $invoice_number = $Sk_Invoice_No;
                            else
                                $invoice_number - $Ext_Invoice_No;

                            $store_balance1 = get_amount_store_transaction($this->pdo, $Order_No, $invoice_number);
                            if (empty($store_balance1)) {
                                $msg = "Failed to retrieve store balance for order number " . $Order_No;
                                $status = false;
                                $data = '';
                                // createLog([$msg]);
                                return get_response($msg, $status, $data);
                            }

                            $store_transaction[1]['order_no'] = $Order_No;
                            if(isset($Sk_Invoice_No))
                                $store_transaction[1]['invoice_number'] = $Sk_Invoice_No;
                            else
                                $store_transaction[1]['invoice_number'] = $Ext_Invoice_No;
                            $store_transaction[1]['transaction_type'] = 5;
                            $store_transaction[1]['store_no'] = $store_no;
                            $store_transaction[1]['cust_no'] = $cust_no;
                            $store_transaction[1]['fso_no'] = $store_balance1['FSO_No'];
                            $store_transaction[1]['deposit_amount'] = $store_balance1['Outstanding_Amt'];
                            $store_transaction[1]['withdraw_amount'] = 0;
                            $store_transaction[1]['outstanding_amt'] = 0;
                            if (isset($store_transaction[0]['balance_amt'])) {
                                $store_transaction[1]['balance_amt'] = $store_transaction[0]['balance_amt'];
                            } else {
                                $store_transaction[1]['balance_amt'] = $store_balances['Balance_Amt'];
                            }
                            $store_transaction[1]['outstanding_balance_amt'] = $store_balances['Outstanding_Balance_Amt'] + $store_balance1['Outstanding_Amt'];
                            $store_transaction[1]['remark'] = "Reverse invoice amount update on cancel";

                            $ans = create_store_transaction($this->pdo, $store_transaction[1]);
                            if ($ans) {
                                // $msg = "Created store transaction for order " . $Order_No;
                                $status = true;
                            } else {
                                $msg = "Failed to create store transaction entry for order " . $Order_No;
                                $status = false;
                                $data = '';
                                return get_response($msg, $status, $data);
                            }
                        }


                        $query=$this->pdo->prepare("select Store_Name, Mobile_No_1, Mobile_No_2 from Store_Master where Store_No='$store_no'");
                        $query->execute();
                        $row1 = $query->fetch(PDO::FETCH_ASSOC);

                        $store_name=$row1['Store_Name'];
                        $store_mobile_no_1=$row1["Mobile_No_1"];
                        $store_mobile_no_2=$row1["Mobile_No_2"];

                        $store_owner_mobile;
                        if($store_mobile_no_1 != '' && $store_mobile_no_2 != '')
                        {
                            $store_owner_mobile = $store_mobile_no_1.",".$store_mobile_no_2;
                        }else if($store_mobile_no_1 == '')
                        {
                            $store_owner_mobile = $store_mobile_no_2;
                        }else if($store_mobile_no_2 == '')
                        {
                            $store_owner_mobile = $store_mobile_no_1;
                        }

                        // if(isset($_REQUEST['store_id'])){
                        // SubmitSMS($phone_no, 'ORDER_CANCELLED_USER', array($Order_No,$store_name));
                        // SubmitSMS($store_owner_mobile, 'ORDER_CANCELLED_STORE', array($store_name, $Order_No, $cust_name));

                        // }else{
                        if($Payment_Status == 'Paid' || $Payment_Status == 'Partial Paid')
                        {
                            // echo"here";
                            $refund = cancel_order_for_initiate_refund($this->pdo, $Order_No, $User_No);
                        }

                        if(isset($store_no))
                        {
                            SubmitSMS($phone_no, 'ORDER_CANCELLED_USER', array($Order_No,$store_name));
                            SubmitSMS($store_owner_mobile, 'ORDER_CANCELLED', array($store_name, $Order_No));
                        }

                        $msg="order canceled successfully";
                        $status=true;

                    }
                    else
                    {
                        $msg = 'Unable to cancel order.';
                        $status = false;
                    }

                }
                else{
                    $msg = 'Invalid Data';
                    $status = false;
                }
            }
            else
            {
                $msg = 'Invalid Data';
                $status = false;
            }
        }catch (PDOException $e)
        {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
            // return get_response("Something went wrong", $status, $data);
        }

        if($status == true){
            send_api_notification($this->pdo,'cancel_order', $User_No, 'Self');
        }
        return get_response($msg, $status, $data);
    }

    //Json input
    // businessID
    // StoreNo
    // CustNo
    // fso
    // start_order_date [ format YYYY-MM-DD ]
    // end_order_date [ format YYYY-MM-DD ]
    // OrderYear
    // OrderStatus
    // UnsentOrdersFlag

    // TODO: parameter DO to retrieve orders 'ready to deliver'
    // All inputs are optional.

    public function get_orderlist(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        // At this point we have input parameters in
        // $business_id, $OrderStatus, $custno, $fso, $start_order_date, $end_order_date, $order_year, $order_status
        // ignore business_id for now.

        // if storeno is passed then filter order list for that store.
        // if custno is passed then filter order list for that buyer.
        // if fso is passed then filter order list for that fso. ( FSO or DO is passed )
        // if both order_start_date and order_end_date is passed then filter order list for that date range.
        // if order list is to be retrieved for a single date then that date will be passed in order_start_date parameter.
        // if an order year is passed then it would be one of 'Last 6 Months', 'Last 30 Days' or a Year eg 2019.
        // if an order status is passed then it would be one of the available status types.
        // if an 'UnsentOrdersFlag' is set then retrieve only the orders that do not have the legacy order no is not populated.
        // TODO: multiple stores, customers.
        // TODO: enhance to have DO as a parameter.

        // TODO: validate input parameters.

        // build a where clause depending on the input parameters

        $param_array = array();
        $where = '';

        // order year will always be supplied for the app.
        // however it would not be supplied from the batch process
        try {
            if (isset($Order_Year)) {
                if (($Order_Year == 'Last 6 Months') || ($Order_Year == 'Last 30 Days')) {
                    if ($Order_Year == 'Last 6 Months') {
                        $interval = new DateInterval('P6M'); // 6 months
                    } else if ($Order_Year == 'Last 30 Days') {
                        $interval = new DateInterval('P30D'); // 30 days
                    }
                    // work out the order start date and set the order end date to today.
                    // the where condition uses >= so the selected days orders are retrieved.

                    $date = new DateTime($dt);
                    $date->sub($interval);
                    $start_order_date = $date->format('Y-m-d');
                    // set the order end date to today.
                    $end_order_date = date("Y-m-d");
                } else { // this is a case where a order year is specified eg 2019
                    $start_order_date = date("$Order_Year-01-01");
                    $end_order_date = date("$Order_Year-12-31");
                }
            }

            if (isset($start_order_date)) {
                $param_array[':start_order_date'] = $start_order_date;

                $where .= 'Order_Hdr.Order_Date >= STR_TO_DATE(:start_order_date, "%Y-%m-%d") AND ';
            }

            if (isset($end_order_date)) {
                $param_array[':end_order_date'] = $end_order_date;
                $where .= 'Order_Hdr.Order_Date <= STR_TO_DATE(:end_order_date, "%Y-%m-%d") AND ';
            } else {
                if (isset($start_order_date)) {
                    $param_array[':end_order_date'] = $start_order_date;
                    $where .= 'Order_Hdr.Order_Date <= STR_TO_DATE(:end_order_date, "%Y-%m-%d") AND ';
                }
            }

            // Order Status is always sent from the app however it is optional from the batch process.
            if (isset($Order_Status)) {
                if ($Order_Status == 'All') {
                    // No status filters to be applied.
                } else {
                    $param_array[':order_status'] = $Order_Status;
                    $where .= 'Order_Hdr.Order_Status = :order_status AND ';
                }
            }

            if (isset($StoreNo) && $StoreNo > 0) {
                $param_array[':storeno'] = $StoreNo;
                // currently we dont have capability to select multiple sellers.
                $where .= 'Order_Hdr.Store_No = :storeno AND ';
            }
            if (isset($CustNo) && $CustNo > 0) {
                $param_array[':custno'] = $CustNo;
                // currently we dont have capability to select multiple buyers.
                $where .= 'Order_Hdr.Cust_No = :custno AND ';
            }

            if (isset($fso) && $fso > 0) {
                $param_array[':fso'] = $fso;
                $where .= 'Order_Hdr.FSO_No=:fso AND ';
            }

            //Added by Meenal Barve 10th June 2019 for DO Daily Delivery and Return Requests
            if (isset($do) && $do > 0) {
                $param_array[':do'] = $do;
                $where .= '(Order_Hdr.Order_No,Order_Hdr.Store_No) in (select  Order_No,Store_No
    													        from  Order_Con_Book_Form
    													        where Vendor_Type="DO"
    													        and   Vendor_No =:do
    													        ) AND ';

            }

            // this is used to identify orders which have not yet been sent to the 3rd party application
            if (isset($UnsentOrdersFlag)) {
                if ($UnsentOrdersFlag == 'Y') {
                    // $where .= ' ( Order_Hdr.Legacy_Order_No IS NULL OR Order_Hdr.Legacy_Order_No = "")  AND ';
                    $where .= ' Order_Hdr.Legacy_Order_No is NULL AND ';
                }
            }

            //this is used to identify orders which are related to return to send as return orders 3rd party,Branch - mee_send_return_orders
            if (isset($ReturnOrdersFlag)) {
                if ($ReturnOrdersFlag == 'Y') {
                    $where .= ' Order_Hdr.Order_Status in ("Goods Collected","Return","Reject","Return Request") AND ';
                } //if N then send all orders except above
                else {
                    $where .= ' Order_Hdr.Order_Status not in ("Goods Collected","Return","Reject","Return Request") AND ';
                }
            }

            $where .= '1=1';

            $orderlistSQL = "select
        Order_Hdr.Order_No,
        Order_Hdr.Invoice_PDF,
        Order_Hdr.Address_ID,
        Cust_Master.Mobile_No,
        CA.Flat_No,
        CA.Locality,
        CAM.Area_Name,
        CA.Address,
        CCM.City_Name,
        CSM.State_Name,
        CA.Latitude,
        CA.Longitude,
        SA.Latitude as Supplier_Latitude,
        SA.Longitude as Supplier_Longitude,
        CA.Pincode,
        Store_Master.Store_No,
        Store_Master.Store_Name,
        DATE_FORMAT(Order_Hdr.`Order_Date`, '%Y-%m-%d') as Order_Date,
        Order_Hdr.Order_Time as Order_Time,
        Order_Hdr.Order_Amount,
        Order_Hdr.Net_Amount,
        Order_Hdr.Header_Discount,
        Order_Hdr.Order_Status as Order_Status,
        Order_Hdr.Snap_Order_Code,
        Order_Hdr.Delivery_Charges,
        Order_Hdr.`Is_Modified` as Modified,
        Order_Hdr.`Payment_Status`,
        Order_Hdr.`Payment_Type`,
        Order_Hdr.`Cust_No`,
        COALESCE(Cust_Store_Master.`Supplier_Retailer_No`,'') as legacy_buyer_no,
        COALESCE(Store_Master.`Supplier_Store_No`,'') as legacy_supplier_no,
        Order_Hdr.`Cust_Type` as Login_Type,
        CASE
        WHEN  ( Order_Hdr.`Cust_Type` ='Self' ) THEN CONCAT(Order_Hdr.`Cust_Type`,'-',Cust_Master.Outlet_Name)
        WHEN  ( Order_Hdr.`Cust_Type` ='FSO' OR Order_Hdr.`Cust_Type` ='DO')  THEN CONCAT(Order_Hdr.`Cust_Type`,'-',Cust_Master.Outlet_Name)
        ELSE ''
        END as Cust_Type,
        Order_Hdr.`FSO_No`,
        DATE_FORMAT(Order_Hdr.`Pref_Del_Date`, '%Y-%m-%d') as Delivery_Date,
        CONCAT(DATE_FORMAT(Order_Hdr.`Actual_Del_Date`, '%Y-%m-%d'),' ',
               TIME_FORMAT(Order_Hdr.`Actual_Del_Time`, '%h:%i:%s'))  as Actual_Delivery_Date,
        UNIX_TIMESTAMP(concat(Order_Hdr.Actual_Del_date,' ',Order_Hdr.Actual_Del_Time)) as Actual_Del_Date_For_Sort,
        COALESCE(Order_Hdr.`legacy_order_no`,'') as Source_Order_No,
        CASE
        WHEN  ( Locate('Return', Order_Status ) > 0 ) THEN COALESCE(Order_Hdr.`Return_Order_No`,'')
        WHEN  ( Locate('Reject', Order_Status ) > 0 ) THEN COALESCE(Order_Hdr.`Return_Order_No`,'')
        WHEN  ( Locate('Goods Collected', Order_Status ) > 0 ) THEN COALESCE(Order_Hdr.`Return_Order_No`,'')
        WHEN  ( Locate('Return Request', Order_Status ) > 0 ) THEN COALESCE(Order_Hdr.`Return_Order_No`,'')
        ELSE ''
        END as Original_Order_No,
        Order_Hdr.Return_reason_Type as Return_Type,
        Order_Hdr.Return_Reason_Desc as Return_Reason,
        Year(Order_Hdr.Order_Date) order_year,
        Order_Type,
        COALESCE(CF.Message,'null') as Feedback,

        -- Get_Collection_Amount2(Order_Hdr.Order_No , Order_Hdr.Net_Amount) as Balance_Amount,

        COALESCE(Order_Hdr.Net_Amount - SUM(ST.Deposit_Amt),Order_Hdr.Net_Amount) as Balance_Amount,

        -- Get_Food_Amount2(Order_Hdr.Order_No , Order_Hdr.Net_Amount) as Balance_Food_Amount

        (COALESCE(Order_Hdr.Net_Amount - SUM(ST.Deposit_Amt),Order_Hdr.Net_Amount) -
        (CASE WHEN Order_Hdr.Order_Status = 'Open' or Order_Hdr.Order_Status='Accepted' THEN ifnull(sum(OI.Order_Amount),0)
         ELSE ifnull(sum(OI.Pick_Amount),0)
        END)) as Balance_Food_Amount

        from Order_Hdr inner join Cust_Master on Order_Hdr.Cust_No=Cust_Master.Cust_No
        inner join Store_Master on Order_Hdr.Store_No=Store_Master.Store_No
        inner join Order_Addresses CA on Order_Hdr.Address_ID = CA.Address_ID AND Order_Hdr.Order_No = CA.Order_No AND CA.Address_Type='Delivery'
        inner join Area_Master  CAM   on CA.Locality  = CAM.Area_Code
        inner join City_Master  CCM   on CA.City_Code  = CCM.City_Code
        inner join State_Master CSM   on CA.State_Code = CSM.State_Code
        inner join Order_Addresses SA on Order_Hdr.Supplier_Address_ID = SA.Address_ID AND Order_Hdr.Order_No = SA.Order_No
        inner join Area_Master  SAM   on SA.Locality  = SAM.Area_Code
        inner join City_Master  SCM   on SA.City_Code  = SCM.City_Code
        inner join State_Master SSM on SA.State_Code = SSM.State_Code
        inner join Cust_Store_Master on ( Order_Hdr.Store_No=Cust_Store_Master.Store_No and Order_Hdr.Cust_No=Cust_Store_Master.Cust_No and Cust_Store_Master.Status='A')
        left join Customer_Feedback CF on CF.Title = Order_Hdr.Order_No and CF.Type = 'Order'

        left join Store_Transaction as ST on ST.Transaction_Type = 1 AND ST.Order_No = Order_Hdr.Order_No
 		left join Order_Itm as OI on OI.Order_No = Order_Hdr.Order_No
 				   AND OI.Article_No IN (SELECT am.Article_No FROM Article_Master AS am WHERE am.Dietary_Code != 1)

        where " . $where . " GROUP BY Order_Hdr.Order_No Order By Order_Hdr.Order_No Desc ";

            $stmt = $this->pdo->prepare($orderlistSQL);

            // is this format to be used for order and delivery dates '%d-%b-%y'
            $stmt->execute($param_array);
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
            if (!empty($arr)) { // we have retrieved a list of orders

                // create the array of unique order status based on retrieved column 'Order_Status'
                // create the array for order year based on the retrieved column 'order_year'

                $order_year = array();
                $order_status = array();
                $order_year_temp = array();
                $order_status_temp = array();

                $order_year_temp[0] = 'Last 30 Days';
                $order_year_temp[1] = 'Last 6 Months';
                $order_status_temp[0] = 'All';

                // prepare the query for getting list of return_order_numbers ( one or multiple returns )
                $return_order_stmt = $this->pdo->prepare("SELECT Order_No Return_Order_No
                    FROM Order_Hdr WHERE return_order_no = :original_order_number ;");

                // create the array of order status and order year based on retrieved column 'Order_Status'
                foreach ($arr as $key => $val) {
                    array_push($order_year_temp, $arr[$key]['order_year']);
                    array_push($order_status_temp, $arr[$key]['Order_Status']);
                    $arr[$key]['Return_Order_No'] = array();
                    if ($arr[$key]['Order_Status'] == "Delivered") {
                        $param_ar[':original_order_number'] = $arr[$key]['Order_No'];

                        $return_order_stmt->execute($param_ar);
                        $retarr = $return_order_stmt->fetchALL(PDO::FETCH_ASSOC);

                        if (!empty($retarr)) {
                            $arr[$key]["Return_Order_No"] = array();
                            foreach ($retarr as $retkey => $retval) {
                                array_push($arr[$key]['Return_Order_No'], $retarr[$retkey]['Return_Order_No']);
                            }

                        }
                    }

                    if (!($Login_Type) || ((isset($Login_Type) && ($Login_Type != "FSO")) && (isset($Login_Type) && ($Login_Type != "DO")))) {
                        unset($arr[$key]['Mobile_No']);
                    }
                }

                // make the created array of order status and order year unique
                //TODO: possibly some more validation needed.
                $order_year = array_values(array_unique($order_year_temp));
                $order_status = array_values(array_unique($order_status_temp));
                // populate the payload to be returned.
                $data['orders'] = $arr;
                $data['order_status'] = $order_status;
                $data['order_year'] = $order_year;
                $msg = "Success";
                $status = true;
            } else {
                //Get Total count of Orders Branch <dev-10>
                //Get distinct Order statuses
                if (isset($StoreNo) && $StoreNo > 0) {
                    $stmt = $this->pdo->prepare("select 1 as order_present
            from Order_Hdr where Order_Hdr.Cust_No =$CustNo and Order_Hdr.Store_No = $StoreNo Order By Order_Hdr.Order_Status ");
                } else {
                    $stmt = $this->pdo->prepare("select 1 as order_present
                from Order_Hdr where Order_Hdr.Cust_No =$CustNo Order By Order_Hdr.Order_Status ");
                }
                $stmt->execute();
                //$stmt->debugDumpParams();die();
                $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
                if (empty($arr)) {
                    $order_present = "N";
                } else {
                    $order_present = "Y";
                }

                //Branch dev-10
                $msg = ' Couldnt find any orders ' . $start_order_date . '.';
                $status = false;
                $data['order_placed'] = $order_present;

            }
        } catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
        }
        return get_response($msg, $status, $data);
    }

    //Json input businessid, orderno
    // TODO: orderno array as input - PDO cant accept and array...need additional function as workaround.

    public function get_orderdetails(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        // At this point we have input parameters in
        // $businessid and $orderno
        // Ignore business id for now and if order list is provided then a return all items of all orders in a single array.

        // Build a where clause depending on the input parameters
        // the 1st 3 data blocks look at order header while the last one looks at order item so 2 where clauses.
        // this could be combined in a single where clause but 2 make it more readable.

        $where = "";
        $whereitem = "";
        $param_array = array();

        if (isset($orderno) && $orderno > 0) {
            $param_array[':orderno'] = $orderno;
            if (strpos($orderno,',')) {
                $where .= ' Order_Hdr.Order_No in (:orderno) AND ';
                $whereitem .= 'Order_Itm.Order_No in (:orderno) AND ';
            } else {
                $where .= ' Order_Hdr.Order_No = :orderno AND ';
                $whereitem .= 'Order_Itm.Order_No = :orderno AND ';
            }
        } else {
            $status = false;
            $status_code = 400;
            $msg = 'No details for Order ' . $orderno . '.';
            return get_response($msg, $status, $data);
        }

        $where .= '1=1'; $whereitem .= '1=1';

        // All the below php logic is now within the sql query
        // we have an order retrieved so transform it and then retrieve the other data elements.
        // if ($order_info['Modified'] == 1) {
        //     $flaga = 1;
        // } else {
        //     $flaga = 0;
        // }
        // $order_info['Modified'] = $flaga;

        // if ($order_info['Snap_Order_Code'] != "") {
        //     $order_info['Snap_Order_Flag'] = 1;
        // } else {
        //     $order_info['Snap_Order_Flag'] = 0;
        // }

        // $chkStatus = array('Open', 'Accepted', 'Ready To Deliver', 'Ready To Pick');

        // if (in_array($order_info['Order_Status'], $chkStatus)) {
        //     $order_info['show_cancel_button'] = 1;
        // } else {
        //     $order_info['show_cancel_button'] = 0;
        // }

        // if (!empty($order_info['Snap_Order_Code'])) {
        //     $order_info['Snap_Order_Flag'] = 1;
        //     $order_info['reorder'] = 0;
        // } else {
        //     $order_info['Snap_Order_Flag'] = 0;
        //     $order_info['reorder'] = 1;
        // }

        // $order_info['Payment_Type_Retry'] = $order_info['Payment_Type'] ?? '';

        // $paymentType = $order_info['Payment_Type'];
        // $pmtType = str_replace('_', ' ', $paymentType);
        // $paymentType = ucfirst(strtolower($pmtType));

        // $order_info['Payment_Type'] = $paymentType;
        // $order_info['Payment_Status'] = $row['Payment_Status'] ?? '';

        // $imagePath = $order_info['Image_Path'];
        // unset($order_info['Image_Path']);
        // if (!empty($order_info['Image_Path'])) {
        //     $order_info['Image_Path'] = $imagePath;
        // } else {
        //     $order_info['Image_Path'] = "";
        // }

        $order_info_stmt = $this->pdo->prepare("SELECT
    Order_Hdr.`Order_No`,
        Order_Hdr.`Cust_No`,
        Order_Hdr.`Store_No`,
        DATE_FORMAT(Order_Hdr.`Order_Date`, '%d-%b-%y') as Order_Date,
        Order_Hdr.`Order_Time`,
        DATE_FORMAT(Order_Hdr.`Pref_Del_Date`, '%d-%b-%y') as Pref_Del_Date,
        Order_Hdr.`Pref_Del_Time_From`,
        Order_Hdr.`Pref_Del_Time_To`,
        Order_Hdr.`Actual_Del_Date`,
        Order_Hdr.`Actual_Del_Time`,
        Order_Hdr.`Order_Status`,
        Order_Hdr.`Order_Amount` as total_order_amount,
        (Order_Hdr.`Order_Amount`-Order_Hdr.`Delivery_Charges`) as 'without_del_amount',
        Order_Hdr.`Promo_Code`,
        Order_Hdr.`Header_Discount`,
        Order_Hdr.`Net_Amount`,
        Order_Hdr.`Delivery_Mode`,
        Order_Hdr.`Delivery_Boy_Name`,
        Order_Hdr.`Snap_Order_Code`,
        if ( ifnull(Order_Hdr.`Snap_Order_Code`, 0) = 0, 0, 1 ) as Snap_Order_Flag,
		if ( ifnull(Order_Hdr.`Snap_Order_Code`, 0) = 0, 1, 0 ) as reorder,
        ifnull(Order_Hdr.Payment_Status, '') as Payment_Type_Retry,
        Order_Hdr.`Delivery_Charges` as Delivery_Charges,
        if ( Order_Hdr.`Is_Modified`= 1,1,0 ) as Modified,
        Promo_Order_Level.Coorporate_Offer as Offer_Type,
        Promo_Order_Level.Offer_Desc,
        Store_Master.Set_Billing,
        COALESCE(Order_Hdr.Ext_Invoice_No, Order_Hdr.Sk_Invoice_No,'') as Sk_Invoice_No,
        lower(REPLACE(	Order_Hdr.Payment_Type, '_',' ')) Payment_Type,
        ifnull(Order_Hdr.Payment_Status, '') Payment_Status,
        Order_Hdr.Order_Status,
        if ( Order_Hdr.Order_Status in ( 'Open', 'Accepted', 'Ready To Deliver', 'Ready To Pick' ) , 1 , 0 ) show_cancel_button,
        ifnull(Bulk_Order_Image.Image_Path, '' ) Image_Path -- ,
        -- COALESCE(Order_Hdr.`Return_Order_No`,'') as Return_Order_No
    FROM `Order_Hdr`
    Left Outer join Cust_Master on Order_Hdr.Cust_No=Cust_Master.Cust_No
    Left Outer join Promo_Order_Level on Order_Hdr.Promo_Code=Promo_Order_Level.Promo_Code
    Left Outer join Store_Master on Order_Hdr.Store_No=Store_Master.Store_No
    Left Outer join Bulk_Order_Image on Order_Hdr.Snap_Order_Code=Bulk_Order_Image.Order_Code
    where" . $where);

        $order_info_stmt->execute($param_array);
        // $order_info = array();
        $order_info = $order_info_stmt->fetch(PDO::FETCH_ASSOC);

        // echo "<pre>";
        // print_r($order_info);
        // echo " Order status is " . $order_info['Order_Status'];

        if (empty($order_info)) {
            $msg = 'No Open/Accepted Orders ' . $orderno . '.';
            $status = false;
        } else {

            // prepare the query for getting list of return_order_numbers ( one or multiple returns )
            $return_order_stmt = $this->pdo->prepare("SELECT Order_No Return_Order_No
            FROM Order_Hdr WHERE return_order_no = :original_order_number ;");

            // create the array of return orders if the order is Delivered
            $order_info["Return_Order_No"] = array();
            if ($order_info['Order_Status'] == "Delivered") {
                $param_arey[':original_order_number'] = $order_info['Order_No'];
                $return_order_stmt->execute($param_arey);
                $retarr = $return_order_stmt->fetchALL(PDO::FETCH_ASSOC);

                if (!empty($retarr)) {
                    foreach ($retarr as $retkey => $retval) {
                        array_push($order_info['Return_Order_No'], $retarr[$retkey]['Return_Order_No']);
                    }
                }
            }

            $address_info_stmt = $this->pdo->prepare("SELECT
        Cust_Master.`Mobile_No`,
        Order_Addresses.`Name` as Cust_Name,
        Order_Addresses.`Email_ID` as Email_ID,
        Order_Addresses.`Flat_No`,
        Area_Master.`Area_Name` as Locality,
        Order_Addresses.`Address`,
        Order_Addresses.`Contact_No`,
        Order_Addresses.`Contact_No_Type`,
        Order_Addresses.`Landmark` as Landmark,
        Order_Addresses.Pincode as Pincode,
        City_Master.`City_Name`,
        State_Master.`State_Name`
        FROM `Order_Hdr`
        Left Outer join Cust_Master on Order_Hdr.Cust_No=Cust_Master.Cust_No
        Left Outer join Order_Addresses on Order_Hdr.Address_ID=Order_Addresses.Address_ID AND Order_Hdr.Order_No=Order_Addresses.Order_No
        Left Outer join State_Master on Order_Addresses.`State_Code`=State_Master.`State_Code`
        Left Outer join City_Master on Order_Addresses.`City_Code`=City_Master.`City_Code`
        Left Outer join Area_Master on Area_Master.`Area_Code`=Order_Addresses.`Locality`
        inner join Store_Master on Order_Hdr.Store_No=Store_Master.Store_No
        where " . $where);

            $address_info_stmt->execute($param_array);

            // $address_info = array();
            $address_info = $address_info_stmt->fetch(PDO::FETCH_ASSOC);

            // echo "<pre>";
            // print_r($address_info);

            $store_info_info_stmt = $this->pdo->prepare("SELECT
		Store_Master.`Store_Name` as Store_Name,
		BBC_Addresses.`Address` as Address1,
		BBC_Addresses.`Email_ID` as Email_ID,
		BBC_Addresses.`Contact_No` as Mobile_No_1,
		Area_Master.`Area_Name` as Locality,
		City_Master.`City_Name`,
		State_Master.`State_Name`
    FROM `BBC_Addresses`
		Left Outer join State_Master on BBC_Addresses.`State_Code`=State_Master.`State_Code`
		Left Outer join City_Master on BBC_Addresses.`City_Code`=City_Master.`City_Code`
		Left Outer join Area_Master on Area_Master.`Area_Code`=BBC_Addresses.`Locality`
		inner join Order_Hdr on Order_Hdr.Store_No=BBC_Addresses.User_No
		inner join Store_Master on BBC_Addresses.`User_No`=Store_Master.`Store_No`
	WHERE BBC_Addresses.Address_ID=IFNULL(Get_Billing_Address(BBC_Addresses.User_No,Get_Shipping_Address(BBC_Addresses.User_No)),Get_Registered_Address(BBC_Addresses.User_No))
	AND " . $where);

            $store_info_info_stmt->execute($param_array);

            // $store_info_info = array();
            $store_info_info = $store_info_info_stmt->fetch(PDO::FETCH_ASSOC);

            // echo "<pre>";
            // print_r($store_info_info);

            // If pick quantity is greater than zero then replace order_quantity with pick quantity
            // and replace order_amount with pick amount

            $item_detail_param_array[':orderno'] = $orderno;
            $item_detail_param_array[':order_status'] = $order_info['Order_Status'];

            $item_detail_stmt = $this->pdo->prepare("SELECT
        if ( find_in_set( :order_status, 'Open,Accepted'), Order_Itm.Order_Quantity, Order_Itm.Pick_Quantity ) Order_Quantity,
        if ( find_in_set( :order_status, 'Open,Accepted'), Order_Itm.Order_Amount, Order_Itm.Pick_Amount ) Order_Amount,
        if ( find_in_set( :order_status, 'Open,Accepted'), Order_Itm.Order_Offer_Price, round(((Order_Itm.Pick_Amount) / (Order_Itm.Pick_Quantity) ) , 2) ) Order_Offer_Price
        ,Order_Itm.Order_Mrp,
        Order_Itm.Pick_Quantity,
        Order_Itm.Pick_Amount,
        Order_Itm.Pick_Quantity as returnable_qty,
        Order_Itm.Article_No ArticleID,
    Article_Master.Article_Desc, Article_Master.Image_Url, Article_Master.`Large_Image_Url` as large_img, Case_Size, Article_Master.GST as GST, Valume, Unit ,
    Article_Master.V_Mfg as make,
    Article_Master.V_Mfg_Month_Year as year,
    Article_Master.V_Model as model,
    Article_Master.OEM_Part_No as oemno,
    Get_Brand_Name(Article_Master.Brand_ID) as brandname,
    '' as split_store_no
    from Order_Itm left outer join Article_Master on Order_Itm.Article_No=Article_Master.Article_no where " . $whereitem);

            $item_detail_stmt->execute($item_detail_param_array);

            $item_detail = array();
            $item_detail = $item_detail_stmt->fetchAll(PDO::FETCH_ASSOC);

            $retunable_arr = array();
            // returnable quantity only if order is 'Delivered'
            if ($order_info['Order_Status'] == 'Delivered') {

                $returnable_qty_stmt = $this->pdo->prepare("SELECT Order_Itm.Article_No ArticleID,
            sum( IF (Order_Itm.Order_No = :order_number,Order_Itm.Pick_Quantity ,0 - Order_Itm.Pick_Quantity)) qty_left
            from Order_Itm where find_in_set(Order_Itm.Order_No , ( select Concat ( :order_no ,',',Group_Concat( Order_No)) Return_Order_No
                from Order_Hdr where return_order_no =  :order_num and Order_Status != 'Reject Return')) group by Order_Itm.Article_No;");

                $param_arr = array();
                $param_arr[':order_number'] = $orderno;
                $param_arr[':order_no'] = $orderno;
                $param_arr[':order_num'] = $orderno;
                $returnable_qty_stmt->execute($param_arr);

                $returnable_arr = $returnable_qty_stmt->fetchAll(PDO::FETCH_ASSOC);

                // print_r($item_detail);
                // echo "Returnable array is ";
                // print_r($retunable_arr);

                if (!empty($returnable_arr)) {

                    foreach ($item_detail as $itemkey => $val) {

                        foreach ($returnable_arr as $retkey => $retvalue) {

                            // if ArticleID from item_detail exists in returnable_arr
                            // then assign the qty_left to item_detail[$itemkey]['returnable_qty']
                            if ($item_detail[$itemkey]['ArticleID'] == $returnable_arr[$retkey]['ArticleID']) {
                                $item_detail[$itemkey]['returnable_qty'] = $returnable_arr[$retkey]['qty_left'];

                            }
                        }
                    }
                }
            } // order is 'Delivered'
            //dev-17 , return batch details for each article
            //start
            foreach ($item_detail as $itemkey => $val) {
                $batch_detail_stmt = $this->pdo->prepare("SELECT
                            Order_Itm_Batch.Order_No as Order_No,
                            Order_Itm_Batch.Article_No as Article_No,
                            Order_Itm_Batch.Return_Reason_Type as Return_Type,
                            Order_Itm_Batch.Return_Reason_Desc as Return_Desc,
                            Order_Itm_Batch.Batch_No as Batch_No,
                            Order_Itm_Batch.Batch_Quantity as Batch_Quantity,
                            DATE_FORMAT(Order_Itm_Batch.Batch_Date, '%Y-%m-%d') as Batch_Date,
                            Order_Itm_Batch.Image_Url1 as Image_Url1,
                            Order_Itm_Batch.Image_Url2 as Image_Url2,
                            Order_Itm_Batch.Return_Reason_Type as Batch_Return_Type,
                            Order_Itm_Batch.Return_Reason_Desc as Batch_Return_Desc
                            FROM Order_Itm_Batch where Order_Itm_Batch.Order_No = :order_no and Order_Itm_Batch.Article_No = :article_num");

                $param_arr = array();
                $param_arr[':order_no'] = $orderno;
                $param_arr[':article_num'] = $item_detail[$itemkey]['ArticleID'];
                $batch_detail_stmt->execute($param_arr);

                $batch_arr = $batch_detail_stmt->fetchAll(PDO::FETCH_ASSOC);
                $item_detail[$itemkey]['batch_detail'] =$batch_arr;
            }
            //End


            // echo "<pre>";
            // print_r($item_detail);

            //Added to fetch Consignment details Branch <dev-10>
            $con_info_stmt = $this->pdo->prepare("SELECT F.Order_No, F.Vendor_No, F.Store_No, S.User_Name CustomerCode, F.Ewaybill_No, F.Ewaybill_Date, F.Ewaybill_Valid_Date, S.Password CustomerPassword, C.Con_No ConNo, F.Vendor_Name Vendor_Name
            FROM Order_Con_Book_Form F
            inner join Order_Consignment C on F.ID = C.Book_Form_ID and C.Status = 'A'
            left join Store_Vendor_Master S on (CASE
            WHEN F.Vendor_No = 0 and (F.Vendor_Name='SPOTON' OR F.Vendor_Name = 'SPOT ON') THEN S.Vendor_No = 1
            ELSE F.Vendor_No = S.Vendor_No END)
            left join Order_Hdr H on F.Store_No = H.Store_No and F.Order_No = H.Order_No
            left join Vendor_Master V on F.Store_No = S.Store_No and V.ID = F.Vendor_No
            where  F.Order_No = $orderno");

            $con_info_stmt->execute();

            // $address_info = array();
            $con_info = $con_info_stmt->fetch(PDO::FETCH_ASSOC);
            //</dev-10>
            if (empty($con_info)) $con_info=null;

            $order_histroy_stmt = $this->pdo->prepare("SELECT Memo, History_Date, History_Time FROM Order_History where Order_ID=$orderno and Memo not like 'Delivery date changed from%' and Memo not like '%amount is overridden'");
            $order_histroy_stmt->execute();
            $order_histroy = $order_histroy_stmt->fetchAll(PDO::FETCH_ASSOC);
            if (empty($order_histroy)) $order_histroy=null;

            $record_final = array();
            $record_final['order_info'] = $order_info;
            $record_final['address_info'] = $address_info;
            $record_final['store_info_info'] = $store_info_info;
            $record_final['item_detail'] = $item_detail;
            $record_final['con_detail']  = $con_info;  //dev_info
            $record_final['history_detail']  = $order_histroy;

            $msg = "Success";
            $status = true;
            $data = $record_final;
        }

        //  echo "<pre>";
        //  print_r($record_final);

        return get_response($msg, $status, $data);
    }
}
