<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class ProfileController extends Controller
{
    public function get_profile(Request $request){
        $post = $request->post();
        extract($post);
        $status = false;

        $param_array = array();
        $where = '';
        $msg = "Success";

        if (isset($User_No) && $User_No > 0) {

            if (isset($Login_Type)) {
                // for login type
                switch ($Login_Type) {
                    case "Self":
                        $param_array[':cust_no'] = $User_No;
                        $where = ' CM.Cust_No = :cust_no;';
                        break;
                    case "DO":
                    case "FSO":
                        //dev-14
                        //start
                    case "STADM":
                    case "ADMIN":
                        //end
                        $param_array[':fsono'] = $User_No;
                        $where = ' FM.FSO_No = :fsono;';
                        break;
                    default:
                        $msg = "Something went wrong";
                        $data = "LoginType incorrect!!";
                    // return get_response( $msg, $status, $data);

                }

                try {
                    if ($Login_Type == "Self") {
                        // select user info if login type self
                        $stmt = $this->pdo->prepare("SELECT
					    	CM.Cust_No User_No
                            , 'Self' Login_Type
							,'' FSO_Name
							, Cust_Name
							,Outlet_Name
							,COALESCE(GSTIN,'') GSTIN
							,COALESCE(PAN, '') PAN
							,COALESCE(Email_ID,'') Email_ID
							,Mobile_No
							,COALESCE(License_No, '') License_No
							,COALESCE(Date(License_Expiry_Date) , '0000-00-00') License_Expiry_Date,
                            COALESCE(Speciality_Id,'') speciality_id
							FROM Cust_Master CM WHERE " . $where);
                        $stmt->execute($param_array);
                        $data = $stmt->fetch(PDO::FETCH_ASSOC);
                    } else {
                        // select user info if login type not self
                        $stmt = $this->pdo->prepare("SELECT
					        FM.FSO_No User_No
                            , Login_Type Login_Type
							, FSO_Name
							, '' Cust_Name
							, '' Outlet_Name
							, '' GSTIN
							, '' PAN
							,COALESCE(Email_ID,'') Email_ID
							,Mobile_No
							, '' License_No
							, '0000-00-00' License_Expiry_Date
                            , '' speciality_sd
							FROM FSO_Master FM WHERE " . $where);
                        $stmt->execute($param_array);
                        $data = $stmt->fetch(PDO::FETCH_ASSOC);
                    }

                    if (!empty($data)) {
                        // $data = $arr;
                        $msg = "Success";
                        $status = true;
                    } else {
                        $msg = "No data found!"; // ' Couldnt find a profile for ' . $CustNo . '.';
                    }

                } catch (PDOException $e) {
                    $msg = "Something went wrong";
                    $data = $e->getMessage();
                    // return get_response( "Something went wrong", $status, $data);
                }

            } else {
                // Login_Type incorrect
                $msg = "Something went wrong";
                $data = "Login_Type incorrect!!";
            }

        } else { // CustNo not passed
            $msg = "Something went wrong";
            $data = "Incorrect or missing User!!";
        }

        return get_response($msg, $status, $data);
    }

    // Input

    // "data": {
    //     "User_No": "40",
    //     "Login_Type": "FSO",
    //     "FSO_Name": "Ashish (Sudin Dist )",
    //     "Cust_Name": "",
    //     "Outlet_Name": "",
    //     "GSTIN": "",
    //     "PAN": "",
    //     "Email_ID": "",
    //     "Mobile_No": "9518346594",
    //     "License_No": "",
    //     "License_Expiry_Date": ""
    //     "Changed_By": "40",
    //     "Changed_By_Login": "Self",
    //     "Buyer_Speciality" : 1
    // }
    public function update_profile(Request $request){
        $post = $request->post();
        extract($post);
        $status = false;

        $param_array = array();
        $where = '';
        $setvalues = '';
        $msg = "Success";
        $time1 = date('H:i:s');
        $data = '';

        $Cust_Name = trim($Cust_Name);
        $Outlet_Name = trim($Outlet_Name);


        $Cust_Name = str_replace('  ', ' ', $Cust_Name);
        $Outlet_Name = str_replace('  ', ' ', $Outlet_Name);


        $str_name = "/[0-9]{10}/i";

        $validate_name = preg_match($str_name, $Cust_Name, $validate_name, PREG_OFFSET_CAPTURE); //return 1 if digits > 9 else return 0

        $validate_outlet_name = preg_match($str_name, $Outlet_Name, $validate_outlet_name, PREG_OFFSET_CAPTURE); //return 1 if digits > 9 else return 0

        if ($validate_name == 0 && $validate_outlet_name == 0) {
            $Cust_Name = $Cust_Name;
            $Outlet_Name = $Outlet_Name;
            $status = true;
            if (isset($User_No) && $User_No > 0) {

                if (isset($Login_Type)) {

                    /*switch ($Login_Type) {
                    case "Self":

                    $param_array[':cust_no'] = $User_No;
                    $where = ' CM.Cust_No = :cust_no;';

                    if (isset($Cust_Name)) {
                    $param_array[':cust_name'] = $Cust_Name;
                    $setvalues .= ' Cust_Name = :cust_name , ';
                    }

                    if (isset($Outlet_Name)) {
                    $param_array[':outletname'] = $Outlet_Name;
                    $setvalues .= ' Outlet_Name = :outletname , ';
                    }

                    if (isset($GSTIN)) {
                    $param_array[':gstin'] = $GSTIN;
                    $setvalues .= ' GSTIN = :gstin ,';
                    }

                    if (isset($PAN)) {
                    $param_array[':pan'] = $PAN;
                    $setvalues .= ' PAN = :pan ,';
                    }

                    if (isset($Email_ID)) {
                    $param_array[':emailid'] = $Email_ID;
                    $setvalues .= ' Email_ID = :emailid ,';
                    }

                    if (isset($License_No)) {
                    $param_array[':licenseno'] = $License_No;
                    $setvalues .= ' License_No = :licenseno ,';
                    }

                    if (isset($License_Expiry_Date)) {
                    $param_array[':licenseexpirydate'] = $License_Expiry_Date;
                    $setvalues .= ' License_Expiry_Date = :licenseexpirydate, ';
                    }

                    if (isset($Mobile_No)) {
                    $param_array[':mobileno'] = $Mobile_No;
                    $setvalues .= ' Mobile_No = :mobileno ';
                    }

                    $stmt = $this->pdo->prepare("UPDATE Cust_Master CM SET " . $setvalues . ' WHERE ' . $where);

                    break;

                    case "DO":
                    case "FSO":

                    $param_array[':fsono'] = $User_No;
                    $where = ' FM.FSO_No = :fsono ; ';

                    if (isset($FSO_Name)) {
                    $param_array[':fsoname'] = $FSO_Name;
                    $setvalues .= ' FSO_Name = :fsoname , ';
                    }

                    if (isset($Email_ID)) {
                    $param_array[':emailid'] = $Email_ID;
                    $setvalues .= ' Email_ID = :emailid ,';
                    }

                    if (isset($Mobile_No)) {
                    $param_array[':mobileno'] = $Mobile_No;
                    $setvalues .= ' Mobile_No = :mobileno ';
                    }

                    $stmt = $this->pdo->prepare("UPDATE FSO_Master FM SET " . $setvalues . ' WHERE ' . $where);

                    break;

                    default:
                    $msg = "LoginType incorrect!!";
                    $data = "LoginType incorrect!!";
                    $status = false;
                    return get_response( $msg, $status, $data);

                    }*/

                    //Added by Meenal Barve for branch dev-13 , seller profile in mobile App
                    //start
                    if ($Login_Type == "Self") {

                        $param_array[':cust_no'] = $User_No;
                        $where = ' CM.Cust_No = :cust_no;';

                        if (isset($Cust_Name)) {
                            $param_array[':cust_name'] = $Cust_Name;
                            $setvalues .= ' Cust_Name = :cust_name , ';
                        }

                        if (isset($Outlet_Name)) {
                            $param_array[':outletname'] = $Outlet_Name;
                            $setvalues .= ' Outlet_Name = :outletname , ';
                        }

                        if (isset($GSTIN)) {
                            $param_array[':gstin'] = $GSTIN;
                            $setvalues .= ' GSTIN = :gstin ,';
                        }

                        if (isset($PAN)) {
                            $param_array[':pan'] = $PAN;
                            $setvalues .= ' PAN = :pan ,';
                        }

                        if (isset($Email_ID)) {
                            $param_array[':emailid'] = $Email_ID;
                            $setvalues .= ' Email_ID = :emailid ,';
                        }

                        if (isset($License_No)) {
                            $param_array[':licenseno'] = $License_No;
                            $setvalues .= ' License_No = :licenseno ,';
                        }

                        if (isset($License_Expiry_Date)) {

                            // Sheetal Chive
                            // 06 - 04 - 2022
                            // handeled the condition that the date is in any form like y-m-d or d-m-y .
                            // it should be save in db in the form of YYYY - MM - DD

                            $License_Expiry_Date  = date('Y-m-d',strtotime($License_Expiry_Date));

                            $param_array[':licenseexpirydate'] = $License_Expiry_Date;
                            $setvalues .= ' License_Expiry_Date = :licenseexpirydate, ';
                        }
                        if (isset($Status)) {
                            $param_array[':status'] = $Status;
                            $setvalues .= ' Status = :status, ';
                        }

                        if (isset($Mobile_No)) {
                            $param_array[':mobileno'] = $Mobile_No;
                            $setvalues .= ' Mobile_No = :mobileno, ';
                        }
                        if (isset($Changed_By)) {
                            $param_array[':changedby'] = $Changed_By;
                            $setvalues .= 'Changed_By = :changedby,';
                        }
                        if (isset($speciality_id)) {
                            $param_array[':buyerspeciality'] = $speciality_id;
                            $setvalues .= 'Speciality_Id = :buyerspeciality,';
                        }
                        if (isset($Changed_By_Login)) {
                            $param_array[':changedbylogin'] = $Changed_By_Login;
                            $setvalues .= 'Login_Type = :changedbylogin,';
                        }

                        $param_array[':changetime'] = $time1;
                        $setvalues .= 'Change_Time = :changetime , Change_Date = CURDATE()';
                        $stmt = $this->pdo->prepare("UPDATE Cust_Master CM SET " . $setvalues . ' WHERE ' . $where);

                        //print_r($stmt); exit();
                    } else {

                        $param_array[':fsono'] = $User_No;
                        $where = ' FM.FSO_No = :fsono ; ';
                        if (isset($FSO_Name)) {
                            $param_array[':fsoname'] = $FSO_Name;
                            $setvalues .= ' FSO_Name = :fsoname , ';
                        }

                        if (isset($Email_ID)) {
                            $param_array[':emailid'] = $Email_ID;
                            $setvalues .= ' Email_ID = :emailid ,';
                        }

                        if (isset($Mobile_No)) {
                            $param_array[':mobileno'] = $Mobile_No;
                            $setvalues .= ' Mobile_No = :mobileno, ';
                        }

                        if (isset($Changed_By)) {
                            $param_array[':changedby'] = $Changed_By;
                            $setvalues .= 'Changed_By = :changedby,';
                        }
                        $param_array[':changetime'] = $time1;
                        $setvalues .= 'Change_Time = :changetime , Change_Date = CURDATE()';
                        $stmt = $this->pdo->prepare("UPDATE FSO_Master FM SET " . $setvalues . ' WHERE ' . $where);

                    }



                    //end
                    try {

                        $updated = $stmt->execute($param_array);

                        if ($updated == 1) {
                            $msg = "User Profile Updated";
                            $status = true;
                        } else {
                            $msg = "Profile Not Updated";
                            $status = false;
                        }

                    } catch (PDOException $e) {
                        $status = false;
                        $data = $e->getMessage();
                        return get_response( "Something went wrong", $status, $data);
                    }

                } else {
                    // Login_Type incorrect
                    $msg = "Something went wrong";
                    $data = "LoginType incorrect!!";
                    $status = false;
                }

            } else { // User_No not passed

                $msg = "Something went wrong";
                $data = "Incorrect or missing User!!";
                $status = false;

            }
        }else {
            $msg = "Please enter valid Name or outlet name which has digits less than 10";
            $status = false;

            return get_response( $msg, $status, $data);

        }

        return get_response( $msg, $status, $data);
    }
}
