<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;

class ReportController extends Controller
{
    //Json input
    // businessID
    // FSONo
    public function get_reportfilters(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        // At this point we have input parameters in
        // $business_id,$fsono
        // ignore business_id for now.


        // build a where clause depending on the input parameters

        $param_array = array();
        $where = '';

        if (isset($FSONo) && $FSONo > 0) {
            $param_array[':fsono'] = $FSONo;

            $where .= 'Order_Hdr.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :fsono) AND ';

        }

        //Currently these filters are only for Sales Report
        //so use Order Status as Ready To Deliver,Delivered
        //$where .= ' Order_Hdr.Order_Status in ("Ready To Deliver","Delivered") AND '; //dev-16 , this is not needed
        $where .= '1=1';

        //var_dump( $where );
        //Get distinct Store No.s
        $stmt = $this->pdo->prepare("select distinct Order_Hdr.Store_No as store_no , Store_Master.Store_Name as store_name
    	from Order_Hdr , Store_Master where Order_Hdr.Store_No = Store_Master.Store_No AND ". $where ." Order By Order_Hdr.Order_Status ");

        $stmt->execute($param_array);
        //echo '<pre>'; print_r($stmt);exit;
        $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
        // $row = $arr -> fetch_assoc();
        //Get distinct Year
        $stmt1 = $this->pdo->prepare("select distinct Year(Order_Date) as order_year
	from Order_Hdr where ". $where ." Order By Order_Hdr.Order_Status ");

        $stmt1->execute($param_array);
        //$stmt1->debugDumpParams();
        $arr1 = $stmt1->fetchAll(PDO::FETCH_ASSOC);

        //Get distinct Quarter
        $stmt2 = $this->pdo->prepare("select distinct QUARTER(Order_Date) as order_quarter
	from Order_Hdr where ". $where ." Order By Order_Hdr.Order_Status ");

        $stmt2->execute($param_array);
        //$stmt2->debugDumpParams();
        $arr2 = $stmt2->fetchAll(PDO::FETCH_ASSOC);

        //Get distinct Month
        $stmt3 = $this->pdo->prepare("select distinct Month(Order_Date) as order_month
	from Order_Hdr where ". $where ." Order By Order_Hdr.Order_Status ");

        $stmt3->execute($param_array);

        $arr3 = $stmt3->fetchAll(PDO::FETCH_ASSOC);


        if (!empty($arr) && !empty($arr1) && !empty($arr2) && !empty($arr3)) { // we have retrieved a list of filters
            // populate the payload to be returned.
            $store_no=array();
            $store_name=array();
            $store_no[0]='All'; // default value for store no array
            $store_name[0]='All'; // default value for store name array
            foreach ($arr as $key => $val) {
                array_push($store_name,$arr[$key]['store_name']);
                array_push($store_no,$arr[$key]['store_no']);
            }

            $order_year=array();
            $order_year[0] = 'All'; // dafault value for year array

            foreach ($arr1 as $key => $val) {
                array_push($order_year,$arr1[$key]['order_year']);
            }

            $order_quarter=array();
            $order_quarter[0] = 'All'; // dafault value for quarter array
            foreach ($arr2 as $key => $val) {
                array_push($order_quarter,$arr2[$key]['order_quarter']);
            }

            $order_month=array();
            $order_month[0] = 'All'; // dafault value for month array
            foreach ($arr3 as $key => $val) {
                array_push($order_month,$arr3[$key]['order_month']);
            }

            $data['store_no']      = array_values($store_no);
            $data['store_name']      = array_values($store_name);
            $data['order_year']    = array_values($order_year);
            $data['order_quarter'] = array_values($order_quarter);
            $data['order_month']   = array_values($order_month);

            $msg = "Success";
            $status = true;
            // echo "<pre>";
            // print_r($data);
        } else {
            //$msg = ' Couldnt find any orders ' . $orderDate . '.';
            $msg = ' Couldnt find any order filters ';
            $status = false;
        }
        return get_response($msg, $status, $data);
    }

    public function get_performance_reports(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);
        // At this point we have input parameters in
        // $business_id, $fso, $storeno, $start_order_date, $end_order_date, $order_year, $order_month, $order_quarter
        // ignore business_id for now.

        // if storeno is passed then filter order list for that store.
        // if custno is passed then filter order list for that buyer.
        // if fso is passed then filter order list for that fso. ( FSO or DO is passed )
        // if both order_start_date and order_end_date is passed then filter order list for that date range.
        // if order list is to be retrieved for a single date then that date will be passed in order_start_date parameter.
        // if an order year is passed then it would be one of 'Last 6 Months', 'Last 30 Days' or a Year eg 2019.
        // if an order status is passed then it would be one of the available status types.
        // if an 'UnsentOrdersFlag' is set then retrieve only the orders that do not have the legacy order no is not populated.
        // TODO: multiple stores, customers.
        // TODO: enhance to have DO as a parameter.

        // TODO: validate input parameters.

        // build a where clause depending on the input parameters

        $param_array = array();
        $where = '';
        $having= '';
        if (isset($User_No))  {
            $param_array[':userno'] = $User_No;

        }

        else{
            $msg = "User No not given , No Order Found";
            $status = false;
            return get_response($msg, $status, $data);
        }

        if (isset($Order_Year) && ($Order_Year !== 'All'))  {
            $param_array[':order_year'] = $Order_Year;

            $where .= 'YEAR(OH.Order_Date)= :order_year and ';

        }

        if (isset($Order_Month) && ($Order_Month !== 'All'))  {
            $param_array[':order_month'] = $Order_Month;

            $where .= 'MONTH(OH.Order_Date)= :order_month and ';

        }

        if (isset($Order_Quarter) && ($Order_Quarter !== 'All'))  {
            $param_array[':order_quarter'] = $Order_Quarter;
            $where .= 'QUARTER(OH.Order_Date)= :order_quarter and ';
        }

        if (isset($Store_No) && ($Store_No !== 'All'))  {
            $param_array[':store_no'] = $Store_No;
            $where .= 'OH.Store_No= :store_no and ';
        }

        $where .= '1=1';

        if ($ReportType=='Salesman') {  //Salesman Performance
            //Salesman Performance
            $stmt = $this->pdo->prepare("SELECT SM.Store_Name,FM.FSO_Name,
    count(distinct OH.Order_No) as OrderCount,
    sum(CASE WHEN (OH.Order_Status in ('Ready To Deliver','Delivered' ) ) THEN OI.Pick_Amount ELSE 0 END) as SaleAmount,
    sum(CASE WHEN (OH.Order_Status not in ('Return Request','Reject Return','Return','Goods Collected') ) THEN OI.Order_Amount ELSE 0 END) as OrderAmount
    from FSO_Master FM,Order_Hdr OH,Order_Itm OI,Store_Master SM
    where ".$where." and FM.FSO_No=OH.FSO_No
    and OH.Order_No = OI.Order_No
    and OH.Cust_Type='FSO'
    and OH.Store_No = SM.Store_No
    and OH.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :userno and Status = 'A')
    group by OH.Store_No,FM.FSO_No
    order by OH.Store_No,SaleAmount desc ");
            /*$stmt=$this->pdo->prepare("SELECT SM.Store_Name Store_Name,FM.FSO_Name,
            count(distinct OH.Order_No) as OrderCount,'1' Sort_Order,
            sum(CASE WHEN (OH.Order_Status in ('Ready To Deliver','Delivered' ) ) THEN OI.Pick_Amount ELSE 0 END) as SaleAmount,
            sum(CASE WHEN (OH.Order_Status not in ('Return Request','Reject Return','Return','Goods Collected') ) THEN OI.Order_Amount ELSE 0 END) as OrderAmount
            from FSO_Master FM,Order_Hdr OH,Order_Itm OI,Store_Master SM
            where ".$where." and FM.FSO_No=OH.FSO_No
            and OH.Order_No = OI.Order_No
            and OH.Cust_Type='FSO'
            and OH.Store_No = SM.Store_No
            and OH.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :userno and Status = 'A')
            group by OH.Store_No,FM.FSO_No
            union ALL
            SELECT SM.Store_Name Store_Name,'Summary',
            count(distinct OH.Order_No) as OrderCount,'2' Sort_Order,
            sum(CASE WHEN (OH.Order_Status in ('Ready To Deliver','Delivered' ) ) THEN OI.Pick_Amount ELSE 0 END) as SaleAmount,
            sum(CASE WHEN (OH.Order_Status not in ('Return Request','Reject Return','Return','Goods Collected') ) THEN OI.Order_Amount ELSE 0 END) as OrderAmount
            from FSO_Master FM,Order_Hdr OH,Order_Itm OI,Store_Master SM
            where ".$where." and FM.FSO_No=OH.FSO_No
            and OH.Order_No = OI.Order_No
            and OH.Cust_Type='FSO'
            and OH.Store_No = SM.Store_No
            and OH.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :userno and Status = 'A')
            group by OH.Store_No
            order by Store_Name,SaleAmount desc,Sort_Order desc");*/

            //echo '<pre>'; print_r($stmt); exit;
            $stmt->execute($param_array);
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
            //$stmt->debugDumpParams();
            //$orderSummary = [];
            if(!empty($arr)) {
                foreach($arr as $key=>$details){
                    $data[$key]['Store_Name'] = $details['Store_Name'];
                    $data[$key]['Name']   = $details['FSO_Name'];
                    $data[$key]['Count'] = $details['OrderCount'];
                    $data[$key]['SaleAmount'] = $details['SaleAmount'];
                    $data[$key]['OrderAmount'] = $details['OrderAmount'];
                }
                //$data[] = $orderSummary;
                //array_push($data,$orderSummary);
                $msg = 'Success';
                $status = true;
            } else {
                $msg = 'No Orders found';
                $status = false;
            }
        }
        else if ($ReportType=='Article'){
            if (isset($Sale_Qty_Exceeds))  {
                $param_array[':sale_qty_exceeds'] = $Sale_Qty_Exceeds;
                //$having .= 'OH.Store_No= :store_no and ';
                $having .= ' total >  :sale_qty_exceeds ';
            }
            else
                $having .= '1=1';

            $stmt=$this->pdo->prepare("select SM.Store_Name,OI.Article_No,CONCAT(AM.Article_Desc,' ',AM.Valume,' ',AM.Unit) Article_Desc,Count(OI.Article_No) total,
    sum(CASE WHEN (OH.Order_Status in ('Ready To Deliver','Delivered' ) ) THEN OI.Pick_Amount ELSE 0 END) as SaleAmount,
    sum(CASE WHEN (OH.Order_Status not in ('Return Request','Reject Return','Return','Goods Collected') ) THEN OI.Order_Amount ELSE 0 END) as OrderAmount
    from Order_Hdr OH,Order_Itm OI,Article_Master AM,Store_Master SM
    where ".$where." and OH.Order_No = OI.Order_No
    and OI.Article_No = AM.Article_No
    and OH.Store_No = SM.Store_No
    and OH.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :userno and Status = 'A')
    group by OI.Article_No having ".$having." order by OH.Store_No,Total desc");

            /*$stmt=$this->pdo->prepare("select SM.Store_Name Store_Name,OI.Article_No,CONCAT(AM.Article_Desc,' ',AM.Valume,' ',AM.Unit) Article_Desc,Count(OI.Article_No) total,'1' Sort_Order,
            sum(CASE WHEN (OH.Order_Status in ('Ready To Deliver','Delivered' ) ) THEN OI.Pick_Amount ELSE 0 END) as SaleAmount,
            sum(CASE WHEN (OH.Order_Status not in ('Return Request','Reject Return','Return','Goods Collected') ) THEN OI.Order_Amount ELSE 0 END) as OrderAmount
            from Order_Hdr OH,Order_Itm OI,Article_Master AM,Store_Master SM
            where ".$where." and OH.Order_No = OI.Order_No
            and OI.Article_No = AM.Article_No
            and OH.Store_No = SM.Store_No
            and OH.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :userno and Status = 'A')
            group by OH.Store_No,OI.Article_No having ".$having."
            union ALL
            select SM.Store_Name Store_Name,0,'Summary' Article_Desc,Count(OI.Article_No) total,'2' Sort_Order,
            sum(CASE WHEN (OH.Order_Status in ('Ready To Deliver','Delivered' ) ) THEN OI.Pick_Amount ELSE 0 END) as SaleAmount,
            sum(CASE WHEN (OH.Order_Status not in ('Return Request','Reject Return','Return','Goods Collected') ) THEN OI.Order_Amount ELSE 0 END) as OrderAmount
            from Order_Hdr OH,Order_Itm OI,Article_Master AM,Store_Master SM
            where ".$where." and OH.Order_No = OI.Order_No
            and OI.Article_No = AM.Article_No
            and OH.Store_No = SM.Store_No
            and OH.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :userno and Status = 'A')
            group by OH.Store_No having ".$having."
            order by Store_Name,Total desc,Sort_Order desc");*/
            $stmt->execute($param_array);
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
            //$stmt->debugDumpParams();
            //$orderSummary = [];
            if(!empty($arr)) {
                foreach($arr as $key=>$details){
                    $data[$key]['Store_Name'] = $details['Store_Name'];
                    $data[$key]['Name']       = $details['Article_Desc'];
                    $data[$key]['Count']      = $details['total'];
                    $data[$key]['SaleAmount'] = $details['SaleAmount'];
                    $data[$key]['OrderAmount'] = $details['OrderAmount'];
                }
                //$data[] = $orderSummary;
                //array_push($data,$orderSummary);
                $msg = 'Success';
                $status = true;
            } else {
                $msg = 'No Products found';
                $status = false;
            }

        }
        else if ($ReportType =='Buyer'){ //Buyer Performamce

            //Customer Performance
            $stmt =$this->pdo->prepare("SELECT SM.Store_Name,CM.Outlet_Name,
    count(distinct OH.Order_No) as OrderCount,
    sum(CASE WHEN (OH.Order_Status in ('Ready To Deliver','Delivered' ) ) THEN OI.Pick_Amount ELSE 0 END) as SaleAmount,
    sum(CASE WHEN (OH.Order_Status not in ('Return Request','Reject Return','Return','Goods Collected') ) THEN OI.Order_Amount ELSE 0 END) as OrderAmount
    from Cust_Master CM,Order_Hdr OH,Order_Itm OI,Store_Master SM
    where ".$where." and CM.Cust_No=OH.Cust_No
    and OH.Order_No = OI.Order_No
    and OH.Store_No = SM.Store_No
    and OH.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :userno and Status = 'A')
    group by OH.Store_No,CM.Cust_No
    order by OH.Store_No,SaleAmount desc");
            /*$stmt = $this->pdo->prepare("SELECT SM.Store_Name Store_Name,CM.Outlet_Name,G.ID Beat,
            count(distinct OH.Order_No) as OrderCount,'1' Sort_Order,
            sum(CASE WHEN (OH.Order_Status in ('Ready To Deliver','Delivered' ) ) THEN OI.Pick_Amount ELSE 0 END) as SaleAmount,
            sum(CASE WHEN (OH.Order_Status not in ('Return Request','Reject Return','Return','Goods Collected') ) THEN OI.Order_Amount ELSE 0 END) as OrderAmount
            from Order_Hdr OH
            left join BBC_Org_Group_Users U on U.User_No = OH.Cust_No and U.Store_No = OH.Store_No and U.Login_Type='Buyer' and U.Status='A'
            left join BBC_Org_User_Groups G on G.ID = U.Org_Group_ID and G.Status= 'A'
            inner join Cust_Master CM on OH.Cust_No = CM.Cust_No
            inner join Store_Master SM on OH.Store_No = SM.Store_No
            inner join Order_Itm OI on OH.Order_No = OI.Order_No
            where ".$where." and CM.Cust_No=OH.Cust_No
            and OH.Order_No = OI.Order_No
            and OH.Store_No = SM.Store_No
            and OH.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :userno and Status = 'A')
            group by OH.Store_No,CM.Cust_No
            union all
            SELECT SM.Store_Name Store_Name,CONCAT(IFNULL(G.User_Group_Name,'No'),' Beat Summary') Outlet_Name,G.ID Beat,
            count(distinct OH.Order_No) as OrderCount,'2' Sort_Order,
            sum(CASE WHEN (OH.Order_Status in ('Ready To Deliver','Delivered' ) ) THEN OI.Pick_Amount ELSE 0 END) as SaleAmount,
            sum(CASE WHEN (OH.Order_Status not in ('Return Request','Reject Return','Return','Goods Collected') ) THEN OI.Order_Amount ELSE 0 END) as OrderAmount
            from Order_Hdr OH
            left join BBC_Org_Group_Users U on U.User_No = OH.Cust_No and U.Store_No = OH.Store_No and U.Login_Type='Buyer' and U.Status='A'
            left join BBC_Org_User_Groups G on G.ID = U.Org_Group_ID and G.Status= 'A'
            inner join Cust_Master CM on OH.Cust_No = CM.Cust_No
            inner join Store_Master SM on OH.Store_No = SM.Store_No
            inner join Order_Itm OI on OH.Order_No = OI.Order_No
            where ".$where." and CM.Cust_No=OH.Cust_No
            and OH.Order_No = OI.Order_No
            and OH.Store_No = SM.Store_No
            and OH.Store_No in (Select Store_No from BBC_Org_Users where FSO_No= :userno and Status = 'A')
            group by OH.Store_No,G.ID
            order by Store_Name,Beat,Sort_Order desc,SaleAmount desc");*/

            $stmt->execute($param_array);
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
            //$stmt->debugDumpParams();
            //$orderSummary = [];
            if(!empty($arr)) {
                foreach($arr as $key=>$details){
                    $data[$key]['Store_Name'] = $details['Store_Name'];
                    $data[$key]['Name']   = $details['Outlet_Name'];
                    $data[$key]['Count'] = $details['OrderCount'];
                    $data[$key]['SaleAmount'] = $details['SaleAmount'];
                    $data[$key]['OrderAmount'] = $details['OrderAmount'];
                }
                //$data[] = $orderSummary;
                //array_push($data,$orderSummary);
                $msg = 'Success';
                $status = true;
            } else {
                $msg = 'No Buyers found';
                $status = false;
            }

        }
        else {
            $msg = 'No Report Selection found';
            $status = false;
        }
        return  get_response($msg, $status, $data);
    }
}
