<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class RetailerController extends Controller
{
    public function get_retailer_invoices(Request $request){
        $data = array();
        $status = true;

        $post = $request->post();
        extract($post);


        /*$stmt = $this->pdo->prepare("Select Order_No,'' as Invoice_No,Order_Amount as Amount
        from Order_Hdr where Order_Status in ('Open','Accepted')
        and Cust_No=? and Store_No=?
        union
        select O.Order_No,I.Invoice_no as Invoice_No,Tot_Inv_Amt as Amount
        from Invoice_Hdr I, Order_Hdr O
        where I.Order_No = O.Order_No
        and O.Payment_Status in ('Pending') and O.Cust_No=? and O.Store_No= ?");*/
        $stmt = $this->pdo->prepare("Select Order_No,'' as Invoice_No,Net_Amount as Amount , Get_Collection_Amount2(Order_No , Net_Amount) as Balance_Amount
from Order_Hdr where Order_Status in ('Open','Accepted') and Payment_Status in ('Pending' , 'Partial')
and Cust_No=? and Store_No=?
union
select O.Order_No,I.Invoice_no as Invoice_No,O.Net_Amount as Amount , Get_Collection_Amount2(O.Order_No,O.Net_Amount) as Balance_Amount
from Invoice_Hdr I, Order_Hdr O
where I.Order_No = O.Order_No
and O.Payment_Status in ('Pending' , 'Partial') and O.Cust_No=? and O.Store_No= ?");

        $stmt->execute([$cust_no, $store_no, $cust_no, $store_no]);
        $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

        if(!empty($arr)) {
            $msg="Success";
            $data['Order_Details']=$arr;

        } else {
            $msg = 'No Order/Invoices Generated.';
            $status = false;
        }
        return  get_response($msg, $status, $data);
    }

    public function get_retailer_outstanding_bal(Request $request){
        $post = $request->post();
        extract($post);


        /*$query="SELECT cm.Credit_Days,cm.Credit_Limit,sm.Store_Name,cu.Cust_Name FROM `Cust_Store_Master` cm
            join Store_Master sm
            on sm.Store_No = cm.Store_No
            join Cust_Master cu
            on cu.Cust_No=cm.Cust_No
            WHERE cm.Cust_No=".$cust_no." and cm.Store_No=".$store_No."";*/
        $query="select ifnull(cm1.Credit_Days,0) as Credit_Days,ifnull(cm1.Credit_Limit,0) as Credit_Limit,S.Store_Name,C.Cust_Name
	from Store_Master S left join Cust_Store_Master cm  on  S.Store_No = cm.Store_No and cm.Status='A',
		 Cust_Master  C left join Cust_Store_Master cm1  on C.Cust_No = cm1.Cust_No and cm1.Status='A'
	where S.Store_No=".$store_No."
	and   C.Cust_No =".$cust_no."";
        $data = $this->pdo->query($query)->fetch();

        if($data > 0){
            $qury2="SELECT Balance_Amt as CreditAmt,Outstanding_Amt,Outstanding_Balance_Amt from Store_Transaction where Cust_No='".$cust_no."' and Store_No ='".$store_No."' ORDER by Transaction_ID DESC LIMIT 1";
            $data1 = $this->pdo->query($qury2)->fetch();
            if($data1==NULL){
                $result= array(
                    "Credit_Days" 		 		=> $data['Credit_Days'],
                    "Credit_Limit"	 	 		=> $data['Credit_Limit'],
                    "Store_Name" 		 		=> $data['Store_Name'],
                    "Cust_Name" 		 		=> $data['Cust_Name'],
                    "Credit_Balance_Amt" 		=> '0',
                    "Outstanding_Balance_Amt" 	=> '0');

            }else{
                $result= array(
                    "Credit_Days" 				=> $data['Credit_Days'],
                    "Credit_Limit" 				=> $data['Credit_Limit'],
                    "Store_Name"				=> $data['Store_Name'],
                    "Cust_Name" 				=> $data['Cust_Name'],
                    "Credit_Balance_Amt" 		=> $data1['CreditAmt'],
                    "Outstanding_Balance_Amt" 	=> $data1['Outstanding_Balance_Amt']);
            }

            return get_response("Data Found", true, $result);
        }else{
            return get_response("Result not found", false, []);
        }
    }

    public function get_retailer_ledger(Request $request){
        $post = $request->post();
        extract($post);
        $where2 = '';
        $where3 = '';
        $whereTransaction_ID ='';
        $wherestoreNo = '';
        $wheretransaction_Type ='';
        $where = '1=1 ';
        if(isset($transaction_ID)){
            if($transaction_ID!=0)
            {
                $whereTransaction_ID = " and st.Transaction_ID=". $transaction_ID;
            }
        }


        if(isset($Legacy_Transaction_No))
        {
            if($Legacy_Transaction_No == 'Y'){
                $where3  = " and st.`Legacy_Transaction_No` IS  NULL";
            }	else
            {
                $where3  = " and st.Legacy_Transaction_No IS NOT NULL";
            }
        }
        if(isset($transaction_start_date) && isset($transaction_end_date))
        {
            if($transaction_start_date!='0000-00-00' && $transaction_end_date=='0000-00-00'){
                $data['transaction_start_date'] = $transaction_start_date;
                $where2 = " AND DATE_FORMAT(st.Creation_Date,'%Y-%m-%d')= '".$data['transaction_start_date']."'";}

            //if(if(isset($transaction_start_date))
            if($transaction_start_date!='0000-00-00' && $transaction_end_date!='0000-00-00')
            {
                $data['transaction_start_date'] = $transaction_start_date;
                $data['transaction_end_date'] = $transaction_end_date;
                $where2 = " AND DATE_FORMAT(st.Creation_Date,'%Y-%m-%d')>='".$data['transaction_start_date']."'  AND DATE_FORMAT(st.Transaction_Date,'%Y-%m-%d')<='".$data['transaction_end_date']."'";
            }
        }
        if(!isset($transaction_start_date) && !isset($transaction_end_date))
        {
            $where2 = " ";
        }

        if($store_No==0)
        {
            $store_No = '';
        }
        //print_r($where);die;
        if(!empty($store_No) && !empty($cust_No))
        {
            $where .= " AND  st.`Store_No`=".$store_No." and st.Cust_No=".$cust_No;
        }

        else if(!empty($store_No) && empty($cust_No))
        {
            $where .= " AND  st.`Store_No`=".$store_No;
        }

        if( !empty($transaction_Type))
        {
            $wheretransaction_Type = " and   st.`Transaction_Type`=".$transaction_Type;
            $where .=$wheretransaction_Type;

        }

        if(!empty($where2))
        {
            $where .=$where2;
        }
        if(!empty($where3))
        {
            $where .=$where3;
        }

        $where .=$whereTransaction_ID;
        $where .=$wherestoreNo;

        $stmt = $this->pdo->query("SELECT st.Transaction_ID,st.Transaction_Date,st.Transaction_Type,st.Order_No,st.Invoice_No,st.Deposit_Amt,st.Withdraw_Amt,st.Balance_Amt,st.Outstanding_Amt,st.Outstanding_Balance_Amt,sd.Ref_No,sd.Branch_Name,sd.Bank_Name,sd.Deposit_Mode,st.Remark, st.Store_No, sm.Supplier_Store_No, st.Cust_No, csm.Supplier_Retailer_No, st.FSO_No, st.Invoice_No, st.Deposit_Amt, st.Outstanding_Balance_Amt, sd.Branch_Name,DATE_FORMAT(st.Creation_Date,'%Y-%m-%d') as Creation_Date,DATE_FORMAT(st.Transaction_Date,'%Y-%m-%d') as Trans_Date, st.Legacy_Transaction_No
	FROM `Store_Transaction`st
	LEFT JOIN Store_Transaction_Detail sd on st.`Transaction_ID`= sd.Transaction_ID  LEFT JOIN Cust_Store_Master as csm on csm.Cust_No=st.Cust_No and csm.Status='A'  AND csm.Store_No =st.Store_No
	LEFT JOIN  Store_Master as sm on sm.Store_No=st.Store_No where  ".$where." ORDER BY st.Transaction_ID DESC");
        //$stmt->debugDumpParams();
        //die;
        $result_data=$stmt->fetchAll(PDO::FETCH_ASSOC);
        if ($result_data) {
            return get_response("Data Found", true, $result_data);
        } else {
            return get_response("Result not found", false, $result_data);
        }
    }

    public function search_retailer(Request $request){
        $output = array();
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        /*$stmt = $this->pdo->prepare("select Cust_No,Mobile_No,Outlet_Name from Cust_Master
                               where  Status = 'A'
                               and    Mobile_No like ?");*/
        if (!isset($mobile) || $mobile =="" || $mobile==null || $mobile==NULL  ) {
            //Get all retailers mapped to the FSO
            $stmt = $this->pdo->prepare("SELECT DISTINCT Cust_No, Mobile_No,Outlet_Name, Cust_Master.Status as Status , Area_Master.Area_Name ,City_Master.City_Name,
            BBC_Addresses.City_Code as City_Code,
            -- Get_Default_City_For_Cust(Cust_No) as City_Code ,
            License_No , COALESCE(Date(License_Expiry_Date) , '0000-00-00') as License_Expiry_Date
        FROM BBC_Org_Group_Users , Cust_Master
        LEFT Join BBC_Addresses ON BBC_Addresses.User_no = Cust_Master.Cust_No
            AND    BBC_Addresses.Login_Type = 'Buyer'
            AND    BBC_Addresses.Default_Flag = 'A'
            AND    BBC_Addresses.Status = 'A'
            and    Address_Type = 'Delivery'
        LEFT JOIN Area_Master ON Area_Master.Area_Code = BBC_Addresses.Locality
        LEFT JOIN City_Master on City_Master.City_Code = BBC_Addresses.City_Code

        WHERE Org_Group_ID in (
                                SELECT DISTINCT(FSO.Org_Group_ID)
                                FROM BBC_Org_Group_Users FSO
                                INNER JOIN BBC_Org_User_Groups  ON FSO.Org_Group_ID = BBC_Org_User_Groups.ID AND FSO.Store_No = BBC_Org_User_Groups.Store_No
                                INNER JOIN BBC_Org_Group_Days   ON BBC_Org_Group_Days.Org_Group_ID =FSO.Org_Group_ID  AND BBC_Org_Group_Days.Store_No = FSO.Store_No
                                WHERE FSO.Status='A'
                                AND FSO.User_No = ?
                                AND FSO.Login_Type = ?
                                AND BBC_Org_Group_Days.Days_For='Order'
                                AND BBC_Org_Group_Days.Status='A'
                            )
        AND BBC_Org_Group_Users.Status='A'
        AND BBC_Org_Group_Users.Login_Type='Buyer'
        AND Cust_Master.Cust_No = BBC_Org_Group_Users.User_No
        AND Cust_Master.Status  ='A'
        ORDER BY Cust_Master.Outlet_Name ASC ;");
            $stmt->execute([$user_no,$login_type]);
        }

        else   {

            $search_string='%'.str_replace(' ','%',$mobile).'%';

            //Search in Cust Master
            $stmt = $this->pdo->prepare("SELECT Cust_No, Mobile_No, Outlet_Name, Cust_Master.Status,  Area_Master.Area_Name,
                                         BBC_Addresses.City_Code as City_Code, City_Master.City_Name,
                                    --  Get_Default_City_For_Cust(Cust_Master.Cust_No) as City_Code ,
                                    License_No , COALESCE(Date(License_Expiry_Date) , '0000-00-00') as License_Expiry_Date
                                FROM Cust_Master
                                LEFT JOIN BBC_Addresses ON BBC_Addresses.User_no = Cust_Master.Cust_No

                                    AND    BBC_Addresses.Login_Type = 'Buyer'
                                    AND    BBC_Addresses.Default_Flag = 'A'
                                    AND    BBC_Addresses.Status = 'A'
                                    and    Address_Type = 'Delivery'
                                    LEFT JOIN Area_Master ON Area_Master.Area_Code = BBC_Addresses.Locality
                                    LEFT JOIN City_Master ON City_Master.City_Code = BBC_Addresses.City_Code

                            where  Mobile_No LIKE ? OR Outlet_Name LIKE ?
                            ORDER BY Cust_Master.Outlet_Name ASC ;");
            $stmt->execute([$search_string,$search_string]);
        }
        // $stmt->debugDumpParams();
        $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
        // print_r($arr);
        if(!empty($arr)) {
            foreach($arr as $key=>$details){
                $data[$key]['Cust_No']      = $details['Cust_No'];
                $data[$key]['Status']       = $details['Status'];
                $data[$key]['Area_Name']    = $details['Area_Name'];
                $data[$key]['Mobile_No']    = $details['Mobile_No'];
                $data[$key]['Outlet_Name']  = $details['Outlet_Name'];
                $data[$key]['City_Code']  = $details['City_Code'];
                $data[$key]['City_Name']  = $details['City_Name'];
                $data[$key]['License_No']  = $details['License_No'];
                $data[$key]['License_Expiry_Date']  = $details['License_Expiry_Date'];
            }
            $msg = 'Success';
            $output['retailers'] = $data;
        } else {
            $msg = 'No Retailers found for searched Mobile No';
            $status = false;
        }

        return  get_response($msg, $status, $output);
    }

    public function get_retailer_suppliers(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        $param_array = array();
        $where = '';

        if (isset($User_No) && $User_No > 0) {

            if (isset($LoginType)) {

                if ($LoginType == "Self") {

                    $param_array[':user_no'] = $User_No;

                    $rstmt = $this->pdo->prepare("SELECT  DISTINCT Store_Master.Store_No store_no,
                Cust_Store_Master.Cust_No as cust_no,
                '' as Login_Type ,
                Store_Master.Store_Name store_name,
                Store_Master.City_Code city_code,
                Store_Master.State_Code state_code,
                Store_Master.Area_Code area_code,
                Store_Master.Delivery_Limit delivery_limit,
                Store_Master.Min_Order_Amt min_order_amt,
                Store_Master.Min_Order_Amt_Without_Chrg min_order_amt_without_chrg,
                Store_Master.Delivery_Charge delivery_charge,
                Store_Master.Ratings ratings,
                Store_Master.Image_Url image_url,
                Store_Master.Status status,
                Store_Master.Delivery_Limit delivery_limit,
                Store_Master.Latitude latitude,
                Store_Master.Longitude longitude,
                Store_Master.Split_Order Split_Order,
                Store_Master.Split_Order_Rule Split_Rule,
                Store_Master.Seller_Type,
                '' promotional_message,
                '' Order_Edit,
                '' Order_Edit_Max_Percent,
                '' Offer_Edit,
                '' Offer_Edit_Max_Percent
            FROM Cust_Store_Master
        INNER JOIN Store_Master ON Cust_Store_Master.Store_No = Store_Master.Store_No
    where  Cust_Store_Master.Cust_No = :user_no
    and    Store_Master.Status='A'
    and Cust_Store_Master.Status='A'");
                } else {
                    $param_array[':user_no'] = $User_No;
                    $param_array[':fso_no']  =$FSO_No; //Added by Meenal Barve Branch sss-sendcollection
                    // $rstmt = $this->pdo->prepare("Select Store_Master.Store_Name from Store_Master where Store_No = :userno; ");
                    $rstmt = $this->pdo->prepare("SELECT DISTINCT Store_Master.Store_No store_no,
            Store_Master.Store_No store_no,
            BBC_Org_Group_Users.User_No as cust_no,
            BBC_Org_Group_Users.Login_Type as login_type,
                Store_Master.Store_Name store_name,
                BBC_Addresses.City_Code city_code,
                BBC_Addresses.State_Code state_code,
                BBC_Addresses.Locality area_code,
                Store_Master.Delivery_Limit delivery_limit,
                Store_Master.Min_Order_Amt min_order_amt,
                Store_Master.Min_Order_Amt_Without_Chrg min_order_amt_without_chrg,
                Store_Master.Delivery_Charge delivery_charge,
                Store_Master.Ratings ratings,
                Store_Master.Image_Url image_url,
                Store_Master.Status status,
                Store_Master.Delivery_Limit delivery_limit,
                BBC_Addresses.Latitude latitude,
                BBC_Addresses.Longitude longitude,
                Store_Master.Split_Order Split_Order,
                Store_Master.Split_Order_Rule Split_Rule,
                Store_Master.Seller_Type,
                '' promotional_message,
                ifnull(Get_Order_Amt_Edit_Priv(Store_Master.Store_No,:fso_no,'FSO'),'') Order_Edit,
                ifnull(Get_Order_Amt_Edit_Percent(Store_Master.Store_No,:fso_no,'FSO'),'') Order_Edit_Max_Percent,
                ifnull(Get_Offer_Price_Edit_Priv(Store_Master.Store_No,:fso_no,'FSO'),'') Offer_Edit,
                ifnull(Get_Offer_Price_Edit_Percent(Store_Master.Store_No,:fso_no,'FSO'),'') Offer_Edit_Max_Percent

        FROM BBC_Org_Group_Users
    INNER JOIN Store_Master ON BBC_Org_Group_Users.Store_No = Store_Master.Store_No
    INNER JOIN BBC_Addresses ON BBC_Org_Group_Users.Store_No = BBC_Addresses.User_No AND BBC_Addresses.Login_Type='Seller' AND BBC_Addresses.Address_ID=Get_Registered_Address(BBC_Org_Group_Users.Store_No)
where BBC_Org_Group_Users.Status='A'
AND BBC_Org_Group_Users.User_No = :user_no
AND BBC_Org_Group_Users.Login_Type = 'Buyer'
AND Store_Master.Store_No IN ( Select Store_No from BBC_Org_Group_Users U
                               WHERE  U.User_No =:fso_no
                               AND    U.Login_Type ='FSO'
                               AND    U.Status='A')
and   Store_Master.Status='A'");
                }

                try {
                    $arr = array();
                    $rstmt->execute($param_array);
                    // $rstmt->debugDumpParams(); die();
                    $arr = $rstmt->fetchAll(PDO::FETCH_ASSOC);

                    $supplier_count = 0;
                    $storeids = array();

                    if (count($arr) > 0) {

                        $supplier_count = count($arr);

                        // get promotional message for Store

                        // array of all stores for use with promotional message query.
                        foreach ($arr as $key => $val) {
                            array_push($storeids, $arr[$key]['store_no']);
                        }

                        $in = str_repeat('?,', count($storeids) - 1) . '?';
                        $sqlsmt = "SELECT Store_No store_no, group_concat(`Store_Offer_Msg`, '                    ') as promotional_message FROM `Store_Promo_Messages` WHERE `Store_No` in ($in) group by `Store_No`";

                        $stm = $this->pdo->prepare($sqlsmt);
                        $stm->execute($storeids);
                        $promoarr = $stm->fetchAll(PDO::FETCH_ASSOC);

                        foreach ($arr as $key => $val) {
                            foreach ($promoarr as $promokey => $promoval) {
                                if ($arr[$key]['store_no'] == $promoarr[$promokey]['store_no']) {
                                    $arr[$key]['promotional_message'] = trim($promoarr[$promokey]['promotional_message']);
                                }
                            }
                        }

                        $data['result'] = $arr;
                        $data['supplier_count'] = $supplier_count;
                        $msg = "Success";
                        $status = true;

                    } else {
                        $msg = "Data not found";
                        $data['supplier_count'] = "0";
                        //$data = array();
                        $status = true;
                    }

                } catch (PDOException $e) {
                    $status = false;
                    $data = $e->getMessage();
                    return get_response("Something went wrong", $status, $data);
                }

            } else {
                // Login_Type incorrect
                $msg = "Something went wrong";
                $data = "Login_Type incorrect!!";
                $status = false;
            }

        } else { // CustNo not passed

            $msg = "Something went wrong";
            $data = "Incorrect or missing User!!";
            $status = false;

        }

        return get_response($msg, $status, $data);
    }

    // { "User_No" : "" , "LoginType" : "" , "day_num" : 0}
    public function get_daywise_retailers(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        $param_array = array();
        $where = '';
        $where1 = ''; //mmb-fso-searchperformance

        $page = $Page;
        if ($page == "0") {
            $start = 0;
            $limit = 10; //for Pagination 10 per page
        } else {
            $start = $page * 10;
            $limit = 10; //for Pagination 10 per page
        }

        if (isset($User_No) && $User_No > 0) {

            if (isset($LoginType)) {

                $param_array[':user_no'] = $User_No;
                $param_array[':login_type'] = $LoginType;

                if ($LoginType == "DO") {
                    $param_array[':daysfor'] = 'Delivery';
                } else {
                    $param_array[':daysfor'] = 'Order';
                }

                if (isset($day_num)) {

                    if ($day_num == 0) {
                        // Get all the retailers regardless of Days
                    } else {
                        // Get the retailers for the given day of week.
                        $param_array[':day_num'] = $day_num;
                        $where .= " BBC_Org_Group_Days.Day_Num = :day_num AND ";
                    }
                    //mmb-fso-searchperformance
                    if (isset($Cust_Name) ) {
                        //added to search for utfmb4 characterset also
                        //$convert_cname = mb_convert_encoding($Cust_Name, 'UTF-8', 'Windows-1252');
                        //$param_array[':c_name'] = $convert_cname;

                        $param_array[':c_name'] = $Cust_Name;
                        $where1 .= " (CM.Outlet_Name like  CONCAT('%', :c_name, '%') OR CM.Mobile_No like CONCAT('%', :c_name, '%') ) AND ";
                        //$where1 .= " AND CM.Outlet_Name like  'Ramesh%' ";
                    }
                    else {
                        $fsoname = '';
                        $stmt2 = $this->pdo->prepare("select FSO_Name from FSO_Master where FSO_No=?");
                        $stmt2->execute([$User_No]);
                        $fso_data = $stmt2->fetch(PDO::FETCH_ASSOC);
                        if($fso_data){
                            $fsoname = $fso_data['FSO_Name'] ;
                        }


                        if (strtolower($fsoname) == "customer support%" || strtolower($fsoname)=="customer care" || strtolower($fsoname)=="customer service")
                            $where1 .= " CM.Creation_Date >= curDate() AND ";
                    }


                    $where .= " 1 = 1 ";
                    $where1 .= " 1 = 1 " ;

                    try {



                        $rstmt = $this->pdo->prepare("WITH cte as
                ( SELECT FSO.Org_Group_ID Org_Group_ID, FSO.Store_No, FSO.User_No, FSO.Login_Type, FSO.Status, BBC_Org_Group_Days.Day_Num day_num
                FROM BBC_Org_Group_Users FSO
                INNER JOIN BBC_Org_User_Groups  ON FSO.Org_Group_ID = BBC_Org_User_Groups.ID AND FSO.Store_No = BBC_Org_User_Groups.Store_No
                INNER JOIN BBC_Org_Group_Days   ON BBC_Org_Group_Days.Org_Group_ID =FSO.Org_Group_ID  AND BBC_Org_Group_Days.Store_No = FSO.Store_No
                WHERE FSO.Status='A' AND
                FSO.User_No = :user_no AND
                FSO.Login_Type = :login_type AND
                BBC_Org_Group_Days.Status='A' AND
                BBC_Org_Group_Days.Days_For= :daysfor AND " . $where . "
                )
                SELECT CM.Cust_No,'' FSO_No,  Mobile_No as Cust_Name,Outlet_Name,BA.Latitude as Latitude,BA.Longitude as Longitude,COALESCE(GROUP_CONCAT(OH.Order_No),'') as Order_No,COALESCE((CC.City_Code),'') as City_Code,COALESCE((CC.City_Name),'') as City_Name , CM.License_No as License_No , COALESCE(Date(CM.License_Expiry_Date) , '0000-00-00') as License_Expiry_Date,CM.Speciality_Id as Speciality_Id
                from BBC_Org_Group_Users seller
                inner join cte on cte.Org_Group_ID = seller.Org_Group_ID and seller.Status='A' and seller.Login_Type = 'Buyer'
                inner join Cust_Master CM on CM.Cust_No = seller.User_No and CM.Status = 'A' AND " . $where1 ."
                left join Order_Hdr   OH on OH.Cust_No = seller.User_No and Order_Date = curdate()
                left join BBC_Addresses BA on BA.User_No= seller.User_No and BA.Default_Flag='A' and BA.Login_Type='Buyer' AND BA.Address_Type='Delivery'
                left join City_Master as CC on CC.City_Code=BA.City_Code and CC.Status = 'Y'
                group by CM.Cust_No,Mobile_No ,Outlet_Name,BA.Latitude,BA.Longitude order by Outlet_Name ASC limit ".$start.",".$limit."
                "); // fso no removed from group by


                        $arr = array();
                        $rstmt->execute($param_array);
                        $arr = $rstmt->fetchAll(PDO::FETCH_ASSOC);
                        //print_r($rstmt);
                        // $rstmt->debugDumpParams();

                        //die;
                        $tstmt = $this->pdo->prepare("WITH cte as
                ( SELECT FSO.Org_Group_ID Org_Group_ID, FSO.Store_No, FSO.User_No, FSO.Login_Type, FSO.Status, BBC_Org_Group_Days.Day_Num day_num
                FROM BBC_Org_Group_Users FSO
                INNER JOIN BBC_Org_User_Groups  ON FSO.Org_Group_ID = BBC_Org_User_Groups.ID AND FSO.Store_No = BBC_Org_User_Groups.Store_No
                INNER JOIN BBC_Org_Group_Days   ON BBC_Org_Group_Days.Org_Group_ID =FSO.Org_Group_ID  AND BBC_Org_Group_Days.Store_No = FSO.Store_No
                WHERE FSO.Status='A' AND
                FSO.User_No = :user_no AND
                FSO.Login_Type = :login_type AND
                BBC_Org_Group_Days.Status='A' AND
                BBC_Org_Group_Days.Days_For= :daysfor AND " . $where . "
                )
                SELECT CM.Cust_No,'' FSO_No,  Mobile_No as Cust_Name,Outlet_Name,BA.Latitude as Latitude,BA.Longitude as Longitude,COALESCE(GROUP_CONCAT(OH.Order_No),'') as Order_No,COALESCE((CC.City_Code),'') as City_Code,COALESCE((CC.City_Name),'') as City_Name , CM.License_No as License_No , COALESCE(Date(CM.License_Expiry_Date) , '0000-00-00') as License_Expiry_Date,CM.Speciality_Id as Speciality_Id
                from BBC_Org_Group_Users seller
                inner join cte on cte.Org_Group_ID = seller.Org_Group_ID and seller.Status='A' and seller.Login_Type = 'Buyer'
                inner join Cust_Master CM on CM.Cust_No = seller.User_No and CM.Status = 'A' AND " . $where1 ."
                left join Order_Hdr   OH on OH.Cust_No = seller.User_No and Order_Date = curdate()
                left join BBC_Addresses BA on BA.User_No= seller.User_No and BA.Default_Flag='A' and BA.Login_Type='Buyer' AND BA.Address_Type='Delivery'
                left join City_Master as CC on CC.City_Code=BA.City_Code and CC.Status = 'Y'
                group by CM.Cust_No,Mobile_No ,Outlet_Name,BA.Latitude,BA.Longitude
                order by Outlet_Name ASC");
                        $tarr = array();
                        $tstmt->execute($param_array);
                        $tarr = $tstmt->fetchAll(PDO::FETCH_ASSOC);
                        $count_main = 0;
                        if (!empty($tarr)){
                            // $datacount=mysqli_fetch_assoc($resultalla);
                            $count_main = count($tarr);//product count from the loop
                        }
                        $max_page_no = 0;
                        if($count_main > 0){
                            $max_page_no = ceil($count_main/10);
                        }

                        if (count($arr) > 0) {
                            $data['result'] = $arr;
                            $data['pageno'] = $page;
                            $data['totalpages']=$max_page_no;
                            $data['totalrecords']=$count_main;

                            $msg = "Success";
                            $status = true;
                        } else {
                            $msg = "Data not found";
                            $data = array();
                            $status = false;
                        }
                    } catch (PDOException $e) {
                        $status = false;
                        $data = $e->getMessage();
                        return get_response("Something went wrong", $status, $data);
                    }

                } else {  // day number incorrect
                    $msg = "Something went wrong";
                    $data = "Day Number incorrect!!";
                    $status = false;
                }

            } else { // Login_Type incorrect
                $msg = "Something went wrong";
                $data = "Login_Type incorrect!!";
                $status = false;
            }

        } else { // User not passed
            $msg = "Something went wrong";
            $data = "Incorrect or missing User!!";
            $status = false;

        }

        return get_response($msg, $status, $data);
    }

    /****
    retailer_signup
    1. insert retailer in inactive status
    2. add dummy fso entry with store no, inserted retailer no in Cust_FSO_Lookup
    3. send sms on retailers mobile
     ****/

    /******** JSON INPUT
    {"name":"shivshakti", "mobile":"9898989898","password":"daya","gstin":"54lrgd57trelre","pan":"fldsfjl","channel":"M","store_no" : "1", "cust_type": "I" or "B"}
     ********/
    public function retailer_signup(Request $request){
        $post = $request->post();
        extract($post);

        $status = true;
        $data = [];
        //$storeNo = $_REQUEST['store_id'] ?? '';

        ####Check retailer is exists
        $isExists = $this->checkRetailerExists($this->pdo, $post);

        if($isExists == false){
            ##### Add retailer into db with inactive status
            $custNo = $this->insertRetailer($this->pdo, $post);
            if($custNo > 0) {
                $msg = "Procespective Customer Added";
            } else {
                $msg = "Something Went Wrong";
                $status = false;
            }
        } else {
            $msg = $isExists;
            $status = false;

        }
        return get_response($msg, $status, $data);
    }

    /****
     * checkRetailerExists
     * @param: $pdo : is pdo object
     * @param: $post : is post input data array
     * return error msg or false
     ****/
    private function checkRetailerExists($pdo, $post){
        extract($post['cust_details']);
        $msg = '';
        //Added by Meenal B. 28th September 2018
        if ($cust_type=='I') {
            $append_name = 'customer';
            $query="select * from Cust_Master where Mobile_No='$mobile'";
        }
        else {
            $append_name = 'outlet';
            $query="select * from Cust_Master where Mobile_No='$mobile' and Outlet_Name='$outlet_name'";
        }

        $data =$pdo->query($query)->fetchAll(PDO::FETCH_ASSOC);
        if(count($data) > 0){
            $data = $data['0'];
            if($data['Status'] == 'I' && $data['Excluded'] == 'Y'){
                $msg = 'You are a registered '.$append_name.' but your account has not been activated yet. Please contact Customer care to activate your account';
            } else if($data['Status'] == 'I' && $data['OTP_Count'] < 5){
                $msg = 'You are a registered '.$append_name.' but your account has not been activated yet. Please enter OTP received on your number to activate your account';
            } else if($data['Status'] == 'I' && $data['OTP_Count'] >= 5){
                $msg = 'You are a registered '.$append_name.' but your account has not been activated yet. Please contact Customer care to activate your account';
            } else {
                $msg = 'Your number is already registered and activated with us. Please login to continue';
            }
            return $msg;
        } else {
            return false;
        }

    }

    /****
     * insertRetailer
     * insert reatailer, insert mapping, send sms
     * @param: $pdo : is pdo object
     * @param: $post : is post input data array
     * return cust_no or false
     ****/
    private function insertRetailer($pdo, $post){
        extract($post['cust_details']);

        //$password=md5(trim($password));
        $password=trim($password); //Removed MD5 as Android app is already converting password into MD5
        $otp = str_pad(mt_rand(1000, 9999), 4, '0', STR_PAD_LEFT);
        $otp_count = 1;
        $excluded = 'N';
        $status         = 'I';
        if($channel == '') $channel = 'M';
        $creation_date  = date('Y-m-d');
        $creation_time  = date('H:i:s',strtotime('+5 hours 30 minutes'));
        $created_by     = '0';
        $change_date    = $creation_date;
        $change_time    = $creation_time;
        $changed_by     = $created_by;
        $cust_type      = $cust_type; //Added by Meenal B. 27th Sep 2018 cust_type (I/B)
        $ref_code       = $ref_code; //Added by Meenal B. 15th Jan 2019 ref_code

        /*if ($cust_type =='I')
        $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status) values('$name','$name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code' , '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status')";
        else
        $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status) values('$name','$outlet_name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code' , '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status')";*/

        if ($cust_type =='I'){
            ### Insert as indivisual
            $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status) values('$name','$name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code', '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status')";
        } else {
            ### Insert as a Outlet
            $query="insert into Cust_Master(Cust_Name,Outlet_Name, Mobile_No,Password,OTP,OTP_Count,Excluded,Channel,GSTIN, PAN,Supplier_Retailer_No, Creation_Date,Creation_Time,Created_By,Change_Date,Change_Time,Changed_By,Status) values('$name','$outlet_name', '$mobile','$password','$otp','$otp_count','$excluded','$channel', '$gstin', '$pan' , '$ref_code' , '$creation_date','$creation_time','$created_by','$change_date','$change_time','$changed_by','$status')";

            ### Update otp to all outlet with the same mobile number ###
            $this->updateOutletsOtp($pdo, $otp, $mobile);
        }
        if($pdo->query($query)){
            $custNo=$pdo->lastInsertId();

            ##### Add retailer store mapping #####
            $this->retailerStoreFSOMapping($pdo, $custNo, $store_no);

            ##### Send SMS #####
            /*$smsMsg = generate_sms(OTP, array($otp));
            Submit(SMS_HOST,SMS_PORT,SMS_USERNAME,SMS_PASSWORD,SMS_SENDER, $smsMsg, $mobile,SMS_MSG_TYPE,SMS_DLR);*/
            SubmitSMS($mobile, 'OTP', array($otp));

            return $custNo;
        } else {
            return false;
        }

    }

    /****
     * retailerStoreFSOMapping
     * insert retailer store fso mapping with dummy fso no : 1
     * @param: $pdo : is pdo object
     * @param: $custNo : cust_no/ retailer no
     * @param: $store_no : store no
     ****/
    private function retailerStoreFSOMapping($pdo, $custNo, $store_no){
        $creation_date  = date('Y-m-d H:i:s',strtotime('+5 hours 30 minutes'));
        $created_by     = '1';
        $status = 'A';

        /*$query = "INSERT INTO `Cust_FSO_Lookup` (`Cust_No`, `Store_No`, `FSO_No`, `Status`, `Creation_Date`, `Created_By`, `Changed_Date`, `Changed_By`) VALUES ('$custNo', '$store_no', '1', 'A', '$creation_date', '$created_by', '$creation_date', '$created_by')";*/
        //Added by Meenal Barve 15th April 2019 added 0 to new column Supplier_Legacy_No
        $query = "INSERT INTO Cust_Store_Master
     VALUES ('$custNo',
            '$store_no',
             '0',
             '0',
             '0',
             '$status',
             '$creation_date',
             '$created_by',
             '$creation_date',
             '$created_by')";
        $pdo->query($query);
    }

    /****
     * updateOutletsOtp
     * Update otp to all outlets with the same mobile number
     * @param: $pdo : is pdo object
     * @param: $mobile : mobile no
     ****/
    private function updateOutletsOtp($pdo, $otp, $mobile){

        $changedDate = date('Y-m-d');
        $changedTime = date('H:i:s',strtotime('+5 hours 30 minutes'));
        $changedBy = '0';

        $stmt = $pdo->prepare("update Cust_Master set OTP=?, OTP_Count=?, Change_Date=?, Change_Time=?, Changed_By=?  where Mobile_No=?");
        $stmt->execute(array($otp, 1, $changedDate, $changedTime, $changedBy, $mobile));
        //$stmt->debugDumpParams();
    }




}
