<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class ReturnOrderBatchController extends Controller
{
    public function returnorder_withbatch(Request $request){
        // extract the input from input json string to an object
        $post = $request->post();
        extract($post);

        $order_info  = $post['order_info'];
        $item_detail = $post['item_detail'];

        // print_r($order_info);
        // print_r($item_detail);

        // Return order actions and statuses

        // Customer
        // Delivered and action Return Request                Full              Expected - new order with status  “Return Request”
        // Delivered and action Return Request                Partial         Expected - new order with status  “Return Request”

        // FSO
        // Delivered and action Goods Collected                Full              Expected - new order with status  “Goods Collected”
        // Delivered and action Goods Collected                Partial          Expected - new order with status  “Goods Collected”

        // Return Request and action Goods Collected        Full              Expected - order status changed to “Goods Collected”
        // Return Request and action Goods Collected        Partial          Expected - order status changed to  “Goods Collected”
        // Return Request and action Reject Return Request    Full              Expected - order status changed to “Reject Return”

        // echo "<pre>";
        // print_r($order_info);
        // validate the input

        $isinputvalid = $this->validate_order_input($order_info, $item_detail);

        if ($isinputvalid) {
            $original_orderno = $order_info['Order_No'];
            $ReturnType = $order_info['ReturnType'];
            $CurrentOrderStatus = $order_info['CurrentOrderStatus'];
            //Added by Meenal B. to get Logged in User No
            $Login_Type=$order_info['Cust_Type'];
            if ($order_info['Cust_Type']=="Self")
                $UserNo=$order_info['Cust_No'];
            else
                $UserNo=$order_info['FSO_No'];
            $status = true;
        } else {
            $msg = "Invalid input for return with batch";
            $status = false;
            $data = $msg;
            return get_response("Something went wrong", $status, $data);
        }

        // if OrderAction is one of  "Accept Return Request"  or "Reject Return Request"
        // then
        // update return order hdr [ status, return reason & description and summary ]
        // partialFlag == 'Y' then
        //      update return order items [ quantity, return reason type & description ]
        //      update return order hdr summary
        // update original order header

        // else if OrderAction is one of "Return Request" or "Return"
        // then generate a new order id
        // create return order hdr
        // partialFlag == 'Y'  create partial return order items
        //                        else create return order all items
        // update original order header
        // create order address
        // add transaction entry

        // create return order history

        try {
            if (!empty($order_info)) {

                $OrderAction = $order_info['OrderAction'];

                // echo "$CurrentOrderStatus and $OrderAction";

                // CurrentOrderStatus

                if (($CurrentOrderStatus != "Delivered") && ($OrderAction == "Goods Collected" || $OrderAction == "Reject Return Request")) {

                    // echo "In update.";
                    $return_order_id = $order_info['Order_No'];

                    // update the return order status, return reason type & description and return order items.
                    $ans = updateReturnOrderHdrForBatch($this->pdo, $order_info);
                    if ($ans) {
                        if ($ReturnType == 'Order') {
                            //      for each recd input order items
                            //      insert return item in Order_Itm for this return order no.
                            $ans = '';
                            $ans = updatePartialReturnOrderItemsForBatch($this->pdo, $order_info, $item_detail, $return_order_id);
                            if ($ans) {
                                $msg = "Updated order items for partial return order $return_order_id";
                                $status = true;
                                $ans = '';

                                $ans = updatePartialReturnOrderItemBatch($this->pdo, $order_info, $item_detail, $return_order_id);
                                if ($ans) {
                                    $msg = "deleted old item batch detail for return order $return_order_id ";
                                    $status = true;
                                    $ans = '';
                                    $ans = createOpenReturnOrderItemBatch($this->pdo, $order_info, $item_detail, $return_order_id,$ReturnType);
                                    if ($ans) {
                                        $msg = "Created  the new order items batch details for return order $return_order_id";
                                        $status = true;
                                    } else {
                                        $msg = "Failed to create new item batch details for full return order $return_order_id";
                                        $status = false;
                                        $this->pdo->rollback();
                                        return get_response($msg, $status, $data);
                                    }
                                } else {
                                    $msg = "Failed to delete old item batch detail for return order $return_order_id.";
                                    $status = false;
                                    $data = '';
                                    return get_response("Something went wrong", $status, $data);
                                }

                                $ans = '';
                                $original_orderno = get_original_order_no_ForBatch($this->pdo, $return_order_id);

                                //if (isset($original_orderno)) {
                                //$ans = updateReturnOrderHdrSummaryForBatch($this->pdo, $original_orderno, $return_order_id);
                                $ans =updateOpenReturnOrderHdrSummary($this->pdo, $order_info, $item_detail, $return_order_id);
                                if ($ans) {
                                    $msg = "Updated order header for partial return order $return_order_id";
                                    // echo $msg;
                                    $status = true;
                                } else {
                                    $msg = "Failed to update order header for partial return order $return_order_id";
                                    // echo $msg;
                                    $status = false;
                                    $data = '';
                                    return get_response("Something went wrong", $status, $data);
                                }
                                /*} else {
                                    $msg = "Failed to get original order no for return order $return_order_id";
                                    // echo $msg;
                                    $status = false;
                                    $data = '';
                                    return get_response("Something went wrong", $status, $data);

                                }*/
                            } else {
                                $msg = "Failed to update order items for partial return order $return_order_id";
                                // echo $msg;
                                $status = false;
                                $data = '';
                                return get_response("Something went wrong", $status, $data);
                            }
                        }
                        // update original order header
                        // Set Return_goods flag if the return order is accepted.
                        $ans = '';
                        $ans = updateOriginalOrderHdrcolsForBatch($this->pdo, $return_order_id, $OrderAction);
                        if ($ans) {
                            $msg = "Updated original order return goods flag for return order $return_order_id ";
                            $status = true;
                        } else {
                            $msg = "Failed to update original order return goods flag for return order $return_order_id.";
                            $status = false;
                            $data = '';
                            return get_response("Something went wrong", $status, $data);
                        }

                        // create the order history entry for the return order.
                        //
                        $ans = '';
                        $ans = createReturnOrderHistoryForBatch($this->pdo, $return_order_id, $OrderAction, $Login_Type ,$UserNo); //Login Type and User No added by Meenal Barve
                        if ($ans) {
                            $msg = "Created order history entry for return order $return_order_id ";
                            $status = true;
                        } else {
                            $msg = "Failed to create order history entry for return order $return_order_id";
                            $status = false;
                            $data = '';
                            return get_response("Something went wrong", $status, $data);
                        }
                    } else {
                        $data = '';
                        $status = false;
                        $data = "msg " . "Return Order $return_order_id could not be updated.";
                        return get_response("Something went wrong", $status, $data);

                    }

                } else {
                    // if input is valid then generate a new order no and increment the current id
                    $return_order = $this->generate_new_orderid_ForBatch($this->pdo);

                    // echo "after return order generated $return_order.";

                    if (!empty($return_order)) {
                        $return_order_id = $return_order['returnOrderNo'];
                        $reference_ID = $return_order['reference_ID'];
                    } else {
                        $msg = 'Return Order could not be created.';
                        $status = false;
                        $data = '';
                        return get_response($msg, $status, $data);
                    }

                    // echo "after return order generated $return_order.";

                    // echo "return order id is $return_order_id";

                    if (!is_null($return_order_id)) {
                        // begin transaction
                        $this->pdo->beginTransaction();
                        $isTrans=0;
                        $isTrans++;
                        //      insert return order row in Order_Hdr from original order id and recd input data.
                        //      this function returns true or false depending on success or failure.

                        if ($ReturnType == 'Order')
                            $ans = $this->createReturnOrderHdrForBatch($this->pdo, $order_info, $return_order_id, $reference_ID);
                        else
                            $ans = $this->createOpenReturnOrderHdr($this->pdo, $order_info, $return_order_id, $reference_ID);
                        if ($ans) {
                            if ($ReturnType == 'Order') {
                                //      for each recd input order items
                                //      insert return item in Order_Itm for this return order no.
                                //This is common for Full or Partial
                                $ans = '';
                                $ans = $this->createPartialReturnOrderItemsForBatch($this->pdo, $order_info, $item_detail, $return_order_id);
                                if ($ans) {
                                    $msg = "Created partial order items for return order $return_order_id";
                                    $status = true;
                                } else {
                                    $msg = "Failed to create order items for partial return order $return_order_id";
                                    $status = false;
                                    $this->pdo->rollback();
                                    return get_response($msg, $status, $data);
                                }
                            } else {
                                // create open return
                                $ans = '';
                                $ans = $this->createOpenReturnOrderItems($this->pdo, $order_info, $item_detail, $return_order_id);
                                if ($ans) {
                                    $msg = "Created all the order items for return order $return_order_id";
                                    $status = true;
                                } else {
                                    $msg = "Failed to create order items for full return order $return_order_id";
                                    $status = false;
                                    $this->pdo->rollback();
                                    return get_response($msg, $status, $data);

                                }
                            }

                            //This code is for batch items

                            /*if ($ReturnType == 'Order') {
                                //      for each recd input order items
                                //      insert return item in Order_Itm for this return order no.
                                //This is common for Full or Partial
                                $ans = '';
                                $ans = createPartialReturnOrderItemBatch($this->pdo, $order_info, $item_detail, $return_order_id);
                                if ($ans) {
                                    $msg = "Created partial order items for return order $return_order_id";
                                    $status = true;
                                } else {
                                    $msg = "Failed to create order items for partial return order $return_order_id";
                                    $status = false;
                                }
                            } else {*/
                            // create open return
                            $ans = '';
                            $ans = $this->createOpenReturnOrderItemBatch($this->pdo, $order_info, $item_detail, $return_order_id,$ReturnType);
                            if ($ans) {
                                $msg = "Created all the order items for return order $return_order_id";
                                $status = true;
                            } else {
                                $msg = "Failed to create order items for full return order $return_order_id";
                                $status = false;
                                $this->pdo->rollback();
                                return get_response($msg, $status, $data);
                            }
                            //}

                            //      calculate the weight, amount etc... and
                            //      update Order_Hdr with the calculated data.
                            $ans = '';
                            if ($ReturnType == 'Order')
                                $ans = $this->updateReturnOrderHdrSummaryForBatch($this->pdo, $original_orderno, $return_order_id);
                            else
                                $ans = $this->updateOpenReturnOrderHdrSummary($this->pdo, $order_info, $item_detail, $return_order_id);

                            if ($ans) {
                                $msg = "Updated return order $return_order_id with summary of return order items. ";
                                $status = true;
                            } else {
                                $msg = "Failed to update the return order $return_order_id with summary partial order items.";
                                $status = false;
                                if ($isTrans > 0) {
                                    $this->pdo->rollback();
                                    $isTrans--;
                                }
                                return get_response("Something went wrong", $status, $data);

                            }

                            // update the original order with the return order number.
                            // Set Return_goods flag if the return order is accepted.
                            if ($ReturnType == 'Order') {
                                $ans = '';
                                $ans = $this->updateOriginalOrderHdrForBatch($this->pdo, $original_orderno, $return_order_id, $OrderAction);
                                if ($ans) {
                                    $msg = "Updated original order $original_orderno ";
                                    $status = true;
                                } else {
                                    $msg = "Failed to update the original order $original_orderno.";
                                    $status = false;
                                    if ($isTrans > 0) {
                                        $this->pdo->rollback();
                                        $isTrans--;
                                    }
                                    return get_response("Something went wrong", $status, $data);

                                }
                            }

                            // create the order history entry for the return order for both return types
                            //
                            $ans = '';
                            $ans = $this->createReturnOrderHistoryForBatch($this->pdo, $return_order_id, $OrderAction ,$Login_Type ,$UserNo); //Login Type and User No added by Meenal Barve
                            if ($ans) {
                                $msg = "Created order history entry for return order $return_order_id ";
                                $status = true;
                            } else {
                                $msg = "Failed to create order history entry for return order $return_order_id.";
                                $status = false;
                                if ($isTrans > 0) {
                                    $this->pdo->rollback();
                                    $isTrans--;
                                }
                                return get_response("Something went wrong", $status, $data);
                            }

                            $ans = '';
                            if ($ReturnType == 'Order')
                                $ans = $this->createOrderAddressForBatch($this->pdo, $original_orderno, $return_order_id, $order_info);
                            else
                                $ans = $this->createOpenOrderAddress($this->pdo, $original_orderno, $return_order_id, $order_info);
                            if ($ans) {
                                $msg = "Created order addresses for return order $return_order_id ";
                                $status = true;
                            } else {
                                $msg = "Failed to create order addresses for return order $return_order_id.";
                                $status = false;
                                if ($isTrans > 0) {
                                    $this->pdo->rollback();
                                    $isTrans--;
                                }
                                return get_response("Something went wrong", $status, $data);

                            }

                            // end transaction
                            $this->pdo->commit();
                            $isTrans--;
                            $status = true;
                            $msg = "Success";
                            $data = $return_order_id;

                        } // if createReturnOrderHdr has been successful
                        else {
                            $msg = "Error creating return order";
                            $status = false;
                            $data = $msg;
                            return get_response("Something went wrong", $status, $data);
                        }
                        // fill the response object. success
                    } else {
                        // raise error as a return order number could not be generated.
                        $msg = "Issue creating the return order";
                        $data = "$msg " . $e->getMessage();
                        $status = false;
                        if ($isTrans > 0) {
                            $this->pdo->rollback();
                            $isTrans--;
                        }
                        return get_response("Something went wrong", $status, $data);


                    } // else of New Order id
                } // else of OrderAction
            } // empty order info
            else {
                $data = '';
                $data = "msg " . "Input missing. Please check";
                $status = false;
                return get_response("Something went wrong", $status, $data);
            }
        } catch (PDOException $e) {
            if ($isTrans > 0) {
                $this->pdo->rollback();
                $isTrans--;
            }
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
        $msg = "Success";
        $data = $return_order_id;
        return get_response($msg, $status, $data);
    }
    private function convertBase64toImg($pdf_base64, $file){

        $imageData = base64_decode($pdf_base64);
        $file = RETURN_PATH_UPLOAD.$file;

        /*if (file_exists($file)) {

            unlink($file);
         } else { */
        file_put_contents($file, $imageData); // file downloading on local
        if (file_exists($file)) {
            header('Content-Description: File Transfer');
            header('Content-Type: application/octet-stream');
            header('Content-Disposition: attachment; filename='.basename($file));
            header('Expires: 0');
            header('Cache-Control: must-revalidate');
            header('Pragma: public');
            header('Content-Length: ' . filesize($file));
            ob_clean(); // Clean (erase) the output buffer ..(IMP)
            flush();
            readfile($file);
        }
        return;
    }

    private function validate_order_input($order_info, $item_detail)
    {

        // Input json structure ( partial return )
        // {
        //     "order_info": {
        //         "Order_No": "1100001100526",
        //         "FSO_No": "10",
        //         "Cust_Type": "Buyer",
        //         "Cust_No": "76",
        //         "Return_Reason_Type": "Damaged Goods",
        //         "ReturnDescription": "",
        //         "PartialFlag": "Y",
        //         "OrderAction" : "Return Request",
        //
        //     },
        //     "item_detail": [{
        //             "Order_Quantity": "18",
        //             "ArticleID": "301",
        //             "Return_Reason_Type": "Damaged Goods",
        //             "ReturnDescription": "",
        //         }
        //     ]
        // }

        // Input json structure ( full return )
        // {
        //     "order_info": {
        //         "Order_No": "1100001100040",
        //         "FSO_No": "10",
        //         "Cust_Type": "FSO",
        //         "Cust_No": "76",
        //         "Return_Reason_Type": "Damaged goods",
        //         "ReturnDescription": "",
        //         "PartialFlag": "N",
        //         "OrderAction" : "Y",
        //     }
        // }

        // fso, return reason type and return description are optional
        // TODO: Validate the valid value of partial flag.
        // TODO: Business rule validations eg if partial flag then item detail.return reason type is mandatory.

        if (empty($order_info['Cust_Type']) || empty($order_info['Cust_No']) || empty($order_info['ReturnType']) || empty($item_detail)) {
            $retval = false;
        } else {
            $retval = true;
            if ($order_info['ReturnType'] == 'Order') {
                // Return against Order so Order_No cannot be empty
                if (empty($order_info['Order_No']) || empty($order_info['CurrentOrderStatus'])) {
                    $retval = false;
                }
            }
        }

        return $retval;

    } // validate_input

    private function generate_new_orderid_ForBatch($pdo)
    {

        // generate a new return order number and get the current financial year, next_current_id, order code, reference ID from Order_Hdr_Year
        // if currentdate is less then 31-march then preview year is fin. year else current year is fin. year.
        // begin transaction
        $pdo->beginTransaction();
        $isTrans=0;
        $isTrans++;
        $stmt = $pdo->prepare("select  Year_ID, Year as finYear, Current_ID + 1 next_current_id ,-- , Year, Start_ID start_id, End_ID end_id, Current_ID current_id,
    concat( Year_ID , Start_ID , Current_ID + 1)  OrderCode,
    LPAD(FLOOR(RAND() * 999999.99), 6, '0') reference_ID
    from Order_Hdr_Year where Year=(case when (MONTH(CURDATE()) < 4 ) then  YEAR(CURDATE()) - 1 else YEAR(CURDATE()) end);");
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);

        // echo "<pre>";
        // print_r($row);

        if (!empty($row)) {

            // extract into local variables.

            //$yearID = $row['year_id'];
            $finyear = $row['finYear'];
            //$start_id = $row['start_id'];
            $next_current_id = $row['next_current_id'];
            //$end_id = $row['end_id'];
            //$current_id = $row['current_id'];
            $OrderCode = $row['OrderCode'];
            $reference_ID = $row['reference_ID'];

            $param_arr[':next_current_id'] = $next_current_id;
            $param_arr[':finYear'] = $finyear;

            // As we have a financial year and an order number, we need to update the current_id on Order_Hdr_Year.
            // Update the order header year with the next current id  ( ie current id + 1 ) recd. from generate order number query

            try {
                $stmt = $pdo->prepare("UPDATE Order_Hdr_Year SET Current_ID=:next_current_id WHERE Year = :finYear;");
                $retval = $stmt->execute($param_arr);
                $pdo->commit();
                $isTrans--;
                // $pdo->endTransaction();
                $returnOrder['returnOrderNo'] = $OrderCode;
                $returnOrder['reference_ID'] = $reference_ID;
                $msg = "After commit Return order number is $OrderCode and next current id is $next_current_id";
            } catch (DOException $e) {
                $msg = "Rolling back generate return order number.";
                $returnOrder = array();
                if ($isTrans > 0) {
                    $pdo->rollback();
                    $isTrans--;
                }
            }
            // end transaction
        } // end found data row
        else {
            // financial year could not be determined so return an error
            $msg = "Rolling back generate return order number";
            echo " $msg " . $e->getMessage();
            $returnOrder = array();
            if ($isTrans > 0) {
                $pdo->rollback();
                $isTrans--;
            }
            throw $e;
        }
        return ($returnOrder);
    } // generate_new_orderid

    private function createReturnOrderHdrForBatch($pdo, $orderinfo, $return_orderno, $reference_ID)
    {

        $retval = true;
        // create return order header entry with the generate return order no.

        if ($orderinfo['Cust_Type'] == 'Self') {
            $logintype = 'Self';
            $param_array[':return_orderstatus'] = "Return Request";
            $param_array[':payment_status'] = "Pending";
        } else {
            //$logintype = 'FSO'; //commented by Meenal Barve to capture DO also
            $logintype = $orderinfo['Cust_Type'];
            $param_array[':return_orderstatus'] = "Goods Collected";
            $param_array[':payment_status'] = "Refund Pending";
        }

        $original_orderno = $orderinfo['Order_No'];
        $orderCustType = $this->getOrderCustType($pdo, $original_orderno);
        if($logintype == 'DO' || $logintype == ''){
            $logintype = $orderCustType;
        }

        $param_array[':return_order_no'] = $return_orderno;
        $param_array[':return_ordercode'] = $return_orderno;
        $param_array[':reference_id'] = $reference_ID;
        $param_array[':logintype'] = $logintype;
        $param_array[':return_fso_no'] = $orderinfo['FSO_No'];

        $param_array[':original_orderno'] = $original_orderno;
        $param_array[':original_ordernumber'] = $original_orderno;

        // return reason on order header only if partial flag is 'N' ie complete order is being returned.

        $param_array[':return_reason_type'] = "";
        $param_array[':return_reason_description'] = "";


        //echo "Printing the values to sql <pre>";
        //print_r($param_array);

        $orderhdrstmt = '';

        try {
            $orderhdrstmt = $pdo->prepare("Insert into Order_Hdr (Order_No, Order_Code, Reference_ID,
    Cust_No, Cust_Type, FSO_No, Address_ID, Bill_Address_ID, Supplier_Address_ID, Supplier_Bill_Address_ID, Store_No,
    Order_Date, Order_Time, Order_Status, Payment_Status, Order_Amount, Header_Discount, Net_Amount, Saving_Amount, Total_Weight, Delivery_Charges,
    Creation_Date, Creation_Time, Created_By, Change_Date, Change_Time, Changed_By, Source, Return_reason_Type, Return_Reason_Desc, Return_Order_No )
    select :return_order_no,:return_ordercode,:reference_id,Cust_No,:logintype,:return_fso_no,Address_ID,Bill_Address_ID,Supplier_Address_ID,Supplier_Bill_Address_ID, Store_No, now(), now(),:return_orderstatus,:payment_status,0,0,0,0,0,0,now(),now(),1,now(),now(),1,'android',:return_reason_type,:return_reason_description, :original_ordernumber
    from Order_Hdr where Order_No = :original_orderno;");

        } catch (PDOException $e) {
            $msg = "Error preparing order header sql statement for order $return_orderno ";
            echo " $msg " . $e->getMessage();
            $retval = false;
            //throw $e;
            return ($retval);
        }

        try {
            $orderhdrstmt->execute($param_array);

            $msg = "The order header is created for " . $return_orderno . " ";

        } catch (PDOException $e) {
            $msg = "Error creating order header for order $return_orderno ";
            echo $msg . $e->getMessage();
            $retval = false;
            // throw $e;
            return ($retval);
        }
        // echo "$msg";

        // // IF order header is created for the return order then update the original order header entry with the return order number.
        // $orderhdrupdatestmt = '';
        // $param_arr[':return_OrderCode'] = $return_orderno;
        // $param_arr[':original_orderNo'] = $original_orderno;

        // try {
        //     $orderhdrupdatestmt = $pdo->prepare("update Order_Hdr set Return_Order_No = :return_OrderCode where Order_No = :original_orderNo ;");
        //     $orderhdrupdatestmt->execute($param_arr);

        //     $retval = true;
        //     $msg = "Updated order header for order $original_orderno with $return_orderno  ";

        // } catch (PDOException $e) {
        //     $msg = "Error updating order header for order $original_orderno with $return_orderno ";
        //     $retval = false;
        //     throw $e;
        //     //return($retval);
        // }
        // // echo "$msg";

        // $orderhdrstmt = '';
        // $orderhdrupdatestmt = '';
        return ($retval);

    } // createReturnOrderHdr

//dev-14 , For Open Returns - Meenal Barve
    private function createOpenReturnOrderHdr($pdo, $orderinfo, $return_orderno, $reference_ID)
    {

        $retval = true;

        // create return order header entry with the generate return order no.
        if ($orderinfo['Cust_Type'] == 'Self') {
            $logintype = 'Self';
            $param_array[':return_orderstatus'] = "Return Request";
            $param_array[':payment_status'] = "Pending";
        } else {
            //$logintype = 'FSO'; //commented by Meenal Barve to capture DO also
            $logintype = $orderinfo['Cust_Type'];
            $param_array[':return_orderstatus'] = "Goods Collected";
            $param_array[':payment_status'] = "Refund Pending";
        }

        $original_orderno = $orderinfo['Order_No'];
        $orderCustType = $this->getOrderCustType($pdo, $original_orderno);
        if($logintype == 'DO' || $logintype == ''){
            $logintype = $orderCustType;
        }

        $param_array[':return_order_no'] = $return_orderno;
        $param_array[':return_ordercode'] = $return_orderno;
        $param_array[':reference_id'] = $reference_ID;
        $param_array[':logintype'] = $logintype;
        $param_array[':return_fso_no'] = $orderinfo['FSO_No'];
        $param_array[':store_no'] = $orderinfo['Store_No'];
        $param_array[':cust_no'] = $orderinfo['Cust_No'];
        $Store_No = $orderinfo['Store_No'];
        $Cust_No  = $orderinfo['Cust_No'];

        //$param_array[':original_orderno'] = "";
        $param_array[':original_ordernumber'] = "";

        $param_array[':return_reason_type'] = "";
        $param_array[':return_reason_description'] = "";

        $queryStoreShippingAddress=$pdo->prepare("Select Get_Shipping_Address($Store_No) as Address_ID");
        $queryStoreShippingAddress->execute();
        $resultStoreShippingAddress  = $queryStoreShippingAddress->fetchAll(PDO::FETCH_ASSOC);
        $queryStoreShippingAddress->closeCursor();
        $Shipping_Address_ID = $resultStoreShippingAddress[0]['Address_ID'];

        $queryStoreBillingAddress=$pdo->prepare("Select Get_Billing_Address($Store_No,$Shipping_Address_ID) as Ref_Address_ID");
        $queryStoreBillingAddress->execute();
        $resultStoreBillingAddress  = $queryStoreBillingAddress->fetchAll(PDO::FETCH_ASSOC);
        $queryStoreBillingAddress->closeCursor();
        $Billing_Address_ID = $resultStoreBillingAddress[0]['Ref_Address_ID'];

        $queryCustDeliveryAddress=$pdo->prepare("Select Get_Delivery_Address($Cust_No) as Address_ID");
        $queryCustDeliveryAddress->execute();
        $resultCustDeliveryAddress  = $queryCustDeliveryAddress->fetchAll(PDO::FETCH_ASSOC);
        $queryCustDeliveryAddress->closeCursor();
        $Delivery_Address_ID = $resultCustDeliveryAddress[0]['Address_ID'];

        $param_array[':address_id']                  = $Delivery_Address_ID;
        $param_array[':billing_address_id']          = $Delivery_Address_ID;
        $param_array[':shipping_address_id']         = $Shipping_Address_ID;
        $param_array[':shipping_billing_address_id'] = $Billing_Address_ID;

        //create session for address fields
        $_SESSION['addrData'] = [$Delivery_Address_ID, $Shipping_Address_ID, $Billing_Address_ID];

        //echo "Printing the values to sql <pre>";
        //print_r($param_array);

        $orderhdrstmt = '';

        try {
            $orderhdrstmt = $pdo->prepare("Insert into Order_Hdr (Order_No, Order_Code, Reference_ID,
    Cust_No, Cust_Type, FSO_No, Address_ID, Bill_Address_ID, Supplier_Address_ID, Supplier_Bill_Address_ID, Store_No,
    Order_Date, Order_Time, Order_Status, Payment_Status, Order_Amount, Header_Discount, Net_Amount, Saving_Amount, Total_Weight, Delivery_Charges,
    Creation_Date, Creation_Time, Created_By, Change_Date, Change_Time, Changed_By, Source, Return_reason_Type, Return_Reason_Desc, Return_Order_No )
    select :return_order_no,:return_ordercode,:reference_id,:cust_no,:logintype,:return_fso_no,:address_id,:billing_address_id,:shipping_address_id,:shipping_billing_address_id, :store_no, now(), now(),:return_orderstatus,:payment_status,0,0,0,0,0,0,now(),now(),1,now(),now(),1,'android',:return_reason_type,:return_reason_description, :original_ordernumber;");

        } catch (PDOException $e) {
            $msg = "Error preparing order header sql statement for order $return_orderno ";
            echo " $msg " . $e->getMessage();
            $retval = false;
            //throw $e;
            return ($retval);
        }

        try {
            $orderhdrstmt->execute($param_array);

            $msg = "The order header is created for " . $return_orderno . " ";

        } catch (PDOException $e) {
            $msg = "Error creating order header for order $return_orderno ";
            echo $msg . $e->getMessage();
            $retval = false;
            // throw $e;
            return ($retval);
        }
        // echo "$msg";

        // // IF order header is created for the return order then update the original order header entry with the return order number.
        // $orderhdrupdatestmt = '';
        // $param_arr[':return_OrderCode'] = $return_orderno;
        // $param_arr[':original_orderNo'] = $original_orderno;

        // try {
        //     $orderhdrupdatestmt = $pdo->prepare("update Order_Hdr set Return_Order_No = :return_OrderCode where Order_No = :original_orderNo ;");
        //     $orderhdrupdatestmt->execute($param_arr);

        //     $retval = true;
        //     $msg = "Updated order header for order $original_orderno with $return_orderno  ";

        // } catch (PDOException $e) {
        //     $msg = "Error updating order header for order $original_orderno with $return_orderno ";
        //     $retval = false;
        //     throw $e;
        //     //return($retval);
        // }
        // // echo "$msg";

        // $orderhdrstmt = '';
        // $orderhdrupdatestmt = '';
        return ($retval);

    } // createReturnOrderHdr

    private function createReturnOrderAllItemsForBatch($pdo, $original_orderno, $return_orderno)
    {

        $param_array[':original_orderNo'] = $original_orderno; // $order_info['Order_No'];
        $param_array[':return_order_no'] = $return_orderno; // $return_order_id;

        // echo "<pre>";
        // print_r($param_array);

        // Insert order items from the data recd from requester.
        $orderitmstmt = "";

        try {
            $orderitmstmt = $pdo->prepare("insert into Order_Itm(Order_No, Article_No, Order_Quantity, Order_Amount, Order_Offer_Price, Order_Mrp, Pick_Quantity,
        Pick_Amount, Item_Discount, Net_Amount, Saving_Amount, Item_Weight, Status,
        Creation_Date, Creation_Time, Created_By, Change_Date, Change_Time, Changed_By)
        select :return_order_no Order_No, Article_No,  Order_Quantity,  Order_Amount,
        Order_Offer_Price, Order_Mrp, Pick_Quantity, Pick_Amount ,
        0 Item_Discount,  Net_Amount, 0 Saving_Amount, Item_Weight, Status,
        now(), now(), 1, now(), now(), 1
        from Order_Itm where Order_No = :original_orderNo and Pick_Quantity > 0;");

            $orderitmstmt->execute($param_array);

        } catch (PDOException $e) {
            $msg = "Error creating order items for order $return_orderno " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);
        }

        $msg = "The order items are created for $return_orderno ";
        //echo "no exceptions in createReturnOrderAllItems $msg";
        return (true);

    } // createReturnOrderAllItems

    private function createPartialReturnOrderItemsForBatch($pdo, $order_info, $order_detail, $return_order_id)
    {
        // order info array has the original order number.
        // order detail has the items that are to be returned.

        $original_orderno = $order_info['Order_No'];

        // Prepare the sql insert statement and then execute it once for each returned articles

        $orderpartialitmstmt = "";

        try {
            $orderpartialitmstmt = $pdo->prepare("insert into Order_Itm(Order_No, Article_No, Order_Quantity, Order_Amount, Order_Offer_Price, Order_Mrp, Pick_Quantity,
        Pick_Amount, Item_Discount, Net_Amount, Saving_Amount, Item_Weight, Status, Return_reason_Type, Return_Reason_Desc,
        Creation_Date, Creation_Time, Created_By, Change_Date, Change_Time, Changed_By)
        select :return_order_no Order_No, :article_no,  :order_quantity,  ( :order_qty * Order_Offer_Price) Order_Amount,
        Order_Offer_Price, Order_Mrp, :odr_quantity Pick_Quantity, ( :odr_qty * Order_Offer_Price) Pick_Amount ,
        0 Item_Discount,  Net_Amount, 0 Saving_Amount, ((  Item_Weight / Order_Quantity ) * :order_quanti) Item_Weight , Status, :return_reason_type, :return_reason_description,
        now(), now(), 1, now(), now(), 1
        from Order_Itm where Order_No = :original_orderNo and Article_No = :articleno ;");

            // Fill the placeholder array for common data fields
            $param_arry = array();
            $param_arry[':original_orderNo'] = $original_orderno;
            $param_arry[':return_order_no']  = $return_order_id;

            foreach ($order_detail as $key => $val) {
                // following are to be set for each returned item
                $param_arry[':article_no'] = $order_detail[$key]['ArticleID'];
                $param_arry[':articleno'] = $order_detail[$key]['ArticleID'];
                $param_arry[':order_quantity'] = $order_detail[$key]['Order_Quantity'];
                $param_arry[':order_qty'] = $order_detail[$key]['Order_Quantity'];
                $param_arry[':order_quanti'] = $order_detail[$key]['Order_Quantity'];
                $param_arry[':odr_quantity'] = $order_detail[$key]['Order_Quantity'];
                $param_arry[':odr_qty'] = $order_detail[$key]['Order_Quantity'];
                $param_arry[':return_reason_type'] = "";//$order_detail[$key]['Return_Reason_Type'];
                $param_arry[':return_reason_description'] = "";//$order_detail[$key]['ReturnDescription'];

                // echo "Printing the param_arry <pre>";
                // print_r($param_arry);

                $orderpartialitmstmt->execute($param_arry);
            }

        } catch (PDOException $e) {
            $msg = "Error creating order items for order $return_orderno " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);
        }
        return (true);

    } //createPartialReturnOrderItemsForBatch

//dev-14 , For Open Returns - Meenal Barve
    private function createOpenReturnOrderItems($pdo, $order_info, $order_detail, $return_order_id)
    {
        // order info array has the original order number.
        // order detail has the items that are to be returned.

        $original_orderno = "";

        // Prepare the sql insert statement and then execute it once for each returned articles

        $orderpartialitmstmt = "";

        try {
            $orderpartialitmstmt = $pdo->prepare("insert into Order_Itm(Order_No, Article_No, Order_Quantity, Order_Amount, Order_Offer_Price, Order_Mrp, Pick_Quantity,
        Pick_Amount, Item_Discount, Net_Amount, Saving_Amount, Item_Weight, Scheme_ID, Status, Return_reason_Type, Return_Reason_Desc,
        Creation_Date, Creation_Time, Created_By, Change_Date, Change_Time, Changed_By)
        select :return_order_no , :article_no,  :order_quantity,  :order_amount,
        :offer_price, :order_mrp, :pick_quantity, :pick_amount ,
        0 ,:net_amount, 0 , :item_weight , :scheme_id ,:order_status, :return_reason_type, :return_reason_description,
        now(), now(), 1, now(), now(), 1;");

            // Fill the placeholder array for common data fields
            $param_arry = array();
            //$param_arry[':original_orderNo'] = $original_orderno;
            $param_arry[':return_order_no'] = $return_order_id;

            foreach ($order_detail as $key => $val) {
                // following are to be set for each returned item
                $param_arry[':article_no'] = $order_detail[$key]['ArticleID'];
                //$param_arry[':articleno'] = $order_detail[$key]['ArticleID'];
                $param_arry[':order_quantity'] = $order_detail[$key]['Order_Quantity'];
                $param_arry[':pick_quantity'] = $order_detail[$key]['Order_Quantity'];

                //$param_arry[':oqty'] = $order_detail[$key]['Order_Quantity'];

                $param_arry[':offer_price'] = $order_detail[$key]['Offer_Price'];
                $param_arry[':order_mrp'] = $order_detail[$key]['Unit_Price'];
                $param_arry[':scheme_id'] = $order_detail[$key]['Scheme_ID'];
                $param_arry[':item_weight'] = $order_detail[$key]['Approx_Weight'] * $order_detail[$key]['Order_Quantity'];
                $param_arry[':net_amount'] = $order_detail[$key]['Offer_Price'] * $order_detail[$key]['Order_Quantity'];
                $param_arry[':order_amount'] = $order_detail[$key]['Offer_Price'] * $order_detail[$key]['Order_Quantity'];
                $param_arry[':pick_amount'] = $order_detail[$key]['Offer_Price'] * $order_detail[$key]['Order_Quantity'];
                $param_arry[':order_status'] = "R";

                $param_arry[':return_reason_type'] ="";
                $param_arry[':return_reason_description'] = "";

                //echo "Printing the param_arry <pre>";
                //print_r($param_arry);
                //$orderpartialitmstmt->debugDumpParams();
                $orderpartialitmstmt->execute($param_arry);
                //$orderpartialitmstmt->debugDumpParams();
            }

        } catch (PDOException $e) {
            $msg = "Error creating order items for order $return_orderno " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);
        }
        return (true);

    } //createOpenReturnOrderItems

//dev-14 , For Open Returns - Meenal Barve
    private function createOpenReturnOrderItemBatch($pdo, $order_info, $order_detail, $return_order_id,$ReturnType)
    {
        // order info array has the original order number.
        // order detail has the items that are to be returned.

        $original_orderno = $order_info['Order_No'];

        // Prepare the sql insert statement and then execute it once for each returned articles
        $date_time = date('Y-m-d H:i:s');
        $orderitmbatchstmt = "";

        try {
            $orderitmbatchstmt = $pdo->prepare("insert into Order_Itm_Batch(Order_No, Article_No, Batch_No, Batch_Quantity, Batch_Date, Return_Reason_Type, Return_Reason_Desc,Image_Url1,Image_Url2,
        Creation_Date,Created_By, Changed_Date,Changed_By)
        select :orderNo , :article_no, :batch_no, :batch_quantity, :batch_date,
        :return_reason_type, :return_reason_description,:image_url1,:image_url2,
        '$date_time', 1, '$date_time', 1;");

            // Fill the placeholder array for common data fields
            $param_arry = array();

            $param_arry[':orderNo']  = $return_order_id;

            foreach ($order_detail as $key => $val) {
                // following are to be set for each returned item
                $param_arry[':article_no'] = $order_detail[$key]['ArticleID'];

                $batch_detail =  $order_detail[$key]['Batch_Detail'];

                foreach ($batch_detail as $key1 => $val1) {
                    $param_arry[':batch_no'] = $batch_detail[$key1]['Batch_No'];
                    $param_arry[':batch_quantity'] = $batch_detail[$key1]['Batch_Quantity'];
                    $param_arry[':batch_date'] = $batch_detail[$key1]['Batch_Date'];
                    if (!empty($batch_detail[$key1]['Image_Url1'])) {
                        $pdf_base64 = $batch_detail[$key1]['Image_Url1'];
                        $this->convertBase64toImg($pdf_base64, $return_order_id.'_'.$order_detail[$key]['ArticleID'].'_'.$key1.'_1.'.'jpg');
                    }
                    if ((!empty($batch_detail[$key1]['Image_Url1']))) {
                        $pdf_base64 = $batch_detail[$key1]['Image_Url2'];
                        $this->convertBase64toImg($pdf_base64, $return_order_id.'_'.$order_detail[$key]['ArticleID'].'_'.$key1.'_2.'.'jpg');
                    }
                    $param_arry[':image_url1'] = "";//$return_order_id.'_'.$order_detail[$key]['ArticleID'].'_'.$key1.'_1.'.'jpg';
                    $param_arry[':image_url2'] = "";//$return_order_id.'_'.$order_detail[$key]['ArticleID'].'_'.$key1.'_2.'.'jpg';
                    $param_arry[':return_reason_type'] = $batch_detail[$key1]['Return_Reason_Type'];
                    $param_arry[':return_reason_description'] = $batch_detail[$key1]['Return_Reason_Desc'];


                    // echo "Printing the param_arry <pre>";
                    //print_r($param_arry);

                    $orderitmbatchstmt->execute($param_arry);
                    //$orderitmbatchstmt->debugDumpParams();
                }

            }

        } catch (PDOException $e) {
            $msg = "Error creating order items batch for order $return_orderno " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);
        }
        return (true);

    } //createOpenReturnOrderItemBatch


    private function updateReturnOrderHdrSummaryForBatch($pdo, $original_orderno, $return_order_id)
    {
        // update the return order hdr with the summary from the items in the returned order

        // Fill the placeholder array for common data fields
        $param_arry = array();
        $param_arry[':original_orderno'] = $original_orderno;
        $param_arry[':return_order_no'] = $return_order_id;
        $param_arry[':return_ordernum'] = $return_order_id;

        try {

            // This query looks at the per unit weight and price from the original order and works out the
            // total weight and amount based on the quantity of the articles in the return order.
            // This calculated total weight and total amount is updated in the return order header.
            $updatereturnorderstmt = $pdo->prepare("UPDATE Order_Hdr oh inner join
            (select  sum(org_order_item.perunit_wt * return_order_item.Pick_Quantity) order_wt ,
                    sum(org_order_item.perunit_offer_price * return_order_item.Pick_Quantity ) order_amt,
                    sum(org_order_item.Item_Discount) header_discount
            from
            ( select Article_No, (  Item_Weight / Pick_Quantity ) perunit_wt, Order_Offer_Price perunit_offer_price, Item_Discount from Order_Itm where Order_No = :original_orderno ) org_order_item,
            ( select Article_No, Pick_Quantity from Order_Itm where Order_No = :return_order_no ) return_order_item
            where org_order_item.Article_No = return_order_item.Article_No) x
            set oh.Order_Amount = x.order_amt,
            oh.Total_Weight = x.order_wt,
            oh.Header_Discount = x.header_discount,
            oh.Net_Amount = x.order_amt - x.header_discount
            where oh.Order_No = :return_ordernum ;");

            $updatereturnorderstmt->execute($param_arry);

        } catch (PDOException $e) {
            $msg = "Error updating summary for return order $return_order_id " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);
        }

        return (true);

    } // updateReturnOrderHdrSummary

//dev-14 , For Open Returns - Meenal Barve
    private function updateOpenReturnOrderHdrSummary($pdo, $order_info, $order_detail, $return_order_id)
    {
        // update the return order hdr with the summary from the items in the returned order

        $updatereturnorderstmt = "";
        $total_weight = 0;
        $total_amount = 0;
        $total_saving_amount = 0;

        try {
            $updatereturnorderstmt = $pdo->prepare("UPDATE Order_Hdr
        set Order_Amount = :total_amount,
            Total_Weight = :total_weight,
            Net_Amount   = :total_amount,
            Saving_Amount = 0
            where Order_No = :return_order_no;");

            // Fill the placeholder array for common data fields
            $param_arry = array();

            $param_arry[':return_order_no'] = $return_order_id;

            foreach ($order_detail as $key => $val) {

                ### Get total weight and amount
                $total_weight = $total_weight + $order_detail[$key]['Approx_Weight'];
                $total_amount = $total_amount + $order_detail[$key]['Order_Quantity'] * $order_detail[$key]['Offer_Price'];
                $total_saving_amount = $total_saving_amount + $order_detail[$key]['Unit_Price'] - $order_detail[$key]['Offer_Price'];
            }

            $param_arry[':total_weight'] = $total_weight;
            $param_arry[':total_amount'] = $total_amount;
            //$param_arry[':net_amount']   = $total_amount;
            //$param_arry[':saving_amount']   = $total_saving_amount;

            $updatereturnorderstmt->execute($param_arry);

        } catch (PDOException $e) {
            $msg = "Error updating summary for Open return order $return_orderno " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);
        }

        return (true);

    } // updateOpenReturnOrderHdrSummary

    private function updateOriginalOrderHdrForBatch($pdo, $original_orderno, $return_order_id, $OrderAction)
    {
        // update the original order hdr for Return_goods,
        try {
            // oh.Return_goods = 1 is set only if the return order is accepted or if FSO returns on behalf of the buyer.
            if (isset($OrderAction)) {
                if ($OrderAction == "Goods Collected") {
                    $param_arry = array();
                    $param_arry[':original_orderno'] = $original_orderno;
                    $updatestring = "UPDATE Order_Hdr set Return_goods = 1 where Order_No = :original_orderno ;";
                    $updateorigorderstmt = $pdo->prepare($updatestring);
                    $updateorigorderstmt->execute($param_arry);
                }
            } else {
                $msg = "Error OrderAction is not provided.";
                return (false);
            }
        } catch (PDOException $e) {
            $msg = "Error updating summary for original order header $original_orderno " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);
        }

        return (true);

    } // updateOriginalOrderHdr

    private function createReturnOrderHistoryForBatch($pdo, $return_order_id, $OrderAction, $Login_Type ,$UserNo)
//Login Type and User No added by Meenal Barve
    {
        $creationDate = date('Y-m-d');
        $creationTime = date('H:i:s');

        switch ($OrderAction) {
            case "Return Request":$memo = "Return Request";
                break;
            case "Goods Collected":$memo = "Goods Collected"; //case "Return":$memo = "Return";
                break;
            // case "Accept Return Request":$memo = "Goods Collected";
            //     break;
            case "Reject Return Request":$memo = "Return Rejected";
                break;
            default:$memo = $OrderAction;
        }

        $history_param_arry = array();
        $history_param_arry[':memo'] = $memo;
        $history_param_arry[':history_date'] = $creationDate;
        $history_param_arry[':history_time'] = $creationTime;
        $history_param_arry[':status'] = 'A';
        $history_param_arry[':creation_date'] = $creationDate;
        $history_param_arry[':creation_time'] = $creationTime;
        $history_param_arry[':change_date'] = $creationDate;
        $history_param_arry[':change_time'] = $creationTime;
        $history_param_arry[':return_order_id'] = $return_order_id;
        $history_param_arry[':login_type'] = $Login_Type; //Added by Meenal Barve
        $history_param_arry[':user_no'] = $UserNo;

        try {
            /*$orderhistorystmt = $pdo->prepare("INSERT INTO `Order_History`(`Order_ID`, `Memo`, `History_Date`, `History_Time`, `Status`, `Creation_Date`, `Creation_Time`, `Created_By`, `Change_Date`, `Change_Time`, `Changed_By`,`Login_Type`)
            SELECT  Order_No, :memo, :history_date, :history_time, :status, :creation_date, :creation_time, Created_By, :change_date, :change_time, Changed_By,:login_type
            from Order_Hdr where Order_No = :return_order_id");*/
            $orderhistorystmt = $pdo->prepare("INSERT INTO `Order_History`(`Order_ID`, `Memo`, `History_Date`, `History_Time`, `Status`, `Creation_Date`, `Creation_Time`, `Created_By`, `Change_Date`, `Change_Time`, `Changed_By`,`Login_Type`)
        SELECT  Order_No, :memo, :history_date, :history_time, :status, :creation_date, :creation_time, :user_no, :change_date, :change_time, :user_no,:login_type
        from Order_Hdr where Order_No = :return_order_id");

        } catch (PDOException $e) {
            $msg = "Error preparing order history sql statement for order $return_orderno ";
            echo " $msg " . $e->getMessage();
            $retval = false;
            return ($retval);
        }

        try {
            $orderhistorystmt->execute($history_param_arry);

            $msg = "The order history is created for " . $return_order_id;

        } catch (PDOException $e) {
            $msg = "Error creating order history for order " . $return_order_id;
            echo $msg . $e->getMessage();
            $retval = false;
            return ($retval);
        }
        return (true);

    } // createReturnOrderHistory

    private function updatePartialReturnOrderItemsForBatch($pdo, $order_info, $order_detail, $return_order_id)
    {
        // order info array has the original order number.
        // order detail has the items that are to be returned.

        $original_orderno = $order_info['Order_No'];

        // Prepare the sql insert statement and then execute it once for each returned articles

        $orderpartialitmstmt = "";

        try {
            /*
            Added by Meenal to update pick quantity of all articles as 0*/
            $orderpartialitmstmt = $pdo->prepare("update Order_Itm
        set Pick_Amount   =  0
            , Pick_Quantity =  0
            , Change_Date = now()
            , Change_Time = now()
            , Changed_By = 1
        where Order_No = :return_order_no  ;");

            // Fill the placeholder array for common data fields
            $param_arry = array();
            // $param_arry[':original_orderNo'] = $original_orderno;
            $param_arry[':return_order_no'] = $return_order_id;

            $orderpartialitmstmt->execute($param_arry);


            // TODO: Created_By and Changed_By to be set to the buyer or FSO id.
            $orderpartialitmstmt = $pdo->prepare("update Order_Itm
        set Pick_Amount   =  ( :odr_qty * Order_Offer_Price)
            , Pick_Quantity =  :odr_quantity
            , Item_Weight = ((  Item_Weight / Order_Quantity ) * :order_quanti)
            , Return_reason_Type = :return_reason_type
            , Return_Reason_Desc = :return_reason_description
            , Change_Date = now()
            , Change_Time = now()
            , Changed_By = 1
        where Order_No = :return_order_no and Article_No = :articleno ;");


            foreach ($order_detail as $key => $val) {
                // following are to be set for each returned item
                // $param_arry[':article_no'] = $order_detail[$key]['ArticleID'];
                $param_arry[':articleno'] = $order_detail[$key]['ArticleID'];
                $param_arry[':odr_quantity'] = $order_detail[$key]['Order_Quantity'];
                $param_arry[':odr_qty'] = $order_detail[$key]['Order_Quantity'];
                $param_arry[':order_quanti'] = $order_detail[$key]['Order_Quantity'];
                $param_arry[':return_reason_type'] = $order_detail[$key]['Return_Reason_Type'];
                $param_arry[':return_reason_description'] = $order_detail[$key]['ReturnDescription'];
                // echo "Printing the param_arry <pre>";
                // print_r($param_arry);

                $orderpartialitmstmt->execute($param_arry);
            }
            $retval = true;
            // following are to be set for each returned item

        } catch (PDOException $e) {
            $msg = "Error creating order items for order $return_orderno " . $e->getMessage();
            // echo "exception is $msg";
            throw $e;
            $retval = false;
            return ($retval);
        }
        return ($retval);

    } //updatePartialReturnOrderItems

    private function updatePartialReturnOrderItemBatch($pdo, $order_info, $order_detail, $return_order_id)
    {
        // order info array has the original order number.
        // order detail has the items that are to be returned.

        $original_orderno = $order_info['Order_No'];

        // Prepare the sql insert statement and then execute it once for each returned articles

        $orderitmbatchstmt = "";

        try {
            // TODO: Created_By and Changed_By to be set to the buyer or FSO id.
            /*$orderitmbatchstmt = $pdo->prepare("update Order_Itm_Batch
            set Batch_No     =  :batch_no
                , Batch_Date =  :batch_date
                , Batch_Quantity =  :batch_quantity
                , Return_Reason_Type = :return_reason_type
                , Return_Reason_Desc = :return_reason_description
                , Image_Url1  = :image_url1
                , Image_Url2  = :image_url2
                , Changed_Date=  now()
                , Changed_By = 1
            where Order_No = :return_order_no and Article_No = :articleno ;");*/

            $orderitmbatchstmt = $pdo->prepare("Delete from Order_Itm_Batch
          where Order_No = :return_order_no ;");

            // Fill the placeholder array for common data fields
            $param_arry = array();
            // $param_arry[':original_orderNo'] = $original_orderno;
            $param_arry[':return_order_no'] = $return_order_id;

            /*foreach ($order_detail as $key => $val) {
            // following are to be set for each returned item
            $param_arry[':articleno'] = $order_detail[$key]['ArticleID'];

            $batch_detail =  $order_detail[$key];

                foreach ($batch_detail as $key1 => $val) {
                $param_arry[':batch_no'] = $batch_detail[$key1]['Batch_No'];
                $param_arry[':batch_quantity'] = $batch_detail[$key1]['Batch_Quantity'];
                $param_arry[':batch_date'] = $batch_detail[$key1]['Batch_Date'];
                $param_arry[':image_url1'] = $batch_detail[$key1]['Image_Url1'];
                $param_arry[':image_url2'] = $batch_detail[$key1]['Image_Url2'];
                $param_arry[':return_reason_type'] = $batch_detail[$key1]['Return_Reason_Type'];
                $param_arry[':return_reason_description'] = $batch_detail[$key1]['Return_Reason_Desc'];


                // echo "Printing the param_arry <pre>";
                // print_r($param_arry);

                $orderitmbatchstmt->execute($param_arry);
                }
                 $orderitmbatchstmt->execute($param_arry);

            }*/
            //once old entires are deleted create new batch detail entries
            //$retval=createOpenReturnOrderItemBatch($pdo, $order_info, $order_detail, $return_order_id,'')
            $orderitmbatchstmt->execute($param_arry);

            $retval = true;

        } catch (PDOException $e) {
            $msg = "Error creating order items batch for order $return_orderno " . $e->getMessage();
            // echo "exception is $msg";
            throw $e;
            $retval = false;
            return ($retval);
        }
        return ($retval);

    } //updatePartialReturnOrderItemBatch

    private function updateReturnOrderHdrForBatch($pdo, $orderinfo)
    {
        // create return order header entry with the generate return order no.

        // if ($orderinfo['Cust_Type'] == 'Self') {
        //     $logintype = 'Self';
        // } else
        // {
        $logintype = $orderinfo['Cust_Type'];
        // }

        $original_orderno = $orderinfo['Order_No'];
        $orderCustType = $this->getOrderCustType($pdo, $original_orderno);
        if($logintype == 'DO' || $logintype == ''){
            $logintype = $orderCustType;
        }

        switch ($orderinfo['OrderAction']) {
            case "Goods Collected":$return_order_status = "Goods Collected";
                break;
            case "Reject Return Request":$return_order_status = "Reject Return";
                break;
            // case "Goods Collected":$return_order_status = "Goods Collected";
            //     break;
            case "Request Return":$return_order_status = "Request Return";
                break;
            default:$return_order_status = $orderinfo['OrderAction'];
        }

        //  echo " Order status in updateReturnOrderHdr " . $order_info['OrderAction'] .  $return_order_status ;

        // $original_orderno = $orderinfo['Order_No'];

        $param_array[':return_order_no'] = $orderinfo['Order_No'];
        $param_array[':logintype'] = $logintype;
        $param_array[':return_fso_no'] = $orderinfo['FSO_No'];
        $param_array[':ret_fso_no'] = $orderinfo['FSO_No'];
        $param_array[':return_orderstatus'] = $return_order_status;
        $param_array[':return_reason_type'] = "";
        $param_array[':return_reason_description'] = "";


        // echo"Printing the values to sql <pre>";
        // print_r($param_array );

        $orderhdrstmt = '';

        try {

            $orderhdrstmt = $pdo->prepare("UPDATE Order_Hdr
        SET Order_Status = :return_orderstatus
            , Cust_Type = :logintype
            , FSO_No = :return_fso_no
            , Return_reason_Type = :return_reason_type
            , Return_Reason_Desc = :return_reason_description
            , Change_Date = now()
            , Change_Time = now()
            , Changed_By = :ret_fso_no
        where Order_No = :return_order_no;");

        } catch (PDOException $e) {
            $msg = "Error preparing update order header sql statement for order" . $orderinfo['Order_No'];
            echo " $msg " . $e->getMessage();
            $retval = false;
            throw $e;
        }

        try {
            $orderhdrstmt->execute($param_array);
            $msg = "The order header is updated for " . $orderinfo['Order_No'] . " ";
            $retval = true;

        } catch (PDOException $e) {
            $msg = "Error updating order header for order " . $orderinfo['Order_No'];
            echo $msg . $e->getMessage();
            $retval = false;
            throw $e;
        }
        // echo "$msg";

        $orderhdrstmt = '';
        $orderhdrupdatestmt = '';
        return ($retval);

    } // updateReturnOrderHdr

    private function get_original_order_no_ForBatch($pdo, $return_order_id)
    {

        // Fill the placeholder array for common data fields
        $param_arry = array();
        $param_arry[':return_ordernum'] = $return_order_id;

        try {
            // Return_goods = 1 is set only if the return order is accepted or if FSO returns on behalf of the buyer.
            $selorigorder = "SELECT return_order_no as original_order_no from Order_Hdr where Order_No = :return_ordernum LIMIT 1;";
            $selorigstmt = $pdo->prepare($selorigorder);
            $selorigstmt->execute($param_arry);
            $row = $selorigstmt->fetch(PDO::FETCH_ASSOC);
            $original_order_no = $row['original_order_no'];
        } catch (PDOException $e) {
            // $msg = "Error retrieving original order number for return order $return_order_id " . $e->getMessage();
            // echo "exception is $msg";
            // throw $e;
            // return (false);
            $original_order_no = '';
        }
        return ($original_order_no);
    }

    private function updateOriginalOrderHdrcolsForBatch($pdo, $return_order_id, $OrderAction)
    {
        // update the original order hdr for Return_goods,

        // Fill the placeholder array for common data fields
        $param_arry = array();
        $param_arry[':return_ordernum'] = $return_order_id;

        try {
            // Return_goods = 1 is set only if the return order is accepted or if FSO returns on behalf of the buyer.
            $selorigorder = "select return_order_no as original_order_no from Order_Hdr where Order_No = :return_ordernum LIMIT 1;";
            $selorigstmt = $pdo->prepare($selorigorder);
            $selorigstmt->execute($param_arry);
            $row = $selorigstmt->fetch(PDO::FETCH_ASSOC);
        } catch (PDOException $e) {
            $msg = "Error retrieving original order number for return order $return_order_id " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);
        }

        try {
            $parameter_ary[':original_order_no'] = $row['original_order_no'];

            $updatestring = "UPDATE Order_Hdr set Return_goods = 1 where Order_No = :original_order_no;";

            $updateorigorderstmt = $pdo->prepare($updatestring);
            $updateorigorderstmt->execute($parameter_ary);
        } catch (PDOException $e) {
            $msg = "Error updating return goods flag for original order " . $row['original_order_no'] . " of return order $return_order_id " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);
        }

        return (true);

    } // updateOriginalOrderHdrcols

    private function createOrderAddressForBatch($pdo, $original_order_id, $return_order_id, $orderinfo)
    {
// Called only when the OrderAction is Return Request OR Return. For the return order, this creates a snapshot of the original order addresses.

        try {

            $odraddrquery = $pdo->prepare("INSERT INTO Order_Addresses
(`Order_No`, `Address_ID`, `Address_Type`, `Ref_Address_ID`, `User_No`, `Login_Type`, `GSTIN`, `Name`, `Email_ID`, `Address`, `Flat_No`, `Locality`, `Pincode`,
`City_Code`, `State_Code`, `Latitude`, `Longitude`, `Contact_No`, `Contact_No_Type`, `Status`, `Default_Flag`, `Creation_Date`, `Created_By`, `Changed_Date`, `Changed_By`, `Landmark`)
    SELECT :return_order_id Order_No
    ,`Address_ID`, `Address_Type`,`Ref_Address_ID`
    , User_No
    ,`Login_Type`, `GSTIN`,`Name`,`Email_ID`,`Address`,`Flat_No`, `Locality`, `Pincode`, `City_Code`,`State_Code`, `Latitude`
    ,`Longitude`, `Contact_No`,`Contact_No_Type`,`Status`, `Default_Flag`, now()
    , :created_by,  now()
    , :changed_by, `Landmark`
    FROM `Order_Addresses` where Order_No = :order_no
    and Address_ID in ( with cte as ( select Address_ID, Bill_Address_ID, Supplier_Address_ID, Supplier_Bill_Address_ID
    from Order_Hdr where  Order_No = :order_id )
        select  Address_ID  from cte
    union all
        select  Bill_Address_ID from cte
    union all
        select  Supplier_Address_ID from cte
    union all
        select Supplier_Bill_Address_ID from cte);");

        } catch (PDOException $e) {
            $msg = "Error preparing return order address query for $return_order_id " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);

        }

        $parm_array[':return_order_id'] = $return_order_id;
        $parm_array[':order_id'] = $original_order_id;
        $parm_array[':order_no'] = $original_order_id;

        if ($orderinfo['Cust_Type'] == 'Self') {
            //$parm_array[':user_no'] = $orderinfo['Cust_No'];
            $parm_array[':created_by'] = $orderinfo['Cust_No'];
            $parm_array[':changed_by'] = $orderinfo['Cust_No'];
        } else {
            //$parm_array[':user_no'] = $orderinfo['FSO_No'];
            $parm_array[':created_by'] = $orderinfo['FSO_No'];
            $parm_array[':changed_by'] = $orderinfo['FSO_No'];
        }

        try {

            $retans = $odraddrquery->execute($parm_array);

            // var_dump($retans);

        } catch (PDOException $e) {
            $msg = "Error creating address snapshot for return order $return_order_id " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);

        }

        return (true);

    } //createOrderAddress

//dev-14 , For Open Returns - Meenal Barve
    private function createOpenOrderAddress($pdo, $original_order_id, $return_order_id, $orderinfo)
    {
// Called only when the OrderAction is Return Request OR Return. For the return order, this creates a snapshot of the original order addresses.

        try {

            $odraddrquery = $pdo->prepare("INSERT INTO Order_Addresses(`Order_No`,
        `Address_ID`,
        `Address_Type`,
        `Ref_Address_ID`,
        `User_No`,
        `Login_Type`,
        `GSTIN`,
        `Name`,
        `Email_ID`,
        `Address`,
        `Flat_No`,
        `Locality`,
        `Pincode`,
        `City_Code`,
        `State_Code`,
        `Latitude`,
        `Longitude`,
        `Contact_No`,
        `Contact_No_Type`,
        `Status`,
        `Default_Flag`,
        `Creation_Date`,
        `Created_By`,
        `Changed_Date`,
        `Changed_By`,
        `Landmark`)
            SELECT
					:return_order_id,
					`Address_ID`,
					'Shipping',
					`Ref_Address_ID`,
					`User_No`,
					`Login_Type`,
					`GSTIN`,
					`Name`,
					`Email_ID`,
					`Address`,
					`Flat_No`,
					`Locality`,
					`Pincode`,
					`City_Code`,
					`State_Code`,
					`Latitude`,
					`Longitude`,
					`Contact_No`,
					`Contact_No_Type`,
					`Status`,
					`Default_Flag`,
					 now(),
					 :created_by,
					 now(),
					 :changed_by,
					`Landmark` FROM `BBC_Addresses` where Address_ID IN (:shipping_address_id)
        UNION ALL
                SELECT
                    :return_order_id1,
                    `Address_ID`,
                    'Billing',
                    `Ref_Address_ID`,
                    `User_No`,
                    `Login_Type`,
                    `GSTIN`,
                    `Name`,
                    `Email_ID`,
                    `Address`,
                    `Flat_No`,
                    `Locality`,
                    `Pincode`,
                    `City_Code`,
                    `State_Code`,
                    `Latitude`,
                    `Longitude`,
                    `Contact_No`,
                    `Contact_No_Type`,
                    `Status`,
                    `Default_Flag`,
                     now(),
                     :created_by1,
                     now(),
                     :changed_by1,
                    `Landmark` FROM `BBC_Addresses` where Address_ID IN (:billing_address_id);");

        } catch (PDOException $e) {
            $msg = "Error preparing return order Shipping address query for $return_order_id " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);

        }

        $parm_array[':return_order_id']      = $return_order_id;
        $parm_array[':return_order_id1']     = $return_order_id;
        $parm_array[':shipping_address_id']  = $_SESSION['addrData'][1]; //Shipping Address
        $parm_array[':billing_address_id']   = $_SESSION['addrData'][2]; //Billing Address


        if ($orderinfo['Cust_Type'] == 'Self') {
            //$parm_array[':user_no'] = $orderinfo['Cust_No'];
            $parm_array[':created_by'] = $orderinfo['Cust_No'];
            $parm_array[':changed_by'] = $orderinfo['Cust_No'];
            $parm_array[':created_by1'] = $orderinfo['Cust_No'];
            $parm_array[':changed_by1'] = $orderinfo['Cust_No'];
        } else {
            //$parm_array[':user_no'] = $orderinfo['FSO_No'];
            $parm_array[':created_by'] = $orderinfo['FSO_No'];
            $parm_array[':changed_by'] = $orderinfo['FSO_No'];
            $parm_array[':created_by1'] = $orderinfo['FSO_No'];
            $parm_array[':changed_by1'] = $orderinfo['FSO_No'];
        }

        try {

            $retans = $odraddrquery->execute($parm_array);
            //$odraddrquery->debugDumpParams();
            // var_dump($retans);

        } catch (PDOException $e) {
            $msg = "Error creating shipping address snapshot for return order $return_order_id " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);

        }

        //Customer Address - Delivery & Billing
        try {


            $odraddrquery = $pdo->prepare("INSERT INTO Order_Addresses(`Order_No`,
        `Address_ID`,
        `Address_Type`,
        `Ref_Address_ID`,
        `User_No`,
        `Login_Type`,
        `GSTIN`,
        `Name`,
        `Email_ID`,
        `Address`,
        `Flat_No`,
        `Locality`,
        `Pincode`,
        `City_Code`,
        `State_Code`,
        `Latitude`,
        `Longitude`,
        `Contact_No`,
        `Contact_No_Type`,
        `Status`,
        `Default_Flag`,
        `Creation_Date`,
        `Created_By`,
        `Changed_Date`,
        `Changed_By`,
        `Landmark`)
            SELECT
					:return_order_id,
					`Address_ID`,
					'Delivery',
					`Ref_Address_ID`,
					`User_No`,
					`Login_Type`,
					`GSTIN`,
					`Name`,
					`Email_ID`,
					`Address`,
					`Flat_No`,
					`Locality`,
					`Pincode`,
					`City_Code`,
					`State_Code`,
					`Latitude`,
					`Longitude`,
					`Contact_No`,
					`Contact_No_Type`,
					`Status`,
					`Default_Flag`,
					 now(),
					 :created_by,
					 now(),
					 :changed_by,
					`Landmark` FROM `BBC_Addresses` where Address_ID IN (:delivery_address_id)
                UNION ALL
            SELECT
					:return_order_id1,
					`Address_ID`,
					'Billing',
					`Ref_Address_ID`,
					`User_No`,
					`Login_Type`,
					`GSTIN`,
					`Name`,
					`Email_ID`,
					`Address`,
					`Flat_No`,
					`Locality`,
					`Pincode`,
					`City_Code`,
					`State_Code`,
					`Latitude`,
					`Longitude`,
					`Contact_No`,
					`Contact_No_Type`,
					`Status`,
					`Default_Flag`,
					 now(),
					 :created_by1,
					 now(),
					 :changed_by1,
					`Landmark` FROM `BBC_Addresses` where Address_ID IN (:delivery_address_id1)
                    ;");

            $parm_arr=array();
            $parm_arr[':delivery_address_id']  = $_SESSION['addrData'][0]; //Delivery Address
            if ($orderinfo['Cust_Type'] == 'Self') {
                //$parm_array[':user_no'] = $orderinfo['Cust_No'];
                $parm_arr[':created_by'] = $orderinfo['Cust_No'];
                $parm_arr[':changed_by'] = $orderinfo['Cust_No'];
            } else {
                //$parm_array[':user_no'] = $orderinfo['FSO_No'];
                $parm_arr[':created_by'] = $orderinfo['FSO_No'];
                $parm_arr[':changed_by'] = $orderinfo['FSO_No'];
            }
            $parm_arr[':return_order_id']      = $return_order_id;
            $parm_arr[':return_order_id1']      = $return_order_id;
            $parm_arr[':delivery_address_id1']  = $_SESSION['addrData'][0]; //Delivery Address
            if ($orderinfo['Cust_Type'] == 'Self') {
                //$parm_array[':user_no'] = $orderinfo['Cust_No'];
                $parm_arr[':created_by1'] = $orderinfo['Cust_No'];
                $parm_arr[':changed_by1'] = $orderinfo['Cust_No'];
            } else {
                //$parm_array[':user_no'] = $orderinfo['FSO_No'];
                $parm_arr[':created_by1'] = $orderinfo['FSO_No'];
                $parm_arr[':changed_by1'] = $orderinfo['FSO_No'];
            }

            unset($_SESSION['addrData']);

        } catch (PDOException $e) {
            $msg = "Error preparing return order Customer Delivery & Billing address query for $return_order_id " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);

        }
        try {

            $retans = $odraddrquery->execute($parm_arr);
            //$odraddrquery->debugDumpParams();
            // var_dump($retans);

        } catch (PDOException $e) {
            $msg = "Error creating customer delivery & Billing address snapshot for return order $return_order_id " . $e->getMessage();
            echo "exception is $msg";
            throw $e;
            return (false);

        }

        return (true);

    } //createOpenOrderAddress


    private function getOrderCustType($pdo, $order_no){
        $get_custype  = $pdo->prepare("SELECT Cust_Type FROM  Order_Hdr WHERE Order_No='$order_no'");
        $get_custype->execute();
        $get_custype->debugDumpParams();
        $custyperow = $get_custype->fetch(PDO::FETCH_ASSOC);
        $original_cust_type = '';
        if(!empty($custyperow)){
            $original_cust_type = $custyperow['Cust_Type'];
        }
        return $original_cust_type;
    }
}
