<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use PDO;
use PDOException;

/******** JSON INPUT
{"Store_No" :, "Area_Code":}
 ********/
class StoreController extends Controller
{
    public function get_store_serving_area(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        try {
            // get all serving area of given area and store no
            $servingAreastmt = $this->pdo->prepare("SELECT A.Area_Code, A.Area_Name, Is_Area_Served('$Store_No','$Area_Code') as Is_Area_Served
                               FROM Store_Master as S
                               JOIN BBC_Org_Serving_Areas as BCSA ON BCSA.Store_No = S.Store_No
                               JOIN Area_Master as A ON A.Area_Code = BCSA.Area_Code
                               WHERE BCSA.Store_No = '$Store_No'
                               AND BCSA.Status = 'A'
                               AND BCSA.Type = 'R';");
            $servingAreastmt->execute();
            $servingArea = $servingAreastmt->fetchAll(PDO::FETCH_ASSOC);

            if(!empty($servingArea))
            {
                $ai_array = [];
                // $final_array = [];
                for($i=0;$i<count($servingArea);$i++)
                {
                    $ai_array[$i]['area_code'] = $servingArea[$i]['Area_Code'];
                    $ai_array[$i]['area_name'] = $servingArea[$i]['Area_Name'];
                }

                $data['is_served'] = $servingArea[0]['Is_Area_Served'];
                $data['serving_areas'] = $ai_array;
            }
            if (!empty($data)) {

                // $data = $final_array;
                $msg = 'Success';
            } else {
                $msg = 'Currently no serving areas for this store';
                $status = false;
            }
        } catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
            // return get_response("Something went wrong", $status, $data);
        }

        return get_response($msg, $status, $data);
    }

    public function get_all_store_brands(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        try{
            if((!empty($FSO_No)) && ($FSO_No > 0)){ //if FSO given
                $sql = $this->pdo->prepare("select DISTINCT Filter_ID as brandno ,B.Brand_Desc as brandname
            from   BBC_Org_User_Filters F,Brand_Master B
            where  Store_No   ='$Store_No'
            and    FSO_No     = '$FSO_No'
            and    F.Filter_ID = B.Brand_ID
            and    F.Status     ='A'
            and    B.Status     ='Y'
            and    Filter_Type='Brand'
            and    B.Brand_ID IN (select distinct A.Brand_ID
                                  from   Article_Master A
                                  INNER JOIN Brand_Master B on B.Brand_ID = A.Brand_ID
                                  INNER JOIN Store_Listing S on S.Article_No= A.Article_No
                                  LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = S.Store_No AND S.Article_No = SC.Article_No and SC.City_Code = '$City_Code'
                                  where  ifnull(SC.Show_Flag,1)>0
                                  and    A.Status='A'
                                  and    S.Status='A'
                                  and    B.Status='Y'
                                  and    S.Store_No='$Store_No')
            order by B.Brand_Desc");
                $sql->execute();
                $data = $sql->fetchAll(PDO::FETCH_ASSOC);
            }
            else {  //if Customer is given
                $sqlBrand = $this->pdo->prepare("select distinct A.Brand_ID as brandno,B.Brand_Desc as brandname
            from Article_Master A
            INNER JOIN Brand_Master B on B.Brand_ID = A.Brand_ID
            INNER JOIN Store_Listing S on S.Article_No= A.Article_No
            LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = S.Store_No AND S.Article_No = SC.Article_No and SC.City_Code = '$City_Code'
            where ifnull(SC.Show_Flag,1)>0
            and B.Status='Y'
            and S.Status='A'
            and S.Store_No='$Store_No'
            and A.Status='A'
            order by B.Brand_Desc");
                $sqlBrand->execute();
                $data = $sqlBrand->fetchAll(PDO::FETCH_ASSOC);
            }

            if (!empty($data)) {
                // $data = $allBrands;
                $msg = 'Success';

            } else {
                $msg = 'Brand Data is not available';
                $status = false;
            }
        }
        catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
        }
        return get_response($msg, $status, $data);
    }

    /******** JSON INPUT {"Area_Code" :} ********/
    public function store_details(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        try {
            if (!empty($Area_Code)) {

                $stmt = $this->pdo->prepare("SELECT STM.Store_No,
                                    STM.Store_Name,
                                    STM.Mobile_No_1,
                                    BA.Address,
                                    BA.Locality,
                                    AM.Area_Name,
                                    CM.City_Name,
                                    SM.State_Name,
                                    BA.Pincode,
                                    BA.Latitude,
                                    BA.Longitude,
                                    SBA.Address Store_Address,
                                    SAM.Area_Name Store_Area,
                                    SCM.City_Name Store_City,
                                    SSM.State_Name Store_State,
                                    SBA.Pincode Store_Pincode,
                                    SBA.Latitude Store_Latitude,
                                    SBA.Longitude Store_Longitude,
                                    STM.Min_Order_Amt min_order_amt,
                                    STM.Min_Order_Amt_Without_Chrg min_order_amt_without_chrg,
                                    COALESCE(SPM.Store_Offer_Msg, '') promotional_message,
                                    STM.Seller_Type,
                                    STM.Split_Order ,
                                    STM.Split_Order_Rule as Split_Rule
                                    from Store_Master STM
                                    INNER JOIN BBC_Addresses BA on STM.Store_No = BA.User_No
                                    INNER JOIN Area_Master AM on AM.Area_Code = BA.Locality
                                    INNER JOIN City_Master CM on CM.City_Code = BA.City_Code
                                    INNER JOIN State_Master SM on SM.State_Code = BA.State_Code
                                    LEFT JOIN Store_Promo_Messages SPM on SPM.Store_No = STM.Store_No
                                    LEFT JOIN BBC_Org_Serving_Areas BSA on BSA.Store_No = STM.Store_No
                                    LEFT JOIN BBC_Addresses SBA on STM.Store_No = SBA.User_No and SBA.Address_Type = 'Registered'
                                    LEFT JOIN Area_Master SAM on SAM.Area_Code = SBA.Locality
                                    LEFT JOIN City_Master SCM on SCM.City_Code = SBA.City_Code
                                    LEFT JOIN State_Master SSM on SSM.State_Code = SBA.State_Code
                                    where BA.Status = 'A'
                                    and BA.Address_Type = 'Shipping'
                                    and BA.Login_Type = 'Seller'
                                    and BSA.Area_Code='$Area_Code'
                                    and BSA.Type='R' and STM.Seller_Type in ('Retailer', 'COCO', 'COFO', 'FOCO', 'FOFO')");

                // $stmt = $this->pdo->prepare("select STM.Store_No, STM.Store_Name, STM.Mobile_No_1, BA.Address, BA.Locality, AM.Area_Name, CM.City_Name, SM.State_Name, BA.Pincode, BA.Latitude, BA.Longitude from BBC_Addresses BA INNER JOIN Area_Master AM on AM.Area_Code = BA.Locality INNER JOIN City_Master CM on CM.City_Code = BA.City_Code INNER JOIN State_Master SM on SM.State_Code = BA.State_Code INNER JOIN Store_Master STM on STM.Store_No = BA.User_No where BA.Status = 'A' and BA.Address_Type = 'Shipping' and BA.Login_Type = 'Seller' and BA.Locality='$Area_Code'");
                $stmt->execute();
                // $stmt->debugDumpParams(); die();
                $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

                $address_array = array();
                $a_array = array();
                $store_array = array();
                if(!empty($arr))
                {
                    foreach ($arr as $key => $articleMargin) {
                        $store_no = $articleMargin['Store_No'];
                        $store_array[] = $store_no;
                        $a_array[$store_no][] = $articleMargin;
                    }

                    $address_array = $a_array;
                    $store = array_values(array_unique($store_array));

                    $final_array = [];
                    $ai_array = [];

                    foreach($a_array as $key => $array)
                    {
                        if(in_array($key, $store))
                        {
                            for($i=0;$i<count($array);$i++)
                            {
                                $ai_array[$i]['Address'] = $array[$i]['Address'];
                                $ai_array[$i]['Area_Name'] = $array[$i]['Area_Name'];
                                $ai_array[$i]['City_Name'] = $array[$i]['City_Name'];
                                $ai_array[$i]['State_Name'] = $array[$i]['State_Name'];
                                $ai_array[$i]['Pincode'] = $array[$i]['Pincode'];
                                $ai_array[$i]['Latitude'] = $array[$i]['Latitude'];
                                $ai_array[$i]['Longitude'] = $array[$i]['Longitude'];
                            }
                            $final_array[$key]['Store_No'] = $array[0]['Store_No'];
                            $final_array[$key]['Store_Name'] = $array[0]['Store_Name'];
                            $final_array[$key]['Seller_Type'] = $array[0]['Seller_Type'];
                            $final_array[$key]['Mobile_No_1'] = $array[0]['Mobile_No_1'];
                            $final_array[$key]['Store_Address'] = $array[0]['Store_Address'];
                            $final_array[$key]['Store_Area'] = $array[0]['Store_Area'];
                            $final_array[$key]['Store_City'] = $array[0]['Store_City'];
                            $final_array[$key]['Store_State'] = $array[0]['Store_State'];
                            $final_array[$key]['Store_Pincode'] = $array[0]['Store_Pincode'];
                            $final_array[$key]['Store_Latitude'] = $array[0]['Store_Latitude'];
                            $final_array[$key]['Store_Longitude'] = $array[0]['Store_Longitude'];
                            $final_array[$key]['min_order_amt'] = $array[0]['min_order_amt'];
                            $final_array[$key]['min_order_amt_without_chrg'] = $array[0]['min_order_amt_without_chrg'];
                            $final_array[$key]['promotional_message'] = $array[0]['promotional_message'];
                            $final_array[$key]['Split_Order'] = $array[0]['Split_Order'];
                            $final_array[$key]['Split_Rule'] = $array[0]['Split_Rule'];
                            $final_array[$key]['Address'] = $ai_array;
                        }
                    }
                    $store_final_array['Store'] = array();
                    foreach ($final_array as $key => $dataArray) {
                        $store_final_array['Store'][] = $dataArray;
                    }

                    // foreach ($store_array as $key => $dataArray) {
                    //     print_r($dataArray['Store']['Store_Name']);
                    //     print_r($dataArray['Address'][0]['Address']);
                    // }
                }



                if (!empty($store_final_array)) {
                    $data = $store_final_array;
                    $msg = 'Success';
                } else {
                    $msg = 'Data is not available';
                    $status = false;
                }
            }
        } catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }

        return get_response($msg, $status, $data);
    }

    public function add_store_transaction(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        Log::info('Request for add_store_transaction', ['post' => $post]);
        extract($post);
        $transaction_details = $post['transaction_details'];

        try{
            if(!empty($transaction_details) > 0 && isset($transaction_details['Info']) && !empty($transaction_details['Info'])) {
                Log::debug('In add_store_transaction in if condition checked isset and not empty transaction_details_info', ['transaction_details_info' => $transaction_details['Info']]);
                /* $fp = fopen('request_log.txt', 'a');
                fwrite($fp, $req_dump);
                fclose($fp);  */

                $transaction_type   = $transaction_details['Transaction_Type'];
                $payment_type   	= $transaction_details['Payment_Mode'];
                $remark 			= $transaction_details['Remark'];
                $store_no			= $transaction_details['Store_No'];
                $cust_no 			= $transaction_details['Cust_No'];
                $fso_no 			= $transaction_details['FSO_No'];
                $transactionDate    = date('Y-m-d H:i:s', strtotime($transaction_details['Payment_Date']));
                $Ref_No 			= $transaction_details['Cheque_No'];
                $Bank_Name 			= $transaction_details['Bank_Name'];
                $Branch_Name 		= $transaction_details['Branch_Name'];
                // $branchname 		= '';

                // get balance amount and outstanding balance amount of given store no and cust no
                $queryTransBalstmt = $this->pdo->prepare("SELECT Balance_Amt,Outstanding_Balance_Amt FROM `Store_Transaction` WHERE Store_No='$store_no' and Cust_No='$cust_no' ORDER BY Transaction_ID DESC LIMIT 1");
                $queryTransBalstmt->execute();
                $queryTransBalrow = $queryTransBalstmt->fetch(PDO::FETCH_ASSOC);
                Log::debug('In add_store_transaction get balance amount and outstanding balance amount of given store no and cust no', ['sql' => $queryTransBalstmt->debugDumpParams(),'queryTransBalrow'=>$queryTransBalrow]);
                $bal = 0;$Out_Bal=0;

                if(!empty($queryTransBalrow)) {
                    Log::debug('In add_store_transaction in if condition checks not empty queryTransBalrow', ['sql' => $queryTransBalstmt->debugDumpParams(),'queryTransBalrow'=>$queryTransBalrow]);
                    $bal = $queryTransBalrow['Balance_Amt'];
                    $Out_Bal=$queryTransBalrow['Outstanding_Balance_Amt'];
                }
                $Order_Info = $transaction_details['Info'];
                $balanceAmount = 0;
                $amount = 0;
                $invoice_no = '';
                $order_no = '';
                for($i=0;$i<count($Order_Info);$i++)
                {
                    Log::debug('In add_store_transaction in for loop using Order_Info array with following indexes', ['Order_Info' => $Order_Info,'i'=>$i]);
                    $amount = $Order_Info[$i]['Trans_Amt'];
                    $invoice_no = $Order_Info[$i]['Invoice_No'];
                    $order_no = $Order_Info[$i]['Order_No'];
                    $total=0;

                    if($transaction_type == 1) {
                        Log::debug('In add_store_transaction in if condition checked transaction_type is equal to 1', ['transaction_type' => $transaction_type,'i'=>$i]);

                        // $refno      	= $Ref_No;
                        // $bankname     	= $Bank_Name;
                        // $branchname     = $Branch_Name;
                        // $depositemode 	= $payment_type; //payment mode
                        // $depositamt	  	= $amount;
                        $withdraw_amt 	= 0;
                        $total		  	= ($bal+$amount); //Store - Customer Balance (add)
                        $outtotal       = ($Out_Bal+$amount); //Store - Customer Outstanding Balance (add)
                        $balanceAmount	= ($balanceAmount+$amount);//Store balance as a whole

                    }
                    $balance   		= 0;
                    $creation_date  = date('Y-m-d H:i:s');
                    // insert record in store_transaction
                    $storeTransactionSql = $this->pdo->prepare(
                        "INSERT INTO Store_Transaction (
							Transaction_Type,
							Store_No,
							Cust_No,
							FSO_No,
							Order_No,
							Invoice_No,
							Deposit_Amt,
							Withdraw_Amt,
							Balance_Amt,
							Outstanding_Balance_Amt,
							Transaction_Date,
							Creation_Date,
							Created_By,
							Changed_Date,
							Changed_By,
							Remark
						)

						VALUES (
							'$transaction_type',
							'$store_no',
							'$cust_no',
							'$fso_no',
							'$order_no',
							'$invoice_no',
							'$amount',
							'$withdraw_amt',
							'$total',
							'$outtotal',
							'$transactionDate',
							'$creation_date',
							'$fso_no',
							'$creation_date',
							'$fso_no',
							'$remark'
						)
					");
                    $storeTransactionSql->execute();
                    Log::debug('In add_store_transaction insert record in store_transaction', ['sql' => $storeTransactionSql->debugDumpParams(),'storeTransactionSql'=>$storeTransactionSql]);
                    $transaction_id  = 0;
                    if($storeTransactionSql) {
                        Log::debug('In add_store_transaction in if condition checked inserted record in store transaction', ['sql' => $storeTransactionSql->debugDumpParams(),'storeTransactionSql'=>$storeTransactionSql]);
                        // get last inserted auto increment id of store_transaction
                        $transaction_id = $this->pdo->lastInsertId();
                        // inserted record in store_transaction_detail of last inserted auto increment id of store_transaction
                        $storeTransactionDetailSql = $this->pdo->prepare(
                            "INSERT INTO Store_Transaction_Detail (

							Transaction_ID,
							Deposit_Mode,
							Ref_No,
							Bank_Name,
							Branch_Name,
							Creation_Date,
							Created_By,
							Changed_Date,
							Changed_By
						)

						VALUES (
							'$transaction_id',
							'$payment_type',
							'$Ref_No',
							'$Bank_Name',
							'$Branch_Name',
							'$creation_date',
							'$fso_no',
							'$creation_date',
							'$fso_no'
						)
					");
                        $storeTransactionDetail = $storeTransactionDetailSql->execute();
                        Log::debug('In add_store_transaction inserted record in store_transaction_detail of last inserted auto increment id of store_transaction', ['sql' => $storeTransactionDetailSql->debugDumpParams(),'storeTransactionDetail'=>$storeTransactionDetail]);
                        // get net_amount of given order
                        $getNetAmount = $this->pdo->prepare("Select Net_Amount from Order_Hdr where Order_No='$order_no'");
                        $getNetAmount->execute();
                        $getNetAmountRow = $getNetAmount->fetch(PDO::FETCH_ASSOC);
                        Log::debug('In add_store_transaction get net_amount of given order', ['sql' => $getNetAmount->debugDumpParams(),'getNetAmountRow'=>$getNetAmountRow]);
                        $net_amount = 0;
                        if(!empty($getNetAmountRow))
                        {
                            Log::debug('In add_store_transaction in if condition checked not empty net_amount of given order', ['getNetAmountRow'=>$getNetAmountRow,'net_amount'=>$getNetAmountRow['Net_Amount']]);
                            $net_amount = $getNetAmountRow['Net_Amount'];
                        }
                        if($storeTransactionDetail == 1){
                            Log::debug('In add_store_transaction in if condition checked storeTransactionDetail is eqaul to 1', ['storeTransactionDetail'=>$storeTransactionDetail]);
                            #Added by Meenal B. 29th November 2018 to make Payment Status Paid for the Order No and Invoice No
                            $change_date  = date('Y-m-d');
                            $change_time  = date('H:i:s');
                            // get collection amount of order and net_amount
                            $collectionamt = $this->pdo->prepare("Select Get_Collection_Amount2('$order_no','$net_amount') as collection_amount");
                            $collectionamt->execute();
                            $collectionamtrow = $collectionamt->fetch(PDO::FETCH_ASSOC);
                            if ( isset($order_no) && $order_no != '' ) {
                                Log::debug('In add_store_transaction in if condition checked isset order_no and not empty order_no', ['order_no'=>$order_no]);
                                if($collectionamtrow['collection_amount']==0)
                                {
                                    Log::debug('In add_store_transaction in if condition checked collection_amount is equal to 0', ['sql'=>$collectionamt->debugDumpParams(),'collection_amount'=>$collectionamtrow['collection_amount']]);
                                    if (!isset($invoice_no) || $invoice_no == '' ) {
                                        Log::debug('In add_store_transaction in if condition checked not isset invoice_no or not empty invoice_no', ['invoice_no'=>$invoice_no]);
                                        $updatePaymentStatusSql = $this->pdo->prepare(
                                            "UPDATE Order_Hdr SET Payment_Status='Paid',Change_Date='$change_date',Change_Time='$change_time',Changed_By='$fso_no'
							 	WHERE Order_No='$order_no'") ;
                                        $updatePaymentStatus = $updatePaymentStatusSql->execute();
                                        Log::debug('In add_store_transaction updated Payment_Status, Change_Date, Change_Time, Changed_By', ['sql'=>$updatePaymentStatus->debugDumpParams(),'updatePaymentStatus'=>$updatePaymentStatus]);
                                    }
                                    else {
                                        Log::debug('In add_store_transaction in if condition checked not isset invoice_no or not empty invoice_no', ['invoice_no'=>$invoice_no]);
                                        $updatePaymentStatusSql = $this->pdo->prepare(
                                            "UPDATE Order_Hdr SET Payment_Status='Paid',Change_Date='$change_date',Change_Time='$change_time',Changed_By='$fso_no'
								WHERE Order_No='$order_no'
								AND (Sk_Invoice_No='$invoice_no' OR Ext_Invoice_No='$invoice_no')");
                                        $updatePaymentStatus = $updatePaymentStatusSql->execute();
                                        Log::debug('In add_store_transaction updated Payment_Status, Change_Date, Change_Time, Changed_By', ['sql'=>$updatePaymentStatusSql->debugDumpParams(),'updatePaymentStatus'=>$updatePaymentStatus]);
                                    }
                                }
                                else if($collectionamtrow['collection_amount']>0)
                                {
                                    Log::debug('In add_store_transaction in else if condition checked collection_amount greater than 0', ['collection_amount'=>$collectionamtrow['collection_amount']]);
                                    if (!isset($invoice_no) || $invoice_no == '' ) {
                                        Log::debug('In add_store_transaction in if condition checked not isset invoice_no or not empty invoice_no', ['invoice_no'=>$invoice_no]);
                                        $updatePaymentStatusSql = $this->pdo->prepare(
                                            "UPDATE Order_Hdr SET Payment_Status='Partial',Change_Date='$change_date',Change_Time='$change_time',Changed_By='$fso_no'
								 	WHERE Order_No='$order_no'") ;
                                        $updatePaymentStatus = $updatePaymentStatusSql->execute();
                                        Log::debug('In add_store_transaction updated Payment_Status, Change_Date, Change_Time, Changed_By', ['sql'=>$updatePaymentStatusSql->debugDumpParams(),'updatePaymentStatus'=>$updatePaymentStatus]);
                                    }
                                    else
                                    {
                                        Log::debug('In add_store_transaction in if condition checked not isset invoice_no or not empty invoice_no', ['invoice_no'=>$invoice_no]);
                                        $updatePaymentStatusSql = $this->pdo->prepare(
                                            "UPDATE Order_Hdr SET Payment_Status='Partial',Change_Date='$change_date',Change_Time='$change_time',Changed_By='$fso_no'
									WHERE Order_No='$order_no'
									AND (Sk_Invoice_No='$invoice_no' OR Ext_Invoice_No='$invoice_no')");
                                        $updatePaymentStatus = $updatePaymentStatusSql->execute();
                                        Log::debug('In add_store_transaction updated Payment_Status, Change_Date, Change_Time, Changed_By', ['sql'=>$updatePaymentStatusSql->debugDumpParams(),'updatePaymentStatus'=>$updatePaymentStatus]);
                                    }
                                }
                                else
                                {
                                    if (!isset($invoice_no) || $invoice_no == '' ) {
                                        Log::debug('In add_store_transaction in if condition checked not isset invoice_no or not empty invoice_no', ['invoice_no'=>$invoice_no]);
                                        $updatePaymentStatusSql = $this->pdo->prepare(
                                            "UPDATE Order_Hdr SET Payment_Status='Paid',Change_Date='$change_date',Change_Time='$change_time',Changed_By='$fso_no'
								 	WHERE Order_No='$order_no'") ;
                                        $updatePaymentStatus = $updatePaymentStatusSql->execute();
                                        Log::debug('In add_store_transaction updated Payment_Status, Change_Date, Change_Time, Changed_By', ['sql'=>$updatePaymentStatusSql->debugDumpParams(),'updatePaymentStatus'=>$updatePaymentStatus]);
                                    }
                                    else {
                                        Log::debug('In add_store_transaction in if condition checked not isset invoice_no or not empty invoice_no', ['invoice_no'=>$invoice_no]);
                                        $updatePaymentStatusSql = $this->pdo->prepare(
                                            "UPDATE Order_Hdr SET Payment_Status='Paid',Change_Date='$change_date',Change_Time='$change_time',Changed_By='$fso_no'
									WHERE Order_No='$order_no'
									AND (Sk_Invoice_No='$invoice_no' OR Ext_Invoice_No='$invoice_no')");
                                        $updatePaymentStatus = $updatePaymentStatusSql->execute();
                                        Log::debug('In add_store_transaction updated Payment_Status, Change_Date, Change_Time, Changed_By', ['sql'=>$updatePaymentStatusSql->debugDumpParams(),'updatePaymentStatus'=>$updatePaymentStatus]);
                                    }
                                }

                                if ($updatePaymentStatus==1) {
                                    Log::debug('In add_store_transaction in if condition checked updatePaymentStatus is equal to 1', ['updatePaymentStatus'=>$updatePaymentStatus]);
                                    $msg = "Transaction added successfully";
                                    $status = true;
                                }
                                else {
                                    Log::debug('In add_store_transaction in else condition checked updatePaymentStatus is equal to 1', ['updatePaymentStatus'=>$updatePaymentStatus]);
                                    $msg = "Transaction failed";
                                    $status = false;
                                }

                            }
                            else {
                                $msg = "Transaction added successfully";
                                $status = true;
                            }
                        }else{
                            $msg = "Transaction failed";
                            $status = false;
                        }
                    }
                    else {
                        $msg = "Transaction failed";
                        $status = false;
                    }
                }

            }else {
                Log::debug('In add_store_transaction in else checked checked isset and not empty transaction_details_info', ['transaction_details' => $transaction_details,'msg'=>'Invalid request for transaction.']);
                $msg = "Invalid request for transaction.";
                $status = false;
            }
            // return get_response($msg, $status, $data);
        }catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
            Log::debug('Response for add_store_transaction in catch', ['data' => $data,'status'=>false,'msg'=>$msg]);
            // return get_response("Something went wrong", $status, $data);
        }
        Log::info('Response for add_store_transaction', ['data' => $data,'status'=>false,'msg'=>$msg]);
        return get_response($msg, $status, $data);
    }
}
