<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDOException;

class ThirdPartyController extends Controller
{
    public function update_3rdparty_orderno(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        //ini_set('display_errors', 'On');
        //error_reporting(E_ALL);

        // At this point we have input parameter in $businessid, $orderno and $source_order_no
        // ignore businessid for now.

        $where = "";
        $param_array = array();

        if (isset($source_order_no) && $source_order_no > 0) {
            $param_array[':legacy_order_no'] = $source_order_no;

            if (isset($orderno) && $orderno > 0) {
                $param_array[':orderno'] = $orderno;
                $param_array[':Changed_Date'] = date('Y-m-d');
                $param_array[':Change_Time'] = date('H:i:s');
                $param_array[':Changed_By'] = 10000;
                $where .= 'Order_Hdr.Order_No = :orderno ;';

                // echo "where is $where <pre>";
                // print_r($param_array);

                try {
                    $stmt = $this->pdo->prepare("UPDATE Order_Hdr set Order_Hdr.Legacy_Order_No = :legacy_order_no, Order_Hdr.Change_Date = :Changed_Date, Order_Hdr.Change_Time = :Change_Time, Order_Hdr.Changed_By = :Changed_By where " . $where);
                    $stmt->execute($param_array);
                    $msg = "Success....updated $orderno with source order number $source_order_no ";
                    $status = true;
                    $data['legacy_order_no'] = $source_order_no;

                } catch (PDOException $e) {
                    $msg = "Failed to update the source order number $source_order_no for orderno " . $orderno . " " . $e->getMessage();
                    echo "Message when processing $orderno $msg";
                    $status = false;
                }
            } else { // if orderno is not valid
                $msg = "Internal Order Number is mandatory for updating source order number";
                $status = false;
            }
        } else { // if source _order_no is not valid
            $msg = "Source system Order Number is mandatory for updating $orderno order header";
            $status = false;
        }

        return get_response($msg, $status, $data);
    }

    public function update_3rdparty_buyerno(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        // error_reporting(E_ALL);
        // ini_set('display_errors', 1);
        // ini_set('display_startup_errors', 1);

        // At this point we have input parameter in business_id, seller_no, buyer_no and source_buyer_no
        // ignore businessid for now.

        $where = "";
        $param_array = array();

        if (isset($seller_no) && $seller_no > 0) {
            $param_array[':seller_no'] = $seller_no;

            if (isset($buyer_no) && $buyer_no > 0) {
                $param_array[':buyer_no'] = $buyer_no;
                $param_array[':Changed_Date'] = date('Y-m-d H:i:s');
                $param_array[':Changed_By'] = 10000;
                if (isset($source_buyer_no) && $source_buyer_no > 0) {
                    $param_array[':source_buyer_no'] = $source_buyer_no;
                    $where .= ' Cust_Store_Master.Store_No = :seller_no AND Cust_Store_Master.Cust_No = :buyer_no;';

                    try {
                        $stmt = $this->pdo->prepare("UPDATE Cust_Store_Master set Supplier_Retailer_No = :source_buyer_no , Changed_Date = :Changed_Date,  Changed_By = :Changed_By where " . $where);
                        $stmt->execute($param_array);
                        $msg = "Success....updated seller_no $seller_no, buyer_no $buyer_no with source buyer number $source_buyer_no ";
                        $status = true;
                        $data['source_buyer_no'] = $source_buyer_no;

                    } catch (PDOException $e) {
                        $msg = "Failed to update the source buyer number $source_buyer_no for seller_no $seller_no, buyer_no $buyer_no " . $e->getMessage();
                        echo "Message when processing $orderno $msg";
                        $status = false;
                    }
                } else { // if source buyer no is not valid
                    $msg = "Source system buyer number is mandatory for updating source buyer number";
                    $status = false;
                }
            } else { // if internal buyer no is not valid
                $msg = "Internal buyer number is mandatory for updating source buyer number";
                $status = false;
            }
        } else { // if source _order_no is not valid
            $msg = "Internal Store number is mandatory for updating source buyer number";
            $status = false;
        }

        return get_response($msg, $status, $data);
    }

    public function update_3rdparty_transactionId(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        ini_set('display_errors', 'On');
        error_reporting(E_ALL);

        // At this point we have input parameter in $businessid, $orderno and $source_order_no
        // ignore businessid for now.

        $where = "";
        $param_array = array();

        if (isset($source_payment_number) && $source_payment_number > 0) {
            $param_array[':legacy_Transaction_no'] = $source_payment_number;
            $param_array[':Changed_Date'] = date('Y-m-d H:i:s');
            $param_array[':Changed_By'] = 10000;
            if (isset($Transaction_ID) && $Transaction_ID > 0) {
                $param_array[':Transaction_ID'] = $Transaction_ID;

                $where .= 'Store_Transaction.Transaction_ID = :Transaction_ID ;';
                /* print_r($where);
                die;*/
                try {
                    $stmt = $this->pdo->prepare("UPDATE Store_Transaction set Store_Transaction.Legacy_Transaction_No = :legacy_Transaction_no , Changed_Date = :Changed_Date, Changed_By = :Changed_By where " . $where);
                    $stmt->execute($param_array);
                    /*  print_r($stmt);
                      die;*/
                    $msg = "Success....updated $Transaction_ID with source Payment number $source_payment_number ";
                    $status = true;
                    $data['Legacy_Transaction_No'] = $source_payment_number;

                } catch (PDOException $e) {
                    $msg = "Failed to update the source Transaction number $source_payment_number for Transaction_ID " . $Transaction_ID . " " . $e->getMessage();
                    echo "Message when processing $Transaction_ID $msg";
                    $status = false;
                }
            } else { // if orderno is not valid
                $msg = "Internal Payment Number is mandatory for updating source Payment number";
                $status = false;
            }
        } else { // if source _order_no is not valid
            $msg = "Source system Payment Number is mandatory for updating $Transaction_ID order header";
            $status = false;
        }

        return get_response($msg, $status, $data);
    }
}
