<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\Auth;

class BasicAuth
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        $credentials = $request->only('email', 'password');
        if (!Auth::once($credentials)) {
            return response()->json(['error' => 'Invalid credentials'], 401);
        }

        return $next($request);
    }
}
