<?php

use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Storage;

global $pdo;
function get_pdo() {
    $db = config('database.connections.mysql');
    global $pdo;
    if($pdo == null){
       $pdo = new PDO('mysql:host='.$db['host'].';port='.$db['port'].';dbname='.$db['database'], $db['username'], $db['password'], array(PDO::ATTR_PERSISTENT => true));
    }
    return $pdo;
}
function get_response($msg, $status = true, $data = array()){
    global $pdo;
        $sCode = 200;
        if($status == false){
            $sCode = 400;
            $status = 'false';
        } else {
            $status = 'true';
        }

        $final_result = array(
            "status"        => $status,
            "status_code"   => $sCode,
            "message"       => $msg
        );
        $final_result['data'] = $data;
        // if(isset($data) && !empty($data))
        $final_result['data'] = $data;

        $custNo = "";
        // $custNo = $final_result['data']['custNo'];

        /*echo basename($_SERVER['PHP_SELF']);
        print_r(json_decode(file_get_contents('php://input'), true));
        print_r(json_decode(file_get_contents('php://output'), true)); */

        ## If status is true then only send sync notification
        if($status == 'true' || $status == true){
            $api = strtolower(basename($_SERVER['PHP_SELF']));
            $inputjson  = json_decode(file_get_contents('php://input'), true);

            switch ($api) {
                case "update_profile": //if login type fso then send to FSO only , if self then send buyer and its FSO using $inputjson['User_No']
                    send_api_notification($pdo,$api, $inputjson['User_No'], $inputjson['Login_Type']);
                    break;
                case "save_favourite": //send both fso and customer mobile using customer_no
                    isset($inputjson['cart_data']['cust_no']) ? send_api_notification($pdo,$api, $inputjson['cart_data']['cust_no'], 'Self') : '';
                    break;
                case "save_cart"://send both fso and customer mobile using customer_no
                    isset($inputjson['cart_data']) ? send_api_notification($pdo,$api, $inputjson['cart_data']['cust_no'], 'Self') : '';
                    break;
                case "fso_retailer_signup"://send both fso and customer mobile using customer_no


                    send_api_notification($pdo, $api, $custNo, 'Self');

                    break;
                case "delete_address"://send both fso and customer mobile using customer_no
                    send_api_notification($pdo,$api, $inputjson['User_No'], $inputjson['Login_Type']);
                    break;
                case "set_address_default"://send both fso and customer mobile using customer_no
                    send_api_notification($pdo,$api, $inputjson['User_No'], $inputjson['Login_Type']);
                    break;
                case "add_feedback"://send both fso and customer mobile using customer_no
                    send_api_notification($pdo,$api, $inputjson['Cust_No'], 'Self');
                    break;
                case "add_store_transaction"://send both fso and customer mobile using customer_no
                    (isset($inputjson['transaction_details'])) ? send_api_notification($pdo,$api, $inputjson['transaction_details']['Cust_No'], 'Self') : '';
                    break;
                case "update_address"://send both fso and customer mobile using customer_no
                    send_api_notification($pdo, $api, $inputjson['User_No'], $inputjson['Login_Type']);
                    break;
                case "add_new_address"://send both fso and customer mobile using customer_no
                    send_api_notification($pdo, $api, $inputjson['Cust_No'], 'Self');
                    break;
                default:
                    //no need to call send api notification
            }
        }
        return response()->json($final_result, 200);
    }

/*****
 * send_api_notification
 * call api/url with curl
 * $apiname : web service / api name
 * $userno  :custno or fsono or do no.
 * $logintype :Buyer, FSO
 * $inputStr : input parameters array or json
 * $method : post/get
 * $inputType : inputStr type array or json
 * $header : header for curl call
 * Author : Meenal
 *****/
function send_api_notification($pdo,$apiname, $userno = 0, $logintype = '') {
    //echo $userno;
    //logging('****IN API**** : ', 'send_api_notification', 1, 'In send_api_notification');

    # Get package details
    $app_package_details = package_details();
    $package_name = '';
    $db_mode = 'ONLINE';
    if(!empty($app_package_details)){
        $package_name = $app_package_details[0]->Package_ID;
        $db_mode = $app_package_details[0]->DB_Mode;
    }

    $sql = '';
    $mobilenos = array();
    $entities  = array();
    $inputStr  = array();
    $data = [];
    # Set value to sendOfflineNotifications true or false
    $sendOfflineNotifications = false;

    Log::notice('Request for function => send_api_notification (Called from '.$apiname.') ', ['userno' => $userno,'logintype' => $logintype,'api' => $apiname]);
    if($userno > 0 && $logintype != ''){
        $sql = prepareSQL($pdo,$apiname, $userno, $logintype);
    }
    if ($db_mode =='OFFLINE')
    {
        if($sql != ''){
            $prepsql = $pdo->prepare($sql);
            $prepsql->execute();
            $data = $prepsql->fetchAll(PDO::FETCH_ASSOC);
            $prepsql->debugDumpParams();
        }

        #If current function called from upsert_article_margin_pricing then userno and logintype is not passed,
        # then get latest loggedin active mobile nos
        if($userno == 0 && $logintype == ''){
            $mobilenos = lastest_loggedin_mobilenos($pdo);//all mobile nos, used for upsert_article_margin
        }

        #flag to send notification
        $sendOfflineNotifications = true;

    } else {
        # Added temporary table with mobile number only
        # send notifications to those mobile no's only for testing purpose
        $prepsql = $pdo->prepare("Select Mobile_No from Temp_Offline_Access_Users ");
        $prepsql->execute();
        $data = $prepsql->fetchAll(PDO::FETCH_ASSOC);
        /*  Sheetal Chive
          21-03-2022
          commended below debugDumpParam(); */
        // $prepsql->debugDumpParams();
    }

    if(!empty($data)){
        $sendOfflineNotifications = true;
    }

    # Send notification if sendOfflineNotifications is true
    if( $sendOfflineNotifications == true ){
        //offline mode , send notification
        if (!empty($data)){
            foreach($data as $row1){
                array_push($mobilenos,$row1['Mobile_No']);
            }
        }

        # Get entities list
        $prepsql = $pdo->prepare("select Dependent_On from Pull_Master where Entity_Name = '$apiname' and Entity_Type='API'");
        $prepsql->execute();
        $data = $prepsql->fetch(PDO::FETCH_ASSOC);
        //$entities = explode(',',$data['Dependent_On']); //convert comma separated entities into array
        $entities = $data['Dependent_On'];

        $inputStr['entities']  = $entities;
        if (count($mobilenos)==1){
            $inputStr['mobilenos'] = $mobilenos[0];
        } else {
            $inputStr['mobilenos'] = implode(',',$mobilenos);  //send comma separated strings
        }

        //$inputStr['mobilenos'] = '9579732831, 7522920974'; // test................

        $inputStr['apiname']   = $apiname;
        $inputStr['syncType']  = 'Delta';  //Delta or Baseline
        //$inputStr['store_no']  = 4;
        $inputStr['package_name']  = $package_name;
        $api =  $_SERVER['HTTP_HOST']."/index.php/offline/create_batch";
        if($_SERVER['HTTP_HOST'] == 'localhost'){
            $api =  $_SERVER['HTTP_HOST']."/bbc/index.php/offline/create_batch";
        }

        logging('****IN API JSON**** : ', 'send_api_notification', 1, json_encode($inputStr));

        $inputStr['loggedInDeviceMtoken'] = '';
        ## Pass current logged in device mToken
        $inputjson = json_decode(file_get_contents('php://input'), true);
        if(!empty($inputjson) && isset($inputjson['mToken']) && $inputjson['mToken'] != ""){
            $inputStr['loggedInDeviceMtoken'] = $inputjson['mToken'];
        }

        //"https://familymartdev.snapkirana.shop/index.php/offline/create_batch";
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $api);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $inputStr);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);
        //print_r($result);exit; //IMP: uncomment this if you want to see prints from offline controller

        curl_close($ch);
        logging('****BACK IN API RESPONSE**** : ', 'send_api_notification', 1, trim($result));
        logging('****BACK IN API RESPONSE**** : ', 'send_api_notification end', 1, "API CODE END>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
        //echo "result=====".trim($result);
    }
    return true;
}

function package_details(){
    //require 'db_connect.php';
    $data = DB::select("Select DB_Mode,Package_ID from Config_Master where Package_ID like '".APP_PACKAGE_NAME_INT."%' ");
    //$cmsql->execute();
    //$data = $cmsql->fetch(PDO::FETCH_ASSOC);
    //$cmsql->debugDumpParams();
    return $data;
    //$package_name = $data['Package_ID'];
}

function prepareSQL($pdo,$apiname, $userno, $logintype){

    if($apiname == 'update_profile'){
        if (strtolower($logintype) =='FSO') {
            $sql= "Select Mobile_No from FSO_Master where FSO_No IN ('$userno') and Status='A'";
        } else {
            $sql = "Select Mobile_No from Cust_Master where Cust_No IN ('$userno') and Status='A'";
        }
    } else {
        if (strtolower($logintype) =='FSO') {
            $sql = "Select Mobile_No from Cust_Master where Cust_No IN (
					SELECT  CM.Cust_No
		                FROM BBC_Org_User_Groups G, Cust_Master CM, BBC_Org_Group_Users Buyer
		                where G.ID = Buyer.Org_Group_ID
		                and Buyer.User_No = CM.Cust_No
		                and Buyer.Login_Type='Buyer'
		                and Buyer.Status = 'A'
		                and CM.Status = 'A'
		                and (G.Store_No,Buyer.Org_Group_ID) IN
		                 (
							SELECT FSO.Store_No, FSO.Org_Group_ID Org_Group_ID
							FROM BBC_Org_Group_Users FSO
							INNER JOIN BBC_Org_User_Groups ON FSO.Org_Group_ID = BBC_Org_User_Groups.ID AND FSO.Store_No = BBC_Org_User_Groups.Store_No
							INNER JOIN BBC_Org_Group_Days ON BBC_Org_Group_Days.Org_Group_ID =FSO.Org_Group_ID AND BBC_Org_Group_Days.Store_No = FSO.Store_No
							INNER JOIN FSO_Master ON FSO_Master.FSO_No =FSO.User_No AND FSO_Master.Login_Type = FSO.Login_Type
							WHERE FSO.Status='A'
							AND FSO.User_No IN ('$userno')
							AND BBC_Org_Group_Days.Status='A'
							AND BBC_Org_Group_Days.Days_For=
							(CASE WHEN FSO_Master.Login_Type='FSO'
							         THEN 'Order'
							     WHEN FSO_Master.Login_Type='DO'
							         THEN 'Delivery'
							     ELSE 'Order'
							END)
		                )

	                group by CM.Cust_No
	            )
			UNION
				Select Mobile_No from FSO_Master where FSO_No IN ('$userno')  and Login_Type in ('FSO','DO')  and Status='A' ";
        } else {
            $sql= "Select Mobile_No from FSO_Master where FSO_No in
				(
					SELECT FSO.User_No
	                FROM BBC_Org_Group_Users FSO
	                INNER JOIN BBC_Org_User_Groups ON FSO.Org_Group_ID = BBC_Org_User_Groups.ID AND FSO.Store_No = BBC_Org_User_Groups.Store_No
	                INNER JOIN BBC_Org_Group_Days ON BBC_Org_Group_Days.Org_Group_ID =FSO.Org_Group_ID AND BBC_Org_Group_Days.Store_No = FSO.Store_No
	                INNER JOIN FSO_Master ON FSO_Master.FSO_No =FSO.User_No AND FSO_Master.Login_Type = FSO.Login_Type
	                WHERE FSO.Status='A' AND
	                BBC_Org_Group_Days.Status='A' AND
	                BBC_Org_Group_Days.Days_For=
	                (CASE
	                	WHEN FSO_Master.Login_Type='FSO'THEN 'Order'
	                	WHEN FSO_Master.Login_Type='DO'THEN 'Delivery'
	                 	ELSE 'Order'
	            	END)
					and (FSO.Store_No,FSO.Org_Group_ID) IN
					(	SELECT G.Store_No,G.ID Org_Group_ID
		                FROM BBC_Org_User_Groups G,
		                Cust_Master CM,
		                 BBC_Org_Group_Users Buyer
		                where G.ID = Buyer.Org_Group_ID
		                and Buyer.User_No = CM.Cust_No and CM.Cust_No in ('$userno')
		                and Buyer.Login_Type='Buyer'
		                and Buyer.Status = 'A'
		                and CM.Status = 'A'
	                )
	                group by FSO.User_No
	            )
			UNION
				Select Mobile_No from Cust_Master where Cust_No IN ('$userno') and Status='A'  ";
        }
    }

    return $sql;
}

function lastest_loggedin_mobilenos($pdo){

    $mTokenDetails = [];
    $app_package_details = package_details();
    if(!empty($app_package_details)){
        $package_name = $app_package_details['Package_ID'];

        $sql = "SELECT l.ID, l.Login_status, l.Mobile_No, l.Mtoken
					FROM Login_History l
					WHERE  Login_status = 'Success'
					AND Mtoken !=''
					AND Package_ID = '".$package_name."'
					AND `Login_Attempt_Date` > now() - INTERVAL 6 MONTH
					AND  Device_ID != ''
					ORDER BY ID DESC";

        $stmt = $pdo->prepare($sql);
        $stmt->execute([]);
        $mTokenDetails = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $mTokenDetails = (array_values(array_unique(array_column($mTokenDetails, 'Mobile_No'))));
    }
    return $mTokenDetails;
}

function getCustType($pdo, $cust_no, $store_no)
{
    $c_type = '';
    $queryCustType = $pdo->prepare("SELECT Seller_Type as Cust_Type
	    				  from Store_Master
						  where Status='A'
						  and   Store_No IN (Select Store_No from Store_Master
	                      where  Cust_No = '$cust_no'
	                      and Status='A')");
    $queryCustType->execute();
    $resultCustType  = $queryCustType->fetch(PDO::FETCH_ASSOC);
    if (!empty($resultCustType)) {
        $dataCustType = $resultCustType;
        $c_type = $dataCustType['Cust_Type'];
    }

    if(empty($c_type))
    {
        $querySType = $pdo->prepare("SELECT Seller_Type as STYPE
						   FROM Store_Master
						   where Store_No = '$store_no'
						   and Status='A'");
        $querySType->execute();
        $resultSType  = $querySType->fetch(PDO::FETCH_ASSOC);
        if (!empty($resultSType)) {
            $dataSType = $resultSType;
            switch($dataSType['STYPE'])
            {
                case "DISTRIBUTOR": $c_type= "Retailer"; break;
                case "Distributor": $c_type= "Retailer"; break;
                case "Superstockiest": $c_type= "Distributor"; break;
                case "SSstockiest": $c_type= "Superstockiest"; break;
                case "Manufacturer": $c_type= "SSstockiest"; break;
                case "COCO": $c_type= "Retailer"; break;
                case "COFO": $c_type= "Retailer"; break;
                case "FOFO": $c_type= "Retailer"; break;
                case "FOCO": $c_type= "Retailer"; break;
                default : $c_type = ""; break;
            }
        }
    }
    return $c_type;
}

function updateCartData($pdo, $custNo, $store_no, $cartData, $source=false)
{
    $date_time = date('Y-m-d H:i:s');

    #If store_no is null then empty the cart
    if( $store_no == null ){
        $updateOrderId=$pdo->prepare("UPDATE User_Cart SET Cart_Data = '[]', Changed_By = '$custNo', Changed_Date= '$date_time' WHERE Cust_No = '$custNo'");
        $updateOrderId->execute();

        $getCartData = $pdo->prepare("SELECT * from User_Cart WHERE Cust_No='$custNo'");
        $getCartData->execute();
        $cartDataResult = $getCartData->fetch(PDO::FETCH_ASSOC);
        return $cartDataResult;
    }

    $encodeCartData = json_encode($cartData);
    $existingCartData = array();
    $selectCart = $pdo->prepare("select * from User_Cart where Cust_No = '$custNo'");
    $selectCart->execute();
    $cart = array();
    $cart = $selectCart->fetchAll(PDO::FETCH_ASSOC);
    if(count($cart)==0)
    {
        $insertCart=$pdo->prepare("insert into User_Cart(Cust_No,Cart_Data, Created_By, Creation_Date, Changed_By, Changed_Date) values('$custNo','$encodeCartData', '$custNo', '$date_time', '$custNo', '$date_time')");
        $insertCart->execute();
        $insertCart->debugDumpParams();
        if($insertCart){
            $getCartData = $pdo->prepare("SELECT * from User_Cart WHERE Cust_No='$custNo'");
            $getCartData->execute();
            $cartDataResult = $getCartData->fetch(PDO::FETCH_ASSOC);
            return $cartDataResult;
        }else{ return false; }
    }else{
        $selectCartData = $cart;
        $existingCartData1 = json_decode($selectCartData[0]['Cart_Data']);
        $existingArticle = array();
        $existingStore = array();
        //if(!empty($existingCartData1))
        if(count($existingCartData1)>0)
        {
            foreach($existingCartData1 as $existingdata) {
                //print_r($existingdata);
                $favourite_cart = array();
                $cart = array();
                $favourite_cart['Article_No'] = $existingdata[0]->Article_No;
                $favourite_cart['Store_No']   = $existingdata[0]->Store_No;
                // array_push($existingStore, $existingdata[0]->Store_No);

                if ($source==true)
                    $favourite_cart['quantity'] =0;	//initialize by zero for save cart, do not for customer cart update
                else
                    $favourite_cart['quantity']   = $existingdata[0]->quantity;
                if($store_no == $existingdata[0]->Store_No ) {  //mmb sph-b2b-bugfix
                    array_push($cart,$favourite_cart);
                    array_push($existingCartData,$cart);
                }
                if($store_no == $existingdata[0]->Store_No ) {
                    array_push($existingArticle, $existingdata[0]->Article_No);
                }
            }
        }

        //if(!empty($existingCartData)){
        //	if(!empty($cartData)){
        //print_r($existingCartData);
        if(count($existingCartData)>0){
            if(count($cartData)>0){
                foreach($cartData as $data){
                    if(!in_array($data[0]['Article_No'], $existingArticle) && $store_no == $data[0]['Store_No']){
                        $favourite_cart = array();
                        $cart = array();
                        $favourite_cart['Article_No'] = $data[0]['Article_No'];
                        $favourite_cart['Store_No']   = $data[0]['Store_No'];
                        $favourite_cart['quantity']   = $data[0]['quantity'];
                        array_push($cart,$favourite_cart);
                        array_push($existingCartData,$cart);
                    }
                    else //update Qty
                    {
                        $articlearraykey = array_keys($existingArticle, $data[0]['Article_No']);

                        // $storearraykey = array_keys($existingStore,$data[0]['Store_No']);
                        if ($source==true) {	//called from save cart
                            $existingCartData[$articlearraykey[0]][0]['quantity'] = $data[0]['quantity'];
                            // $existingCartData[$storearraykey[0]][0]['quantity'] += $data[0]['quantity'];
                            // $existingCartData[$storearraykey[0]][0]['Store_No'] = $data[0]['Store_No'];

                        }
                        else //default false , called from reorder and reorder for customer
                        {
                            $existingCartData[$articlearraykey[0]][0]['quantity'] += $data[0]['quantity'];
                        }
                        // $existingCartData[$storearraykey[0]][0]['quantity'] += $data[0]['quantity'];
                        // $existingCartData[$storearraykey[0]][0]['Store_No'] = $data[0]['Store_No'];
                    }
                }
            }
            // print_r($existingCartData);
            $encodeCartData = json_encode($existingCartData);
            $updateOrderId=$pdo->prepare("UPDATE User_Cart SET Cart_Data = '$encodeCartData', Changed_By = '$custNo', Changed_Date= '$date_time' WHERE Cust_No = '$custNo'");
            $updateOrderId->execute();
        }else{
            $updateOrderId=$pdo->prepare("UPDATE User_Cart SET Cart_Data = '$encodeCartData', Changed_By = '$custNo', Changed_Date= '$date_time' WHERE Cust_No = '$custNo'");
            $updateOrderId->execute();
        }
        if($updateOrderId){
            $getCartData = $pdo->prepare("SELECT * from User_Cart WHERE Cust_No='$custNo'");
            $getCartData->execute();
            $cartDataResult = $getCartData->fetch(PDO::FETCH_ASSOC);
            return $cartDataResult;
        }else{ return false; }
    }
}

function updateInventoryData($pdo, $custNo, $store_no, $inventoryData, $Login_Type, $FSO_No)
{
    $encodeInventoryData = $inventoryData;
    if(!empty($encodeInventoryData))
    {
        foreach($encodeInventoryData as $existingdata) {
            $Article_No = $existingdata[0]['Article_No'];
            $StoreNo   = $existingdata[0]['Store_No'];
            $quantity = $existingdata[0]['quantity'];
            $creation_date  = date('Y-m-d H:i:s');
            $Created_By = 10000;
            if($Login_Type=='FSO')
            {
                $Created_By = $FSO_No;
            }
            else
            {
                $Created_By = $custNo;
            }

            $out_of_stock = 1;
            if($quantity>0)
                $out_of_stock = 0;
            if(!empty($custNo) && isset($custNo))
            {
                // echo"hereif";
                $stmt = $pdo->prepare("select Cust_No
	        				from Cust_Store_Inventory
	        				where Cust_No = '$custNo'
	        				and Store_No = '$StoreNo'
	        				and Article_No = '$Article_No'");
                $stmt->execute();
                // $stmt->debugDumpParams();
                $arr = $stmt->fetch(PDO::FETCH_ASSOC);

                // print_r($arr); die();

                if(!empty($arr) && isset($arr))
                {
                    $updateStmt = $pdo->prepare("Update Cust_Store_Inventory set Inv_Qty = '$quantity' , Out_Of_Stock = '$out_of_stock', Changed_Date = '$creation_date', Changed_By='$StoreNo', Status='A' where Cust_No = '$custNo'
	        				and Store_No = '$StoreNo'
	        				and Article_No = '$Article_No'");
                    $updateStmt->execute();
                }
                else
                {
                    $updateStmt = $pdo->prepare("Insert into Cust_Store_Inventory(Cust_No, Store_No, Inv_Qty, Out_Of_Stock, Login_Type, Article_No, Status, Creation_Date, Created_By, Changed_Date, Changed_By) values($custNo , $StoreNo, $quantity, $out_of_stock, '$Login_Type', $Article_No,'A', '$creation_date', $StoreNo, '$creation_date', $StoreNo)");
                    $updateStmt -> execute();
                }
            }
            else
            {
                $stmt = $pdo->prepare("select Store_No
	        				from Store_Listing
	        				where Store_No = '$StoreNo'
	        				and Article_No = '$Article_No'");
                $stmt->execute();
                $arr = $stmt->fetch(PDO::FETCH_ASSOC);
                $date = date('Y-m-d');
                $time = date('H:i:s');
                if(!empty($arr) && isset($arr))
                {
                    $updateStmt = $pdo->prepare("Update Store_Listing set Inventory = '$quantity', Change_Date = '$date', Change_Time = '$time', Changed_By='$Created_By' where Store_No = '$StoreNo'
	        				and Article_No = '$Article_No'");
                    $updateStmt->execute();
                }
                else
                {
                    $updateStmt = $pdo->prepare("Insert into Store_Listing(Store_No, Inventory, Out_Of_Stock, Article_No, Creation_Date, Creation_Time, Created_By, Change_Date, Change_Time, Changed_By) values($StoreNo, $quantity, $out_of_stock, $Article_No, $date, $time, $Created_By, $date, $time, $Created_By)");
                    $updateStmt -> execute();
                }
            }
        }

        if($updateStmt){
            return true;
        }else{ return false; }
    }
}

function updateFavouriteProductsCode($pdo, $custNo, $store_no, $favouriteData, $source=false)
{
    $date_time = date('Y-m-d H:i:s');

    #If store_no is null then empty the cart
    if( $store_no == null ){
        $updateFavId=$pdo->prepare("UPDATE User_Love SET Love_Data = '[]' , Changed_By = '$custNo', Changed_Date= '$date_time' WHERE Cust_No = '$custNo'");
        $updateFavId->execute();
        $getFavData = $pdo->prepare("SELECT * from User_Love WHERE Cust_No='$custNo'");
        $getFavData->execute();
        $favDataResult = $getFavData->fetch(PDO::FETCH_ASSOC);
        return $favDataResult;
    }

    $encodeFavouriteData = json_encode($favouriteData);

    $existingFavouriteData = array();
    $selectFavourite = $pdo->prepare("select * from User_Love where Cust_No = '$custNo'");
    $selectFavourite->execute();
    $favourites = array();
    $favourites = $selectFavourite->fetchAll(PDO::FETCH_ASSOC);
    if(count($favourites)==0)
    {
        $updateFavId = $pdo->prepare("insert into User_Love(Cust_No,Love_Data, Created_By, Creation_Date, Changed_By, Changed_Date) values('$custNo','$encodeFavouriteData', '$custNo', '$date_time', '$custNo', '$date_time')");
        $updateFavId->execute();

    }
    else
    {
        $existingFavouriteData1 = json_decode($favourites[0]['Love_Data'],true);

        if($source == 'cart_data'){
            foreach($existingFavouriteData1 as $existingdata) {
                $favourite_cart = array();
                $favourite = array();
                $favourite_cart['Article_No'] = $existingdata[0]['Article_No'];
                $favourite_cart['Store_No']   = $existingdata[0]['Store_No'];
                // if($store_no == $existingdata[0]->Store_No ) {
                array_push($favourite,$favourite_cart);
                array_push($existingFavouriteData,$favourite);
                // }
            }
        }
        else
        {
            foreach($existingFavouriteData1 as $existingdata) {
                //print $store_no." != ".$existingdata[0]['Store_No'];
                //if($store_no != $existingdata[0]['Store_No'] ) {  mmb sph-b2c-bugfix
                $favourite_cart = array();
                $favourite = array();
                //print "<br>".$existingdata[0]['Article_No']; exit;
                $favourite_cart['Article_No'] = $existingdata[0]['Article_No'];
                $favourite_cart['Store_No']   = $existingdata[0]['Store_No'];

                if($store_no == $existingdata[0]->Store_No ) {  //mmb sph-b2b-bugfix
                    array_push($favourite,$favourite_cart);
                    array_push($existingFavouriteData,$favourite);
                    array_push($existingArticle, $existingdata[0]->Article_No);
                }
                //}
            }
        }

        if(!empty($existingFavouriteData)){
            if(!empty($favouriteData)){
                foreach($favouriteData as $data){
                    if(!in_array($data[0]['Article_No'], $existingArticle) && $store_no == $data[0]['Store_No']){		//mmb sph-b2c-bugfix
                        $favourite_cart = array();
                        $favourite = array();
                        $favourite_cart['Article_No'] = $data[0]['Article_No'];
                        $favourite_cart['Store_No']   = $data[0]['Store_No'];
                        array_push($favourite,$favourite_cart);
                        array_push($existingFavouriteData,$favourite);
                    }
                }
            }
            $encodeFavouriteData = json_encode($existingFavouriteData);
            $updateFavId=$pdo->prepare("UPDATE User_Love SET Love_Data = '$encodeFavouriteData' , Changed_By = '$custNo', Changed_Date= '$date_time' WHERE Cust_No = '$custNo'");
            $updateFavId->execute();
        }
        else
        {
            $updateFavId=$pdo->prepare("UPDATE User_Love SET Love_Data = '$encodeFavouriteData' , Changed_By = '$custNo', Changed_Date= '$date_time' WHERE Cust_No = '$custNo'");
            $updateFavId->execute();
        }
    }

    if($updateFavId){
        $getFavData = $pdo->prepare("SELECT * from User_Love WHERE Cust_No='$custNo'");
        $getFavData->execute();
        $favDataResult = $getFavData->fetch(PDO::FETCH_ASSOC);
        return $favDataResult;
    } else { return false; }
}

### Read 3rd Party Vendor Details
function get3rdPartyVendorDetails($type, $userNo = ''){
    global $pdo;
    // $logger = new Logger('sfservices');
    // $logger->pushHandler(new StreamHandler($_ENV['LOG_FILE_PATH'], $_ENV['LOG_MODE']));
    // $logger->addNotice('get3rdPartyVendorDetails => Request  : ', ['type' => $type,'userNo' => $userNo]);

    //Log::notice('Request Data for function => get3rdPartyVendorDetails', ['type' => $type,'userNo' => $userNo]);
    $stmt3rd = $pdo->prepare("SELECT Owner_No, ECOMM_Flow FROM Business_Master");
    $stmt3rd->execute([]);
    $bDetails = $stmt3rd->fetch(PDO::FETCH_ASSOC);


    $ecomm_flow = $bDetails['ECOMM_Flow'];
    $businessID = $bDetails['Owner_No'];

    $vendorDetails = [];
    if($ecomm_flow == 'N'){

        if($type == 'SMS'){
            // $sql = "SELECT * FROM Store_Vendor_Master as SVM
            // INNER JOIN `Vendor_Master` as VM ON VM.ID = SVM.`Vendor_No`
            // WHERE SVM.Store_No = ? AND SVM.Vendor_For = 'BUSINESS' AND VM.Type = ? ";
            // $stmt3rdT = $pdo->prepare($sql);
            // $stmt3rdT->execute([$businessID, $type]);
        } else if($type == 'LOGISTICS'){
            $sql = "SELECT * FROM Store_Vendor_Master as SVM
			INNER JOIN `Vendor_Master` as VM ON VM.ID = SVM.`Vendor_No`
			WHERE SVM.Store_No = ? AND SVM.Vendor_For = 'STORE' AND VM.Type = ? ";
            $stmt3rdT = $pdo->prepare($sql);
            $stmt3rdT->execute([$userNo, $type]);
        }

        //$vendorDetails = $stmt3rdT->fetch(PDO::FETCH_ASSOC);
        //$stmt3rdT->debugDumpParams();

    }
    else if($userNo > 0){
        $sql = "SELECT * FROM Store_Vendor_Master as SVM
			INNER JOIN `Vendor_Master` as VM ON VM.ID = SVM.`Vendor_No`
			WHERE SVM.Store_No = ? AND SVM.Vendor_For = 'STORE' AND VM.Type = ? ";

        $stmt3rdT = $pdo->prepare($sql);
        $stmt3rdT->execute([$userNo, $type]);
        $vendorDetails = $stmt3rdT->fetch(PDO::FETCH_ASSOC);
    }

    return $vendorDetails;
}

function getSoreDeliveryDetailsNew($pdo, $StoreNo, $CustomerNo, $Del_Address_Id)
{
    // global $con;
    // print_r($StoreNo);die();
    $close_date = array();

    $queryStoreDetails = $pdo->prepare("SELECT Store_No, Store_Name, Open_AT, Close_AT,
                        Delivery_Limit, Min_Order_Amt, Min_Order_Amt_Without_Chrg,
                        Delivery_Charge, Delivery_Mode, TodayClosed,
                        Today_Close_Date, delay_time,
                        order_delivary_delay_days
                        FROM `Store_Master`
                    WHERE `Store_No` = '$StoreNo' AND `Status` = 'A'");
    $queryStoreDetails->execute();
    $getResponse = $queryStoreDetails->fetch(PDO::FETCH_ASSOC);
    // $query = mysqli_query($con,$queryStoreDetails);
    if(!empty($getResponse))
    {
        // $getResponse = mysqli_fetch_assoc($query);

        $tClosed 		    = $getResponse['TodayClosed'];
        $todayCloseDate 	= $getResponse['Today_Close_Date'];
        $storeStartTime   	= $getResponse['Open_AT'];
        $storeEndTime   	= $getResponse['Close_AT'];
        $deliveryDelayDay   = $getResponse['order_delivary_delay_days'];
        $deliveryDelayTime  = $getResponse['delay_time'];
    }

    // Start -  For fetching time slots from Store_Delivery_Time

    $timeSlots = array();
    $finalLaterTimeSlots = [];
    $finalTodayTimeSlots =[];
    $queryTimeSlot = $pdo->prepare("SELECT Store_Delivery_Time.Store_Id, Store_Delivery_Time.Del_Time_Id, Store_Delivery_Time.Start_Time, Store_Delivery_Time.End_Time FROM `Store_Delivery_Time` WHERE `Store_Delivery_Time`.`Store_Id` = '$StoreNo' ORDER BY Start_Time ASC");
    $queryTimeSlot->execute();
    $resultTimeSlot = $queryTimeSlot->fetchAll(PDO::FETCH_ASSOC);
    if(!empty($resultTimeSlot))
    {
        foreach($resultTimeSlot as $resultTimeSlotData)
        {
            $timeSlots[] = $resultTimeSlotData['Start_Time']."-".$resultTimeSlotData['End_Time'];
        }

        $finalLaterTimeSlots = getLaterTimeSlots($timeSlots, $deliveryDelayTime);

        $finalTodayTimeSlots = getTodayTimeSlots($timeSlots, $deliveryDelayTime);

    }else{
        $finalLaterTimeSlots = [];
        $finalTodayTimeSlots = [];
    }

    // End -  For fetching time slots from Store_Delivery_Time
    $getDelivery = calculatePrefDeliveryDate1($pdo,$StoreNo,$CustomerNo, $Del_Address_Id);

    $getCurrentDate = date('d-m-Y');

    // $todayClosed;
    // if(SIZEOF($finalTodayTimeSlots)>0){
    // 	$todayClosed = $tClosed;
    // }else{ $todayClosed = 1; }


    // if($todayClosed == 0){
    // 	$todayCloseAvailable = 1;
    // }else if($todayClosed == 1 && $todayCloseDate == date('Y-m-d')){
    // 	$todayCloseAvailable = 0;
    // }else if($todayClosed == 1 ){ //&& $todayCloseDate != date('Y-m-d')
    // 	$todayCloseAvailable = 0;
    // }else{ $todayCloseAvailable = 0; }

    if(strtotime($getDelivery)>strtotime($getCurrentDate)){
        $todayCloseAvailable = 0;
    }else{
        $todayCloseAvailable = 1;
    }

    if($deliveryDelayDay  > 0) {
        $dateStartSlots = date('Y-n-j', strtotime(' +'.$deliveryDelayDay.' day'));
        $dateInstoreStartSlots = date('Y-n-j');
    }else if($todayCloseAvailable == 0) {
        $dateStartSlots = date('Y-n-j', strtotime(' +1 day'));
        $dateInstoreStartSlots = date('Y-n-j', strtotime(' +1 day'));
    }else{
        $dateStartSlots = date('Y-n-j');
        $dateInstoreStartSlots = date('Y-n-j');
    }


    // Start -  For fetching monthly off day details from Store_Monthly_Off_Details
    $queryStoreMonthlyOffDetails = $pdo->prepare("SELECT Store_Monthly_Off_Details_Id, Store_Id, Sequence_Details, Day_Details, Date_Details FROM Store_Monthly_Off_Details WHERE Store_Id = '$StoreNo'");
    $queryStoreMonthlyOffDetails->execute();

    $Store_Monthly_Off_Details = $queryStoreMonthlyOffDetails->fetchAll(PDO::FETCH_ASSOC);

    if(!empty($Store_Monthly_Off_Details))
    {
        foreach($Store_Monthly_Off_Details as $Store_Monthly_Off_DetailsData)
        {
            $sequence=$Store_Monthly_Off_DetailsData['Sequence_Details'];
            $day=$Store_Monthly_Off_DetailsData['Day_Details'];

            $thisMonth1 = strtotime($sequence.' '.$day.' of this month');
            $thisMonth = date("Y-n-j", $thisMonth1);
            array_push($close_date,$thisMonth);

            $nextMonth2 = strtotime($sequence.' '.$day.' of next month');
            $nextMonth = date("Y-n-j", $nextMonth2);
            array_push($close_date,$nextMonth);
        }
    }
    // End -  For fetching monthly off day details from Store_Monthly_Off_Details



    // Start -  For fetching weekly off day details from Store_Monthly_Off_Details
    $queryStoreWeeklyOffDetails = $pdo->prepare("SELECT `Store_Weekly_Off_Details_Id`, `Store_Id`, `Day_Details` FROM Store_Weekly_Off_Details WHERE Store_Id = '$StoreNo'");

    $queryStoreWeeklyOffDetails->execute();
    // $queryStoreWeeklyOffDetails =
    $StoreWeeklyOffDetails = $queryStoreWeeklyOffDetails->fetchAll(PDO::FETCH_ASSOC);
    if(!empty($StoreWeeklyOffDetails))
    {
        foreach($StoreWeeklyOffDetails as $StoreWeeklyOffDetailsData)
        {
            $day=$StoreWeeklyOffDetailsData['Day_Details'];
            $now_time=strtotime(date('Y-n-j'));
            $end_time=$date = strtotime(date('Y-n-j') . "+1 Months");
            //while(1){
            $now_time=strtotime('next '.$day.'', $now_time);
            if($now_time>$end_time)
                break;
            array_push($close_date,date("Y-n-j",$now_time));
            //}
        }
    }
    // End -  For fetching weekly off day details from Store_Monthly_Off_Details



    // Start -  For fetching monthly off date from Store_Monthly_Off_Date
    $StoreMonthlyOffDate = array();
    $queryStoreMonthlyOffDate = $pdo->prepare("SELECT `Id`, `Store_Id`, `Off_Date` FROM `Store_Monthly_Off_Date` WHERE `Store_Monthly_Off_Date`.`Store_Id` = '$StoreNo'");
    $queryStoreMonthlyOffDate->execute();
    $StoreMonthlyOffDate = $queryStoreMonthlyOffDate->fetchAll(PDO::FETCH_ASSOC);

    if(!empty($StoreMonthlyOffDate))
    {
        foreach($StoreMonthlyOffDate as $resultStoreMonthlyOffDate)
        {
            $StoreMonthlyOffDate[] = $resultStoreMonthlyOffDate['Off_Date'];
        }

        $mo=date('n');
        for($i=$mo;$i<=12;$i++)
        {
            for($j=0;$j<sizeof($StoreMonthlyOffDate);$j++)
            {
                $year=date('Y');
                $month=$i;
                $new_date=$year."-".$month."-".$StoreMonthlyOffDate[$j];
                array_push($close_date,$new_date);
            }
        }
    }
    // End -  For fetching monthly off date from Store_Monthly_Off_Date


    $close_date=array_unique($close_date);

    define ('GPTM_STORE_NO', 9999);
    define ('MANGO_STORE_NO', 9998);

    if($StoreNo == GPTM_STORE_NO)
    {
        $home_later_time_slots 		= ['10:00 AM - 02:00 PM','02:00 PM - 06:00 PM','06:00 PM - 09:00 PM' ];
        $instore_later_time_slots 	= ['10:00 AM - 02:00 PM','02:00 PM - 06:00 PM','06:00 PM - 09:00 PM' ];

        $instore_later_date_slots_all 	= getDatesFromRange( date('Y-m-d', strtotime(' +2 day')), '2017-02-20' );
        $home_later_date_slots_all 	    = getDatesFromRange( date('Y-m-d', strtotime(' +3 day')), '2017-02-20' );

        $instore_later_date_slots=array();
        for($i=0;$i<sizeof($instore_later_date_slots_all);$i++) {
            $date=date_create($instore_later_date_slots_all[$i]);
            $d= date_format($date,"d M Y");
            array_push($instore_later_date_slots,$d);
        }

        $home_later_date_slots=array();
        for($i=0;$i<sizeof($home_later_date_slots_all);$i++) {
            $date=date_create($home_later_date_slots_all[$i]);
            $d= date_format($date,"d M Y");
            array_push($home_later_date_slots,$d);
        }

        if(empty($instore_later_time_slots))
        {
            $instore_later_time_slots = ['09:00 AM - 20:00 PM'];
        }

        if(empty($home_later_time_slots))
        {
            $home_later_time_slots = ['09:00 AM - 20:00 PM'];
        }


        return $records_final['store_delivery_details'] =
            [
                'instore_pickup' =>
                    [
                        'available' => 0,
                        'now' => 1,
                        'today'=>
                            [
                                'available' => 1,
                                'time_slots'=> ['10:00 AM - 06:00 PM']
                            ],
                        'later'=>
                            [
                                'days'=> $instore_later_date_slots,
                                'time_slots'=> $instore_later_time_slots
                            ]
                    ],

                'home_delivery'=>
                    [
                        'available' => 1,
                        'delivery_charge_type' => 'on_weight',
                        'now' => 0,
                        'today'=>
                            [
                                'available' => 0,
                                'time_slots'=> [ ]
                            ],
                        'later'=>
                            [
                                'days'=> $home_later_date_slots,
                                'time_slots'=> $home_later_time_slots
                            ]
                    ]
            ];
    }
    else if($StoreNo == MANGO_STORE_NO)
    {
        $UserCart = array();
        $Article_No = '';
        $category = array();

        $queryUserCart = $pdo->prepare("
				SELECT
					Cart_Data
					FROM `User_Cart`
						WHERE Cust_No = '$CustomerNo'");
        $queryUserCart->execute();
        $resultUserCart = $queryUserCart->fetch(PDO::FETCH_ASSOC);
        if(!empty($resultUserCart))
        {
            // $resultUserCart = mysqli_fetch_assoc($queryUserCart);

            $UserCart = json_decode($resultUserCart['Cart_Data']);
        }

        foreach($UserCart as $cartData)
        {
            if($cartData[0]->Store_No == $StoreNo)
                $Article_No .= $cartData[0]->Article_No."','";
        }

        $finalArticle = substr($Article_No, 0, -3);

        $queryCategory = $pdo->prepare("
				SELECT
					DISTINCT(Merch_Cat.Merch_Cat_Desc),
					Article_Master.Merch_Cat_L3

						FROM `Article_Master`
						INNER JOIN Merch_Cat ON Article_Master.Merch_Cat_L3 = Merch_Cat.Merch_Cat
							WHERE Article_No IN('$finalArticle') ORDER BY Article_Master.Merch_Cat_L3 ASC");
        $queryCategory->execute();
        $resultCategoryData = $queryCategory->fetchAll(PDO::FETCH_ASSOC);

        if(!empty($resultCategoryData))
        {
            foreach($resultCategoryData as $resultCategory)
            {
                $cat = explode('Delivery Period:',$resultCategory['Merch_Cat_Desc']);
                $category[] = trim($cat[1]);
            }
        }

        $mangoStoreLatterDateSlot = getMangoStoreDateSlot($category);


        return $records_final['store_delivery_details'] =
            [
                'instore_pickup' =>
                    [
                        'available' => 1,
                        'now' => 0,
                        'today'=>
                            [
                                'available' => 0,
                                'time_slots'=> ['09:00 AM - 20:00 PM']
                            ],
                        'later'=>
                            [
                                'days'=> $mangoStoreLatterDateSlot,
                                'time_slots'=> ['10:00 am - 08:00 pm']
                            ]
                    ],

                'home_delivery'=>
                    [
                        'available' => 1,'delivery_charge_type' => 'on_amount',
                        'now' => 0,
                        'today'=>
                            [
                                'available' => 0,
                                'time_slots'=> ['09:00 AM - 20:00 PM']
                            ],
                        'later'=>
                            [
                                'days'=> $mangoStoreLatterDateSlot,
                                'time_slots'=> ['10:00 am - 08:00 pm']
                            ]
                    ]
            ];

    } else {

        // Start InStore Pickup Time And Date Slots
        $instore_later_date_slots_all 	= getDatesFromRange( $dateInstoreStartSlots, date('Y-m-d', strtotime("+30 days")) );
        $instore_later_date_slots_merge=array_diff($instore_later_date_slots_all,$close_date);

        $instore_later_date_slots_all=array();
        $i=0;
        foreach($instore_later_date_slots_merge as $k => $item){
            $instore_later_date_slots_all[$i]=$item;
            unset($instore_later_date_slots_merge[$k]);
            $i++;
        }

        $instore_later_date_slots=array();
        for($i=0;$i<sizeof($instore_later_date_slots_all);$i++) {
            $date=date_create($instore_later_date_slots_all[$i]);
            $d= date_format($date,"d M Y");
            array_push($instore_later_date_slots,$d);
        }
        // End InStore Pickup Time And Date Slots



        // Start Home Delivery Time And Date Slots

        $home_later_date_slots_all 	= getDatesFromRange( $dateStartSlots, date('Y-m-d', strtotime("+30 days")) );

        $home_later_date_slots_merge=array_diff($home_later_date_slots_all,$close_date);

        $home_later_date_slots_all=array();
        $i=0;
        foreach($home_later_date_slots_merge as $k => $item){
            $home_later_date_slots_all[$i]=$item;
            unset($home_later_date_slots_merge[$k]);
            $i++;
        }

        $home_later_date_slots=array();
        for($i=0;$i<sizeof($home_later_date_slots_all);$i++) {
            $date=date_create($home_later_date_slots_all[$i]);
            $d= date_format($date,"d M Y");
            array_push($home_later_date_slots,$d);
        }
        // End Home Delivery Time And Date Slots

        if(empty($finalTodayTimeSlots))
        {
            $finalTodayTimeSlots = ['09:00 AM - 20:00 PM'];
        }

        if(empty($finalLaterTimeSlots))
        {
            $finalLaterTimeSlots = ['09:00 AM - 20:00 PM'];
        }

        return $records_final['store_delivery_details'] =
            [
                'instore_pickup' =>
                    [
                        'available' => 1,
                        'now' => 0,
                        'today'=>
                            [
                                'available' => $todayCloseAvailable,
                                'time_slots'=> $finalTodayTimeSlots
                            ],
                        'later'=>
                            [
                                'days'=> $instore_later_date_slots,
                                'time_slots'=> $finalLaterTimeSlots
                            ]
                    ],

                'home_delivery'=>
                    [
                        'available' => 1,'delivery_charge_type' => 'on_amount',
                        'now' => 0,
                        'today'=>
                            [
                                'available' => $todayCloseAvailable,
                                'time_slots'=> $finalTodayTimeSlots
                            ],
                        'later'=>
                            [
                                'days'=> $home_later_date_slots,
                                'time_slots'=> $finalLaterTimeSlots
                            ]
                    ]
            ];
    }
}

function getStorePaymentTypesNew($pdo,$storeNo)
{
    // global $con;
    $storePaymentTypes = array();
    $storeOnlinePaymentTypes = array();
    $queryStorePaymentTypes = $pdo->prepare("
			SELECT
				Payment_Types.Type,
				Payment_Types.Name,
				Store_Payment_Types.Value
					FROM `Store_Payment_Types`
						INNER JOIN Payment_Types ON Payment_Types.Payment_Types_Id = Store_Payment_Types.Payment_Types_Id
						WHERE Payment_Types.Name !='Online' AND `Store_No` = '$storeNo' AND `Status`='A'");

    $queryStorePaymentTypes->execute();
    $queryStorePayment = $queryStorePaymentTypes->fetchAll(PDO::FETCH_ASSOC);
    // print_r($queryStorePayment);
    // die();
    if(!empty($queryStorePayment))
    {
        foreach($queryStorePayment as $queryStorePaymentData)
        {
            // print_r($queryStorePayment);
            $offlinePayments['Type'] 		= $queryStorePaymentData['Type'];
            $offlinePayments['Payment_Info'] = $queryStorePaymentData['Value'];
            array_push($storePaymentTypes, $offlinePayments);
        }
    }

    // print_r($storePaymentTypes);
    // die();

    $queryStoreOnlinePaymentTypes = $pdo->prepare("
			SELECT
				Payment.Name,
				Store_Payment_Types.Value
				FROM `Store_Payment_Types`
					INNER JOIN Payment ON Payment.Payment_Id = Store_Payment_Types.Payment_Id
					WHERE `Store_No` = '$storeNo' AND Payment_Types_Id = 5 and Store_Payment_Types.Status = 'A'" );

    $queryStoreOnlinePaymentTypes->execute();
    $queryStoreOnlinePayment = $queryStoreOnlinePaymentTypes->fetchAll(PDO::FETCH_ASSOC);

    if(!empty($queryStoreOnlinePayment))
    {
        foreach($queryStoreOnlinePayment as $queryStoreOnlinePaymentData)
        {
            $onlinePayments['Type'] = $queryStoreOnlinePaymentData['Name'];
            $onlinePayments['Payment_Info'] = $queryStoreOnlinePaymentData['Value'];
            array_push($storeOnlinePaymentTypes, $onlinePayments);
        }
    }

    // print_r($storeOnlinePaymentTypes);
    // die();
    /*$storePaymentTypes = ['offline' => [ 'cash_on_delivery','cheque_on_delivery','card_on_delivery','ewallet_on_delivery'],
                    'online' => ['Billdesk','ICICI'] ]; */

    $storePaymentTypes = [
        'offline' 	=> $storePaymentTypes,
        'online' 	=> $storeOnlinePaymentTypes
    ];

    // print_r($storePaymentTypes);
    // die();

    return $storePaymentTypes;
}

function getLaterTimeSlots($timeSlots, $deliveryDelayTime)  //$format = 'd M Y'
{

    $finalLaterTimeSlots = array();
    $convertedLetterSlots = array();
    /*if($deliveryDelayTime!="" || $deliveryDelayTime > 0)
    {
        $latterSlotDiff=0;
        $tempLetter=0;
        for($i=0; $i<SIZEOF($timeSlots); $i++){
            $latterSlots = explode("-",$timeSlots[$i]);
            $latterSlotDiff += $latterSlots[1] - $latterSlots[0];

            if($latterSlotDiff >= $deliveryDelayTime)
            {
                if($tempLetter != 0)
                {
                    $slotsLetterConvert = explode("-",$timeSlots[$i]);
                    $convertedLetterSlots = date('h:i A', strtotime($slotsLetterConvert[0]))." - ".date('h:i A', strtotime($slotsLetterConvert[1]));
                    array_push($finalLaterTimeSlots,$convertedLetterSlots);
                }
                $tempLetter +=1;
            }
        }
    }else{  */
    for($i=0; $i<SIZEOF($timeSlots); $i++)
    {
        $slotsLetterConvert = explode("-",$timeSlots[$i]);
        $convertedLetterSlots = date('h:i A', strtotime($slotsLetterConvert[0]))." - ".date('h:i A', strtotime($slotsLetterConvert[1]));
        array_push($finalLaterTimeSlots,$convertedLetterSlots);

    }
    //}

    return $finalLaterTimeSlots;
}


function getTodayTimeSlots($timeSlots, $deliveryDelayTime)
{
    $todayCurrentTime=date("G:i",strtotime('+5 hours 30 minutes'));

    $todayCurrentTimeSlots = explode("-",$timeSlots[0]);

    $todayCurrentTime_time = strtotime($todayCurrentTime);
    $todayCurrentTimeSlots_time = strtotime($todayCurrentTimeSlots[0]);



    $todayCurrentTimeDiff = $todayCurrentTime_time - $todayCurrentTimeSlots_time;

    $todayCurrentTimeDiff = floor(($todayCurrentTimeDiff/60)/60);


    if($deliveryDelayTime!="" || $deliveryDelayTime > 0)
    {
        $delDelayTime = $deliveryDelayTime;
    }else{
        $delDelayTime = 0;
    }

    $todaySlotDiff=0;
    $tempToday=0;
    $finalTodayTimeSlots = array();
    $convertedTodaySlots = array();
    for($i=0; $i<SIZEOF($timeSlots); $i++){
        $todaySlots = explode("-",$timeSlots[$i]);
        $todaySlotDiff += strtotime($todaySlots[1]) - strtotime($todaySlots[0]);

        $DelayTime = $delDelayTime+$todayCurrentTimeDiff;
        if($todaySlotDiff >= $DelayTime)
        {
            if($tempToday != 0)
            {
                $slotsTodayConvert = explode("-",$timeSlots[$i]);
                $convertedTodaySlots = date('h:i A', strtotime($slotsTodayConvert[0]))." - ".date('h:i A', strtotime($slotsTodayConvert[1]));
                array_push($finalTodayTimeSlots,$convertedTodaySlots);
            }
            $tempToday +=1;
        }
    }

    return $finalTodayTimeSlots;
}

function calculatePrefDeliveryDate1($pdo, $storeNo, $custNo, $address_id, $flag=false){
    $deliveryDays = array();
    Log::notice('Request for function => calculatePrefDeliveryDate1 ', ['storeNo' => $storeNo,'custNo' => $custNo,'address_id'=>$address_id,'flag' => $flag]);
    ###get delivery days from Cust_Store_Days_Lookup table of that store

    //<---- this address should be Order's delivery address\n +
    $stmt4 = $pdo->prepare("SELECT DISTINCT(BOGD.Day_Num) as Day_Num
						FROM BBC_Org_User_Groups AS BOUG
						LEFT JOIN BBC_Org_Group_Areas BOGA ON
							BOGA.Org_Group_ID = BOUG.ID  AND
							BOGA.Store_No = BOUG.Store_No AND
							BOGA.Status = 'A'
						LEFT JOIN BBC_Org_Group_Days AS BOGD ON
							BOGD.Org_Group_ID = BOUG.ID  AND
							BOGD.Store_No = BOUG.Store_No AND
							BOGD.Status = 'A' and
							BOGD.Days_For = 'Delivery'
						INNER JOIN BBC_Addresses AS BA ON
							BOGA.Area_Code = BA.Locality AND
							BA.User_No = ".$custNo." AND
							BA.Address_ID = ".$address_id."
						WHERE BOUG.Store_No = ".$storeNo."
						ORDER BY Day_Num");


    $stmt4->execute([$storeNo, $custNo]);
    $dDaysRow = $stmt4->fetchAll(PDO::FETCH_ASSOC);
    // $stmt4->debugDumpParams();
    /**
     * Added By Priyanka Kumbhar
     * Reason : Getting empty value with key Day_Num So need to check every row for key Day_Num
     * Added at : 11-08-2022
     */

    $dDaysRowValues = array_column($dDaysRow, 'Day_Num');

    $checkdDaysRowValues = implode(',',$dDaysRowValues);

    if(($checkdDaysRowValues == '') || empty($checkdDaysRowValues))
    {
        /*$stmt3 = $pdo->prepare("select Day_Num from Cust_Store_Days_Lookup where Store_No=? and Cust_No=?");*/
        $stmt3 = $pdo->prepare("SELECT DISTINCT(Day_Num) AS Day_Num FROM BBC_Org_Group_Users U,BBC_Org_Group_Days D,Cust_Master M
							WHERE  U.Store_No=?
							AND    U.User_No =?
							AND    U.Login_Type='Buyer'
							AND    U.Store_No = D.Store_No
							AND    U.Org_Group_ID = D.Org_Group_ID
							AND    D.Days_For='Delivery'
							AND    U.Status='A'
							AND    D.Status='A'
							AND    U.User_No=M.Cust_No
							AND    M.Status ='A'");

        $stmt3->execute([$storeNo, $custNo]);
        // $stmt3->debugDumpParams();

        $dDaysRow = $stmt3->fetchAll(PDO::FETCH_ASSOC);
    }

    $deliveryDays = array_column($dDaysRow, 'Day_Num');


    sort($deliveryDays);


    ### reindex : start index with 1
    $newDeliveryDays = array();

    if(!empty($deliveryDays)){
        foreach ($deliveryDays as $key => $value) {
            $newDeliveryDays[$key+1] = $value;
        }
    }


    // $stmt = $pdo->prepare("SELECT order_delivary_delay_days As delayDays, delay_time As delayTime
    // 						FROM `Store_Master` WHERE `Store_No` = ' storeNo'");

    $stmt = $pdo->prepare("SELECT  COALESCE(NULLIF(order_delivary_delay_days ,''),'0') as delayDays ,COALESCE(NULLIF(delay_time ,''),'0') as delayTime FROM `Store_Master` WHERE `Store_No` = '$storeNo'");


    // $stmt->debugDumpParams();

    $stmt->execute([$storeNo]);
    $row = $stmt->fetch(PDO::FETCH_ASSOC);

    $delayDays = 0;
    $delayTime = 0;



    if (isset($row))
    {
        $delayDays = $row['delayDays'];
        $delayTime = $row['delayTime'];
    }



    if(!isset($delayDays) || $delayDays == '' )
    {
        $delayDays = 0;

    }

    if(!isset($delayTime) || $delayTime == '' )
    {
        $delayTime = 0;

    }

    ##Get delivery date with the help for Cust_Store_Days_Lookup table
    if(!empty($newDeliveryDays)){
        $Pref_Del_Date = getNextDeliveryDate1($newDeliveryDays, $delayDays, $delayTime);

    } else {
        // } else if(sizeof($row) > 0 ) {



        $today_date = date('Y-m-d');
        $Pref_Del_Date = date('Y-m-d', strtotime( $today_date."+".$delayDays." days +".$delayTime." minutes"));

    }
    // else {
    //     $Pref_Del_Date = date('Y-m-d');
    // }
    // return $Pref_Del_Date;

    if($flag==true)
    {
        Log::notice('Response for function => calculatePrefDeliveryDate1 ', ['storeNo' => $storeNo,'custNo' => $custNo,'address_id'=>$address_id,'flag' => $flag,'result' => $newDeliveryDays]);
        return $newDeliveryDays;
    }
    else
    {
        Log::notice('Response for function => calculatePrefDeliveryDate1', ['storeNo' => $storeNo,'custNo' => $custNo,'address_id'=>$address_id,'flag' => $flag,'result' => $Pref_Del_Date]);
        return $Pref_Del_Date;
    }
}

function getNextDeliveryDate1($deliveryDayNums, $delayDays, $delayTime) {

    $days = array('1'=>'monday', '2' => 'tuesday', '3' => 'wednesday', '4' => 'thursday', '5' => 'friday', '6' => 'saturday', '7' => 'sunday');

    ### Get available delivery day array with day names
    $deliveryDays = array();
    foreach ($deliveryDayNums as $key => $dayNum) {
        if(array_key_exists($dayNum, $days)) {
            $deliveryDays[$key] = $days[$dayNum];
        }
    }
    $todayDate = date("Y-m-d");
    ## Get orderDate (Now)+ delaydays and Time
    $orderDateWithDelayDays = strtolower(date("l",strtotime("+".$delayDays." day +".$delayTime." minutes")));
    $orderDateWithDelayDaysIndex = array_search($orderDateWithDelayDays, $days);
    $orderDateWithDelayDate =  date('Y-m-d', strtotime('+'.$delayDays.'day +'.$delayTime.' minutes'));
    ## Get today day
    $today = strtolower(date('l'));
    ## Get today day index from all day
    $currentIndex = array_search($today, $days);
    ## Get next index from current index
    $nextIndex = '';
    foreach ($deliveryDayNums as $key => $value) {
        if ( $value >= $orderDateWithDelayDaysIndex)
            // if($value > $currentIndex)
        {
            $nextIndex = $value;
            break;
        }
    }
    if($nextIndex == '') {

        ## If today is not in store delivery days, then take 1st index day from provided days
        $nextDay = $deliveryDays['1'];

    } else {

        $nextDay = $days[$nextIndex];
    }
    ## Get this week date
    /*
        Name : Sheetal Chive
        Date : 15-04-2022
        Changed : Added Below if Condition
    */
    $nextDate = date('Y-m-d', strtotime('this '.$nextDay));

    if($orderDateWithDelayDate == $nextDate)
    {
        $nextDate  = $nextDate ;
    }
    else
    {
        // $delayDays = strtotime("+$delayDays days");
        $delayDays = strtotime("+".$delayDays." day +".$delayTime." minutes");

        $nextDate = date("Y-m-d",strtotime("next $nextDay",$delayDays));

    }

    return $nextDate;
}

function getMangoStoreDateSlot($category)
{
    //foreach($category as $dateSlot)
    //{
    if(in_array('3 - 8 April',$category))
    {
        $deliveryDate = Array (
            0 => '03 Apr 2017',
            1 => '04 Apr 2017'/*,
							2 => '05 Apr 2017',
							3 => '06 Apr 2017',
							4 => '07 Apr 2017',
							5 => '08 Apr 2017'*/
        );
    }else
        if(in_array('10 - 15 April',$category))
        {
            $deliveryDate = Array (
                0 => '10 Apr 2017',
                1 => '11 Apr 2017'/*,
							2 => '12 Apr 2017',
							3 => '13 Apr 2017',
							4 => '14 Apr 2017',
							5 => '15 Apr 2017'*/
            );
        }else
            if(in_array('17 - 22 April',$category))
            {
                $deliveryDate = Array (
                    0 => '17 Apr 2017',
                    1 => '18 Apr 2017'/*,
							2 => '19 Apr 2017',
							3 => '20 Apr 2017',
							4 => '21 Apr 2017',
							5 => '22 Apr 2017'*/
                );
            }else
                if(in_array('24 - 29 April',$category))
                {
                    $deliveryDate = Array (
                        0 => '24 Apr 2017',
                        1 => '25 Apr 2017'/*,
							2 => '26 Apr 2017',
							3 => '27 Apr 2017',
							4 => '28 Apr 2017',
							5 => '29 Apr 2017'*/
                    );
                }else
                    if(in_array('1 - 6 May',$category))
                    {
                        $deliveryDate = Array (
                            0 => '01 May 2017',
                            1 => '02 May 2017'/*,
							2 => '03 May 2017',
							3 => '04 May 2017',
							4 => '05 May 2017',
							5 => '06 May 2017' */
                        );

                    }else
                        if(in_array('8 - 13 May',$category))
                        {
                            $deliveryDate = Array (
                                0 => '08 May 2017',
                                1 => '09 May 2017'/*,
							2 => '10 May 2017',
							3 => '11 May 2017',
							4 => '12 May 2017',
							5 => '13 May 2017'*/
                            );
                        }else
                            if(in_array('15 - 20 May',$category))
                            {
                                $deliveryDate = Array (
                                    0 => '15 May 2017',
                                    1 => '16 May 2017'/*,
							2 => '17 May 2017',
							3 => '18 May 2017',
							4 => '19 May 2017',
							5 => '20 May 2017'*/
                                );
                            }else
                                if(in_array('22 - 27 May',$category))
                                {
                                    $deliveryDate = Array (
                                        0 => '22 May 2017',
                                        1 => '23 May 2017'/*,
							2 => '24 May 2017',
							3 => '25 May 2017',
							4 => '26 May 2017',
							5 => '27 May 2017'*/
                                    );
                                }else
                                    if(in_array('27 May - 3 June',$category))
                                    {
                                        $deliveryDate = Array (
                                            /*0 => '27 May 2017',
                                            1 => '28 May 2017',*/
                                            0 => '29 May 2017',
                                            1 => '30 May 2017'/*,
							4 => '31 May 2017',
							5 => '01 June 2017',
							6 => '02 June 2017',
							7 => '03 June 2017' */
                                        );
                                    }

    //}
    return $deliveryDate;
}

function getDatesFromRange($start, $end, $format = 'Y-n-j')  //$format = 'd M Y'
{
    $array = array();
    $interval = new DateInterval('P1D');

    $realEnd = new DateTime($end);
    $realEnd->add($interval);

    $period = new DatePeriod(new DateTime($start), $interval, $realEnd);

    foreach($period as $date) {
        $array[] = $date->format($format);
    }

    return $array;
}

/*****
 * call_3rdparty_api
 * call api/url with curl
 * $api : url
 * $inputStr : input parameters array or json
 * $method : post/get
 * $inputType : inputStr type array or json
 * $header : header for curl call
 * Author : Daya
 *****/
function call_3rdparty_api($api, $inputStr, $method = 'post', $inputType = 'array', $header = []) {

    // $this->log->addNotice('call_3rdparty_api => Response for '.$api.' : ', ['request' => $request,'api' => $api]);

    if($inputType == 'json') {
        $request = $inputStr;
    } else {
        $request = json_encode($inputStr);
    }

    if(empty($header)){
        $headerData = array('Content-Type: application/json');
    } else {
        $headerData = $header;
    }

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $api);
    if($method == 'post'){
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $request);
    }
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headerData);
    $result = curl_exec($ch);
    //print_r($result); exit;
}

function getLatLong($address){
    if(!empty($address)){
        //Formatted address
        $formattedAddr = str_replace(' ','+',$address);

        //open connection
        $ch = curl_init();
        $url = 'https://maps.googleapis.com/maps/api/geocode/json?address='.$formattedAddr.'&key='.MAPS_API_KEY;

        //set the url, number of POST vars, POST data
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $geocodeFromAddr = curl_exec($ch);
        curl_close($ch);

        //var_dump($geocodeFromAddr); die;
        $output = json_decode($geocodeFromAddr);
        //Get latitude and longitute from json data
        if(!empty($output) && isset($output))
        {
            if($output->status!='REQUEST_DENIED')
            {
                $data['latitude']  = $output->results[0]->geometry->location->lat;
                $data['longitude'] = $output->results[0]->geometry->location->lng;
            }
            else
            {
                $data['latitude'] = 0;
                $data['longitude'] = 0;
            }
        }
        else
        {
            $data['latitude'] = 0;
            $data['longitude'] = 0;
        }
        //Return latitude and longitude of the given address
        if(!empty($data)){
            return $data;
        }else{
            return false;
        }
    } else {
        return false;
    }
}

function cancel_order_for_initiate_refund($pdo, $Order_No, $User_No=0)
{
    $select = "Order_Hdr.Order_No, Order_Hdr.Order_Amount, Order_Hdr.Refund_Amount, Cust_Master.Cust_No, Store_Master.Store_No, Store_Master.Store_Name, Cust_Master.Cust_Name, Cust_Master.Outlet_Name, Cust_Master.Mobile_No, Cust_Master.Email_ID, Transaction.Ref_Transaction_Id as TXN_ID, Transaction.Source as PayGateway,Transaction.amount, Transaction.Transaction_Id";

    $whereArr[] = "Order_Hdr.Refund_Amount > 0 AND Transaction.Status = 'success' AND Transaction_For = 'Payment'";
    $where = "Order_Hdr.Order_No=$Order_No";
    if($where !=''){
        if(!empty($whereArr)){
            $where .= ' AND '.implode(' AND ', $whereArr);
        }
    }else{
        $where .= implode(' AND ', $whereArr);
    }
    $query1= $pdo->prepare("select $select from Transaction join Order_Hdr on Order_Hdr.Order_No = Transaction.Order_No join Cust_Master on Cust_Master.Cust_No = Order_Hdr.Cust_No join Store_Master on Store_Master.Store_No = Order_Hdr.Store_No where $where");
    $query1->execute();
    $queryResult = $query1->fetchAll(PDO::FETCH_ASSOC);

    if(!empty($queryResult))
    {
        foreach($queryResult as $row){
            $data = [];
            $data['fromPageCancel'] = 'Cancel_Refund_Api';
            $data['refundData'] = $row['Order_No'].'#'.$row['Order_Amount'].'#'.$row['amount'].'#'.$row['Email_ID'].'#'.$row['Mobile_No'].'#'.$row['TXN_ID'].'#'.$row['Cust_No'].'#'.$row['Store_No'];
            $data['chkRowsDD'][] = $row['Order_No'].'#'.$row['Order_Amount'].'#'.$row['amount'].'#'.$row['Email_ID'].'#'.$row['Mobile_No'].'#'.$row['TXN_ID'].'#'.$row['Cust_No'].'#'.$row['Store_No'];
            $data['refundDataKey'][] = $row['Order_No'];
            $data['txt_refund_amount'] = $row['Order_No'];
            $data['order_break_refund_amount'][] = $row['Order_No'].'#'.$row['PayGateway'].'#'.$row['amount'];
            $data['Store_No'] = $row['Store_No'];
            $data['Cust_No'] = $row['Cust_No'];
            $data['User_No'] = $User_No;
            $data['PayGateway'] = $row['PayGateway'];
            $data['Cancel_Transaction_Id'] = $row['Transaction_Id'];

            $data_string = http_build_query($data);
            $url = API_CANCEL_URL;
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL, $url);
            curl_setopt($ch,CURLOPT_POST, count($data));
            curl_setopt($ch,CURLOPT_POSTFIELDS, $data_string);
            $result = curl_exec($ch);
            curl_close($ch);
        }
        return;
    }
    return;
}

#get business id from database
function getDBBusinessId(){
    global $pdo;
    $stmt3rd = $pdo->prepare("SELECT Owner_No FROM Business_Master");
    $stmt3rd->execute([]);
    $bDetails = $stmt3rd->fetch(PDO::FETCH_ASSOC);
    if(!empty($bDetails)){
        return $bDetails['Owner_No'];
    } else return 0;
}

function logMeIn($logFileName, $data){
    $dataNew = [];
    //$logdate = date("d-m-Y H:i:s");
    $t = microtime(true);
    $micro = sprintf("%06d",($t - floor($t)) * 1000000);
    $d = new DateTime( date('Y-m-d H:i:s.'.$micro, $t) );
    $logdate  = $d->format("Y-m-d H:i:s.u"); // note at point on "u"

    $log = OFFLINE_LOG_URL.'/'.$logFileName.'_'.date("j.n.Y").'.log';
    $dataNew[$logdate] = $data;
    //file_put_contents($log, print_r($dataNew, true), FILE_APPEND | LOCK_EX );
    Storage::disk('local')->put($log,print_r($dataNew, true));
}

function getDateTimeWithMS()
{
    $t = microtime(true);
    $micro = sprintf("%06d",($t - floor($t)) * 1000000);
    $d = new DateTime( date('Y-m-d H:i:s.'.$micro, $t) );
    $logdate = $d->format("Y-m-d H:i:s.u"); // note at point on "u"
    return $logdate;
}

function logging($msg_type, $module, $msg_lvl, $msg_text, $parameters = ""): void
{
    ## check if msg_lvl is 1 then add entry in the logfile
    if ($msg_lvl === 1) {

        if (file_exists(OFFLINE_LOG_URL)) {

            $logdate = date("d-m-Y H:i:s");
            if ($parameters != '') {
                $msg_text = $msg_text . ':' . $parameters;
            }

            $txt = $logdate.", ||".$module."||, ".$msg_type.", ".$msg_text."\r\n";
            $file = OFFLINE_LOG_URL.'/LOGIN_log_'.date("j.n.Y").'.log';
            file_put_contents($file, $txt, FILE_APPEND | LOCK_EX );
        }
    }
}
