<?php

function getEntityPK($pdo, $table_name){

    $entStmt = $pdo->prepare("SELECT Primary_Key, Type, Select_Cols,Archive_Period FROM Pull_Master WHERE Entity_Name = '".$table_name."' AND Entity_Type = 'DB' " );
    $entStmt->execute();
    // $entStmt->debugDumpParams();
    $entStmt = $entStmt->fetch(PDO::FETCH_ASSOC);
    if(!empty($entStmt)){
        return $entStmt;
    } else return '';
}

function getDefaultDate($pdo, $businessID){

    $entStmt = $pdo->prepare("SELECT Config_Value FROM Business_Config_Master WHERE Status = 'A' and Config_Attribute = 'OFFLINE_DEFAULT_PULL_DATE' AND Business_ID = '".$businessID."'" );
    $entStmt->execute();
    //$entStmt->debugDumpParams();
    $entStmt = $entStmt->fetch(PDO::FETCH_ASSOC);
    if(!empty($entStmt)){
        return $entStmt;
    } else return '';
}

function checkTableNewOrOld($pdo, $table_name){

    $returnArr = [];

    $tableStmt = $pdo->prepare("SELECT DISTINCT TABLE_NAME  FROM INFORMATION_SCHEMA.COLUMNS
    WHERE COLUMN_NAME IN ('Change_Time') AND TABLE_NAME = '$table_name' " );

    $tableStmt->execute();
    $tableStmtRow = $tableStmt->fetchAll(PDO::FETCH_ASSOC);

    $orderbydefault = " Changed_Date ";
    $oldTable = false;

    $returnArr['orderbydefault'] = $orderbydefault;
    $returnArr['oldtable'] = $oldTable;
    return $returnArr;
}

function getCellWhereClause($table_name, $cellNo){
    return (!empty($cellNo) && ($table_name == 'Cust_Master' || $table_name == 'FSO_Master')) ?  " Mobile_No = $cellNo " : "";
}

function getPackageWhereClause($table_name, $package){
    return ( $package != '' && $table_name == 'Config_Master') ? " AND Package_ID ='$package' " : '';
}

function getBusinessWhereClause($table_name, $businessID){

    $where = '';
    if($businessID > 0)
    {
        if ($table_name == 'Business_Master') {
            $where =  " AND Owner_No = $businessID ";
        } else if ($table_name == 'Business_Config_Master') {
            $where = " AND Business_ID = $businessID ";
        } else if ($table_name == 'Article_Margins' && CENTRALIZE_PRICING) {
            //2 for CBM
            $where = " AND Filter_ID = $businessID AND Filter_Type = 'Business' ";
        }
    }
    return $where;
}


function getFSONoSubWhereClause($fso_id_array, $whereop, $type){

    switch ($type){
        case 'custno':
            $inColumn = 'Cust_No';
            $selectSubColumns = 'CM.Cust_No';
            break;
        case 'custnoIn':
            $inColumn = 'Cust_No';
            $selectSubColumns = 'CM.Cust_No';
            break;
        case 'useraddr';
            $inColumn = 'User_No';
            $selectSubColumns = 'CM.Cust_No';
            break;
        case 'storeno';
            $inColumn = 'Store_No';
            $selectSubColumns = 'G.Store_No';
            break;
        case 'supplierno';
            $inColumn = 'Supplier_No';
            $selectSubColumns = 'Supplier_No';
            break;
        case 'storeid';
            $inColumn = 'Store_Id';
            $selectSubColumns = ' G.Store_No ';
            break;
        case 'storeaddr';
            $inColumn = 'User_No';
            $selectSubColumns = ' G.Store_No ';
            break;
        case 'groupusers';
            $inColumn = ' (Store_No, Org_Group_ID) ';
            $selectSubColumns = ' G.Store_No, G.Org_Group_ID ';
            break;
        case 'storecatalogfilter';
            $inColumn = 'CAT_ID';
            $selectSubColumns = 'CAT_ID';
            break;
        default:
            $inColumn = '';
            $selectSubColumns = '';
    }
    //$whereop.

    $selectSql = '';
    if($type == 'custnoIn'){
        $selectSql = "$inColumn IN (";
    }
    $selectSql .=  " SELECT  $selectSubColumns
                    FROM BBC_Org_User_Groups G, Cust_Master CM, BBC_Org_Group_Users Buyer
                    WHERE G.ID = Buyer.Org_Group_ID
                    AND G.User_Group_Name != 'Call Center Route'
                    and Buyer.User_No = CM.Cust_No
                    and Buyer.Login_Type='Buyer'
                    and Buyer.Status = 'A'
                    and CM.Status = 'A'
                    and (G.Store_No,Buyer.Org_Group_ID) IN
                    (
                        SELECT FSO.Store_No, FSO.Org_Group_ID Org_Group_ID
                        FROM BBC_Org_Group_Users FSO
                        INNER JOIN BBC_Org_User_Groups ON FSO.Org_Group_ID = BBC_Org_User_Groups.ID AND FSO.Store_No = BBC_Org_User_Groups.Store_No
                        INNER JOIN BBC_Org_Group_Days ON BBC_Org_Group_Days.Org_Group_ID =FSO.Org_Group_ID AND BBC_Org_Group_Days.Store_No = FSO.Store_No
                        INNER JOIN FSO_Master ON FSO_Master.FSO_No =FSO.User_No AND FSO_Master.Login_Type = FSO.Login_Type
                        WHERE FSO.Status='A'
                        AND BBC_Org_User_Groups.User_Group_Name != 'Call Center Route'
                        AND FSO.User_No IN $fso_id_array
                        AND BBC_Org_Group_Days.Status='A'
                        AND BBC_Org_Group_Days.Days_For= (
                                CASE WHEN FSO_Master.Login_Type='FSO'
                                    THEN 'Order'
                                WHEN FSO_Master.Login_Type='DO'
                                    THEN 'Delivery'
                                ELSE 'Order'
                                END
                        )
                    )
            group by $selectSubColumns
         ";

    if($type == 'custnoIn'){
        $selectSql .= " ) ";
    }
    return $selectSql;

}


function Cust_Master_OFL($clause)
{
    if($clause == 'custno'){
        $where = '';
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function User_Cart_OFL($clause, $cust_id_array){
    if($clause == 'custno'){
        $where = "  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function User_Love_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = "  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function BBC_Org_Serving_Areas_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function BBC_Notification_History_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = "  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Transaction_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = "  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Cust_Store_Master_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $cust_id_array = rtrim($cust_id_array,")");
        $cust_id_array = ltrim($cust_id_array,"(");
        $where = "  SELECT Cust_No FROM Cust_Master
    	WHERE Cust_No IN ( $cust_id_array )";
        //$where = "  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Cust_Store_Inventory_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $cust_id_array = rtrim($cust_id_array,")");
        $cust_id_array = ltrim($cust_id_array,"(");
        //$where = "  Cust_No IN ( SELECT $cust_id_array AS Cust_No ";
        $where = "  Cust_No IN ( $cust_id_array ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Customer_Feedback_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = "  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Order_Hdr_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " AND  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Master_OFL($clause, $cust_id_array){
    if($clause == 'custno'){
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Listing_OFL($clause, $cust_id_array){
    if($clause == 'custno'){
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Catalog_Master_OFL($clause, $cust_id_array){
    if($clause == 'custno'){
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Scheme_Master_OFL($clause, $cust_id_array){
    if($clause == 'custno'){
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Payment_Types_OFL($clause, $cust_id_array){
    if($clause == 'custno'){
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ) ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_City_Article_OFL($clause, $cust_id_array){
    if($clause == 'custno'){
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ) ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Promo_Order_Level_OFL($clause, $cust_id_array){
    if($clause == 'custno'){
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Promo_Messages_OFL($clause, $cust_id_array){
    if($clause == 'custno'){
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ) ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Catalog_Filters_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " CAT_ID IN (SELECT
		CAT_ID
		FROM
			Store_Catalog_Master
		WHERE
			Store_No IN ( SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){
    }
    return $where;
}
function Store_Catalog_Listing_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " Cat_ID IN (SELECT
		   Cat_ID
	   FROM
		   Store_Catalog_Master
	   WHERE
		   Store_No IN ( SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ";
    } elseif($clause == 'fsono'){
    }
    return $where;
}
function BBC_Org_Group_Days_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        /*
            Sheeta Chive
            change below varibles Query to get info strom cust_store_master table
            17-05-2022
            */
        //    $where = "Org_Group_ID in(select fso.Org_Group_ID
        //    from BBC_Org_Group_Users fso
        //    INNER JOIN Cust_Master ON Cust_Master.Cust_No = fso.User_No AND  fso.Login_Type='Buyer' and fso.User_No IN $cust_id_array";
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ";

    } elseif($clause == 'fsono'){
    }
    return $where;
}
function BBC_Org_Group_Users_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = "( User_No IN $cust_id_array AND Login_Type = 'Buyer' )";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function BBC_Org_User_Groups_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        /*
            Sheeta Chive
            change below varibles Query to get info strom cust_store_master table
            17-05-2022
            */
        //    $where = " ID in ( select fso.Org_Group_ID
        //    from BBC_Org_Group_Users fso
        //    INNER JOIN Cust_Master ON Cust_Master.Cust_No = fso.User_No AND  fso.Login_Type='Buyer' and fso.User_No IN $cust_id_array ";
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ";

    } elseif($clause == 'fsono'){

    }
    return $where;
}
function BBC_Org_Group_Areas_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        /*
            Sheeta Chive
            change below varibles Query to get info strom cust_store_master table
            17-05-2022
            */
        $where = " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ";

    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Delivery_Time_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " Store_Id IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ) ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Monthly_Off_Date_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " Store_Id IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ";
    }
    elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Monthly_Off_Details_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " Store_Id IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Weekly_Off_Details_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " Store_Id IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Scheme_Filters_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " Scheme_ID IN ( SELECT ID FROM Scheme_Master WHERE ";
        $where .= " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array  ";
        //$where .= " ) ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Scheme_Article_Rules_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = " Scheme_ID IN ( SELECT ID FROM Scheme_Master WHERE ";
        $where .= " Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ) ";
        //$where .= " ) ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Article_Margins_OFL($clause, $cust_id_array, $businessID) {
    if($clause == 'custno'){
        if ( $businessID > 0 && CENTRALIZE_PRICING)
        {
            $where = getBusinessWhereClause('Article_Margins', $businessID);
        } else {
            $where =  " Filter_ID IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array ) AND Filter_Type ='Store' ";
        }
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Transaction_Detail_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where =  " Transaction_ID IN (SELECT Transaction_ID FROM Store_Transaction WHERE  Cust_No IN $cust_id_array ) ";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Order_Itm_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where =  " ( Order_No IN (SELECT Order_No FROM Order_Hdr WHERE  Cust_No IN $cust_id_array  ) )" ;
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Order_Itm_Batch_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where =  " ( Order_No IN (SELECT Order_No FROM Order_Hdr WHERE  Cust_No IN $cust_id_array  ) )" ;
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Order_Con_Book_Form_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where =  " ( Order_No IN (SELECT Order_No FROM Order_Hdr WHERE  Cust_No IN $cust_id_array  ) )" ;
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Invoice_Hdr_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where =  " ( Order_No IN (SELECT Order_No FROM Order_Hdr WHERE  Cust_No IN $cust_id_array  ) )" ;
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Order_Addresses_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where =  " ( Order_No IN (SELECT Order_No FROM Order_Hdr WHERE  Cust_No IN $cust_id_array  ) )" ;
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Order_Consignment_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where =  " ( Book_Form_ID IN ( SELECT ID FROM Order_Con_Book_Form WHERE  Order_No IN (SELECT Order_No FROM Order_Hdr WHERE  Cust_No IN $cust_id_array  ) ) )" ;
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Order_History_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where =  " ( Order_ID IN (SELECT Order_No FROM Order_Hdr WHERE  Cust_No IN $cust_id_array  ) )" ;
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function BBC_Addresses_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = "( (Login_Type = 'Buyer' AND User_No IN $cust_id_array)
		OR
		(Login_Type = 'Seller' AND User_No IN  (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array )) )";
    } elseif($clause == 'fsono'){

    }
    return $where;
}
function Store_Cust_Article_Price_OFL($clause, $cust_id_array) {
    if($clause == 'custno'){
        $where = "Store_No IN (SELECT Store_No FROM Cust_Store_Master WHERE  Cust_No IN $cust_id_array )";
    } elseif($clause == 'fsono'){

    }
    return $where;
}

function logging_v2($module, $parameters = "", $log_file = "")
{
    ## check if msg_lvl is 1 then add entry in the logfile
    $logdate = date("d-m-Y H:i:s");

    //$txt = $logdate."\r\n ";
    $txt = print_r($parameters, true);
    //$txt .= "\r\n ";

    $logFileName = OFFLINE_LOG_URL.'/'.$module.'_'.date("j.n.Y").'.log';
    // print_r($logFileName);die;

    file_put_contents($logFileName, $txt, FILE_APPEND | LOCK_EX );
}

function getMicrotime(){
    return round(microtime(true) * 1000);
    $now = DateTime::createFromFormat('U.u', microtime(true));
    return $now->format("m-d-Y H:i:s.u");
}

function getCustomerDetails($pdo, $column, $value){
    $entStmt = $pdo->prepare("SELECT Cust_No FROM Cust_Master WHERE ".$column." = '".$value."' AND Status = 'A'");
    $entStmt->execute();
    //$entStmt->debugDumpParams();
    $entStmt = $entStmt->fetchAll(PDO::FETCH_ASSOC);
    if(!empty($entStmt)){
        return $entStmt;
    } else return [];
}

function getFSODetails($pdo, $column, $value){
    $entStmt = $pdo->prepare("SELECT FSO_No, Login_Type FROM FSO_Master WHERE ".$column." = '".$value."' AND Status = 'A'");
    $entStmt->execute();
    //$entStmt->debugDumpParams();
    $entStmt = $entStmt->fetchAll(PDO::FETCH_ASSOC);
    if(!empty($entStmt)){
        return $entStmt;
    } else return [];
}
