<?php

use Illuminate\Support\Facades\Log;

function sms__unicode($message)
{

    $hex1 = '';
    if (function_exists('iconv')) {
        $latin = @iconv('UTF-8', 'ISO-8859-1', $message);
        if (strcmp($latin, $message)) {
            $arr = unpack('H*hex', @iconv('UTF-8', 'UCS2BE', $message));
            $hex1 = strtoupper($arr['hex']);
        }
        if ($hex1 == '') {
            $hex2 = '';
            $hex = '';
            for ($i = 0; $i < strlen($message); $i++) {

                $hex = dechex(ord($message[$i]));
                $len = strlen($hex);
                $add = 4 - $len;
                if ($len < 4) {
                    for ($j = 0; $j < $add; $j++) {
                        $hex = "0" . $hex;
                    }
                }
                $hex2 .= $hex;
            }
            return $hex2;
        } else {
            return $hex1;
        }
    } else {
        print 'iconv Function Not Exists !';
    }
}

/**
 * SubmitSMS
 * This function will check sms is allowed to that business then only send sms
 * @param type (number) $mobile: sms will be sent to this no
 * @param type (string) $constantName : sms constant name
 * @param type (array) $data : customized data of sms
 * @param type (array) $levels : customized data of sms
 * @return boolean
 */
function SubmitSMS($mobile, $constantName, $data = [], $level = '')
{
    Log::info('Sms Request Data of sms => SubmitSMS : ', ['constantName' => $constantName, 'mobile' => $mobile, 'data' => $data, 'level' => $level]);
    $log = [];
    $log['SMS ON'] = 'IN SMS: (' . $constantName . ') sms is = ' . SMS;

    if (SMS == 'off' || SMS_LEVEL == '' || SMS_LEVEL == 0) return '0|' . $mobile;
    ### Get value from constant
    $constantValue = constant($constantName);
    $smsLevels = explode(",", SMS_LEVEL);

    $log['sms levels'] = SMS_LEVEL;

    ## If multiple levels are assigned to business
    ## then check which level is passed to function SubmitSMS as $level
    if ($level != '' && in_array($level, $smsLevels)) {
        $allowedSMS = constant("SMS_LEVEL_" . $level);
    } else {
        $allowedSMS = constant("SMS_LEVEL_" . $smsLevels['0']);
    }

    $log['allowed sms'] = json_encode($allowedSMS);

    $templateId = isset(SEVENOMEDIA_SMS_TEMPLATE_IDS[$constantName]) ? SEVENOMEDIA_SMS_TEMPLATE_IDS[$constantName] : 0;

    $log['templateId'] = $templateId;

    if (!empty($allowedSMS)) {
        ## check sms is allowed or not
        if (in_array($constantName, $allowedSMS)) {
            $message = generate_sms($constantValue, $data);
            $log['message'] = $message;
            createLogSMS($log);
            return transactionalSMS($message, $mobile, $templateId);
        } else return '0|' . $mobile;
    } else return '0|' . $mobile;
}

/**
 * transactionalSMS
 *
 * Transactional SMS will be sent from this function
 * @param string $message : Your Order ID 23847628 with 234823
 * @param string $mobile : can be single or can be multiple with comma separted, 2121212121 OR 2121212121,2323232323,4343434343
 * @param int gwid = will be always 2 here
 * @return json object $response
 * Author : Daya
 */
function transactionalSMS($message, $mobile, $templateId = '')
{
    Log::info('Sms Request Data of sms => transactionalSMS : ', ['message' => $message, 'mobile' => $mobile, 'templateId' => $templateId]);
    $log['function name'] = 'in transactionalSMS';
    try {
        $source = ""; // this will get from jio website
        $business = getBusiness();
        if (strpos(strtolower($business), 'chitale') !== false) {
            $source = "SNPKRN";
        } else if (strpos(strtolower($business), 'familymart') !== false) {
            $source = "MFAMLY";
        }

        $log['source'] = $source;

        //Smpp http Url to send sms.
        //http request : $live_url = "http://".SMS_HOST."/domestic/sendsms/bulksms_v2.php?apikey=c25hcGtpcmFuOlVjRkhsTTNa&type=TEXT&sender=".SMS_SENDER."&entityId=1201161744705117844&templateId=$templateId&mobile=$mobile&message=$message";
        ## sevenomedia json api
        $live_url = "http://" . SMS_HOST . "/domestic/sendsms/jsonapi.php";
        $request = [];
        $mobileNos = explode(',', $mobile);
        if (!empty($mobileNos)) {
            $request['source'] = $source;
            $request['type'] = "TEXT";
            $request['content'] = $message;
            $request['entityId'] = "1201161744705117844";
            $request['tempId'] = $templateId;

            foreach ($mobileNos as $i => $mobileNo) {
                $request['destination'] = trim($mobileNo);
                $inputRequest['data'][$i] = $request;
            }
        }

        $inputStr = json_encode($inputRequest);

        $log['sms request'] = 'url=' . $live_url . ' ====  ' . $inputStr;
        $headers = array(
            'apiKey: c25hcGtpcmFuOnJIQnBhMVVl',
            'Content-Type: application/json'
        );
        //print "INPUTSTR="; print_r($inputStr); exit;

        $response = call_3rdparty_api($live_url, $inputStr, 'post', 'json', $headers);// curl call
        $log['sms response'] = $response;
        createLogSMS($log);
        if (!$response) {
            Log::error('Sms Response Error : ', ['message' => "Sms gateway is temporarly out of service"]);
            throw new Exception("Sms gateway is temporarly out of service");
        }

        $resArray = [];
        $res = json_decode($response, true);
        $res = $res[0];

        if (!empty($res)) {
            if (strtolower($res['cause']) == 'success') {
                $resArray['status'] = 'success';
            } else {
                $resArray['status'] = 'error';
            }
            $errorCd = $res['code'];
            $resArray['error_code'] = $errorCd;
            $resArray['error_msg'] = str_replace('_', ' ', $res['cause']);
        }

        //return json_encode($resArray); return will stop api if any problem occurs in sms gateway

    } catch (Exception $e) {
        Log::error('Sms Response Error : ', ['message' => $e->getMessage()]);
        // 'Message:' .$e->getMessage();exit;
        return 'Message:' . $e->getMessage();
    }
}

function Submit($host, $port, $username, $password, $sender, $message, $mobile, $msgtype, $dlr)
{
    Log::info('Sms Request Data of sms => Submit : ', ['message' => $message, 'mobile' => $mobile]);
    if (SMS == 'off') return '0|' . $mobile;

    return transactionalSMS($message, $mobile);

    if ($msgtype == "2" || $msgtype == "6") {
        //Call The Function Of String To HEX.
        $message = sms__unicode($message);
        try {
            //print_r($msgtype);die;
            //Smpp http Url to send sms.
            //echo "here";die;
            $live_url = "http://" . $host . ":" . $port . "/sendsms?username=" . $username . "&password=" . $password . "&type=" . $msgtype . "&dlr=" . $dlr . "&destination=" . $mobile . "&source=" . $sender . "&message=" . $message . "";
            $parse_url = file($live_url);
            print_r($live_url);
            die;
            echo "send";
            die;
            //echo "ada".$parse_url[0];die;
        } catch (Exception $e) {
            echo 'Message:' . $e->getMessage();
        }
    } else
        $message = urlencode($message);
    try {
        //Smpp http Url to send sms.
        $live_url = "http://" . $host . ":" . $port . "/bulksms/bulksms?username=" . $username . "&password=" . $password . "&type=" . $msgtype . "&dlr=" . $dlr . "&destination=" . $mobile . "&source=" . $sender . "&message=" . $message . "";

        $parse_url = file($live_url);
        //echo "ada".$parse_url[0];die;
    } catch (Exception $e) {
        echo 'Message:' . $e->getMessage();
    }
}

/**
 * generate_sms
 *
 * Generate sms text with sms_constant and prodived smsinfo array
 * @param string $sms : Your Order ID [[0]] with [[1]]
 * @param array $smsInfo : array(10001127, 'Daya')
 * @return string $sms (customized text)
 * Here we are replaceing sms string [[0]] with arrays 0th index and [[1]] with arrays 1st index
 * Result :  Your Order ID 10001127 with Daya
 * Author : Daya
 * $smsInfo = array($order_no,$Store_Name);
 * $smsMsg = generate_sms(ACCEPTED_ANDROID, $smsInfo);
 */
function generate_sms($sms, $smsInfo = array())
{
    Log::info('Sms Request Data of sms => generate_sms : ', ['sms' => $sms, 'smsInfo' => $smsInfo]);
    if (!empty($smsInfo)) {
        for ($i = 0; $i < count($smsInfo); $i++) {
            $needle = '[[' . $i . ']]';
            if (strpos($sms, $needle) !== false) {
                $sms = str_replace($needle, $smsInfo[$i], $sms);
            }
        }
    }
    Log::info('SMS text of sms => generate_sms: ', ['sms' => $sms]);
    return $sms;
}


function createLogSMS($data)
{
    $dataNew = [];
    $logMe = 1;
    if ($logMe == 1) {
        $logdate = date("d-m-Y H:i:s");
        $log = __DIR__ . '/../logs/po_log.txt';
        $dataNew[$logdate] = $data;
        file_put_contents($log, print_r($dataNew, true), FILE_APPEND | LOCK_EX);
    }
}
