<?php

use App\Http\Controllers\Api\AddressController;
use App\Http\Controllers\Api\AppProjectController;
use App\Http\Controllers\Api\AreaController;
use App\Http\Controllers\Api\ArticleController;
use App\Http\Controllers\Api\BankController;
use App\Http\Controllers\Api\BeatRoutesController;
use App\Http\Controllers\Api\BusinessController;
use App\Http\Controllers\Api\BuyerController;
use App\Http\Controllers\Api\CartController;
use App\Http\Controllers\Api\CategoriesController;
use App\Http\Controllers\Api\CheckOutController;
use App\Http\Controllers\Api\CityController;
use App\Http\Controllers\Api\CustomerController;
use App\Http\Controllers\Api\DeliveryChargesController;
use App\Http\Controllers\Api\FavouriteController;
use App\Http\Controllers\Api\FeedbackController;
use App\Http\Controllers\Api\FSOController;
use App\Http\Controllers\Api\GetDataController;
use App\Http\Controllers\Api\InternalHeartBeatController;
use App\Http\Controllers\Api\InvoiceController;
use App\Http\Controllers\Api\LoginController;
use App\Http\Controllers\Api\NotificationController;
use App\Http\Controllers\Api\OfflineController;
use App\Http\Controllers\Api\OrderController;
use App\Http\Controllers\Api\OTPController;
use App\Http\Controllers\Api\PackageVersionController;
use App\Http\Controllers\Api\PlaceOrderController;
use App\Http\Controllers\Api\ProductController;
use App\Http\Controllers\Api\ProfileController;
use App\Http\Controllers\Api\PromoCodeController;
use App\Http\Controllers\Api\ReportController;
use App\Http\Controllers\Api\RetailerController;
use App\Http\Controllers\Api\ReturnOrderBatchController;
use App\Http\Controllers\Api\ReturnOrderController;
use App\Http\Controllers\Api\RTNController;
use App\Http\Controllers\Api\SocietyController;
use App\Http\Controllers\Api\StateController;
use App\Http\Controllers\Api\StoreController;
use App\Http\Controllers\Api\ThirdPartyController;
use App\Http\Controllers\Api\UpsertArticleController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

Route::post('/get_all_area',[AreaController::class,'get_all_area']);
Route::post('/login',[LoginController::class,'login']);
Route::post('/api_get_authtoken',[LoginController::class,'api_get_authtoken']);
Route::post('/getPackageVersion',[PackageVersionController::class,'getPackageVersion']);
Route::post('/address_details',[AddressController::class,'address_details']);
Route::post('/get_all_banks',[BankController::class,'get_all_banks']);
Route::post('/get_all_categories_for_level',[CategoriesController::class,'get_all_categories_for_level']);
Route::post('/rtn_error',[RTNController::class,'rtn_error']);
Route::post('/getdeliverycharges',[DeliveryChargesController::class,'getDeliveryCharges']);
Route::post('/delete_address',[AddressController::class,'delete_address']);
Route::post('/get_all_states',[StateController::class,'get_all_states']);
Route::post('/get_society_name',[SocietyController::class,'get_society_name']);
Route::post('/getAllCategory',[CategoriesController::class,'getAllCategory']);
Route::post('/get_all_cities',[CityController::class,'get_all_cities']);
Route::post('/fso_offline_signup',[FSOController::class,'fso_offline_signup']);
Route::post('/notification_history',[NotificationController::class,'notification_history']);
Route::post('/get_retailer_invoices',[RetailerController::class,'get_retailer_invoices']);
Route::post('/get_app_projects',[AppProjectController::class,'get_app_projects']);
Route::post('/save_cart',[CartController::class,'save_cart']);
Route::post('/save_favourite',[FavouriteController::class,'save_favourite']);
Route::post('/set_address_default',[AddressController::class,'set_address_default']);
Route::post('/get_retailer_outstanding_bal',[RetailerController::class,'get_retailer_outstanding_bal']);
Route::post('/get_Business_Config_Data',[BusinessController::class,'get_Business_Config_Data']);
Route::post('/update_customer_profile',[CustomerController::class,'update_customer_profile']);
Route::post('/get_store_serving_area',[StoreController::class,'get_store_serving_area']);
Route::post('/update_3rdparty_orderno',[ThirdPartyController::class,'update_3rdparty_orderno']);
Route::post('/update_3rdparty_buyerno',[ThirdPartyController::class,'update_3rdparty_buyerno']);
Route::post('/update_3rdparty_transactionId',[ThirdPartyController::class,'update_3rdparty_transactionId']);
Route::post('/get_all_store_brands',[StoreController::class,'get_all_store_brands']);
Route::post('/customer_change_password',[CustomerController::class,'customer_change_password']);
Route::post('/get_orderfilters',[OrderController::class,'get_orderfilters']);
Route::post('/recreate_order',[OrderController::class,'recreate_order']);
Route::post('/checkout_page',[CheckOutController::class,'checkout_page']);
Route::post('/customer_store_inventory',[CustomerController::class,'customer_store_inventory']);
Route::post('/get_orderlistitems',[OrderController::class,'get_orderlistitems']);
Route::post('/add_feedback',[FeedbackController::class,'add_feedback']);
Route::post('/get_order_summary',[OrderController::class,'get_order_summary']);
Route::post('/offline_error',[OfflineController::class,'offline_error']);
Route::post('/get_retailer_ledger',[RetailerController::class,'get_retailer_ledger']);
Route::post('/search_retailer',[RetailerController::class,'search_retailer']);
Route::post('/customer_order_deliver',[CustomerController::class,'customer_order_deliver']);
Route::post('/get_reportfilters',[ReportController::class,'get_reportfilters']);
Route::post('/get_beatroutes',[BeatRoutesController::class,'get_beatroutes']);
Route::post('/get_profile',[ProfileController::class,'get_profile']);
Route::post('/internal_heartbeat',[InternalHeartBeatController::class,'internal_heartbeat']);
Route::post('/add_new_address',[AddressController::class,'add_new_address']);
Route::post('/forgot_password',[LoginController::class,'forgot_password']);
Route::post('/store_details',[StoreController::class,'store_details']);
Route::post('/check_otp',[OTPController::class,'check_otp']);
Route::post('/resend_otp',[OTPController::class,'resend_otp']);
Route::post('/get_buyerdetails',[BuyerController::class,'get_buyerdetails']);
Route::post('/get_retailer_suppliers',[RetailerController::class,'get_retailer_suppliers']);
Route::post('/get_daywise_retailers',[RetailerController::class,'get_daywise_retailers']);
Route::post('/api_orders',[OrderController::class,'api_orders']);
Route::post('/retailer_signup',[RetailerController::class,'retailer_signup']);
Route::post('/get_buyers',[BuyerController::class,'get_buyers']);
Route::post('/applypromocode',[PromoCodeController::class,'applypromocode']);
Route::post('/update_address',[AddressController::class,'update_address']);
Route::post('/cancel_order',[OrderController::class,'cancel_order']);
Route::post('/get_performance_reports',[ReportController::class,'get_performance_reports']);
Route::post('/add_store_transaction',[StoreController::class,'add_store_transaction']);
Route::post('/update_buyer',[BuyerController::class,'update_buyer']);
Route::post('/update_profile',[ProfileController::class,'update_profile']);
Route::post('/get_cat_level_articles',[CategoriesController::class,'get_cat_level_articles']);
Route::post('/get_orderlist',[OrderController::class,'get_orderlist']);
Route::post('/get_favourite',[FavouriteController::class,'get_favourite']);
Route::post('/get_scheme_articles',[ArticleController::class,'get_scheme_articles']);
Route::post('/delete_api_invoices',[InvoiceController::class,'delete_api_invoices']);
Route::post('/search_article_in_store',[ArticleController::class,'search_article_in_store']);
Route::post('/get_cart_data',[CartController::class,'get_cart_data']);
Route::post('/get_orderdetails',[OrderController::class,'get_orderdetails']);
Route::post('/get_article_for_cat_level',[ArticleController::class,'get_article_for_cat_level']);
Route::post('/get_offered_products',[ProductController::class,'get_offered_products']);
Route::post('/get_articles_for_cat_level',[ArticleController::class,'get_articles_for_cat_level']);
Route::post('/fso_retailer_signup',[FSOController::class,'fso_retailer_signup']);
Route::post('/api_invoices_update',[InvoiceController::class,'api_invoices_update']);

Route::post('/returnorder',[ReturnOrderController::class,'returnorder']);
Route::post('/upsert_articles',[UpsertArticleController::class,'upsert_articles']);
Route::post('/returnorder_withbatch',[ReturnOrderBatchController::class,'returnorder_withbatch']);
Route::post('/place_order',[PlaceOrderController::class,'place_order']);
Route::post('/api_get_data',[GetDataController::class,'api_get_data']);
Route::post('/api_get_data_all_queries',[GetDataController::class,'api_get_data_all_queries']);
Route::post('/upsert_article_margin_pricing',[UpsertArticleController::class,'upsert_article_margin_pricing']);







